/* Program EWSH2, Version 1.0.2
*  Authors: Jochen Wolf, Marie Wolfova, Zuzana Krupova, Emil Krupa, 2010
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#define BS 5 /* Maximal number of breeding seasons for female or male progeny + 1 */
#define C 100 /* Maximal number of categories of ewes + 1 */
#define CB 3 /* Differentiates between crossbreeding and purebreeding
                Index 1: pure-bred animals, 2: cross-bred animals,
		0: sum of pure-bred and cross-bred animals */  
#define CLT 5 /* Maximal number of classes for lambing type + 1 */
#define CR 30 /* Maximal number of categories for rams + 1 */
#define CSP 10 /* Maximal number of categories of surplus progeny */
#define FE 6 /* Maximal number of feed rations for ewes + 1 */
#define FL 21 /* Maximal number of feed rations for lambs + 1 */
#define FR 3 /* Maximal number of feed rations for rams + 1 */
#define HS 4 /* Maximal number of sheep husbandry systems + 1 */
#define L 16 /* Maximal number of reproductive cycles + 1 */
#define LF 6 /* Maximal number of different targets for fattening + 1 */
#define N 16 /* Maximal dimension of vector used in the calculation of
   economic weights for saving data */
#define NCHFS 30 /* Maximal number of changes of feeding seasons + 1 */
#define NCL 6 /* Maximal number of quality classes in lambs slaughtered after
  weaning + 1 */
#define NCLCQ 4 /* Maximal number of classes for carcass quality in lambs
  slaughtered after weaning + 1 */
#define NCLCW 5 /* Maximal number of classes for carcass weight + 1 */
#define NCLFL 8 /* Maximal number classes for fleshiness + 1 */
#define NCLFC 8 /* Maximal number classes for fat covering + 1 */
#define NFAT 10 /* Maximal number of threshold values for milk fat */
#define NFS 5 /* Maximal number of feeding seasons + 1 */
#define NPROT 10 /* Maximal number of threshold values for milk protein */ 
#define NSCC 7 /* Maximal number of classes for somatic cell count */ 
#define NT 36 /* Maximal number of traits + 1 */
#define P 52 /* Maximal number of categories for progeny + 1 */
#define R 8 /* Maximal number of breeding cycles for rams + 1 */
#define SP 3 /* Number of genders in progeny + 1 */

void outputrw(FILE *fr, FILE *fw);
void outputr(FILE *fr);
void sysvar(FILE *fr, FILE *fw);
int readsyva(FILE *fr);
void readcom(FILE *fr);
float readdat(FILE *fr);
int readdat1(FILE *fr);
float readfloat(FILE *fw, FILE *fr);
float readint(FILE *fw, FILE *fr);
void readdes(FILE *fr);
void inp00(FILE *fw, int n2, int zz, int breed);
void wrides(FILE *fr, FILE *fw);
int dsjf(int m, int d);
int readymd(FILE *fr, FILE *fw);
double normdis(double x);
double probit (double y);
float maxi(float a, float b);
float scs(float x);
float linregm (float xave, float sigma, float xmin, float xmax, float b0, float b1, float xbar);
void printcb8_2(int cb, float par1, float par2, FILE *fw);
void printcb9_3(int cb, float par1, float par2, FILE *fw);
void nonsense01(int b);
void nonsense02(int b);
void nonsense03(int b, int i, int j, float s, float t);
void nonsense04(int b, int j, float s);
void nonsense05(int b);
void nonsense06(int b);
void nonsense07(int b);
void nonsense08(int b, int i);
void nonsense09(int b, int i, int j, int k, float a2);
void nonsense10(int b, int j, float a2);
void nonsense11(int b, int j, int k);
void nonsense17(int b);
void nonsense18(int b, int i);
void nonsense19(int b, int i);
void nonsense20(int b);
void nonsense21(int b, int i, int j, int k);
void nonsense22(int b);
void nonsense23(int b, int i, int j);
void nonsense24(int b, int i, int j, int k);
void nonsense25(int b);
void nonsense26(int b, int i, int j, int k);
void nonsense27(int b);
void nonsense29(int b, int i);
void nonsense30(int b, int i); 
void nonsense31(int b, int j, float a2);

clock_t zac, kon;

main()
{  
  FILE *fr, *fw, *fw1, *fr1, *fw2, *fr2, *fw3;
  int agearL,agewL,breed,bs[SP],calc,clf[SP][LF],clt,crossing,csp[SP],cy,datbbs,
    datchfs[NCHFS],datconFP[BS],datdry,datebs,datlamb,datwL,dmilkst,dnpregcE,
    dselR,dshpE,errmess,ewopt,fatcb,fatpb,fE,feedcost,femrep,
    fL,flushabE,flushabL,flushbbE,flushbbL,flushbbR,
    fR,hs,i,i1,i2,i3,icb,ilcb,ilpb,ipb,iscb,ispb,j,j1,ja,jb,
    k,k0[SP][CB],k1,k2,k3,k4,k5,k6,k7,kE,kR,
    lengthmp,lengthrc,lf[SP],LL,
    lpreg,milkprice,n2,nchfs,nchfst,nclfL,nclcwwL,nclcqwL,
    nclfcfL,nclfcS,nclfcwL,nclflfL,nclflS,nclflwL,nclS,nclwL,nd[NFS],
    nfat,nfs,nprot,nreins,nSCC,
    nsl,nstg1E,nstg1R,nstg2E,nstg2R,nstgE,nstgR,opsbL,
    placE,PP,RR,TE,pricefL,priceS,pricewL,prods,
    techE[NFS],techbL[NFS],techfatL[NFS],TR,trait,
    typeb,typew,ulf[SP][LF],valfs[NCHFS],z1,z2,zr,zz;
  float a2,a3,a4,ach,adg[SP][CB],adgb[SP][CLT][CB],adgbwL[SP][CLT][CB],adgE,
    adgfE,adgfL,adgP[P][CB],adgR[CB],adgr[SP][BS][CB],adgwarL[SP][CLT][CB],
    ageE[L],agelFP[BS],agepurMP[CB],
    ageR[R][CB],ager[SP][BS],agetP[P][CB],AkharL,AkhE,AkhfL,
    AkhR,AkhrL,avclfL[CB],avclS[CB],avclwL[CB],avconrateE,
    avcqwL[CB],avfcfL[CB],avfcL[CB],avfcS[CB],avfcwL[CB],
    avfleshfL[CB],avfleshL[CB],avfleshS[CB],avfleshwL[CB],avlifelE,avlifeyE,
    avlitE,avlitpE[L],avmilkd,avsur24hL[CB],avsurarL[CB],
    avsurwL[CB],avwar[SP][CB],avww[SP][CB],awo,
    basemilkm,basemilkw,basemilkws[NFS],bch,bwL[SP][CLT][CB],bwo,c1[SP],c2[SP],
    c3[SP],c4[SP],c5[SP],c6[SP],casprot,cch,cheesewhey,cheesey,coninsE,
    conrateE[L],conrateFP[BS][CB],costAkh,costbedE[C],costbedL[P][CB],
    costbedR[CR][CB],costbreedE[C],costbreedL[P][CB],
    costcheese0E,costcheeseE[C],costdead,
    costdiedE[C],costdiedL[P][CB],costdiedR[CR][CB],costE[C],
    costfE[C],costfix0E,costfix0R,costfixarL,costfixE[C],costfixfL,
    costfixL[P][CB],costfixR[CR][CB],costfixrL,
    costfL[P][CB],costfR[CR][CB],
    costins[CB],costL[P][CB],
    costlabE[C],costlabL[P][CB],costlabR[CR][CB],costlamb,
    costmarkbR,costmarkcul,costmarkE[C],costmarkfL,costmarkL[P][CB],
    costmarkR[CR][CB],costmarkrL[SP],costmarkwL,
    costmilk0E,costmilkE[C],costnfE[C],costnfL[P][CB],costnfR[CR][CB],
    costoeinE,costoeinFP,costpurchFP,
    costpurchR[CR][CB],costR[CR][CB],
    costreins[CB],costshe0E,costshe0R,costsheE[C],costshe0L,costsheL[P][CB],
    costsheR[CR][CB],
    costskE[C],costskL[P][CB],costskR[CR][CB],costtan,costvetE[C],
    costvetL[P][CB],costvetR[CR][CB],
    costwatE[C],costwatL[P][CB],costwatR[CR][CB],
    cullbsMP[BS][CB],cwo,
    dcE[C],dcL[P][CB],dcR[CR],
    dnpregcFP,dpregsFP,dresE,dresfL[SP][LF][CB],
    dresR[CB],dresrL[CB],dreswL[CB],
    drymE[FE][NFS],drymL[FL][NFS],drymR[FR][NFS],
    dwatE[FE][NFS],dwatL[FL][NFS],dwatR[FR][NFS],
    dwoolptarL,dwoolptE,dwoolptR[CB],dwoolptrL[SP][CB],dwoolptwL,
    ev[NT][CB],ev0[NT][CB],evdiff[NT][CB],evp[NT][CB],
    facSCC[NSCC],favfL[CB],favwL[CB],
    fat,fatch,fatymst,fdm,feE[C][FE][NFS],feL[P][CB][FL][NFS],
    feR[CR][CB][FR][NFS],ffE[C][FE][NFS],ffL[P][CB][FL][NFS],
    ffR[CR][CB][FR][NFS],fpdiE[C][FE][NFS],fpdiL[P][CB][FL][NFS],
    fpdiR[CR][CB][FR][NFS],
    intlm,intml,
    hetmw,
    kadgbw[SP][CLT][CB],kadgfat[SP][LF][CB],kadgr[SP][BS][CB],
    kadgwar[SP][CLT][CB],kbw[SP][CLT][CB],
    kconrateFP[BS][CB],kdif,kdresEL,kdresER,kdresfL[SP][LF][CB],kdresRL,
    kmilkcE,kmwRE[CB],ktE[HS],ktL[HS],ktlp[L],ktlsl[CLT],
    kwarL[SP][CB],kwE,kwfL[SP][CB],kwrL[SP][CB],kwwL[SP][CB],    
    l1L[P][CB][CLT],l1skL[P][CB],lossfE[FE][NFS],lossfL[FL][NFS],
    lossfR[FR][NFS],
    manarL,manbL,manE,manfL,manR,mcwwL[SP][CB],
    milkch,milkmpar[L],milkmrel[CLT][L],milksw[L],
    milkw0L[NFS],milkwL[CLT][NFS],milkwrel[CLT][L],
    milkws[CLT][L][NFS],milkwsrel[CLT][L][NFS],minw[SP][CB],
    moich,mSCS,mwE[CB],mwE2,mwMP[CB],mwR[CB],
    Na24hL[CB],na24hL[CB][CLT],NarL[CB],narL[CB][CLT],NbtL[CB],nbtL[CB][CLT],
    ndiedfat[SP][LF][CB],nebL[CLT][P][CB][FL][NFS],
    nectoparL,nectopclFP,nectopE,nectopf[SP][LF],nectopR,nectoprL[BS],nectopwL,
    nedE[FE][NFS],nedL[FL][NFS],
    nedR[FR][NFS],neE[C][FE][NFS],nefE[C][FE][NFS],nefL[P][CB][FL][NFS],
    negbL[CLT][P][CB][FL][NFS],negL[P][CB][FL][NFS],negL14m[CB][NFS],
    negL14nm[CB][NFS],neglE[C][FE][NFS],negnlE[C][FE][NFS],negR[CR][CB][FR][NFS],nelbE[CLT][C][FE][NFS],nelE[C][FE][NFS],
    neL[P][CB][FL][NFS],nelwL[CLT][NFS],nembL[CLT][P][CB][FL][NFS],nemilk,
    nemL[P][CB][FL][NFS],nemL14m[CB][NFS],nemL14nm[CB][NFS],nemlE[C][FE][NFS],
    nemnlE[C][FE][NFS],nemR[CR][CB][FR][NFS],
    nendoparL,nendopclFP,nendopE,nendopf[SP][LF],nendopR,nendoprL[BS],nendopwL,
    nepbE[CLT][C][FE][NFS],
    nepE[C][FE][NFS],nepbL[CLT][P][CB][FL][NFS],nepL[P][CB][FL][NFS],
    neR[CR][CB][FR][NFS],newbL[CLT][P][CB][FL][NFS],neweR[CB],
    newL[P][CB][FL][NFS],newL14m[CB][NFS],newL14nm[CB][NFS],newlE[C][FE][NFS],
    newnlE[C][FE][NFS],newR[CR][CB][FR][NFS],nfattar[SP][LF][CB],nherd[SP],
    nmatFP[BS][CB],npurchMP[CB],npurchFP,
    nramMP[CB],nrcull[SP][BS][CB],nrdied[SP][BS][CB],nrdiedmlFP[CB],
    nrmatFP[BS],nshearL,nsheE,nshefL[SP][LF],nsheFP,nsherL[BS],nsheR[CB],nshewL,
    nsold[SP][BS][CB],nsoldMPA,
    nspcull[SP][BS][CB],nspdied[SP][BS][CB],nsp[SP][CSP][CB],
    NwL[CB],nwL[CB][CLT],nwsp[SP][CB],
    parL[CLT][CB],pbarrE[L],pbarrFP[BS][CB],pbtba[CLT][CLT],pcastMP,
    pcl0[N],pcl00[N][N],pcl11[N][N],
    pclcqwL[NCLCW][NCLCQ][CB],pclcwL[SP][NCLCW][NCLCQ][CB],
    pclcwwL[SP][NCLCW][CB],
    pclfcfL[CB][NCLFL][NCLFC],pclfcS[CB][NCLFL][NCLFC],
    pclfcwL[CB][NCLFL][NCLFC],pclfL[CB][NCL],
    pclS[CB][NCL],pclwL[CB][NCL],pclwLql[N],pclwLqm[N],
    pconE[L],
    pconstayE[L],pcrossE[L],pcrosst,pctE[CB],pcullE[L],pcullfcE0,pcullfcEp,
    pcullhE[L],
    pcullhE0,pcullhEp,pcullmE[L],pcullmE0,pcullmEp,
    pcullR[R],pdA,pdB,
    pdibL[CLT][P][CB][FL][NFS],pdiE[C][FE][NFS],pdiedbL[CLT][CB],
    pdiedbtL[CLT][CLT],
    pdiedE[L],pdiedE0,pdiedEp,
    pdiedR[R],pdiedwL[CLT][CB],pdiedarL[CLT][CB],pdifE[C][FE][NFS],
    pdifL[P][CB][FL][NFS],pdigbL[CLT][P][CB][FL][NFS],pdigL[P][CB][FL][NFS],
    pdigL14m[CB][NFS],pdigL14nm[CB][NFS],pdiglE[C][FE][NFS],pdignlE[C][FE][NFS],
    pdidE[FE][NFS],pdidL[FL][NFS],pdidR[FR][NFS],pdigR[CR][CB][FR][NFS],
    pdiL[P][CB][FL][NFS],pdilbE[CLT][C][FE][NFS],pdilE[C][FE][NFS],
    pdilwL[CLT][NFS],pdimbE[CLT][C][FE][NFS],pdimbL[CLT][P][CB][FL][NFS],pdimilk,
    pdimL[P][CB][FL][NFS],pdimL14m[CB][NFS],pdimL14nm[CB][NFS],
    pdimlE[C][FE][NFS],pdimnlE[C][FE][NFS],pdimR[CR][CB][FR][NFS],
    pdipbE[CLT][C][FE][NFS],pdipE[C][FE][NFS],pdipbL[CLT][P][CB][FL][NFS],
    pdipL[P][CB][FL][NFS],pdiR[CR][CB][FR][NFS],pdiwbL[CLT][P][CB][FL][NFS],
    pdiwL[P][CB][FL][NFS],pdiwL14m[CB][NFS],pdiwL14nm[CB][NFS],
    pdiwlE[C][FE][NFS],pdiwnlE[C][FE][NFS],pdiwR[CR][CB][FR][NFS],
    pf[N],pf0[N],pf1[N],
    Pherd[SP],pherd[SP][BS],pherdyMP,PhicwL[NCLCW],
    Phiscc[NSCC],pinsE[CB],pinsFP[CB],
    plambE[C],Pltype[CLT][L],pmatE[L],
    pmat[SP][BS][CB],pmilkch,pmilkwm,
    pnlambE[C],pnconE[L],pnconculE[L],pnconstayE[L],
    ppurchFP,ppurchMP,prbR[CB],prcheese,prclcwwL[NCLCW][NCLCQ],
    prclfcfL[NCLFL][NCLFC],prclfcS[NCLFL][NCLFC],prclfcwL[NCLFL][NCLFC],
    prclfL[NCL],prclS[NCL],prclwL[NCL],
    prconFP[BS][CB],prcwawL[SP][CB],prcwbwL[CB],prcwcwL[SP][CB],prcwfL[CB],
    prcwS[CB],prcwwL[CB],
    prectop,prendop,
    prfE[FE][NFS],prfL[FL][NFS],prfR[FR][NFS],prlwfL[CB],
    prlwS0,prlwS[CB],prlwwL[CB],
    prman,prmilk,prmilkb,prmilkf[NFAT],prmilkfp,prmilkp[NPROT],profsub,profnsub,
    prot,protymst,prreffL,prrefS,prrefwL,prsbL[P][CB],prsbR[CB],prSCC[NSCC],
    prscc,prskrE,prskrL[CB],prskrR[CB],
    prsktE,prsktL[CB],prsktR[CB],prstraw,prwat,prwhey,
    prwoolE,prwoolL[CB],prwoolR[CB],ps13[CB],pSCC[NSCC],
    pskarL,pskE,pskfL,pskR,pskrL,pskwL,
    psold[SP][BS][CB],psoldR[R],psp[SP][CSP][CB],
    pstayR[R],PsuckE[CLT][L],pt[N],
    ptskarL,ptskE,ptskfL,ptskR,ptskrL,ptskwL,
    pwL[CLT][CB],pwrepFP[CB],pwrepMP,pyoungMP[CB],
    qaveE[C],qaveL[P][CB],qaveR[CR][CB],qbreedE[C],qbreedL[P],qcl0[N],qendE[C],
    qendL[P][CB],qendR[CR][CB],qmilkE[C],
    qpurchR,
    ratiooldR,ratioR,ratioyoungR,rcas,
    revcE[C],revcheeseE[C],revcL[P][CB],revcR[CR][CB],revE[C],revL[P][CB],
    revmanE[C],revmanL[P][CB],revmanR[CR][CB],revmilkE[C],revR[CR][CB],
    revsbL[P][CB],revskrE[C],revskrL[P][CB],revskrR[CR][CB],
    revsktE[C],revsktL[P][CB],revsktR[CR][CB],revsoldR[CR][CB],revwE[C],
    revwL[P][CB],revwR[CR][CB],
    rf[4][NFAT],rfat,rp[4][NPROT],rs,
    sexrbf,sexrbm,sigmacwwL[SP][CB],sigmafat,sigmaprot,sigmaSCS,
    sigmawr[SP][CB],strawarL,strawE,strawfL,strawR,strawrL,
    subE,subR,surbs[SP][BS][CB],surfat[SP][LF][CB],
    surmlFP[CB],sw[SP][CB],swb[SP][CLT][CB],
    taveL[P][CB],
    Tcosts,TcostsE,TcostsR,tendL[P][CB],thfat[NFAT],thprot[NPROT],
    tmilkm,tmilkst,tmilkw,tmilkw0[NFS],tp[NFS],Tprof,Tprofh,Tprofl,Tprofm,
    Trev,TrevE,TrevR,tSCC[NSCC],tSCS[NSCC],Tsub,tv2h,tv2l,tv2m,tvh,tvl,tvm,twL[CLT][L],
    u,vcwr[SP][CB],vcwwL,
    vetarL,vetclFP,vetE,vetf[SP][LF],vetR,vetrL[BS],vetwL,vlf[SP][LF],
    warL[SP][CLT][CB],watE[C][FE][NFS],watlE[C][FE][NFS],watnlE[C][FE][NFS],
    watL[P][CB][FL][NFS],watL14m[CB][NFS],watL14nm[CB][NFS],
    watR[CR][CB][FR][NFS],
    wbR[R][CB],wgfE,wgfL,wlE[L],wlFP[BS],
    wmat[SP][CB],wnmat[SP][CB],woolptE,woolptR[CB],wP[P][CB],
    wpurMP[CB],wrL[SP][BS][CB],
    wshearL[SP][CB],wsheE,wshefL[SP][CB],wsheR[CB],wsherL[SP][CB],
    wshewL[SP][CB],wwL[SP][CLT][CB];
    
  double a,a1,aa1,l1E[C],l1R[CR],l1aR[CR][CB],l1_0[C],l3E[L],l4E[L],l4R[R],
    l5R[R][CB],Nlamb,sl1E,sl1R,te[C][C],tr[CR][CR];  
    
  zac = clock(); /* Start of measuring time for calculation */

/* Starting values */
  for (i = 0; i < C; i++) {plambE[i] = pnlambE[i] = costfE[i] = costwatE[i] = 
    dcE[i] = costvetE[i] = costlabE[i] = costsheE[i] = costfixE[i] = 
    costbedE[i] = costbreedE[i] = costskE[i] = costmarkE[i] = costdiedE[i] = 
    costmilkE[i] = costcheeseE[i] = costnfE[i] = revwE[i] = revcE[i] = 
    revmanE[i] = revskrE[i] = revsktE[i] = revmilkE[i] = revcheeseE[i] = 
    costE[i] = revE[i] = 0;
    qaveE[i] = qbreedE[i] = qendE[i] = qmilkE[i]= 1;
  }  
  for (i = 0; i < L; i++)
    pbarrE[i] = conrateE[i] = pcullE[i] = pdiedE[i] = ageE[i] = wlE[i] = 
    ktlp[i] = pcullhE[i] = pcullmE[i] = milkmpar[i] = milksw[i] = 
    avlitpE[i] = pconE[i] = pconstayE[i] = pcrossE[i] = pmatE[i] = 
    pnconE[i] = pnconstayE[i] = pnconculE[i] = 0;
  for (i = 0; i < CSP; i++) {
    for (j = 0; j < CB; j++)  {
      for (k = 0; k < SP; k++) nsp[k][i][j] = psp[k][i][j] = 0;
      }
    }
  for (i = 0; i < LF; i++) {
    for (j = 0; j < CB; j++) {  
      for (k = 0; k < SP; k++)
        kadgfat[k][i][j] = ndiedfat[k][i][j] = nfattar[k][i][j] = 
	surfat[k][i][j] = dresfL[k][i][j] = kdresfL[k][i][j] = 0;
      }
    }
  for (i = 0; i < R; i++) {
    pcullR[i] = pdiedR[i] = psoldR[i] = pstayR[i] = 0;
    for (j = 0; j < CB; j++) wbR[i][j] = ageR[i][j] = 0;
    }
  for (i = 0; i < BS; i++) {
    wlFP[i] = agelFP[i] = datconFP[i] = nendoprL[i] = nectoprL[i] = 
      vetrL[i] = nsherL[i] = nrmatFP[i] = 0;
    for (k = 0; k < SP; k++)
      ager[k][i] = pherd[k][i] = 0;  
    for (j = 0; j < CB; j++) {
      conrateFP[i][j] = nmatFP[i][j] = prconFP[i][j] = 
      cullbsMP[i][j] = kconrateFP[i][j] = 0;
      for (k = 0; k < SP; k++)
        kadgr[k][i][j] = adgr[k][i][j] = wrL[k][i][j] = nrcull[k][i][j] = 
	nrdied[k][i][j] = nsold[k][i][j] = nspcull[k][i][j] = 
	nspdied[k][i][j] = pmat[k][i][j] = psold[k][i][j] = surbs[k][i][j] = 0;  
      }
    }
  for (i = 0; i < LF; i++) {
    for (k = 0; k < SP; k++) clf[k][i] = ulf[k][i] = vlf[k][i] = nectopf[k][i] =
      nendopf[k][i] = vetf[k][i] = nshefL[k][i] = 0;
    }
  for (i = 0; i < CB; i++) {
    surmlFP[i] = nrdiedmlFP[i] = pherdyMP = pyoungMP[i] = pctE[i] = neweR[i] = 
    npurchMP[i] = nramMP[i] = mwE[i] = mwR[i] = agepurMP[i] = 
    wpurMP[i] = kmwRE[i] = adgR[i] = mwMP[i] = woolptR[i] = dwoolptR[i] = 
    pinsE[i] = costins[i] = costreins[i] = nsheR[i] = prbR[i] = pinsFP[i] = 
    dresR[i] = dresrL[i] = prwoolR[i] = wsheR[i] = prlwS[i] = prcwS[i] = 
    prskrR[i] = prsktR[i] = prwoolL[CB] = prlwwL[i] = prsbR[i] = 
    dreswL[i] = prlwfL[i] = prskrL[i] = prsktL[i] = ps13[i] = avclwL[i] = 
    avclfL[i] = avclS[i] = avfleshS[i] = avfcS[i] = avfleshfL[i] = avfcfL[i] = 
    prcwfL[i] = avcqwL[i] = avsur24hL[i] = avsurwL[i] = avsurarL[i] = 
    avfleshwL[i] = avfcwL[i] = avfleshL[i] = favfL[i] = favwL[i] = avfcL[i] = 
    Na24hL[i] = NarL[i] = NbtL[i] = prcwbwL[i] = pwrepFP[i] = prcwwL[i] =  0;
    for (k = 0; k < SP; k++) {
      k0[k][i] = minw[k][i] = nwsp[k][i] = sigmawr[k][i] = 
      wmat[k][i] = wnmat[k][i] = vcwr[k][i] = kwarL[k][i] = kwrL[k][i] = 
      kwwL[k][i] = wshearL[k][i] = wsherL[k][i] = wshewL[k][i] = 0;
      for (j = 0; j < NCLCW; j++) {
        pclcwwL[k][j][i] = 0;
	for (i2 = 0; i2 < NCLCQ; i2++) pclcwL[k][j][i2][i] = 0;
	}
      }
    for (k = 0; k < CLT; k++) {
      na24hL[k][j] = narL[k][j] = nbtL[k][j] = nwL[k][j] = pdiedbL[j][k] = 
      pdiedwL[j][k] = pdiedarL[j][k] = 0;
      }  
    for (k = 0; k < BS; k++) {
      pbarrFP[k][i] = 0;
      }  
    }
  for (i = 0; i < CLT; i++) {
    ktlsl[i] = 0;
    for (j = 0; j < CLT; j++) pdiedbtL[i][j] = pbtba[i][j] = 0;
    for (j = 0; j < CB; j++) {
      pwL[i][j] = parL[i][j] = 0;
      for (k = 0; k < SP; k++)
        adgbwL[k][i][j] = bwL[k][i][j] = adgb[k][i][j] = swb[k][i][j] = 
	adgwarL[k][i][j] = wwL[k][i][j] = warL[k][i][j] = kadgbw[k][i][j] = 
	kadgwar[k][i][j] = kbw[k][i][j] = 0;
      }
    for (j = 0; j < L; j++) {
      Pltype[i][j] = PsuckE[i][j] = milkwrel[i][j] = 
      milkmrel[i][j] = twL[i][j] = 0;  
      for (k = 0; k < NFS; k++) milkwsrel[i][j][k] = milkws[i][j][k] = 0;
      }
    for (k = 0; k < NFS; k++) milkwL[i][k] = nelwL[i][k] = pdilwL[i][k] = 0;  
    }
  for (i = 0; i < NCHFS; i++) datchfs[i] = valfs[i] = 0;  
  for (i = 0; i < NFS; i++)    
    tp[i] = techE[i] = techbL[i] = techfatL[i] = nd[i] = basemilkws[i] = 
    tmilkw0[i] = milkw0L[i] = 0;  
  for (i = 0; i < CR; i++) {
    dcR[i] = 0;
    for (j = 0; j < CB; j++) {  
      costfR[i][j] = costwatR[i][j] = costvetR[i][j] = costlabR[i][j] = 
      costsheR[i][j] = costfixR[i][j] = costbedR[i][j] = costmarkR[i][j] =
      costskR[i][j] = costdiedR[i][j] = costpurchR[i][j] = costnfR[i][j] = 
      costR[i][j] = revwR[i][j] = revcR[i][j] = revskrR[i][j] = 
      revsktR[i][j] = revmanR[i][j] = revsoldR[i][j] = revR[i][j] = l1aR[i][j] 
      = 0;
      qaveR[i][j] = qendR[i][j] = 1;
      for (k = 0; k < FR; k++) {    
        for (i2 = 0; i2 < NFS; i2++)    
          newR[i][j][k][i2] = negR[i][j][k][i2] = nemR[i][j][k][i2] =
	  neR[i][j][k][i2] = pdiwR[i][j][k][i2] = pdigR[i][j][k][i2] =
	  pdimR[i][j][k][i2] = pdiR[i][j][k][i2] = feR[i][j][k][i2] = 
	  fpdiR[i][j][k][i2] = ffR[i][j][k][i2] = watR[i][j][k][i2] = 0;
        }
      }
    } 
  for (i = 0; i < FR; i++) {    
    for (j = 0; j < NFS; j++) drymR[i][j] = nedR[i][j] = pdidR[i][j]
      = lossfR[i][j] = prfR[i][j] = dwatR[i][j] = 0;   
    }
  for (i = 0; i < C; i++) {
    for (k = 0; k < FE; k++) {    
      for (i2 = 0; i2 < NFS; i2++) {   
        newlE[i][k][i2] = pdiwlE[i][k][i2] = neglE[i][k][i2] = 
	pdiglE[i][k][i2] = nemlE[i][k][i2] = pdimlE[i][k][i2] = 
        newnlE[i][k][i2] = pdiwnlE[i][k][i2] = negnlE[i][k][i2] = 
	pdignlE[i][k][i2] = nemnlE[i][k][i2] = pdimnlE[i][k][i2] = 
	nepE[i][k][i2] = pdipE[i][k][i2] = nefE[i][k][i2] = 
	pdifE[i][k][i2] = nelE[i][k][i2] = pdilE[i][k][i2] =
	neE[i][k][i2] = pdiE[i][k][i2] = feE[i][k][i2] = ffE[i][k][i2] =
	fpdiE[i][k][i2] = watlE[i][k][i2] = watnlE[i][k][i2] = 
	watE[i][k][i2] = 0;
	for (j = 0; j < CLT; j++) 
	  nepbE[j][i][k][i2] = pdipbE[j][i][k][i2] = nelbE[j][i][k][i2] = 
	  pdilbE[j][i][k][i2] = pdimbE[j][i][k][i2] = 0;
	}
      }
    } 
  for (i = 0; i < HS; i++) ktE[i] = ktL[i] = 0;
  for (i = 0; i < FE; i++) {    
    for (j = 0; j < NFS; j++) drymE[i][j] = nedE[i][j] = pdidE[i][j]
      = lossfE[i][j] = prfE[i][j] = dwatE[i][j] = 0;   
    }
  for (i = 0; i < P; i++) {
    qbreedL[i] = 1;
    for (j = 0; j < CB; j++) {  
      costfL[i][j] = costwatL[i][j] = wP[i][j] = dcL[i][j] = costvetL[i][j] = 
        costlabL[i][j] = costsheL[i][j] = costfixL[i][j] = costbedL[i][j] = 
	costbreedL[i][j] = costskL[i][j] = costmarkL[i][j] = costdiedL[i][j] = 
	costnfL[i][j] = costL[i][j] = prsbL[i][j] = revwL[i][j] = revcL[i][j] = 
	revskrL[i][j] = revsktL[i][j] = revmanL[i][j] = revsbL[i][j] = 
	revL[i][j] = agetP[i][j] = adgP[i][j] = l1skL[i][j] = taveL[i][j] = 
	tendL[i][j] = 0;
      qaveL[i][j] = qendL[i][j] = 1;	
      for (k = 0; k < CLT; k++) l1L[i][j][k] = 0;	
      for (k = 0; k < FL; k++) {    
        for (i2 = 0; i2 < NFS; i2++) {
	  neL[i][j][k][i2] = pdiL[i][j][k][i2] = feL[i][j][k][i2] = 
	  ffL[i][j][k][i2] = fpdiL[i][j][k][i2] =
	  newL[i][j][k][i2] = negL[i][j][k][i2] = nemL[i][j][k][i2] = 
	  pdigL[i][j][k][i2] = pdimL[i][j][k][i2] = pdiwL[i][j][k][i2] = 
	  nepL[i][j][k][i2] = pdipL[i][j][k][i2] = nefL[i][j][k][i2] = 
	  pdifL[i][j][k][i2] = watL[i][j][k][i2] = 0;
	  for (j1 = 0; j1 < CLT; j1++)
	    newbL[j1][i][j][k][i2] = negbL[j1][i][j][k][i2] =
	    nembL[j1][i][j][k][i2] = pdigbL[j1][i][j][k][i2] = 
	    pdimbL[j1][i][j][k][i2] = pdiwbL[j1][i][j][k][i2] = 
	    nebL[j1][i][j][k][i2] = pdibL[j1][i][j][k][i2] = 
	    nepbL[j1][i][j][k][i2] = pdipbL[j1][i][j][k][i2] = 0;
	  }   
        }
      }
    } 
  for (i = 0; i < SP; i++) {
    c1[i] = c2[i] = c3[i] = c4[i] = c5[i] = c6[i] = lf[i] = csp[i] = 
    Pherd[i] = costmarkrL[i] = bs[i] = nherd[i] = 0; 
    for (j = 0; j < CB; j++) adg[i][j] = sw[i][j] = dwoolptrL[i][j] = 
      wshefL[i][j] = wsherL[i][j] = mcwwL[i][j] = sigmacwwL[i][j] = 
      prcwawL[i][j] = wshewL[i][j] = wshearL[i][j] = prcwcwL[i][j] = 
      avwar[i][j] = avww[i][j] = kwfL[i][j] = 0; 
    }	
  for (i = 0; i < FL; i++) {    
    for (j = 0; j < NFS; j++) drymL[i][j] = nedL[i][j] = pdidL[i][j]
      = lossfL[i][j] = prfL[i][j] = dwatL[i][j] = 0;   
    }
  for (i = 0; i < CB; i++) {    
    for (j = 0; j < NFS; j++) 
      negL14m[i][j] = negL14nm[i][j] = nemL14m[i][j] = nemL14nm[i][j] = 
      newL14m[i][j] = newL14nm[i][j] = pdigL14m[i][j] = pdigL14nm[i][j] = 
      pdimL14m[i][j] = pdimL14nm[i][j] = pdiwL14m[i][j] = pdiwL14nm[i][j] = 
      watL14m[i][j] = watL14nm[i][j] = 0;
    }
  for (i = 0; i < NCL; i++) {
    prclS[i] = prclwL[i] = prclfL[i] = 0;   
    for (j = 0; j < CB; j++) pclS[j][i] = pclwL[j][i] = pclfL[j][i] = 0;
    }
  for (i = 0; i < NCLFL; i++) {  
    for (j = 0; j < NCLFC; j++) {
      prclfcS[i][j] = prclfcfL[i][j] = prclfcwL[i][j] = 0;
      for (k = 0; k < CB; k++) 
        pclfcS[k][i][j] = pclfcfL[k][i][j] = pclfcwL[k][i][j] = 0;
      }
    }
  for (i = 0; i < NCLCW; i++) {
    PhicwL[i] = 0;    
    for (j = 0; j < NCLCQ; j++) {
      prclcwwL[i][j] = 0;
      for (k = 0; k < CB; k++) pclcqwL[i][j][k] = 0;
      }
    }
  for (i = 0; i < NFAT; i++) {
    thfat[i] = prmilkf[i] = 0;
    for (j = 0; j < 4; j++) rf[j][i] = 0;
    }
  for (i = 0; i < NPROT; i++) {
    thprot[i] = prmilkp[i] = 0;  
    for (j = 0; j < 4; j++) rp[j][i] = 0;    
    }
  for (i = 0; i < NSCC; i++) pSCC[i] = tSCC[i] = prSCC[i] = facSCC[i] = 
    tSCS[i] = Phiscc[i] = 0;  
  for (i = 0; i < N; i++) {
    pclwLqm[i] = pclwLql[i] = pt[i] = pf0[i] = pf[i] = pcl0[i] = qcl0[i] = 
    pf1[i] = 0;
    for (j = 0; j < N; j++) pcl00[i][j] = pcl11[i][j] = 0;
    } 
  for (i = 0; i < NT; i++) {    
    for (j = 0; j < CB; j++) ev[i][j] = ev0[i][j] = evdiff[i][j] = 
      evp[i][j] = 0;   
    }
    
  agearL = agewL = breed = calc = clt = crossing = cy = datbbs = datdry = 
  datebs = datlamb = datwL = dmilkst = dnpregcE = dselR = dshpE = errmess = 
  ewopt = fatcb = fatpb = 
  fE = feedcost = femrep =  fL = flushabE = flushabL = flushbbE = flushbbL = 
  flushbbR = fR = hs = i = i1 = i2 = i3 = icb = ilcb = ilpb = ipb = iscb = ispb =
  j = j1 = ja = jb = k = k1 = k2 = k3 = k4 = k5 = k6 = k7 = kE = kR = lengthmp =
  lengthrc = LL =  lpreg = milkprice = n2 = nchfs = nchfst = nclfL = nclcwwL =
  nclcqwL = nclfcfL = nclfcS = nclfcwL = nclflfL = nclflS = nclflwL = nclS =
  nclwL = nfat = nfs  = nprot = nreins = nSCC =  nsl = nstg1E = nstg1R = nstg2E
  = nstg2R = nstgE  = nstgR =  opsbL = placE = PP = prods = RR = TE = pricefL =
  priceS = pricewL = TR = trait =  typeb = typew = z1 = z2 = zr = zz = 0; 
  a2 = a3 = a4 = ach = adgE = 
  adgfE = adgfL =  AkharL = AkhE = AkhfL = AkhR = AkhrL = avconrateE =  avlifelE
  = avlifeyE =  avlitE = avmilkd = awo = basemilkm = basemilkw = bch = casprot =
  cch = cheesewhey = cheesey = coninsE = costAkh = costcheese0E = costdead =
  costfix0E = costfix0R = costfixarL = costfixfL =  costfixrL = costlamb = 
  costmarkbR = costmarkcul = costmarkfL =  costmarkwL =  costmilk0E = costoeinE =
  costoeinFP = costpurchFP =  costshe0E = costshe0R = costshe0L = cwo = dnpregcFP = dpregsFP = dresE =  dwoolptarL = dwoolptE = dwoolptwL =  fat =
  fatch = fatymst = fdm = intlm = intml = hetmw =  kdif =  kdresEL = kdresER =
  kdresRL =  kmilkcE = kwE = manarL = manbL = manE = manfL = manR =  milkch =
  moich = mSCS =  nectoparL = nectopclFP = nectopE = nectopR = nectopwL =  nemilk
  =  nendoparL = nendopclFP = nendopE = nendopR = nendopwL =  npurchFP =  nshearL
  = nsheFP = nshewL = nsoldMPA = pcastMP =  pcullfcE0 = pcullfcEp =  pcullhE0 = 
  pcullhEp = pcullmE0 = pcullmEp =  pdA = pdB = 
  pdiedE0 = pdiedEp =  pdimilk =  pherdyMP = pmilkch = pmilkwm = 
  ppurchFP = ppurchMP = prcheese =  prectop =
  prendop =  prlwS0 = prman = prmilk = prmilkb = prmilkfp
  = profsub = profnsub = prot = protymst = prreffL = prrefS = prrefwL =  prscc
  = prskrE =  prsktE = prstraw = prwat = prwhey = prwoolE = pskarL = pskE =
  pskfL = pskR = pskrL = pskwL =  ptskarL = ptskE = ptskfL = ptskR = ptskrL =
  ptskwL = pwrepMP =  ratiooldR = ratioR = ratioyoungR = rcas = rfat = rs =
  sexrbf = sexrbm = sigmafat = sigmaprot = sigmaSCS = strawarL = strawE =
  strawfL = strawR = strawrL =  subE = subR =  Tcosts = TcostsE = TcostsR = 
  tmilkm = tmilkst = tmilkw = Tprof = Tprofh = Tprofl = Tprofm =  Trev = TrevE =
  TrevR = Tsub = tv2h = tv2l = tv2m = tvh = tvl = tvm = u = vcwwL =  vetarL =
  vetclFP = vetE = vetR = vetwL =  wgfE = wgfL = woolptE = wsheE = 0.0;
  qpurchR = 1.0;
         
/* Parameters with fixed values */
  trait = 0;
  zr = 1;
  zz = 0;
  lengthrc = 365;
  nstg1E = 3;
  nstg2E = 2;
  nstgE = nstg1E + nstg2E;
  bs[1] = 3;
  bs[2] = 2;
  nstg1R = 3;
  nstg2R = 1;
  nstgR = nstg1R + nstg2R;
  PP = 48;
  sexrbf = sexrbm = 0.5;
  fR = 2;
  fE = 5;
  hs = 3;
  fL = 20; 
  nclcwwL = 3;
  nclcqwL = 2;
    
Part_01:  
  printf("\nRunning EWSH2 Version 1.0.2, 2010\n"); 
  printf("Authors: Jochen Wolf (wolf.jochen@vuzv.cz)\n");
  printf("         Marie Wolfova (wolfova.marie@vuzv.cz)\n");
  printf("         Zuzana Krupova (krupova@cvzv.sk)\n");
  printf("         Emil Krupa (krupa@cvzv.sk)\n"); 

  /* Reading the file ERROR.TXT */
  fr = fopen("ERROR.TXT", "r");
  fscanf(fr, "%d", &errmess);
  close(fr);
  if (errmess == 1) {
    printf("\nError message:\n");
    printf("Program was stopped because there was an error message in one of the\n"); 
    printf("  preceding programs.\n\n");    
    goto END;  
  }
  /* Writing the head of the output file */
  fr2 = fopen("TEXTS2_OUT.TXT", "r"); /* File for reading text for output */
  fr = fopen("P00.TXT", "r"); /* File for reading control parameters */
  fscanf(fr, "%d", &prods);
  fscanf(fr, "%d", &breed);
  fscanf(fr, "%d", &calc);
  close(fr);
  if (breed == 1 && calc == 1) fw = fopen("resA01", "w"); /* File for writing results */  
  if (breed == 1 && calc == 2) fw = fopen("resA02", "w"); 
  if (breed == 1 && calc == 3) fw = fopen("resA03", "w");   
  if (breed == 2 && calc == 1) fw = fopen("resB01", "w");
  if (breed == 2 && calc == 4) fw = fopen("resB04", "w");
  outputrw(fr2, fw);
  fprintf(fw, "%3d", prods);
  outputrw(fr2, fw);
  if (breed == 1) fprintf(fw, "  A");
  if (breed == 2) fprintf(fw, "  B");
  outputrw(fr2, fw);
  fprintf(fw, "%3d\n", calc);
  if (breed == 1) outputrw(fr2, fw);
  else outputr(fr2);
  if (breed == 2) outputrw(fr2, fw);
  else outputr(fr2);
  /* Parameters crossing and ewopt */
  if (prods == 1) {
    crossing = 1;
    ewopt = 0; 
  }  
  if (prods == 2 && breed == 1) {
    crossing = 1;
    ewopt = 0;
  }  
  if (prods == 2 && breed == 2) {
    crossing = 2;
    ewopt = 2;
  }

  /* Reading parameter file PARAS.TXT and writing its information to output file */
  if (breed == 1) fr = fopen("PARASA.TXT", "r");
  if (breed == 2) fr = fopen("PARASB.TXT", "r");
  outputrw(fr, fw);
  sysvar(fr, fw);
  fclose(fr);  
  if (breed == 1) fr = fopen("PARASA.TXT", "r");
  if (breed == 2) fr = fopen("PARASB.TXT", "r");
  printf("\nI am working\nReading data from PARAS.TXT\n");
  outputr(fr);
  typew = readsyva(fr);
  lf[1] = readsyva(fr);
  lf[2] = readsyva(fr);
  lf[0] = readsyva(fr);
  typeb = readsyva(fr);
  feedcost = readsyva(fr);
  femrep = readsyva(fr);
  fclose(fr);  
  if (typew > 2 || typew < 1) {
    nonsense08(breed,1);
    errmess = 1;
    goto END;
  }  
  if (lf[1] > 5 || lf[1] < 0) {
    nonsense08(breed,3);
    errmess = 1;
    goto END;
  }  
  if (lf[2] > 5 || lf[2] < 0) {
    nonsense08(breed,4);
    errmess = 1;
    goto END;
  }  
  if (lf[0] > 5 || lf[0] < 0) {
    nonsense08(breed,5);
    errmess = 1;
    goto END;
  }  
  if (typeb > 3 || typeb < 1) {
      nonsense08(breed,6);
      errmess = 1;
      goto END;
    }  
  if (feedcost > 2 || feedcost < 1) {
      nonsense08(breed,7);
      errmess = 1;
      goto END;
    }  
  if (femrep > 2 || femrep < 1) {
      nonsense08(breed,8);
      errmess = 1;
      goto END;
    }  
  outputrw(fr2, fw);
  
  /* Calculation of parameters from the data in the parameter file */
  csp[0] = lf[0];
  csp[1] = 2 + lf[1];
  csp[2] = 3 + lf[2];

  /* Reading input file INPUTGFS03.TXT and writing the data from this file 
     to the results file. This file is read only for production system 2 with
     breeds A and B and terminal crossing. */
  if (prods == 2 && calc == 1) {
    printf("Reading data from INPUTGFS03.TXT\n");   
    outputrw(fr2, fw);
    fr = fopen("INPUTGFS03.TXT", "r");
    readcom(fr);
    pdA = readfloat(fw,fr);
    pdB = readfloat(fw,fr);
    fprintf(fw, "\n\n");
    fclose(fr);  
  }  
  else outputr(fr2);
    
  /* Reading input file INPUTS01.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS01A.TXT\n"); 
  if (breed == 2) printf("Reading data from INPUTS01B.TXT\n");   
  n2 = 1;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS01A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS01B.TXT", "r");
  readcom(fr);
  fscanf(fr, "%d", &LL);
  if (LL > 15 || LL < 4) {
    nonsense01(breed);
    errmess = 1;
    goto END;
  }  
  wrides(fr,fw);
  fprintf(fw, "%2d", LL);
  for (i = 1; i <= LL; i++) fscanf(fr, "%f", &pdiedE[i]);
  wrides(fr,fw);
  for (i = 1; i <= LL; i++) fprintf(fw, "%8.4f", pdiedE[i]);
  if (typeb == 1) {
    for (i = 1; i <= LL; i++) fscanf(fr, "%f", &pcullmE[i]);
    wrides(fr,fw);
    for (i = 1; i <= LL; i++) fprintf(fw, "%8.4f", pcullmE[i]);
  }
  else readdes(fr); 
  for (i = 1; i <= LL; i++) fscanf(fr, "%f", &pcullhE[i]);
  wrides(fr,fw);
  for (i = 1; i <= LL; i++) fprintf(fw, "%8.4f", pcullhE[i]);
  for (i = 1; i < LL; i++) fscanf(fr, "%f", &conrateE[i]);
  wrides(fr,fw);
  for (i = 1; i < LL; i++) fprintf(fw, "%8.4f", conrateE[i]);
  for (i = 1; i < LL; i++) fscanf(fr, "%f", &pbarrE[i]);
  wrides(fr,fw);
  for (i = 1; i < LL; i++) fprintf(fw, "%8.4f", pbarrE[i]);
  if (crossing == 2) {
    pcrossE[0] = readfloat(fw,fr);  
    for (i = 1; i < LL; i++) fscanf(fr, "%f", &pcrossE[i]);
    wrides(fr,fw);
    for (i = 1; i < LL; i++) fprintf(fw, "%6.3f", pcrossE[i]);
  }
  else for (i = 1; i <= 2; i++) readdes(fr);
  readcom(fr);    
  datlamb = readymd(fr,fw);
  if (datlamb < 0) { 
    nonsense30(breed,1);
    errmess = 1;
    goto END;
  }
  datwL = readymd(fr,fw);
  if (datwL < 0) { 
    nonsense30(breed,2);
    errmess = 1;
    goto END;
  }
  datbbs = readymd(fr,fw);
  if (datbbs < 0) { 
    nonsense30(breed,3);
    errmess = 1;
    goto END;
  }
  datebs = readymd(fr,fw);
  if (datebs < 0) { 
    nonsense30(breed,4);
    errmess = 1;
    goto END;
  }
  if (typeb == 1) {
    datdry = readymd(fr,fw);
    if (datdry < 0) { 
      nonsense30(breed,5);
      errmess = 1;
      goto END;
    }
  }
  else readdes(fr);
  u = readfloat(fw,fr);  
  fclose(fr); /* End of reading INPUTS01.TXT */
  fprintf(fw, "\n\n\n");

  /* Reading input file INPUTS02.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS02A.TXT\n"); 
  if (breed == 2) printf("Reading data from INPUTS02B.TXT\n"); 
  n2 = 2;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS02A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS02B.TXT", "r");
  readcom(fr);
  fscanf(fr, "%d", &RR);
  if (RR > 5 || RR < 1) {
    nonsense05(breed);
    errmess = 1;
    goto END;
  }  
  wrides(fr,fw);
  fprintf(fw, "%2d", RR);
  for (i = 1; i <= RR; i++) fscanf(fr, "%f", &pdiedR[i]);
  wrides(fr,fw);
  for (i = 1; i <= RR; i++) fprintf(fw, "%8.3f", pdiedR[i]);
  for (i = 1; i <= RR; i++) fscanf(fr, "%f", &psoldR[i]);
  wrides(fr,fw);
  for (i = 1; i <= RR; i++) fprintf(fw, "%8.3f", psoldR[i]);
  for (i = 1; i <= RR; i++) fscanf(fr, "%f", &pcullR[i]);
  wrides(fr,fw);
  for (i = 1; i <= RR; i++) fprintf(fw, "%8.3f", pcullR[i]);
  a2 = pdiedR[RR] + pcullR[RR] + psoldR[RR];
  if (a2 > 1.000001 || a2 < 0.999999) {
    nonsense06(breed);
    errmess = 1;
    goto END;
  }  
  fclose(fr); /* End of reading INPUTS02.TXT */
  fprintf(fw, "\n\n\n");

  /* Reading input file INPUTS03.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS03A.TXT\n");
  if (breed == 2) printf("Reading data from INPUTS03B.TXT\n");  
  n2 = 3;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS03A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS03B.TXT", "r");
  readcom(fr);
  fscanf(fr, "%d", &clt);
  if (clt > 5 || clt < 1) {
    nonsense02(breed);
    errmess = 1;
    goto END;
  }  
  wrides(fr,fw);
  fprintf(fw, "%2d", clt);
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++) fscanf(fr, "%f", &Pltype[i][j]);
    }
  a2 = 0;
  for (j = 1; j <= LL; j++) a2 += Pltype[clt][j]; 
  if (a2 < 0.000001) {  
      nonsense25(breed);
      errmess = 1;
      goto END;
    }
  for (j = 1; j <= LL; j++) {
    a2 = 0;
    for (i = 1; i <= clt; i++) a2 += Pltype[i][j];
    if (a2 < 0.99999 || a2 > 1.00001) {
      nonsense19(breed,j);
      errmess = 1;
      goto END;
    }
  }
  wrides(fr,fw);
  fprintf(fw, "\n");
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++) fprintf(fw, "%8.3f", Pltype[i][j]);
    fprintf(fw, "\n");
    }
  for (i = 1; i <= clt; i++) {
    pdiedbL[i][1] = 0;
    for (j = 1; j <= i; j++) {
      fscanf(fr, "%f", &pdiedbtL[i][j]);
      pdiedbL[i][1] += pdiedbtL[i][j];
      }
    }
  wrides(fr,fw);
  fprintf(fw, "\n");
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= i; j++) fprintf(fw, "%8.3f", pdiedbtL[i][j]);
    fprintf(fw, "\n");
    }
  for (i = 1; i <= clt; i++) fscanf(fr, "%f", &pdiedwL[i][1]);
  wrides(fr,fw);
  for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", pdiedwL[i][1]);
  if (typew == 1) readdes(fr);
  if (typew == 2) {
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &pdiedarL[i][1]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", pdiedarL[i][1]);
    }
  for (i = 1; i <= clt; i++) fscanf(fr, "%f", &bwL[1][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", bwL[1][i][1]);
  for (i = 1; i <= clt; i++) fscanf(fr, "%f", &bwL[2][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", bwL[2][i][1]);
  for (i = 1; i <= clt; i++) fscanf(fr, "%f", &wwL[1][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", wwL[1][i][1]);
  for (i = 1; i <= clt; i++) fscanf(fr, "%f", &wwL[2][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", wwL[2][i][1]);
  if (crossing == 1) for (i = 1; i <= 4; i++) readdes(fr);
  if (crossing == 2) {
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &bwL[1][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", bwL[1][i][2]);
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &bwL[2][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", bwL[2][i][2]);
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &wwL[1][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", wwL[1][i][2]);
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &wwL[2][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", wwL[2][i][2]);
    }
  if (typew == 1) for (i = 1; i <= 4; i++) readdes(fr);
  if (typew == 2) {
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &warL[1][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", warL[1][i][1]);
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &warL[2][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", warL[2][i][1]);
    if (crossing == 1) for (i = 1; i <= 2; i++) readdes(fr);
    if (crossing == 2) {
      for (i = 1; i <= clt; i++) fscanf(fr, "%f", &warL[1][i][2]);
      wrides(fr,fw);
      for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", warL[1][i][2]);
      for (i = 1; i <= clt; i++) fscanf(fr, "%f", &warL[2][i][2]);
      wrides(fr,fw);
      for (i = 1; i <= clt; i++) fprintf(fw, "%8.3f", warL[2][i][2]);
      }
    }
  if (typew == 1) readdes(fr);
  if (typew == 2) agearL = readint(fw,fr);
  fclose(fr);  /* End of reading INPUTS03.TXT */
  fprintf(fw, "\n\n\n");
  if (crossing == 2) {
    for (i = 1; i <= clt; i++) {
      pdiedbL[i][2] = pdiedbL[i][1];
      pdiedwL[i][2] = pdiedwL[i][1];
      pdiedarL[i][2] = pdiedarL[i][1];
    }
  }    
  /* Reading input file INPUTS05.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS05A.TXT\n");     
  if (breed == 2) printf("Reading data from INPUTS05B.TXT\n");         
  n2 = 5;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS05A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS05B.TXT", "r");
  readcom(fr); 
  for (i = 1; i <= csp[1]; i++) fscanf(fr, "%f", &psp[1][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= csp[1]; i++) fprintf(fw, "%8.3f", psp[1][i][1]);
    a2 = 0;
    for (i = 1; i <= csp[1]; i++) a2 += psp[1][i][1];
    if (a2 > 1.000001 || a2 < 0.999999) {
      nonsense11(breed,1,1);
      errmess = 1;
      goto END;
    } 
  if (crossing == 2) {  
    for (i = 1; i <= csp[1]; i++) fscanf(fr, "%f", &psp[1][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= csp[1]; i++) fprintf(fw, "%8.3f", psp[1][i][2]);
      a2 = 0;
      for (i = 1; i <= csp[1]; i++) a2 += psp[1][i][2];
      if (a2 > 1.000001 || a2 < 0.999999) {
	nonsense11(breed,2,1);
	errmess = 1;
	goto END;
      }  
    }
    else readdes(fr); 
  for (i = 1; i <= csp[2]; i++) fscanf(fr, "%f", &psp[2][i][1]);
  if (prods == 2 && breed == 1 && calc == 3) {
    fr1 = fopen("TRANSFER02.TXT", "r");
    for (i = 1; i <= csp[2]; i++) fscanf(fr1, "%f", &psp[2][i][1]);
    close(fr1);
  }
  wrides(fr,fw);
  for (i = 1; i <= csp[2]; i++) fprintf(fw, "%8.5f", psp[2][i][1]);
    a2 = 0;
    for (i = 1; i <= csp[2]; i++) a2 += psp[2][i][1];
    if (a2 > 1.00001 || a2 < 0.99999) {
      nonsense11(breed,1,2);
      errmess = 1;
      goto END;
    }  
  if (crossing == 2) {  
    for (i = 1; i <= csp[2]; i++) fscanf(fr, "%f", &psp[2][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= csp[2]; i++) fprintf(fw, "%8.3f", psp[2][i][2]);
      a2 = 0;
      for (i = 1; i <= csp[2]; i++) a2 += psp[2][i][2];
      if (a2 > 1.000001 || a2 < 0.999999) {
	nonsense11(breed,2,2);
	errmess = 1;
	goto END;
      }  
    }
    else readdes(fr);  
  ps13[1] = readfloat(fw,fr);
  if (crossing == 2) ps13[2] = readfloat(fw,fr);
    else readdes(fr);  
  readcom(fr);
  if (lf[1] >= 1) {
    for (i = 1; i <= lf[1]; i++) fscanf(fr, "%d", &ulf[1][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[1]; i++) fprintf(fw, "%3d", ulf[1][i]);
    for (i = 1; i <= lf[1]; i++) fscanf(fr, "%f", &vlf[1][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[1]; i++) fprintf(fw, " %6.1f", vlf[1][i]);  
    for (i = 1; i <= lf[1]; i++) fscanf(fr, "%d", &clf[1][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[1]; i++) fprintf(fw, "%3d", clf[1][i]);
    if (crossing == 1) {
      for (i = 1; i <= lf[1]; i++) {
	if (clf[1][i] == 0 || clf[1][i] == 2) {
	nonsense18(breed,1);
	errmess = 1;
	goto END;
	}  
      }
    }
    fprintf(fw, "\n**********\n"); 
    fprintf(fw, "For checking the correctness of your input data:\n");
    for (i = 1; i <= lf[1]; i++) {
      fprintf(fw, "  Target %d for fattening of female progeny is", i);
      if(ulf[1][i] == 1) fprintf(fw, "%6.1f kg,\n", vlf[1][i]); 
      if(ulf[1][i] == 2) fprintf(fw, "%6.1f days,\n", vlf[1][i]); 
      fprintf(fw, "     target %d is for", i);
      if(clf[1][i] == 0) fprintf(fw, " pure-bred and cross-bred progeny.\n");
      if(clf[1][i] == 1) fprintf(fw, " pure-bred progeny.\n");
      if(clf[1][i] == 2) fprintf(fw, " cross-bred progeny.\n"); 
      }
    fprintf(fw, "**********\n");       
    } 
    else for (i = 1; i <= 3; i++) readdes(fr); 
  if (lf[1] >= 1) {
    for (i = 1; i <= lf[1]; i++) {
      if ((clf[1][i] == 0 || clf[1][i] == 1) && psp[1][i+2][1] < 0.000001) {
        nonsense21(breed,i,1,1);
	errmess = 1;
	goto END;
	}
      if (clf[1][i] == 2 && psp[1][i+2][1] > 0.000001) {
        nonsense21(breed,i,1,1);
	errmess = 1;
	goto END;
	}
      if ((clf[1][i] == 0 || clf[1][i] == 2) && psp[1][i+2][2] < 0.000001) {
        nonsense21(breed,i,2,1);
	errmess = 1;
	goto END;
	}
      if (clf[1][i] == 1 && psp[1][i+2][2] > 0.000001) {
        nonsense21(breed,i,2,1);
	errmess = 1;
	goto END;
      }	
    }
  }
  if (lf[1] >= 1) {
    for (i = 1; i <= lf[1]; i++) {
      fscanf(fr, "%f", &adgP[i+7][1]);
      if (clf[1][i] < 2 && adgP[i+7][1] < 0.000001) {
	nonsense26(breed,i,1,1);
	errmess = 1;
	goto END;
        }
      }	
    wrides(fr,fw);
    for (i = 1; i <= lf[1]; i++) fprintf(fw, "%8.3f", adgP[i+7][1]);
    if (crossing == 2) {  
      for (i = 1; i <= lf[1]; i++) {
        fscanf(fr, "%f", &adgP[i+7][2]);
	if ((clf[1][i] == 0 || clf[1][i] == 2)&& adgP[i+7][2] < 0.000001) {
	  nonsense26(breed,i,2,1);
	  errmess = 1;
	  goto END;
          }
	}    
      wrides(fr,fw);
      for (i = 1; i <= lf[1]; i++) fprintf(fw, "%8.3f", adgP[i+7][2]);
      }
      else readdes(fr);
    for (i = 1; i <= lf[1]; i++) fscanf(fr, "%f", &surfat[1][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= lf[1]; i++) fprintf(fw, "%8.3f", surfat[1][i][1]);
    if (crossing == 2) { 
      for (i = 1; i <= lf[1]; i++) fscanf(fr, "%f", &surfat[1][i][2]);
      wrides(fr,fw);
      for (i = 1; i <= lf[1]; i++) fprintf(fw, "%8.3f", surfat[1][i][2]);  
      }
      else readdes(fr);  
    }
    else for (i = 1; i <= 4; i++) readdes(fr);
  readcom(fr);     
  if (lf[2] >= 1) {
    for (i = 1; i <= lf[2]; i++) fscanf(fr, "%d", &ulf[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[2]; i++) fprintf(fw, "%3d", ulf[2][i]);
    for (i = 1; i <= lf[2]; i++) fscanf(fr, "%f", &vlf[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[2]; i++) fprintf(fw, " %6.1f", vlf[2][i]);  
    for (i = 1; i <= lf[2]; i++) fscanf(fr, "%d", &clf[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[2]; i++) fprintf(fw, "%3d", clf[2][i]);
    if (crossing == 1) {
      for (i = 1; i <= lf[2]; i++) {
	if (clf[2][i] == 0 || clf[2][i] == 2) {
	nonsense18(breed,2);
	errmess = 1;
	goto END;
	}  
      }
    }
    fprintf(fw, "\n**********\n"); 
    fprintf(fw, "For checking the correctness of your input data:\n");
    for (i = 1; i <= lf[2]; i++) {
      fprintf(fw, "  Target %d for fattening of male progeny is", i);
      if(ulf[2][i] == 1) fprintf(fw, "%6.1f kg,\n", vlf[2][i]); 
      if(ulf[2][i] == 2) fprintf(fw, "%6.1f days,\n", vlf[2][i]); 
      fprintf(fw, "     target %d is for", i);
      if(clf[2][i] == 0) fprintf(fw, " pure-bred and cross-bred progeny.\n");
      if(clf[2][i] == 1) fprintf(fw, " pure-bred progeny.\n");
      if(clf[2][i] == 2) fprintf(fw, " cross-bred progeny.\n"); 
      }
    fprintf(fw, "**********\n");       
    } 
    else for (i = 1; i <= 3; i++) readdes(fr); 
  if (lf[2] >= 1) {
    for (i = 1; i <= lf[2]; i++) {
      if ((clf[2][i] == 0 || clf[2][i] == 1) && psp[2][i+3][1] < 0.000001) {
        nonsense21(breed,i,1,2);
	errmess = 1;
	goto END;
	}
      if (clf[2][i] == 2 && psp[2][i+3][1] > 0.000001) {
        nonsense21(breed,i,1,2);
	errmess = 1;
	goto END;
	}
      if ((clf[2][i] == 0 || clf[2][i] == 2) && psp[2][i+3][2] < 0.000001) {
        nonsense21(breed,i,2,2);
	errmess = 1;
	goto END;
	}
      if (clf[2][i] == 1 && psp[2][i+3][2] > 0.000001) {
        nonsense21(breed,i,2,2);
	errmess = 1;
	goto END;
      }	
    }
  }
  if (lf[2] >= 1) {
    for (i = 1; i <= lf[2]; i++) {
      fscanf(fr, "%f", &adgP[i+32][1]);
      if (clf[2][i] < 2 && adgP[i+32][1] < 0.000001) {
	nonsense26(breed,i,1,2);
	errmess = 1;
	goto END;
        }
      }	
    wrides(fr,fw);
    for (i = 1; i <= lf[2]; i++) fprintf(fw, "%8.3f", adgP[i+32][1]);
    if (crossing == 2) {  
      for (i = 1; i <= lf[2]; i++) {
        fscanf(fr, "%f", &adgP[i+32][2]);
	if ((clf[2][i] == 0 || clf[2][i] == 2)&& adgP[i+32][2] < 0.000001) {
	  nonsense26(breed,i,2,2);
	  errmess = 1;
	  goto END;
          }
	}    
      wrides(fr,fw);
      for (i = 1; i <= lf[2]; i++) fprintf(fw, "%8.3f", adgP[i+32][2]);
      }
      else readdes(fr);
    for (i = 1; i <= lf[2]; i++) fscanf(fr, "%f", &surfat[2][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= lf[2]; i++) fprintf(fw, "%8.3f", surfat[2][i][1]);
    if (crossing == 2) { 
      for (i = 1; i <= lf[2]; i++) fscanf(fr, "%f", &surfat[2][i][2]);
      wrides(fr,fw);
      for (i = 1; i <= lf[2]; i++) fprintf(fw, "%8.3f", surfat[2][i][2]);  
      }
      else readdes(fr);  
    }
    else for (i = 1; i <= 4; i++) readdes(fr); 
  readcom(fr);
  if (lf[0] >= 1) {
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%d", &ulf[0][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%3d", ulf[0][i]);
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%f", &vlf[0][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, " %6.1f", vlf[0][i]);  
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%d", &clf[0][i]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%3d", clf[0][i]);
    if (crossing == 1) {
      for (i = 1; i <= lf[0]; i++) {
	if (clf[0][i] == 0 || clf[0][i] == 2) {
	nonsense18(breed,3);
	errmess = 1;
	goto END;
	}  
      }
    }
    fprintf(fw, "\n**********\n"); 
    fprintf(fw, "For checking the correctness of your input data:\n");
    for (i = 1; i <= lf[0]; i++) {
      fprintf(fw, "  Target %d for fattening of castrates is", i);
      if(ulf[0][i] == 1) fprintf(fw, "%6.1f kg,\n", vlf[0][i]); 
      if(ulf[0][i] == 2) fprintf(fw, "%6.1f days,\n", vlf[0][i]); 
      fprintf(fw, "     target %d is for", i);
      if(clf[0][i] == 0) fprintf(fw, " pure-bred and cross-bred progeny.\n");
      if(clf[0][i] == 1) fprintf(fw, " pure-bred progeny.\n");
      if(clf[0][i] == 2) fprintf(fw, " cross-bred progeny.\n"); 
      }
    fprintf(fw, "**********\n");       
    } 
    else for (i = 1; i <= 3; i++) readdes(fr); 
  if (lf[0] == 0 && psp[2][3][1] > 0.000001) {
    nonsense17(breed);
    errmess = 1;
    goto END;
    }
  if (psp[2][3][1] > 0.000001) {
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%f", &psp[0][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", psp[0][i][1]);
      a2 = 0;
      for (i = 1; i <= lf[0]; i++) a2 += psp[0][i][1];
      if (a2 > 1.000001 || a2 < 0.999999) {
	nonsense11(breed,1,0);
	errmess = 1;
	goto END;
      }  
    for (i = 1; i <= lf[0]; i++) psp[0][i][1] *= psp[2][3][1];  
    }
    else readdes(fr);
  if (crossing == 2 && psp[2][3][2] > 0.000001) {  
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%f", &psp[0][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", psp[0][i][2]);
      a2 = 0;
      for (i = 1; i <= lf[0]; i++) a2 += psp[0][i][2];
      if (a2 > 1.000001 || a2 < 0.999999) {
	nonsense11(breed,2,0);
	errmess = 1;
	goto END;
      }  
    for (i = 1; i <= lf[0]; i++) psp[0][i][2] *= psp[2][3][2];
    }
    else readdes(fr);    
  if (lf[0] >= 1) {
    for (i = 1; i <= lf[0]; i++) {
      if ((clf[0][i] == 0 || clf[0][i] == 1) && psp[0][i][1] < 0.000001) {
        nonsense21(breed,i,1,0);
	errmess = 1;
	goto END;
	}
      if (clf[0][i] == 2 && psp[0][i][1] > 0.000001) {
        nonsense21(breed,i,1,0);
	errmess = 1;
	goto END;
	}
      if ((clf[0][i] == 0 || clf[0][i] == 2) && psp[0][i][2] < 0.000001) {
        nonsense21(breed,i,2,0);
	errmess = 1;
	goto END;
	}
      if (clf[0][i] == 1 && psp[0][i][2] > 0.000001) {
        nonsense21(breed,i,2,0);
	errmess = 1;
	goto END;
      }	
    }
  }
  if (psp[2][3][1] > 0.000001) {
    for (i = 1; i <= lf[0]; i++) {
      fscanf(fr, "%f", &adgP[i+42][1]);
      if (clf[0][i] < 2 && adgP[i+42][1] < 0.000001) {
	nonsense26(breed,i,1,3);
	errmess = 1;
	goto END;
        }
      }	
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", adgP[i+42][1]);
    }
    else readdes(fr);
  if (crossing == 2 && psp[2][3][2] > 0.000001) {  
    for (i = 1; i <= lf[0]; i++) {
      fscanf(fr, "%f", &adgP[i+42][2]);
      if ((clf[0][i] == 0 || clf[0][i] == 2)&& adgP[i+42][2] < 0.000001) {
	nonsense26(breed,i,2,3);
	errmess = 1;
	goto END;
        }
      }    
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", adgP[i+42][2]);
    }
    else readdes(fr);
  if (psp[2][3][1] > 0.000001) {    
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%f", &surfat[0][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", surfat[0][i][1]);
    }
    else readdes(fr);
  if (crossing == 2 && psp[2][3][2] > 0.000001) { 
    for (i = 1; i <= lf[0]; i++) fscanf(fr, "%f", &surfat[0][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= lf[0]; i++) fprintf(fw, "%8.3f", surfat[0][i][2]);  
    }
    else readdes(fr);  
  fclose(fr); /* End of reading INPUTS05.TXT  */
  fprintf(fw, "\n\n\n");
  /* Reading input file INPUTS04.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS04A.TXT\n");      
  if (breed == 2) printf("Reading data from INPUTS04B.TXT\n");      
  n2 = 4;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS04A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS04B.TXT", "r");
  readcom(fr);
  mwE[1] = readfloat(fw,fr);
  if (crossing == 2) {
    fscanf(fr, "%f", &mwE2);
    if (prods == 2 && breed == 2 && calc == 4) {
      fr1 = fopen("TRANSFER03.TXT", "r");
      fscanf(fr1, "%f", &mwE2);
    }
    wrides(fr,fw);
    fprintf(fw, "%8.2f", mwE2);
  }
  else readdes(fr);
  pwrepFP[1] = readfloat(fw,fr);
  if (crossing == 2 && psp[1][2][2] > 0.000001) pwrepFP[2] = readfloat(fw,fr);
    else readdes(fr);
  for (i = 1; i < bs[1]; i++) fscanf(fr, "%f", &adgr[1][i][1]);
  wrides(fr,fw);
  for (i = 1; i < bs[1]; i++) fprintf(fw, "%8.3f", adgr[1][i][1]);
  if (crossing == 2 && psp[1][2][2] > 0.000001) {
    for (i = 1; i < bs[1]; i++) fscanf(fr, "%f", &adgr[1][i][2]);
    wrides(fr,fw);
    for (i = 1; i < bs[1]; i++) fprintf(fw, "%8.3f", adgr[1][i][2]);
    }    
    else readdes(fr);  
  vcwr[1][1] = readfloat(fw,fr);
  if (crossing == 2 && psp[1][2][2] > 0.000001) vcwr[1][2] = readfloat(fw,fr);
    else readdes(fr);
  if (psp[1][2][1] > 0.000001) psold[1][0][1] = readfloat(fw,fr);  
    else readdes(fr);
  if (crossing == 2 && psp[1][2][2] > 0.000001) psold[1][0][2] = readfloat(fw,fr);
    else readdes(fr);
  for (i = 1; i <= bs[1]; i++) fscanf(fr, "%f", &conrateFP[i][1]);
  wrides(fr,fw);
  for (i = 1; i <= bs[1]; i++) fprintf(fw, "%8.3f", conrateFP[i][1]);
  if (crossing == 2 && psp[1][2][2] > 0.000001) {
    for (i = 1; i <= bs[1]; i++) fscanf(fr, "%f", &conrateFP[i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[1]; i++) fprintf(fw, "%8.3f", conrateFP[i][2]);
    }    
    else readdes(fr);  
  for (i = 1; i <= bs[1]-1; i++) fscanf(fr, "%f", &pbarrFP[i][1]);
  wrides(fr,fw);
  for (i = 1; i <= bs[1]-1; i++) fprintf(fw, "%8.3f", pbarrFP[i][1]);
  if (crossing == 2 && psp[1][2][2] > 0.000001) {
    for (i = 1; i <= bs[1]-1; i++) fscanf(fr, "%f", &pbarrFP[i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[1]-1; i++) fprintf(fw, "%8.3f", pbarrFP[i][2]);  
    }
    else readdes(fr);  
  for (i = 1; i <= bs[1]; i++) fscanf(fr, "%f", &surbs[1][i][1]);
  wrides(fr,fw);
  for (i = 1; i <= bs[1]; i++) fprintf(fw, "%8.3f", surbs[1][i][1]);
  if (crossing == 2 && psp[1][2][2] > 0.000001) {
    for (i = 1; i <= bs[1]; i++) fscanf(fr, "%f", &surbs[1][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[1]; i++) fprintf(fw, "%8.3f", surbs[1][i][2]);
    }    
    else readdes(fr);  
  surmlFP[1] = readfloat(fw,fr);
  if (crossing == 2 && psp[1][2][2] > 0.000001) surmlFP[2] = readfloat(fw,fr);
    else readdes(fr);
  lpreg = readint(fw,fr);
  wgfE = readfloat(fw,fr);  
  wgfL = readfloat(fw,fr);  
  if (psold[1][0][1] > 0.000001) agetP[13][1] = readfloat(fw,fr);
    else readdes(fr);  
  if (crossing == 2 && psold[1][0][2] > 0.000001) agetP[13][2] = readfloat(fw,fr);
    else readdes(fr);  
  if (psold[1][0][1] > 0.000001) agetP[26][1] = readfloat(fw,fr);
    else readdes(fr);  
  if (crossing == 2 && psold[1][0][2] > 0.000001) agetP[26][2] = readfloat(fw,fr);
    else readdes(fr);  
  if (psp[1][2][1] + psp[1][2][2] > 0.000001) dpregsFP = readfloat(fw,fr);  
    else readdes(fr);    
  dnpregcFP = readfloat(fw,fr);      
  if (femrep == 2) ppurchFP = readfloat(fw,fr);
    else readdes(fr);
  ppurchMP = readfloat(fw,fr);
  mwR[1] = mwMP[1] = readfloat(fw,fr);
  if (crossing == 2) {
    fscanf(fr, "%f", &mwR[2]);
    if (prods == 2 && breed == 2 && calc == 4) {
      fscanf(fr1, "%f", &mwR[2]);
    }
    wrides(fr,fw);
    fprintf(fw, "%8.2f", mwR[2]);
  }  
    else readdes(fr);
  if (ppurchMP < 1.000001 || psp[2][2][1] > 0.000001) {
    pwrepMP = readfloat(fw,fr);  
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &adgr[2][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", adgr[2][i][1]);
    }
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (crossing == 2 && psp[2][2][2] > 0.000001) {
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &adgr[2][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", adgr[2][i][2]);
    }    
    else readdes(fr);  
  if (ppurchMP < 1.000001 || psp[2][2][1] > 0.000001) vcwr[2][1] = readfloat(fw,fr);
    else readdes(fr);
  if (crossing == 2 && psp[2][2][2] > 0.000001) vcwr[2][2] = readfloat(fw,fr);
    else readdes(fr);
  if (psp[2][2][1] > 0.000001) psold[2][1][1] = readfloat(fw,fr);  
    else readdes(fr);
  if (crossing == 2 && psp[2][2][2] > 0.000001) psold[2][1][2] = readfloat(fw,fr);
    else readdes(fr);
  if (ppurchMP < 1.000001 || psp[2][2][1] > 0.000001) {
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &surbs[2][i][1]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", surbs[2][i][1]);
    }    
    else readdes(fr);  
  if (crossing == 2 && psp[2][2][2] > 0.000001) {
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &surbs[2][i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", surbs[2][i][2]);
    }    
    else readdes(fr);  
  if (ppurchMP < 1.000001 || psp[2][2][1] > 0.000001) {    
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &cullbsMP[i][1]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", cullbsMP[i][1]);
    }    
    else readdes(fr);  
  if (crossing == 2 && psp[2][2][2] > 0.000001) {
    for (i = 1; i <= bs[2]; i++) fscanf(fr, "%f", &cullbsMP[i][2]);
    wrides(fr,fw);
    for (i = 1; i <= bs[2]; i++) fprintf(fw, "%8.3f", cullbsMP[i][2]);
    }    
    else readdes(fr);  
  if (psp[2][2][1] > 0.000001) agetP[38][1] = readfloat(fw,fr);
    else readdes(fr);  
  if (crossing == 2 && psp[2][2][2] > 0.000001) agetP[38][2] = readfloat(fw,fr);
    else readdes(fr);  
  if (psp[2][2][1] > 0.000001) agetP[40][1] = readfloat(fw,fr);
    else readdes(fr);  
  if (crossing == 2 && psp[2][2][2] > 0.000001) agetP[40][2] = readfloat(fw,fr);
    else readdes(fr);  
  if (ppurchMP > 0.000001) agepurMP[1] = readfloat(fw,fr);
    else readdes(fr);  
  if (crossing == 2) {
    fscanf(fr, "%f", &agepurMP[2]);
    if (prods == 2 && breed == 2 && calc == 4) fscanf(fr1, "%f", &agepurMP[2]);
    wrides(fr,fw);
    fprintf(fw, "%8.2f", agepurMP[2]);
  }  
    else readdes(fr);  
  if (ppurchMP > 0.000001) wpurMP[1] = readfloat(fw,fr);
    else readdes(fr);     
  if (crossing == 2) {
    fscanf(fr, "%f", &wpurMP[2]);
    if (prods == 2 && breed == 2 && calc == 4) fscanf(fr1, "%f", &wpurMP[2]);
    wrides(fr,fw);
    fprintf(fw, "%8.2f", wpurMP[2]);
  }  
    else readdes(fr);  
  for (j = 1; j <= crossing; j++) {
    if (wpurMP[j] > mwR[j]) {
      nonsense04(breed,j,mwR[j]);
      errmess = 1;
      goto END;
      }
    } 
  ratioyoungR = readfloat(fw,fr); 
  ratiooldR = readfloat(fw,fr); 
  hetmw = readfloat(fw,fr); 
  fclose(fr);  /* End of reading INPUTS04.TXT */
  fprintf(fw, "\n\n\n");

  if (typeb < 3) {
    /* Reading input file INPUTS06.TXT and writing the data from this file 
       to the results file */
    if (breed == 1) printf("Reading data from INPUTS06A.TXT\n");   
    if (breed == 2) printf("Reading data from INPUTS06B.TXT\n");   
    n2 = 6;
    zz++;
    inp00(fw,n2,zz,breed);
    if (breed == 1) fr = fopen("INPUTS06A.TXT", "r");
    if (breed == 2) fr = fopen("INPUTS06B.TXT", "r");
    readcom(fr);
    awo = readfloat(fw,fr); 
    bwo = readfloat(fw,fr);   
    cwo = readfloat(fw,fr);   
    placE = readint(fw,fr);   
    nsl = readint(fw,fr);       
    for (i = 1; i <= LL; i++) fscanf(fr, "%f", &ktlp[i]);
    wrides(fr,fw);
    for (i = 1; i <= LL; i++) fprintf(fw, "%6.3f", ktlp[i]);
    for (i = 0; i <= clt; i++) fscanf(fr, "%f", &ktlsl[i]);
    wrides(fr,fw);
    if (typeb == 2) ktlsl[0] = 0;
    for (i = 0; i <= clt; i++) fprintf(fw, "%6.3f", ktlsl[i]);
    if (typeb == 1) pmilkwm = readfloat(fw,fr);
      else readdes(fr);
    kmilkcE = readfloat(fw,fr);
    if (typeb == 1) { 
      dmilkst = readint(fw,fr);
      pmilkch = readfloat(fw,fr);
    }  
      else for (i = 1; i <= 2; i++) readdes(fr); 
    readcom(fr);         
    if (typeb == 1 && pmilkch > 0.000001) { 
      cy = readint(fw,fr);
      if (cy == 1) {
	ach = readfloat(fw,fr);
	bch = readfloat(fw,fr);
	cch = readfloat(fw,fr);
      }
      else for (i = 1; i <= 3; i++) readdes(fr);
      if (cy == 2) {
        rfat = readfloat(fw,fr);
	rcas = readfloat(fw,fr);
	casprot = readfloat(fw,fr);
	moich = readfloat(fw,fr);
	fatch = readfloat(fw,fr);
      }
      else for (i = 1; i <= 5; i++) readdes(fr);
    }  
    else for (i = 1; i <= 8; i++) readdes(fr);     
    fclose(fr); /* End of reading INPUTS06.TXT  */  
    fprintf(fw, "\n\n\n");
  }

  if (typeb == 3) {
    /* Reading input file INPUTS07.TXT and writing the data from this file 
       to the results file */
    if (breed == 1) printf("Reading data from INPUTS07A.TXT\n");   
    if (breed == 2) printf("Reading data from INPUTS07B.TXT\n");   
    n2 = 7;
    zz++;
    inp00(fw,n2,zz,breed);
    if (breed == 1) fr = fopen("INPUTS07A.TXT", "r");
    if (breed == 2) fr = fopen("INPUTS07B.TXT", "r");
    readcom(fr);
    basemilkw = readfloat(fw,fr); 
    placE = readint(fw,fr);   
    nsl = readint(fw,fr);       
    for (i = 1; i <= LL; i++) fscanf(fr, "%f", &ktlp[i]);
    wrides(fr,fw);
    for (i = 1; i <= LL; i++) fprintf(fw, "%6.3f", ktlp[i]);
    for (i = 1; i <= clt; i++) fscanf(fr, "%f", &ktlsl[i]);
    wrides(fr,fw);
    for (i = 1; i <= clt; i++) fprintf(fw, "%6.3f", ktlsl[i]);

    fclose(fr); /* End of reading INPUTS07.TXT  */  
    fprintf(fw, "\n\n\n");
  }

  /* Reading input file INPUTS08.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS08A.TXT\n");   
  if (breed == 2) printf("Reading data from INPUTS08B.TXT\n");   
  n2 = 8;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS08A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS08B.TXT", "r");
  readcom(fr);
  nfs = readint(fw,fr);
  valfs[0] = readint(fw,fr);
  nchfs = readint(fw,fr);
  readcom(fr);
  for (i = 1; i <= nchfs; i++) {
    datchfs[i] = readymd(fr,fw);
    if (datchfs[i] < 0) { 
      nonsense30(breed,6);
      errmess = 1;
      goto END;
    }
    valfs[i] = readint(fw,fr);  
  }  
  readcom(fr);
  if (valfs[0] != valfs[nchfs]) {
    nonsense20(breed);
    errmess = 1;
    goto END;
    }
  flushbbR = readint(fw,fr);  
  dselR = readint(fw,fr);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &tp[i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%7.1f", tp[i]);
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &drymR[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fR; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", drymR[i][j]);
  }
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &nedR[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fR; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", nedR[i][j]);
  }
  if (feedcost == 1) {
    for (i = 1; i <= fR; i++) {
      for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &pdidR[i][j]);
    }
    wrides(fr,fw);
    for (i = 1; i <= fR; i++) {
      fprintf(fw, "\n");
      for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", pdidR[i][j]);
    }
  }
  else readdes(fr);
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &lossfR[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fR; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", lossfR[i][j]);
  }
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &prfR[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fR; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%12.4f", prfR[i][j]);
  }
  flushbbE = readint(fw,fr);  
  flushabE = readint(fw,fr);  
  dnpregcE = readint(fw,fr);      
  for (i = 1; i <= nfs; i++) fscanf(fr, "%d", &techE[i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%3d", techE[i]);
  for (i = 1; i <= hs; i++)  ktE[i] = readfloat(fw,fr); 
  dshpE = readint(fw,fr);  
  fat = readfloat(fw,fr);
  prot = readfloat(fw,fr);
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &drymE[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fE; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", drymE[i][j]);
  }
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &nedE[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fE; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", nedE[i][j]);
  }
  if (feedcost == 1) {
    for (i = 1; i <= fE; i++) {
      for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &pdidE[i][j]);
    }
    wrides(fr,fw);
    for (i = 1; i <= fE; i++) {
      fprintf(fw, "\n");
      for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", pdidE[i][j]);
    }
  }
  else readdes(fr);
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &lossfE[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fE; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.3f", lossfE[i][j]);
  }
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &prfE[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fE; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%12.4f", prfE[i][j]);
  }
  for (i = 1; i <= nfs; i++) fscanf(fr, "%d", &techbL[i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%3d", techbL[i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%d", &techfatL[i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%3d", techfatL[i]);
  dwoolptwL = readfloat(fw,fr);
  for (i = 1; i <= hs; i++)  ktL[i] = readfloat(fw,fr); 
  nemilk = readfloat(fw,fr);
  if (feedcost == 1) pdimilk = readfloat(fw,fr);
    else readdes(fr);  
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[1][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[1][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[1][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[1][i]);
  if (feedcost == 1) {
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[1][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.2f", pdidL[1][i]);
    }
  else readdes(fr);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[1][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%8.1f", lossfL[1][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[1][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[1][i]);
  readcom(fr);
  if (typew == 2) {
    dwoolptarL = readfloat(fw,fr);
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[2][i]);
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[2][i]);
    if (feedcost == 1) {
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[2][i]);
      wrides(fr,fw);
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.2f", pdidL[2][i]);
      }
    else readdes(fr);  
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%8.1f", lossfL[2][i]);
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[2][i]);
    }
    else for (i = 1; i <= 6; i++) readdes(fr);
    for (i = 1; i < SP; i++) fscanf(fr, "%f", &dwoolptrL[i][1]);
    wrides(fr,fw);
    for (i = 1; i < SP; i++) fprintf(fw, "%10.5f", dwoolptrL[i][1]);
    if (crossing == 2) {
      for (i = 1; i < SP; i++) fscanf(fr, "%f", &dwoolptrL[i][2]);
      wrides(fr,fw);
      for (i = 1; i < SP; i++) fprintf(fw, "%10.5f", dwoolptrL[i][2]);
      }
    else readdes(fr);  
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[3][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[3][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[3][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[3][i]);
  if (feedcost == 1) {
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[3][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.2f", pdidL[3][i]);
    }
  else readdes(fr);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[3][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%8.1f", lossfL[3][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[3][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[3][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[4][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[4][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[4][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[4][i]);
  if (feedcost == 1) {
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[4][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.2f", pdidL[4][i]);
    }
  else readdes(fr);  
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[4][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%8.1f", lossfL[4][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[4][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[4][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[5][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[5][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[5][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[5][i]);
  if (feedcost == 1) {
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[5][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.2f", pdidL[5][i]);
    }
  else readdes(fr);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[5][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%8.1f", lossfL[5][i]);
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[5][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[5][i]);
  flushbbL = readint(fw,fr);  
  flushabL = readint(fw,fr);  
  readcom(fr);
  if (lf[1] > 0) {
    for (k = 6; k <= 5 + lf[1]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[k][i]);
    wrides(fr,fw);
    for (k = 6; k <= 5 + lf[1]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[k][i]);
      }
    for (k = 6; k <= 5 + lf[1]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[k][i]);
    wrides(fr,fw);
    for (k = 6; k <= 5 + lf[1]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[k][i]);
      }
    if (feedcost == 1) {
      for (k = 6; k <= 5 + lf[1]; k++) 
	for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[k][i]);
      wrides(fr,fw);
      for (k = 6; k <= 5 + lf[1]; k++) {
	fprintf(fw, "\n");
	for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", pdidL[k][i]);
	}
      }
    else readdes(fr);
    for (k = 6; k <= 5 + lf[1]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[k][i]);
    wrides(fr,fw);
    for (k = 6; k <= 5 + lf[1]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", lossfL[k][i]);
      }
    for (k = 6; k <= 5 + lf[1]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[k][i]);
    wrides(fr,fw);
    for (k = 6; k <= 5 + lf[1]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[k][i]);
      }
    }
    else for (i = 1; i <= 5; i++) readdes(fr);
  readcom(fr);  
  if (lf[2] > 0) {
    for (k = 11; k <= 10 + lf[2]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[k][i]);
    wrides(fr,fw);
    for (k = 11; k <= 10 + lf[2]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[k][i]);
      }
    for (k = 11; k <= 10 + lf[2]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[k][i]);
    wrides(fr,fw);
    for (k = 11; k <= 10 + lf[2]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[k][i]);
      }
    if (feedcost == 1) {
      for (k = 11; k <= 10 + lf[2]; k++) 
	for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[k][i]);
      wrides(fr,fw);
      for (k = 11; k <= 10 + lf[2]; k++) {
	fprintf(fw, "\n");
	for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", pdidL[k][i]);
	}
      }
    else readdes(fr);
    for (k = 11; k <= 10 + lf[2]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[k][i]);
    wrides(fr,fw);
    for (k = 11; k <= 10 + lf[2]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", lossfL[k][i]);
      }
    for (k = 11; k <= 10 + lf[2]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[k][i]);
    wrides(fr,fw);
    for (k = 11; k <= 10 + lf[2]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[k][i]);
      }
    }
    else for (i = 1; i <= 5; i++) readdes(fr);
  readcom(fr);  
  if (lf[0] > 0) {
    for (k = 16; k <= 15 + lf[0]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &drymL[k][i]);
    wrides(fr,fw);
    for (k = 16; k <= 15 + lf[0]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", drymL[k][i]);
      }
    for (k = 16; k <= 15 + lf[0]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &nedL[k][i]);
    wrides(fr,fw);
    for (k = 16; k <= 15 + lf[0]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", nedL[k][i]);
      }
    if (feedcost == 1) {
      for (k = 16; k <= 15 + lf[0]; k++) 
	for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &pdidL[k][i]);
      wrides(fr,fw);
      for (k = 16; k <= 15 + lf[0]; k++) {
	fprintf(fw, "\n");
	for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", pdidL[k][i]);
	}
      }
    else readdes(fr);
    for (k = 16; k <= 15 + lf[0]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &lossfL[k][i]);
    wrides(fr,fw);
    for (k = 16; k <= 15 + lf[0]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.3f", lossfL[k][i]);
      }
    for (k = 16; k <= 15 + lf[0]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &prfL[k][i]);
    wrides(fr,fw);
    for (k = 16; k <= 15 + lf[0]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%12.4f", prfL[k][i]);
      }
    }
    else for (i = 1; i <= 5; i++) readdes(fr);
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &dwatE[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fE; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.1f", dwatE[i][j]);
  }
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &dwatR[i][j]);
  }
  wrides(fr,fw);
  for (i = 1; i <= fR; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.1f", dwatR[i][j]);
  }
  for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &dwatL[1][i]);
  wrides(fr,fw);
  for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", dwatL[1][i]);
  if (typew == 2) {
    for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &dwatL[2][i]);
    wrides(fr,fw);
    for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", dwatL[2][i]);
    }
  else readdes(fr);
  for (i = 3; i <= 5; i++) {
    for (j = 1; j <= nfs; j++) fscanf(fr, "%f", &dwatL[i][j]);
  }
  wrides(fr,fw);
  for (i = 3; i <= 5; i++) {
    fprintf(fw, "\n");
    for (j = 1; j <= nfs; j++) fprintf(fw, "%10.1f", dwatL[i][j]);
  }
  readcom(fr);
  if (lf[1] > 0) {
    for (k = 6; k <= 5 + lf[1]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &dwatL[k][i]);
    wrides(fr,fw);
    for (k = 6; k <= 5 + lf[1]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", dwatL[k][i]);
      }
    }
  else readdes(fr);  
  readcom(fr);
  if (lf[2] > 0) {
    for (k = 11; k <= 10 + lf[2]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &dwatL[k][i]);
    wrides(fr,fw);
    for (k = 11; k <= 10 + lf[2]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", dwatL[k][i]);
      }
    }
  else readdes(fr);  
  readcom(fr);
  if (lf[0] > 0) {
    for (k = 16; k <= 15 + lf[0]; k++) 
      for (i = 1; i <= nfs; i++) fscanf(fr, "%f", &dwatL[k][i]);
    wrides(fr,fw);
    for (k = 16; k <= 15 + lf[0]; k++) {
      fprintf(fw, "\n");
      for (i = 1; i <= nfs; i++) fprintf(fw, "%10.1f", dwatL[k][i]);
      }
    }
  else readdes(fr);  
  prwat = readfloat(fw,fr);  
  fclose(fr); /* End of reading INPUTS08.TXT  */    
  fprintf(fw, "\n\n\n");

  /* Reading input file INPUTS09.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS09A.TXT\n");   
  if (breed == 2) printf("Reading data from INPUTS09B.TXT\n");   
  n2 = 9;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS09A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS09B.TXT", "r");
  readcom(fr);
  nendopE = readfloat(fw,fr);
  prendop = readfloat(fw,fr);
  nectopE = readfloat(fw,fr);
  prectop = readfloat(fw,fr);
  vetE = readfloat(fw,fr);
  AkhE = readfloat(fw,fr);
  costAkh = readfloat(fw,fr);
  nsheE = readfloat(fw,fr);
  costshe0E = readfloat(fw,fr);
  costfix0E = readfloat(fw,fr);
  strawE = readfloat(fw,fr);
  prstraw = readfloat(fw,fr);
  pinsE[1] = readfloat(fw,fr);
  if (crossing == 2) pinsE[2] = readfloat(fw,fr);
    else readdes(fr);
  costins[1] = readfloat(fw,fr);
  if (crossing == 2) costins[2] = readfloat(fw,fr);
    else readdes(fr);
  costreins[1] = readfloat(fw,fr);
  if (crossing == 2) costreins[2] = readfloat(fw,fr);
    else readdes(fr);
  nreins = readint(fw,fr);  
  coninsE = readfloat(fw,fr);  
  costoeinE = readfloat(fw,fr);
  costtan = readfloat(fw,fr);
  pskE = readfloat(fw,fr);
  ptskE = readfloat(fw,fr);
  costmarkcul = readfloat(fw,fr);
  costdead = readfloat(fw,fr);
  readcom(fr);
  if (typeb == 1) {  
    costmilk0E = readfloat(fw,fr);
    costcheese0E = readfloat(fw,fr);
  }
  else for (i = 1; i <= 2; i++) readdes(fr);
  readcom(fr);
  nendopR = readfloat(fw,fr);
  nectopR = readfloat(fw,fr);
  vetR = readfloat(fw,fr);
  AkhR = readfloat(fw,fr);
  nsheR[1] = readfloat(fw,fr);
  if (crossing == 2) nsheR[2] = readfloat(fw,fr);
    else readdes(fr);
  costshe0R = readfloat(fw,fr);
  costfix0R = readfloat(fw,fr);  
  strawR = readfloat(fw,fr);
  pskR = readfloat(fw,fr);
  ptskR = readfloat(fw,fr);
  costmarkbR = readfloat(fw,fr);
  prbR[1] = readfloat(fw,fr);
  if (crossing == 2) {
    fscanf(fr, "%f", &prbR[2]);
    if (prods == 2 && breed == 2 && calc == 4) {
      fscanf(fr1, "%f", &prbR[2]);
      close(fr1);
    }
    wrides(fr,fw);
    fprintf(fw, "%8.2f", prbR[2]);
  }  
    else readdes(fr);
  readcom(fr);
  costshe0L = readfloat(fw,fr);
  costmarkwL = readfloat(fw,fr);
  readcom(fr);
  nendopwL = readfloat(fw,fr);
  nectopwL = readfloat(fw,fr);
  vetwL = readfloat(fw,fr);
  nshewL = readfloat(fw,fr);
  pskwL = readfloat(fw,fr);
  ptskwL = readfloat(fw,fr);
  readcom(fr);
  if (typew == 2) {  
    nendoparL = readfloat(fw,fr);
    nectoparL = readfloat(fw,fr);
    vetarL = readfloat(fw,fr);
    AkharL = readfloat(fw,fr);
    costfixarL = readfloat(fw,fr);
    strawarL = readfloat(fw,fr);
    nshearL = readfloat(fw,fr);
    pskarL = readfloat(fw,fr);
    ptskarL = readfloat(fw,fr);
  }
    else for (i = 1; i <= 9; i++) readdes(fr);
  readcom(fr);
  nendoprL[1] = readfloat(fw,fr);
  nendoprL[2] = readfloat(fw,fr);  
  nendopclFP = readfloat(fw,fr);
  nectoprL[1] = readfloat(fw,fr);
  nectoprL[2] = readfloat(fw,fr);  
  nectopclFP = readfloat(fw,fr);
  vetrL[1] = readfloat(fw,fr);
  vetrL[2] = readfloat(fw,fr);  
  vetclFP = readfloat(fw,fr);
  AkhrL = readfloat(fw,fr);
  for (i = 1; i <= bs[1]; i++) fscanf(fr, "%f", &nsherL[i]);
  wrides(fr,fw);
  for (i = 1; i <= bs[1]; i++) fprintf(fw, "%7.1f", nsherL[i]);
  nsheFP = readfloat(fw,fr); 
  costfixrL = readfloat(fw,fr); 
  strawrL = readfloat(fw,fr); 
  pinsFP[1] = readfloat(fw,fr);
  if (crossing == 2) pinsFP[2] = readfloat(fw,fr);
    else readdes(fr);
  costoeinFP = readfloat(fw,fr); 
  pskrL = readfloat(fw,fr);
  ptskrL = readfloat(fw,fr); 
  costmarkrL[1] = readfloat(fw,fr);
  costmarkrL[2] = readfloat(fw,fr);
  readcom(fr);
  for (i2 = 1; i2 <= 3; i2++) {
    j = i2;
    if (i2 == 3) j = 0;
    if (lf[j] > 0) {
      for (i = 1; i <= lf[j]; i++) fscanf(fr, "%f", &nendopf[j][i]);
      wrides(fr,fw);
      for (i = 1; i <= lf[j]; i++) fprintf(fw, "%7.1f", nendopf[j][i]);
      for (i = 1; i <= lf[j]; i++) fscanf(fr, "%f", &nectopf[j][i]);
      wrides(fr,fw);
      for (i = 1; i <= lf[j]; i++) fprintf(fw, "%7.1f", nectopf[j][i]);
      for (i = 1; i <= lf[j]; i++) fscanf(fr, "%f", &vetf[j][i]);
      wrides(fr,fw);
      for (i = 1; i <= lf[j]; i++) fprintf(fw, "%12.4f", vetf[j][i]);
      for (i = 1; i <= lf[j]; i++) fscanf(fr, "%f", &nshefL[j][i]);
      wrides(fr,fw);
      for (i = 1; i <= lf[j]; i++) fprintf(fw, "%7.1f", nshefL[j][i]);
      }
      else for (i = 1; i <= 4; i++) readdes(fr);     
    }
  if (lf[0] + lf[1] + lf[2] > 0) {
    AkhfL = readfloat(fw,fr);
    costfixfL = readfloat(fw,fr);
    strawfL = readfloat(fw,fr);
    pskfL = readfloat(fw,fr);
    ptskfL = readfloat(fw,fr);
    costmarkfL = readfloat(fw,fr);
    }
  else for (i = 1; i <= 6; i++) readdes(fr);
  kdif = readfloat(fw,fr);
  fclose(fr); /* End of reading INPUTS09.TXT  */    
  fprintf(fw, "\n\n\n");

  /* Reading input file INPUTS10.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS10A.TXT\n");   
  if (breed == 2) printf("Reading data from INPUTS10B.TXT\n");   
  n2 = 10;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS10A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS10B.TXT", "r");
  readcom(fr);
  prwoolE = readfloat(fw,fr);  
  wsheE = readfloat(fw,fr);
  prskrE = readfloat(fw,fr);
  prsktE = readfloat(fw,fr);
  manE = readfloat(fw,fr);
  prman = readfloat(fw,fr); 
  prwoolR[1] = readfloat(fw,fr);
  if (crossing == 2) prwoolR[2] = readfloat(fw,fr);
    else readdes(fr);
  wsheR[1] = readfloat(fw,fr);
  if (crossing == 2) wsheR[2] = readfloat(fw,fr);
    else readdes(fr);
  prskrR[1] = readfloat(fw,fr);
  if (crossing == 2) prskrR[2] = readfloat(fw,fr);
    else readdes(fr);
  prsktR[1] = readfloat(fw,fr);
  if (crossing == 2) prsktR[2] = readfloat(fw,fr);
    else readdes(fr);
  manR = readfloat(fw,fr);
  prsbR[1] = readfloat(fw,fr);
  if (crossing == 2) prsbR[2] = readfloat(fw,fr);
    else readdes(fr);  
  prwoolL[1] = readfloat(fw,fr);
  if (crossing == 2) prwoolL[2] = readfloat(fw,fr);
    else readdes(fr);
  if (typew == 1) {
    wshewL[1][1] = readfloat(fw,fr);
    if (crossing == 2) wshewL[1][2] = readfloat(fw,fr);
      else readdes(fr);
    wshewL[2][1] = readfloat(fw,fr);
    if (crossing == 2) wshewL[2][2] = readfloat(fw,fr);
      else readdes(fr);
  }
    else for (i = 1; i <= 4; i++) readdes(fr);
  if (typew == 2) {
    wshearL[1][1] = readfloat(fw,fr);
    if (crossing == 2) wshearL[1][2] = readfloat(fw,fr);
      else readdes(fr);
    wshearL[2][1] = readfloat(fw,fr);
    if (crossing == 2) wshearL[2][2] = readfloat(fw,fr);
      else readdes(fr);
  }
    else for (i = 1; i <= 4; i++) readdes(fr);
  if (lf[1] > 0.000001) {
    wshefL[1][1] = readfloat(fw,fr);
    if (crossing == 2) wshefL[1][2] = readfloat(fw,fr);
      else readdes(fr);
  }  
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (lf[2] > 0.000001) {
    wshefL[2][1] = readfloat(fw,fr);
    if (crossing == 2) wshefL[2][2] = readfloat(fw,fr);
      else readdes(fr);
  }  
    else for (i = 1; i <= 2; i++) readdes(fr);
  if (lf[0] > 0.000001) {
    wshefL[0][1] = readfloat(fw,fr);
    if (crossing == 2) wshefL[0][2] = readfloat(fw,fr);
      else readdes(fr);
  }  
    else for (i = 1; i <= 2; i++) readdes(fr);
  wsherL[1][1] = readfloat(fw,fr);
  if (crossing == 2) wsherL[1][2] = readfloat(fw,fr);
    else readdes(fr);
  if (ppurchMP < 1.000001 || psp[2][2][1] > 0.000001) wsherL[2][1] = readfloat(fw,fr);
    else readdes(fr);
  if (crossing == 2 && psp[2][2][2] > 0.000001) wsherL[2][2] = readfloat(fw,fr);
    else readdes(fr);
  prskrL[1] = readfloat(fw,fr);
  if (crossing == 2) prskrL[2] = readfloat(fw,fr);
    else readdes(fr);
  prsktL[1] = readfloat(fw,fr);
  if (crossing == 2) prsktL[2] = readfloat(fw,fr);
    else readdes(fr);
  if (lf[0] + lf[1] + lf[2] > 0) manfL = readfloat(fw,fr);  
    else readdes(fr);
  if (typew == 2) manarL = readfloat(fw,fr);  
    else readdes(fr); 
  manbL = readfloat(fw,fr);
  opsbL = readint(fw,fr);     
  readcom(fr);
  if (opsbL == 1) {
    if (psp[1][2][1] > 0.000001) revsbL[13][1] = readfloat(fw,fr);
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) revsbL[13][2] = readfloat(fw,fr);
      else readdes(fr);
    if (psp[1][2][1] > 0.000001) revsbL[26][1] = readfloat(fw,fr);
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) revsbL[26][2] = readfloat(fw,fr);
      else readdes(fr);
    if (psp[1][2][1] > 0.000001) {
      for (i = 0; i <= 2; i++) fscanf(fr, "%f", &revsbL[15+i*4][1]);
      wrides(fr,fw);
      for (i = 0; i <= 2; i++) fprintf(fw, "%9.0f", revsbL[15+i*4][1]);
      }
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) {
      for (i = 0; i <= 2; i++) fscanf(fr, "%f", &revsbL[15+i*4][2]);
      wrides(fr,fw);
      for (i = 0; i <= 2; i++) fprintf(fw, "%9.0f", revsbL[15+i*4][2]);
      }
      else readdes(fr);
    if (psp[2][2][1] > 0.000001) {      
      for (i = 0; i <= 1; i++) fscanf(fr, "%f", &revsbL[38+i*2][1]);
      wrides(fr,fw);
      for (i = 0; i <= 1; i++) fprintf(fw, "%9.0f", revsbL[38+i*2][1]);
      }
      else readdes(fr);
    if (crossing == 2 && psp[2][2][2] > 0.000001) {
      for (i = 0; i <= 1; i++) fscanf(fr, "%f", &revsbL[38+i*2][2]);
      wrides(fr,fw);
      for (i = 0; i <= 1; i++) fprintf(fw, "%9.0f", revsbL[38+i*2][2]);
      }
      else readdes(fr);
  }
  else for (i = 1; i <= 8; i++) readdes(fr);
  readcom(fr);
  if (opsbL == 2) {
    if (psp[1][2][1] > 0.000001) prsbL[13][1] = readfloat(fw,fr);
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) prsbL[13][2] = readfloat(fw,fr);
      else readdes(fr);
    if (psp[1][2][1] > 0.000001) prsbL[26][1] = readfloat(fw,fr);
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) prsbL[26][2] = readfloat(fw,fr);
      else readdes(fr);
    if (psp[1][2][1] > 0.000001) {
      for (i = 0; i <= 2; i++) fscanf(fr, "%f", &prsbL[15+i*4][1]);
      wrides(fr,fw);
      for (i = 0; i <= 2; i++) fprintf(fw, "%9.0f", prsbL[15+i*4][1]);
      }
      else readdes(fr);
    if (crossing == 2 && psp[1][2][2] > 0.000001) {
      for (i = 0; i <= 2; i++) fscanf(fr, "%f", &prsbL[15+i*4][2]);
      wrides(fr,fw);
      for (i = 0; i <= 2; i++) fprintf(fw, "%9.0f", prsbL[15+i*4][2]);
      }
      else readdes(fr);
    if (psp[2][2][1] > 0.000001) {      
      for (i = 0; i <= 1; i++) fscanf(fr, "%f", &prsbL[38+i*2][1]);
      wrides(fr,fw);
      for (i = 0; i <= 1; i++) fprintf(fw, "%9.0f", prsbL[38+i*2][1]);
      }
      else readdes(fr);
    if (crossing == 2 && psp[2][2][2] > 0.000001) {
      for (i = 0; i <= 1; i++) fscanf(fr, "%f", &prsbL[38+i*2][2]);
      wrides(fr,fw);
      for (i = 0; i <= 1; i++) fprintf(fw, "%9.0f", prsbL[38+i*2][2]);
      }
      else readdes(fr);
  }
  else for (i = 1; i <= 8; i++) readdes(fr);
  if (psp[2][2][1] + psp[2][2][2] > 0.000001) subR = readfloat(fw,fr);
    else readdes(fr);
  subE = readfloat(fw,fr);
  fclose(fr); /* End of reading INPUTS10.TXT  */    
  fprintf(fw, "\n\n\n");

  /* Reading input file INPUTS11.TXT and writing the data from this file 
     to the results file */
  if (typeb == 1) {
    if (breed == 1) printf("Reading data from INPUTS11A.TXT\n");   
    if (breed == 2) printf("Reading data from INPUTS11B.TXT\n");   
    n2 = 11;
    zz++;
    inp00(fw,n2,zz,breed);
    if (breed == 1) fr = fopen("INPUTS11A.TXT", "r");
    if (breed == 2) fr = fopen("INPUTS11B.TXT", "r");
    readcom(fr);
    milkprice = readint(fw,fr);
    prmilkb = 0;
    readcom(fr);
    if (milkprice == 1 || milkprice == 3 || milkprice == 5) 
      prmilkb = readfloat(fw,fr);
    else readdes(fr);
    if (milkprice == 1 || milkprice == 2) nfat = nprot = -1;
    readcom(fr);      
    if (milkprice > 2) {
      nfat = readint(fw,fr);
      if (nfat < 1) readdes(fr); 
      if (nfat > 0) {
	for (i = 0; i < nfat; i++) fscanf(fr, "%f", &thfat[i]); 
	wrides(fr,fw);
	for (i = 0; i < nfat; i++) fprintf(fw, "%6.2f", thfat[i]);
	}
      nprot = readint(fw,fr);
      if (nprot < 1) readdes(fr); 
      if (nprot > 0) {
	for (i = 0; i < nprot; i++) fscanf(fr, "%f", &thprot[i]); 
	wrides(fr,fw);
	for (i = 0; i < nprot; i++) fprintf(fw, "%6.2f", thprot[i]);
	}
      if (nfat == -1) readdes(fr); 
      if (nfat > -1) {
	for (j = 0; j <= nfat; j++) {
	  for (i = 0; i <= 2; i++) fscanf(fr, "%f", &rf[i][j]);
	}
	wrides(fr,fw);
	fprintf(fw, "\n         ");
	for (j = 0; j <= nfat; j++) {
	  for (i = 0; i <= 2; i++) fprintf(fw, "%8.3f", rf[i][j]);
	  if (j < nfat) fprintf(fw, "\n         ");
	}      
      }  
      if (nprot == -1) readdes(fr); 
      if (nprot > -1) {
	for (j = 0; j <= nprot; j++) {
	  for (i = 0; i <= 2; i++) fscanf(fr, "%f", &rp[i][j]);
	  }
	wrides(fr,fw);
	fprintf(fw, "\n         ");    
	for (j = 0; j <= nprot; j++) {
	  for (i = 0; i <= 2; i++) fprintf(fw, "%8.3f", rp[i][j]);
	  if (j<nprot) fprintf(fw, "\n         ");      
	}
      }  
      sigmafat = readfloat(fw,fr);
      sigmaprot = readfloat(fw,fr);
    }
    else for (i = 1; i <= 8; i++) readdes(fr);
    readcom(fr);
    if (milkprice == 1 || milkprice == 3) nSCC = 1;  
    if (milkprice == 2 || milkprice > 3){ 
      mSCS = readfloat(fw,fr);
      sigmaSCS = readfloat(fw,fr);  
      nSCC = readint(fw,fr);  
      for (i = 0; i < nSCC - 1; i++) fscanf(fr, "%f", &tSCC[i]);
      wrides(fr,fw);
      for (i = 0; i < nSCC - 1; i++) fprintf(fw, "%9.0f", tSCC[i]);
    }
    else for (i = 1; i <= 4; i++) readdes(fr);  
    readcom(fr);
    if (milkprice == 2 || milkprice == 4){
      for (i = 0; i < nSCC; i++) fscanf(fr, "%f", &prSCC[i]);
      wrides(fr,fw);
      for (i = 0; i < nSCC; i++) fprintf(fw, "%12.4f", prSCC[i]);
    }  
    else readdes(fr);
    readcom(fr);        
    if (milkprice == 5){  
      for (i=0; i < nSCC; i++) {
	fscanf(fr, "%f", &facSCC[i]);
	fscanf(fr, "%f", &prSCC[i]);
      }
      wrides(fr,fw);
      fprintf(fw, "\n         ");    
      for (i = 0; i < nSCC; i++) {
	fprintf(fw, "%10.3f", facSCC[i]);
	fprintf(fw, "%12.4f", prSCC[i]);
	if (i < nSCC-1) fprintf(fw, "\n         ");      
      }
    }  
    else readdes(fr);
    readcom(fr);        
    if (pmilkch > 0.000001 && typeb == 1) {
      prcheese = readfloat(fw,fr);
      prwhey = readfloat(fw,fr);
    }    
    else for (i = 1; i <= 2; i++) readdes(fr);  
    fclose(fr); /* End of reading INPUTS11.TXT  */    
    fprintf(fw, "\n\n\n");
  }
  for (i = 0; i < nSCC-1; i++) tSCS[i] = scs(tSCC[i]);      

  /* Reading input file INPUTS12.TXT and writing the data from this file 
     to the results file */
  if (breed == 1) printf("Reading data from INPUTS12A.TXT\n");   
  if (breed == 2) printf("Reading data from INPUTS12B.TXT\n");   
  n2 = 12;
  zz++;
  inp00(fw,n2,zz,breed);
  if (breed == 1) fr = fopen("INPUTS12A.TXT", "r");
  if (breed == 2) fr = fopen("INPUTS12B.TXT", "r");
  readcom(fr);
  priceS = readint(fw,fr);
  readcom(fr);
  if (priceS == 1) {
    prlwS[1] = readfloat(fw,fr);
    if (crossing == 2) prlwS[2] = readfloat(fw,fr);
    else readdes(fr);
  }
  else for (i = 1; i <=2; i++) readdes(fr);
  readcom(fr);  
  if (priceS == 2) {
    nclS = readint(fw,fr);
    for (i = 1; i <= nclS; i++) fscanf(fr, "%f", &prclS[i]);
    wrides(fr,fw);
    for (i = 1; i <= nclS; i++) fprintf(fw, "%12.4f", prclS[i]);
    for (j = 1; j <= crossing; j++) {
      for (i = 1; i <= nclS; i++) fscanf(fr, "%f", &pclS[j][i]);
      wrides(fr,fw);
      for (i = 1; i <= nclS; i++) fprintf(fw, "%8.2f", pclS[j][i]);
      a2 = 0;
      for (i = 1; i <= nclS; i++) a2 += pclS[j][i];
      if (a2 >= 1.00001 || a2 <= 0.99999) {
	nonsense09(breed,j,1,12,a2);
	errmess = 1;
	goto END;
      }  
    }
    if (crossing == 1) readdes(fr);
  }  
    else for (i = 1; i <= 3; i++) readdes(fr);
  readcom(fr);      
  if (priceS == 3) {
    prcwS[1] = readfloat(fw,fr);
    if (crossing == 2) prcwS[2] = readfloat(fw,fr);
    else readdes(fr);
  }
  else for (i = 1; i <=2; i++) readdes(fr);
  readcom(fr);          
  if (priceS == 4) {
    nclflS = readint(fw,fr);
    nclfcS = readint(fw,fr);
    prrefS = readfloat(fw,fr);
    for (i = 1; i <= nclflS; i++) 
      for (j = 1; j <= nclfcS; j++) 
        fscanf(fr, "%f", &prclfcS[i][j]);
    wrides(fr,fw);    
    for (i = 1; i <= nclflS; i++) {
      fprintf(fw, "\n");
      for (j = 1; j <= nclfcS; j++) 
        fprintf(fw, "%12.4f", prclfcS[i][j]);
    }
    for (k = 1; k <= crossing; k++) {
      a2 = 0;
      for (i = 1; i <= nclflS; i++) {
	for (j = 1; j <= nclfcS; j++) { 
          fscanf(fr, "%f", &pclfcS[k][i][j]);
	  a2 += pclfcS[k][i][j];
	}
      }
      if (a2 >= 1.00001 || a2 <= 0.99999) {
	nonsense09(breed,k,2,12,a2);
	errmess = 1;
	goto END;
      }    	
      wrides(fr,fw);    
      for (i = 1; i <= nclflS; i++) {
	fprintf(fw, "\n");
	for (j = 1; j <= nclfcS; j++) 
          fprintf(fw, "%8.3f", pclfcS[k][i][j]);
      }
    }
    if (crossing == 1) readdes(fr);
  }
    else for (i = 1; i <= 6; i++) readdes(fr);
  readcom(fr);
  if (priceS == 3 || priceS == 4) {
    dresE = readfloat(fw,fr);
    dresR[1] = readfloat(fw,fr);
    if (crossing == 2) dresR[2] = readfloat(fw,fr);
      else readdes(fr);
    dresrL[1] = readfloat(fw,fr);
    if (crossing == 2) dresrL[2] = readfloat(fw,fr);
      else readdes(fr);
  }
    else for (i = 1; i <= 5; i++) readdes(fr);
  fclose(fr); /* End of reading INPUTS12.TXT  */    
  fprintf(fw, "\n\n\n");

  if (typeb > 1) datdry = datwL;
/* Coefficients for dressing percentage of adult sheep */
  if (priceS > 2) {
    kdresER = dresR[1] / dresE;
    kdresEL = dresrL[1] / dresE;
    if (crossing == 2) kdresRL = dresrL[2] / dresR[2];
  }
/* Growth 1 */
  /* Calculation of several coefficients which are not changed in the calculation
     of economic weights */
  printf("Calculating several constants for growth\n");   
  agewL = datwL - datlamb;    
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= crossing; j++) {
      for (k = 1; k <= 2; k++) {
	adgbwL[k][i][j] = (wwL[k][i][j] - bwL[k][i][j]) / (float)agewL;
	if (bwL[1][1][j] > 0.000001)
	  kbw[k][i][j] = bwL[k][i][j] / bwL[1][1][j];
	if (adgbwL[1][1][j] > 0.000001)  
	  kadgbw[k][i][j] = adgbwL[k][i][j] / adgbwL[1][1][j];
	if (typew == 2) {
	  adgwarL[k][i][j] = (warL[k][i][j] - wwL[k][i][j]) / (agearL - agewL);
	  if (adgwarL[1][1][j] > 0.000001)
	    kadgwar[k][i][j] = adgwarL[k][i][j] / adgwarL[1][1][j]; 
	}
      }	
    }
  }
  if (lf[1] >= 1) {
    k = 0;  
    for (i = 1; i <= lf[1]; i++) {
      if (clf[1][i] == 0 || clf[1][i] == 1) {
	k0[1][1] = i;
	k++;
      }
      if (k > 0) break;
    }  
    k = 0;  
    for (i = 1; i <= lf[1]; i++) {
      if (clf[1][i] == 0 || clf[1][i] == 2) {
	k0[1][2] = i;
	k++;
      }
      if (k > 0) break;
    } 
  }
  if (lf[2] >= 1) {
    k = 0;  
    for (i = 1; i <= lf[2]; i++) {
      if (clf[2][i] == 0 || clf[2][i] == 1) {
	k0[2][1] = i;
	k++;
      }
      if (k > 0) break;
    }  
    k = 0;  
    for (i = 1; i <= lf[2]; i++) {
      if (clf[2][i] == 0 || clf[2][i] == 2) {
	k0[2][2] = i;
	k++;
      }
      if (k > 0) break;
    }  
  }
  if (lf[0] >= 1) {
    k = 0;  
    for (i = 1; i <= lf[0]; i++) {
      if (clf[0][i] == 0 || clf[0][i] == 1) {
	k0[0][1] = i;
	k++;
      }
      if (k > 0) break;
    }  
    k = 0;  
    for (i = 1; i <= lf[0]; i++) {
      if (clf[0][i] == 0 || clf[0][i] == 2) {
	k0[0][2] = i;
	k++;
      }
      if (k > 0) break;
    }  
  }
  if (k0[0][1] + k0[1][1] + k0[2][1] > 0) fatpb = 1;
  if (k0[0][2] + k0[1][2] + k0[2][2] > 0) fatcb = 1;
  if (k0[1][1] > 0) ispb = 1;
  if (k0[1][2] > 0) iscb = 1;
  if (k0[1][1] == 0 && k0[2][1] > 0) ispb = 2;
  if (k0[1][2] == 0 && k0[2][2] > 0) iscb = 2;
  if (k0[1][1] == 0 && k0[2][1] == 0 && k0[0][1] > 0) ispb = 0;
  if (k0[1][2] == 0 && k0[2][2] == 0 && k0[0][2] > 0) iscb = 0;
  ilpb = k0[ispb][1];
  ilcb = k0[iscb][2];
  if (ispb == 1) ipb = ilpb + 7;
  if (ispb == 2) ipb = ilpb + 32;
  if (ispb == 0) ipb = ilpb + 42;
  if (iscb == 1) icb = ilcb + 7;
  if (iscb == 2) icb = ilcb + 32;
  if (iscb == 0) icb = ilcb + 42;
  for (j = 1; j <= crossing; j++) {
    k = k0[1][j];
    if (lf[1] >= 1 && adgP[k+7][j] > 0.000001) {
      for (i = 1; i <= lf[1]; i++)
        kadgfat[1][i][j] = adgP[i+7][j] / adgP[k+7][j];
      if (lf[2] >= 1) for (i = 1; i <= lf[2]; i++)
        kadgfat[2][i][j] = adgP[i+32][j] / adgP[k+7][j];
      if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
        kadgfat[0][i][j] = adgP[i+42][j] / adgP[k+7][j];
    }
    k = k0[2][j];
    if (lf[1] == 0 && lf[2] >= 1 && adgP[k+32][j] > 0.000001) {
      for (i = 1; i <= lf[2]; i++)
        kadgfat[2][i][j] = adgP[i+32][j] / adgP[k+32][j];
      if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
        kadgfat[0][i][j] = adgP[i+42][j] / adgP[k+32][j];
    }
    k = k0[0][j];
    if (lf[1] == 0 && lf[2] == 0 && lf[0] >= 1 && adgP[k+42][j] > 0.000001) {
      for (i = 1; i <= lf[0]; i++)
        kadgfat[0][i][j] = adgP[i+42][j] / adgP[k+42][j];
    }
  }
  for (j = 1; j <= crossing; j++) {
    if (adgr[1][1][j] > 0.000001) {  
      for (i = 1; i <= bs[1]; i++) 
	kadgr[1][i][j] = adgr[1][i][j]/adgr[1][1][j];
      for (i = 1; i <= bs[2]; i++) 
	kadgr[2][i][j] = adgr[2][i][j]/adgr[1][1][j];
    }
    if (adgr[2][1][j] > 0.000001 && adgr[1][1][j] < 0.000001) {  
      for (i = 1; i <= bs[2]; i++) 
	kadgr[2][i][j] = adgr[2][i][j]/adgr[2][1][j];
    }
    if (conrateFP[1][j] > 0.000001) {
      for (i = 1; i <= bs[1]; i++) 
	kconrateFP[i][j] = conrateFP[i][j]/conrateFP[1][j];
    }  	
  }
  if (mwE[1] > 0.000001) kmwRE[1] = mwR[1] / mwE[1];
  if (mwE2 > 0.000001) kmwRE[2] = mwR[2] / mwE2;
  /* Coefficients for wool production */
  kwE = wsheE / wsheR[1];
  for (i = 1; i <= 2; i++) {
    for (j = 1; j <= crossing; j++) {
      if (typew == 2) kwarL[i][j] = wshearL[i][j] / wsheR[j];
      if (typew == 1) kwwL[i][j] = wshewL[i][j] / wsheR[j];
      kwrL[i][j] = wsherL[i][j] / wsheR[j];
    }
  }
  for (i = 0; i <= 2; i++) {
    for (j = 1; j <= crossing; j++) {
      if (lf[i] > 0) kwfL[i][j] = wshefL[i][j] / wsheR[j];
    }
  }

Start: /* Begin of the program block for the calculation of economic weights */
/* Recalculation of several parameters */
  if (priceS > 2) {
    dresR[1] = kdresER * dresE;
    dresrL[1] = kdresEL * dresE;
    if (crossing == 2) dresrL[2] = kdresRL * dresR[2];
  }
  if (priceS == 2) {
    for (j = 1; j <= crossing; j++) {
      avclS[j] = 0;
      for (i = 1; i <= nclS; i++) avclS[j] += i * pclS[j][i];
    }
  }
  if (priceS == 4) {
    for (j = 1; j <= crossing; j++) {
      avfleshS[j] = avfcS[j] = 0;
      for (i = 1; i <= nclflS; i++) {
        a2 = 0;
	for (k = 1; k <= nclfcS; k++) a2 += pclfcS[j][i][k];
	avfleshS[j] += i * a2;
      }
      for (k = 1; k <= nclfcS; k++) {
        a2 = 0;
	for (i = 1; i <= nclflS; i++) a2 += pclfcS[j][i][k];
	avfcS[j] += k * a2;
      }	
    }
  }
  for (i = 1; i <= bs[1]; i++) {
    for (j = 1; j <= crossing; j++)
      conrateFP[i][j] = kconrateFP[i][j] * conrateFP[1][j];
    }
/* Recalculation of fleece weight */
  wsheE = kwE * wsheR[1];
  for (i = 1; i <= 2; i++) {
    for (j = 1; j <= crossing; j++) {
      if (typew == 2) wshearL[i][j] = kwarL[i][j] * wsheR[j];
      if (typew == 1) wshewL[i][j] = kwwL[i][j] * wsheR[j];
      wsherL[i][j] = kwrL[i][j] * wsheR[j];
    }
  }
  for (i = 0; i <= 2; i++) {
    for (j = 1; j <= crossing; j++) {
      if (lf[i] > 0) wshefL[i][j] = kwfL[i][j] * wsheR[j];
    }
  }
/* Structure of the ewe flock */
  /* Preparing data for matrix TE */
  if (trait == 0) printf("Calculating the structure of the ewe flock\n");
  TE = nstgE * (LL-1) + nstg1E;
  if (lpreg >= datlamb + lengthrc - datbbs) {
    nonsense22(breed);
    errmess = 1;
    goto END;
  }  
  for (i = 1; i <= LL; i++) pcullE[i] = pcullhE[i] + pcullmE[i];
  intml = datlamb - datbbs + lengthrc;
  intlm = lengthrc - intml;
  for (i = 0; i < L; i++)
    pconE[i] = pmatE[i] = pnconE[i] = pnconculE[i] = pnconstayE[i] = 
      pconstayE[i] = 0;
  for (i = 1; i <= LL-1; i++) {
    pmatE[i] = 1 - (pcullE[i]+pdiedE[i]) * intlm / lengthrc;
    pconE[i] = pmatE[i] * conrateE[i];
    pnconE[i] = pmatE[i] * (1 - conrateE[i]);
    pnconculE[i] = pnconE[i] * (1 - pbarrE[i]);
    pnconstayE[i] = 1 - (pcullE[i] + pdiedE[i]) * intml / lengthrc;
      pnconstayE[i] *= pnconE[i] * pbarrE[i];
    pconstayE[i] = 1 - pnconstayE[i] - pnconculE[i] - pcullE[i] - pdiedE[i];  
    }
  pnconculE[LL] = 1 - pcullE[LL] - pdiedE[LL];  

  /* Filling matrix TE */
  /* Setting all elements to 0 */
  for (i1=0; i1<C; i1++) {
    for (i2=0; i2<C; i2++) {
      te[i1][i2] = 0;
      } 
    }   
  /* Filling columns 1 to nstgE*/
  for (i1 = 1; i1 <= nstg1E; i1++) {
    for (i3 = 0; i3 < LL; i3++) {
      te[nstgE*i3+i1][1] = (double) pdiedE[1];
      te[nstgE*i3+i1][2] = (double) pcullE[1];
      te[nstgE*i3+i1][3] = (double) pnconculE[1];
      te[nstgE*i3+i1][4] = (double) pnconstayE[1];
      te[nstgE*i3+i1][5] = (double) pconstayE[1];
	}
      }  
  /* Filling columns nstgE+1 to TE */  
  for (i1 = nstg1E+1; i1 <= nstgE; i1++) {
    for (i3 = 1; i3 <= LL-1; i3++) {
      te[nstgE*(i3-1)+i1][i3*nstgE+1] = (double) pdiedE[i3+1];
      te[nstgE*(i3-1)+i1][i3*nstgE+2] = (double) pcullE[i3+1];
      te[nstgE*(i3-1)+i1][i3*nstgE+3] = (double) pnconculE[i3+1];
      if (i3 == LL-1) break;
      te[nstgE*(i3-1)+i1][i3*nstgE+4] = (double) pnconstayE[i3+1];
      te[nstgE*(i3-1)+i1][i3*nstgE+5] = (double) pconstayE[i3+1];
	}
      }  
  /* Testing the correctness of matrix TE */
  for (i1 = 1; i1 <= TE; i1++) {
    aa1 = 0;
    for (i2 = 1; i2 <= TE; i2++) {
      aa1 = aa1 + te[i1][i2];
      }
    if (aa1 < 0.999999 || aa1 > 1.000001) {
      printf("Sum of elements in a row of TE is different from 1");
      printf("  %d %12.9f\n", i1, aa1); }
    } 
  /* Calculating vector l1E by iteration */
  /* Initial values of the elements of l1E */
  for (i = 0; i < C; i++) 
    l1E[i] = 0;
  l1E[1] = 1; 
  /* Starting the iteration */
  kE = 0;
  a = 1.;
  for (i = 1; i <= TE; i++) 
    l1_0[i] = 0;
  while (a>.0000000000000001) {kE++;
    if (kE > 2000) break;
    sl1E = 0;  /* Sum of elements of l1E */
    a1 = 0;
    for (i = 1; i <= TE; i++) {
      for (j = 1; j <= TE; j++) 
	l1_0[i] = l1_0[i] + te[j][i] * l1E[j];
      }            
    for (i = 1; i <= TE; i++) 
      sl1E = sl1E + l1_0[i];
    for (i = 1; i <= TE; i++) {
      l1_0[i] = l1_0[i]/sl1E;
      a1 += ((l1_0[i] - l1E[i]) * (l1_0[i] - l1E[i]));
      }
    sl1E = 0;	
    for (i = 1; i <= TE; i++) 
      sl1E += l1E[i];
    a = a1/(double) TE;
    for (i = 1; i <= TE; i++) {
      l1E[i] = l1_0[i];
      }	
    }  		
  /* Proportion of ewes in individual reproductive cycles */
  for (i = 0; i < L; i++) l4E[i] = 0;
  for (i = 1; i < LL; i++) {
    for (j = 1; j <= nstgE; j++) 
      l4E[i] += l1E[(i-1)*nstgE + j];
    }
  for (j = 1; j <= nstg1E; j++) 
    l4E[LL] += l1E[(LL-1)*nstgE + j]; 
  avconrateE = 0;
  for (i = 1; i < LL; i++) avconrateE += l4E[i] * conrateE[i];
  avconrateE /= (1 - l4E[LL]);
  avlifelE = 1 / l4E[1];
  /* Proportion of ewes lambing in individual reproductive cycles */
  for (i = 0; i < L; i++) l3E[i] = 0;        
  l3E[1] = l4E[1];
  Nlamb = l3E[1];  
  for (i = 2; i <= LL; i++) {
    l3E[i] = l1E[(i-1)*nstgE];
    Nlamb += l3E[i];  
    }
  pcrosst = 0;
  for (i = 1; i <= LL-1; i++)
    pcrosst += l4E[i]*pcrossE[i]; 
  pcrosst /= (1 - l4E[LL]);  
  pctE[1] = 0;
  for (i = 1; i < LL; i++) pctE[1] += l4E[i] * (1 - pcrossE[i]);
  pctE[1] *= (1 - pinsE[1] * coninsE);
  pctE[2] = 0;  
  for (i = 1; i < LL; i++) pctE[2] += l4E[i] * pcrossE[i];
  pctE[2] *= (1 - pinsE[2] * coninsE);
  avlitE = 0;
  for (j = 1; j <= LL; j++) {
    avlitpE[j] = 0;
    for (i = 1; i <= clt; i++) avlitpE[j] += i * Pltype[i][j];
    avlitE += l3E[j] * avlitpE[j];
  } 
  avlitE /= Nlamb;
  pdiedE0 = pcullhE0 = pcullmE0 = pcullfcE0 = 0;
  for (i = 1; i <= LL; i++) {
    pdiedE0 += l4E[i] * pdiedE[i];
    pcullhE0 += l4E[i] * pcullhE[i];
    pcullmE0 += l4E[i] * pcullmE[i];
    if (i < LL) pcullfcE0 += l1E[(i-1)*nstgE + nstg1E];
  }
  pdiedEp = 100 * pdiedE0 / l4E[1];
  pcullhEp = 100 * pcullhE0 / l4E[1];
  pcullmEp = 100 * pcullmE0 / l4E[1];
  pcullfcEp = 100 * pcullfcE0 / l4E[1];
  
/* Structure of the ram population */
  /* Preparing data for matrix TR */
  if (trait == 0) printf("Calculating the structure of the ram population\n");
  TR = nstgR * (RR-1) + nstg1R;
  for (i = 0; i < R; i++)
    pstayR[i] = 0;
  for (i = 1; i <= RR-1; i++) {
    pstayR[i] = 1 - pdiedR[i] - pcullR[i] - psoldR[i];
    if (pstayR[i] < 0.000001) {
      nonsense07(breed);
      errmess = 1;
      goto END;
      }  
    }  
  /* Filling matrix TR */
  /* Setting all elements to 0 */
  for (i1 = 0; i1 < CR; i1++) {
    for (i2 = 0; i2 < CR; i2++) {
      tr[i1][i2] = 0;
      } 
    }
  if (RR == 1) {
    for (i = 1; i <= nstg1R; i++) {  
      tr[i][1] = (double) pdiedR[1];
      tr[i][2] = (double) psoldR[1];
      tr[i][3] = (double) pcullR[1];
      }
    }    
  if (RR > 1) { 
    /* Filling columns 1 to nstgR*/
    for (i1 = 1; i1 <= nstg1R; i1++) {
      for (i3 = 0; i3 < RR; i3++) {
	tr[nstgR*i3+i1][1] = (double) pdiedR[1];
	tr[nstgR*i3+i1][2] = (double) psoldR[1];
	tr[nstgR*i3+i1][3] = (double) pcullR[1];
	tr[nstgR*i3+i1][4] = (double) pstayR[1];
	}
      }  
    /* Filling columns nstgR+1 to TR */  
    for (i1 = nstg1R+1; i1 <= nstgR; i1++) {
      for (i3 = 1; i3 <= RR-1; i3++) {
	tr[nstgR*(i3-1)+i1][i3*nstgR+1] = (double) pdiedR[i3+1];
	tr[nstgR*(i3-1)+i1][i3*nstgR+2] = (double) psoldR[i3+1];
	tr[nstgR*(i3-1)+i1][i3*nstgR+3] = (double) pcullR[i3+1];
	if (i3 == RR-1) break;
	tr[nstgR*(i3-1)+i1][i3*nstgR+4] = (double) pstayR[i3+1];
	  }
	}  
    } 
  /* Testing the correctness of matrix TR */
  for (i1 = 1; i1 <= TR; i1++) {
    aa1 = 0;
    for (i2 = 1; i2 <= TR; i2++) {
      aa1 = aa1 + tr[i1][i2];
      }
    if (aa1 < 0.999999 || aa1 > 1.000001) {
      printf("Sum of elements in a row of TR is different from 1");
      printf("  %d %12.9f\n", i1, aa1); }
    } 
  /* Calculating vector l1R by iteration */
  /* Initial values of the elements of l1R */
  for (i = 0; i < CR; i++) 
    l1R[i] = 0;
  l1R[1] = 1; 
  /* Starting the iteration */
  kR = 0;
  a = 1.;
  for (i = 1; i <= TR; i++) 
    l1_0[i] = 0;
  while (a>.0000000000000001) {kR++;
    if (kR > 2000) break;
    sl1R = 0;  /* Sum of elements of l1R */
    a1 = 0;
    for (i = 1; i <= TR; i++) {
      for (j = 1; j <= TR; j++) 
	l1_0[i] = l1_0[i] + tr[j][i] * l1R[j];
      }            
    for (i = 1; i <= TR; i++) 
      sl1R = sl1R + l1_0[i];
    for (i = 1; i <= TR; i++) {
      l1_0[i] = l1_0[i]/sl1R;
      a1 += ((l1_0[i] - l1R[i]) * (l1_0[i] - l1R[i]));
      }
    sl1R = 0;	
    for (i = 1; i <= TR; i++) 
      sl1R += l1R[i];
    a = a1/(double) TR;
    for (i = 1; i <= TR; i++) {
      l1R[i] = l1_0[i];
      }	
    }  		
  /* Frequencies of rams of the breed of the flock and rams used for crossing 
     in the individual categories */
  for (i = 1; i <= TR; i++) {
    l1aR[i][1] = l1R[i] * (double)(1 - pcrosst);
    l1aR[i][2] = l1R[i] * (double)(pcrosst);
  }  
  /* Proportion of rams in individual breeding cycles */
  for (i = 0; i < R; i++) l4R[i] = 0;
  for (i = 1; i < RR; i++) {
    for (j = 1; j <= nstgR; j++) 
      l4R[i] += l1R[(i-1)*nstgR + j];
    }
  for (j = 1; j <= nstg1R; j++) 
    l4R[RR] += l1R[(RR-1)*nstgR + j]; 

/* Structure of progeny until weaning */
  if (trait == 0) printf("Calculating the structure of progeny until weaning\n");

  /* Number of lambs born per ewe and reproductive cycle,
     number of lambs alive at 24 hours after birth per ewe and reproduction
     cycle and number of lambs weaned per ewe and reproductive cycle */    
  for (i = 0; i < CB; i++) {
    NbtL[i] = Na24hL[i] = NwL[i] = NarL[i] = 0;
    for (j = 0; j < CLT; j++)
      nbtL[i][j] = na24hL[i][j] = nwL[i][j] = narL[i][j] = 0;
    }
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      a2 = i * Pltype[i][j] * l3E[j] * (1-pcrossE[j-1]);
      nbtL[1][i] += a2;
      if (crossing == 2) {
	a2 = i * Pltype[i][j] * l3E[j] * pcrossE[j-1];
	nbtL[2][i] += a2;
        }
      }
    na24hL[1][i] = nbtL[1][i] * (1 - pdiedbL[i][1]); 
    if (crossing == 2) na24hL[2][i] = nbtL[2][i] * (1 - pdiedbL[i][2]);  
    nbtL[0][i] = nbtL[1][i] + nbtL[2][i]; 
    na24hL[0][i] = na24hL[1][i] + na24hL[2][i]; 
    }
  for (i = 1; i <= crossing; i++) {
    for (j = 1; j <= clt; j++) {
      nwL[i][j] = (1 - pdiedwL[j][i]) * na24hL[i][j];
      nwL[0][j] += nwL[i][j];    
      if (typew == 2) {
        narL[i][j] = (1 - pdiedarL[j][i]) * nwL[i][j];
	narL[0][j] += narL[i][j];
      }	
      NbtL[i] += nbtL[i][j];
      Na24hL[i] += na24hL[i][j];
      NwL[i] += nwL[i][j];
      if (typew == 2) NarL[i] += narL[i][j];
      } 
    NbtL[0] += NbtL[i];
    Na24hL[0] += Na24hL[i];  
    NwL[0] += NwL[i];
    if (typew == 2) NarL[0] += NarL[i];
    avsur24hL[i] = 100 * Na24hL[i] / NbtL[i];  
    if (typew == 1) avsurwL[i] = 100 * NwL[i] / Na24hL[i];
    if (typew == 2) avsurarL[i] = 100 * NarL[i] / Na24hL[i];
    } 
  /* Calculating vector l1L - first part */
  for (i = 0; i < P; i++) {
    for (j = 0; j < CB; j++)
      for (k = 0; k < CLT; k++)
        l1L[i][j][k] = 0;  
    }
  for (j = 0; j <= crossing; j++) {
    for (k = 1; k <= clt; k++) {
      l1L[1][j][k] = nbtL[j][k] - na24hL[j][k];
      if (typew == 1) l1L[2][j][k] = na24hL[j][k] - nwL[j][k];
      if (typew == 2) l1L[2][j][k] = na24hL[j][k] - narL[j][k];
      l1L[5][j][k] = sexrbf * nwL[j][k];
      l1L[30][j][k] = sexrbm * nwL[j][k];
      if (typew == 2) {
        l1L[6][j][k] = sexrbf * narL[j][k];
	l1L[31][j][k] = sexrbm * narL[j][k];
	}
      }
    } 

  /* Calculating vector l1skL - first part */
  for (i = 0; i < P; i++) {
    for (j = 0; j < CB; j++)
      l1skL[i][j] = 0;  
    }
  for (i = 1; i <= PP; i++) {
    if (i == 3) i = 5;
    if (i == 7) i = 30;
    if (i == 32) break;
    for (j = 0; j <= crossing; j++)
      for (k = 1; k <= clt; k++)
        l1skL[i][j] += l1L[i][j][k];  
    } 

/* Growth 2 */
  if (trait == 0) printf("Calculating parameters of growth\n");
/* Recalculation of growth parameters */
  for (j = 1; j <= crossing; j++) {   
    for (i = 1; i <= clt; i++) {
      for (k = 1; k <= 2; k++) {      
	bwL[k][i][j] = kbw[k][i][j] * bwL[1][1][j];
	adgbwL[k][i][j] = kadgbw[k][i][j] * adgbwL[1][1][j];
        if (typew == 2)	adgwarL[k][i][j] = kadgwar[k][i][j] * adgwarL[1][1][j];
      }
    } 
  }
  for (j = 1; j <= crossing; j++) {
    k = k0[1][j];
    if (lf[1] >= 1) {
      for (i = 1; i <= lf[1]; i++)
        adgP[i+7][j] = kadgfat[1][i][j] * adgP[k+7][j];
      if (lf[2] >= 1) for (i = 1; i <= lf[2]; i++)
        adgP[i+32][j] = kadgfat[2][i][j] * adgP[k+7][j];
      if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
        adgP[i+42][j] = kadgfat[0][i][j] * adgP[k+7][j];
    }
    k = k0[2][j];
    if (lf[1] == 0 && lf[2] >= 1) {
      for (i = 1; i <= lf[2]; i++)
        adgP[i+32][j] = kadgfat[2][i][j] * adgP[k+32][j];
      if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
        adgP[i+42][j] = kadgfat[0][i][j] * adgP[k+32][j];
    }
    k = k0[0][j];
    if (lf[1] == 0 && lf[2] == 0 && lf[0] >= 1) {
      for (i = 1; i <= lf[0]; i++)
        adgP[i+42][j] = kadgfat[0][i][j] * adgP[k+42][j];
    }
  }
  for (j = 1; j <= crossing; j++) {
    if (adgr[1][1][j] > 0.000001) {  
      for (i = 1; i <= bs[1]; i++) 
	adgr[1][i][j] = kadgr[1][i][j] * adgr[1][1][j];
      for (i = 1; i <= bs[2]; i++) 
	adgr[2][i][j] = kadgr[2][i][j] * adgr[1][1][j];
    }
    if (adgr[2][1][j] > 0.000001 && adgr[1][1][j] < 0.000001) {  
      for (i = 1; i <= bs[2]; i++) 
	adgr[2][i][j] = kadgr[2][i][j] * adgr[2][1][j];
    }	
  }
  mwR[1] = kmwRE[1] * mwE[1];
  if (crossing == 2) { 
    mwE[2] = (1 + hetmw/100) * (mwE[1] + mwE2)/2;
    mwR[2] = kmwRE[2] * mwE2; 
    mwMP[2] = (1 + hetmw/100) * (mwR[1] + mwR[2])/2;
    }
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= crossing; j++) {
      for (k = 1; k <= 2; k++) {      
	wwL[k][i][j] = bwL[k][i][j] + adgbwL[k][i][j] * agewL;
	if (typew == 2) 
	  warL[k][i][j] = wwL[k][i][j] + adgwarL[k][i][j] * (agearL - agewL);
      }	
    }
  }
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= clt; i++) {
      pwL[i][j] = nwL[j][i] / NwL[j];
      if (typew == 2) parL[i][j] = narL[j][i] / NarL[j]; 
      }
    }
  for (j = 1; j <= crossing; j++) {
    for (i = 0; i < SP; i++)
      avww[i][j] =  avwar[i][j] = 0;
    for (i = 1; i <= clt; i++) {
      avww[1][j] += wwL[1][i][j] * pwL[i][j];
      avww[2][j] += wwL[2][i][j] * pwL[i][j];
      if (typew == 2) {
	avwar[1][j] += warL[1][i][j] * parL[i][j];
	avwar[2][j] += warL[2][i][j] * parL[i][j];
	}
      }
      wP[32][j] = avww[0][j] = avww[2][j];
      wP[7][j] = avww[1][j];
      if (typew == 1) wP[2][j] = 0.25 * (avww[1][j] + avww[2][j]);
      if (typew == 2) {
        wP[32][j] = avwar[0][j] = avwar[2][j];
	wP[7][j] = avwar[1][j];	
	wP[2][j] = 0.25 * (avwar[1][j] + avwar[2][j]);
      }	
    }

  /* Growth of breeding female progeny from weaning till mature weight */
  for (i = 1; i <= bs[1]; i++) 
    ager[1][i] = datbbs + (i - 1) * (float)lengthrc - datlamb + 1;
  if (typew == 1) a2 = (float)agewL;
    else a2 = (float)agearL;  
  for (j = 1; j <= crossing; j++) {
    if (psold[1][0][j] > 0.000001) {  
      if (agetP[13][j] > ager[1][1] || agetP[13][j] < a2) {
	nonsense03(breed,1,j,a2,ager[1][1]);
	errmess = 1;
	goto END;
	}
      if (agetP[26][j] > ager[1][2] || agetP[26][j] <= ager[1][1]) {
	nonsense03(breed,2,j,ager[1][1]+1,ager[1][2]);
	errmess = 1;
	goto END;
	}
      }	
    } 
  if (psp[1][2][2] < 0.000001) j1 = 1;
    else j1 = crossing;
  for (j = 1; j <= j1; j++) {
    if (typew == 1) 
      wrL[1][1][j] = avww[1][j] + adgr[1][1][j] * (ager[1][1] - agewL);
    if (typew == 2) 
      wrL[1][1][j] = avwar[1][j] + adgr[1][1][j] * (ager[1][1] - agearL);
    if (wrL[1][1][j] > mwE[j]) {
      nonsense24(breed,1,j,1);
      errmess = 1;
      goto END;
    }
    sigmawr[1][j] = vcwr[1][j] * wrL[1][1][j] / 100;
  }
  for (j = 1; j <= j1; j++) {
    minw[1][j] = mwE[j] * pwrepFP[j];  
    pmat[1][1][j] = 1 - normdis((minw[1][j] - wrL[1][1][j])/sigmawr[1][j]);    
    wmat[1][j] = probit(1 - pmat[1][1][j]/2) * sigmawr[1][j] + wrL[1][1][j];  
    wnmat[1][j] = probit((1 - pmat[1][1][j])/2) * sigmawr[1][j] + wrL[1][1][j]; 
    wrL[1][2][j] = wnmat[1][j] + adgr[1][2][j] * (ager[1][2] - ager[1][1]); 
    if (wrL[1][2][j] > mwE[j]) {
      nonsense24(breed,1,j,2);
      errmess = 1;
      goto END;
    }
    wrL[1][3][j] = mwE[j];
    adgr[1][3][j] = (wrL[1][3][j] - wrL[1][2][j]) / (ager[1][3] - ager[1][2]); 
  }
  wlFP[1] = wmat[1][1] + adgr[1][2][1] * (datlamb + lengthrc - datbbs);
  wlFP[2] = wrL[1][2][1] + adgr[1][3][1] * (datlamb + lengthrc - datbbs);
  wlFP[3] = mwE[1];
  for (i = 1; i <= bs[1]; i++)  
    agelFP[i] = i * (float)lengthrc;
    
  /* Weight of female progeny */
  for (i = 1; i <= bs[1]; i++)
    datconFP[i] = datlamb + i * lengthrc - lpreg;
  if (psp[1][2][2] < 0.000001) j1 = 1;
    else j1 = crossing;
  for (j = 1; j <= j1; j++) {
    if (typew == 1 && psold[1][0][j] > 0.000001) 
      wP[13][j] = avww[1][j] + adgr[1][1][j] * (agetP[13][j] - agewL);
    if (typew == 2 && psold[1][0][j] > 0.000001) 
      wP[13][j] = avwar[1][j] + adgr[1][1][j] * (agetP[13][j] - agearL);
    wP[15][j] = wmat[1][j] + adgr[1][2][j] * (datconFP[1] + dpregsFP - datbbs);
    wP[19][j] = wrL[1][2][j] + adgr[1][3][j] * (datconFP[2] + dpregsFP 
      - datbbs);
    wP[17][j] = wmat[1][j] + adgr[1][2][j] * (datebs + dnpregcFP - datbbs);
    wP[21][j] = wrL[1][2][j] + adgr[1][3][j] * (datebs + dnpregcFP 
      - datbbs);
    wP[23][j] = wP[25][j] = mwE[j];
    if (1 - ps13[j] > 0.000001) 
      wP[26][j] = wnmat[1][j] + adgr[1][2][j] * (agetP[26][j] - ager[1][1]);
  }

  /* Growth of breeding male progeny from weaning till mature weight */
  if (psp[2][2][2] < 0.000001) j1 = 1;
    else j1 = crossing;
  for (i = 1; i <= bs[2]; i++) 
    ager[2][i] = datbbs + (i - 1) * lengthrc - datlamb + 1;  
    for (j = 1; j <= j1; j++) {
      if (typew == 1) 
	wrL[2][1][j] = avww[2][j] + adgr[2][1][j] * (ager[2][1] - agewL);
      if (typew == 2) 
	wrL[2][1][j] = avwar[2][j] + adgr[2][1][j] * (ager[2][1] - agearL);
      if (wrL[2][1][j] > mwMP[j]) {
	nonsense24(breed,2,j,1);
	errmess = 1;
	goto END;
      }
      sigmawr[2][j] = vcwr[2][j] * wrL[2][1][j] / 100;
    } 
  for (j = 1; j <= j1; j++) {
    minw[2][j] = mwMP[j] * pwrepMP;  
    pmat[2][1][j] = 1 - normdis((minw[2][j] - wrL[2][1][j])/sigmawr[2][j]);    	
    wmat[2][j] = probit(1 - pmat[2][1][j]/2) * sigmawr[2][j] + wrL[2][1][j];  
    wnmat[2][j] = probit((1 - pmat[2][1][j])/2) * sigmawr[2][j] + wrL[2][1][j]; 
    wrL[2][2][j] = wnmat[2][j] + adgr[2][2][j] * (ager[2][2] - ager[2][1]); 
    if (wrL[2][2][j] > mwMP[j]) {
      nonsense24(breed,2,j,2);
      errmess = 1;
      goto END;
    }    
  }
  for (j = 1; j <= crossing; j++) {
    if (psold[2][1][j] > 0.000001) {
      if (agetP[38][j] >= ager[2][1]) {
	nonsense23(breed,1,j);
	errmess = 1;
	goto END;
	}
      if (agetP[40][j] > ager[2][2] || agetP[40][j] < ager[2][1]) {
	nonsense23(breed,2,j);
	errmess = 1;
	goto END;
	}
      }
    }

  /* Weight of male progeny */
  for (j = 1; j <= j1; j++) {
    if (typew == 1) 
      wP[38][j] = avww[2][j] + adgr[2][1][j] * (agetP[38][j] - agewL);
    if (typew == 2) 
      wP[38][j] = avwar[2][j] + adgr[2][1][j] * (agetP[38][j] - agearL);
    wP[39][j] = wrL[2][1][j];  
    wP[40][j] = wrL[2][1][j] + adgr[2][2][j] * (agetP[40][j] - ager[2][1]);  
    wP[41][j] = wrL[2][2][j];
    }
    
  /* Average daily gain in fattening */    
  if (lf[1] > 0) {
    for (i = 1; i <= lf[1]; i++) {
      if (ulf[1][i] == 1) {
        if (clf[1][i] == 0 || clf[1][i] == 1) {
	  if (typew == 1) 
	    agetP[i+7][1] = agewL + (vlf[1][i] - avww[1][1])/adgP[i+7][1];
	  if (typew == 2)
     	    agetP[i+7][1] = agearL + (vlf[1][i] - avwar[1][1])/adgP[i+7][1];
	  wP[7+i][1] = vlf[1][i];  
	}
        if (clf[1][i] == 0 || clf[1][i] == 2) {
	  if (typew == 1) 
	    agetP[i+7][2] = agewL + (vlf[1][i] - avww[1][2])/adgP[i+7][2];
	  if (typew == 2)
	    agetP[i+7][2] = agearL + (vlf[1][i] - avwar[1][2])/adgP[i+7][2];
	  wP[7+i][2] = vlf[1][i];	    
	}
      }
      if (ulf[1][i] == 2) {
        if (clf[1][i] == 0 || clf[1][i] == 1) {
	  if (typew == 1)
	    wP[7+i][1] = avww[1][1] + (vlf[1][i] - agewL) * adgP[i+7][1];
	  if (typew == 2)
	    wP[7+i][1] = avwar[1][1] + (vlf[1][i] - agearL) * adgP[i+7][1];
	  agetP[i+7][1] = vlf[1][i];  
	}
        if (clf[1][i] == 0 || clf[1][i] == 2) {
	  if (typew == 1)
	    wP[7+i][2] = avww[1][2] + (vlf[1][i] - agewL) * adgP[i+7][2];
	  if (typew == 2)
	    wP[7+i][2] = avwar[1][2] + (vlf[1][i] - agearL) * adgP[i+7][2];
	  agetP[i+7][2] = vlf[1][i];    
	}
      }
    }
  }

  if (lf[2] > 0) {
    for (i = 1; i <= lf[2]; i++) {
      if (ulf[2][i] == 1) {
        if (clf[2][i] == 0 || clf[2][i] == 1) {
	  if (typew == 1) 
	    agetP[i+32][1] = agewL + (vlf[2][i] - avww[2][1])/adgP[i+32][1];
	  if (typew == 2)
     	    agetP[i+32][1] = agearL + (vlf[2][i] - avwar[2][1])/adgP[i+32][1];
	  wP[32+i][1] = vlf[2][i];      
	}
        if (clf[2][i] == 0 || clf[2][i] == 2) {
	  if (typew == 1) 
	    agetP[i+32][2] = agewL + (vlf[2][i] - avww[2][2])/adgP[i+32][2];
	  if (typew == 2)
	    agetP[i+32][2] = agearL + (vlf[2][i] - avwar[2][2])/adgP[i+32][2];
	  wP[32+i][2] = vlf[2][i];        
	}
      }
      if (ulf[2][i] == 2) {
        if (clf[2][i] == 0 || clf[2][i] == 1) {
	  if (typew == 1)
	    wP[32+i][1] = avww[2][1] + (vlf[2][i] - agewL) * adgP[i+32][1];
	  if (typew == 2)
	    wP[32+i][1] = avwar[2][1] + (vlf[2][i] - agearL) * adgP[i+32][1];
	  agetP[i+32][1] = vlf[2][i];    
	}
        if (clf[2][i] == 0 || clf[2][i] == 2) {
	  if (typew == 1)
	    wP[32+i][2] = avww[2][2] + (vlf[2][i] - agewL) * adgP[i+32][2];
	  if (typew == 2)
	    wP[32+i][2] = avwar[2][2] + (vlf[2][i] - agearL) * adgP[i+32][2];
	  agetP[i+32][2] = vlf[2][i];    
	}
      }
    }
  }

  if (lf[0] > 0) {
    for (i = 1; i <= lf[0]; i++) {
      if (ulf[0][i] == 1) {
        if (clf[0][i] == 0 || clf[0][i] == 1) {
	  if (typew == 1) 
	    agetP[i+42][1] = agewL + (vlf[0][i] - avww[2][1])/adgP[i+42][1];
	  if (typew == 2)
     	    agetP[i+42][1] = agearL + (vlf[0][i] - avwar[2][1])/adgP[i+42][1];
	  wP[42+i][1] = vlf[0][i];  
	}
        if (clf[0][i] == 0 || clf[0][i] == 2) {
	  if (typew == 1) 
	    agetP[i+42][2] = agewL + (vlf[0][i] - avww[2][2])/adgP[i+42][2];
	  if (typew == 2)
	    agetP[i+42][2] = agearL + (vlf[0][i] - avwar[2][2])/adgP[i+42][2];
	  wP[42+i][2] = vlf[0][i];  
	}
      }
      if (ulf[0][i] == 2) {
        if (clf[0][i] == 0 || clf[0][i] == 1) {
	  if (typew == 1)
	    wP[42+i][1] = avww[2][1] + (vlf[0][i] - agewL) * adgP[i+42][1];
	  if (typew == 2)
	    wP[42+i][1] = avwar[2][1] + (vlf[0][i] - agearL) 
	      * adgP[i+42][1];
	  agetP[i+42][1] = vlf[0][i];      
	}
        if (clf[0][i] == 0 || clf[0][i] == 2) {
	  if (typew == 1)
	    wP[42+i][2] = avww[2][2] + (vlf[0][i] - agewL) * adgP[i+42][2];
	  if (typew == 2)
	    wP[42+i][2] = avwar[2][2] + (vlf[0][i] - agearL) * adgP[i+42][2];
	  agetP[i+42][2] = vlf[0][i];      
	}
      }
    }
  }

/* Structure of progeny after weaning */
  if (trait == 0) printf("Calculating the structure of progeny after weaning\n");

  /* Calculating the number of pure-bred weaned female lambs for replacement */  
  prconFP[1][1] = surbs[1][1][1] * pmat[1][1][1] * conrateFP[1][1];  
  pherd[1][1] = prconFP[1][1] * surmlFP[1];
  pmat[1][2][1] = surbs[1][1][1] - prconFP[1][1];
    a2 = surbs[1][1][1] * pmat[1][1][1] * (1 - conrateFP[1][1]);
    a2 *= (1 - pbarrFP[1][1]);
    pmat[1][2][1] -= a2;
    pmat[1][2][1] *= surbs[1][2][1];
  prconFP[2][1] = pmat[1][2][1] * conrateFP[2][1];
  pherd[1][2] = prconFP[2][1] * surmlFP[1];
  pmat[1][3][1] = (pmat[1][2][1] - prconFP[2][1]) * pbarrFP[2][1] * surbs[1][3][1];
  prconFP[3][1] = pmat[1][3][1] * conrateFP[3][1];
  pherd[1][3] = prconFP[3][1] * surmlFP[1];
  Pherd[1] = 0;
  for (i = 1; i <= bs[1]; i++) Pherd[1] += pherd[1][i];
  nherd[1] = l4E[1] / Pherd[1];  
  nrmatFP[1] = nherd[1] * surbs[1][1][1] * pmat[1][1][1];
  nrdied[1][1][1] = nherd[1] * (1 - surbs[1][1][1]);
  nrcull[1][1][1] = nherd[1] * (pmat[1][1][1] * surbs[1][1][1] - prconFP[1][1]) 
    * (1 - pbarrFP[1][1]);     
  nrmatFP[2] = nherd[1] * pmat[1][2][1];     
  nrdied[1][2][1] = (nherd[1] - nrdied[1][1][1] - nherd[1] * prconFP[1][1]
    - nrcull[1][1][1]) * (1 - surbs[1][2][1]);    
  nrcull[1][2][1] = nherd[1] * (pmat[1][2][1] - prconFP[2][1]) 
    * (1 - pbarrFP[2][1]);     
  nrmatFP[3] = nherd[1] * pmat[1][3][1];         
  nrdied[1][3][1] = (nrmatFP[2] - nherd[1] * prconFP[2][1] - nrcull[1][2][1])
    * (1 - surbs[1][3][1]);    
  nrcull[1][3][1] = nherd[1] * (pmat[1][3][1] - prconFP[3][1]) 
    * (1 - pbarrFP[2][1]);     
  nrdiedmlFP[1] = 0;
  for (i = 1; i <= bs[1]; i++) nrdiedmlFP[1] += prconFP[i][1];
  nrdiedmlFP[1] *= nherd[1] * (1 - surmlFP[1]);   

  /* Surplus weaned female lambs */  
  for (i = 1; i <= crossing; i++) {  
    if (typew == 1) nwsp[1][i] = l1skL[5][i];
    if (typew == 2) nwsp[1][i] = l1skL[6][i];
    }
  if (femrep == 1) {
    nwsp[1][1] -= nherd[1];
    if (nwsp[1][1] < 0) {
      if (crossing == 2) {      
        nonsense27(breed);
	errmess = 1;
      goto END;
      }  
      npurchFP = -nwsp[1][1];
      nwsp[1][1] = 0;
    }
  }
  if (femrep == 2) {
    npurchFP = nherd[1] * ppurchFP;
    nwsp[1][1] -= nherd[1] * (1 - ppurchFP);
  }
  for (i = 1; i <= csp[1]; i++) {
    for (j = 1; j <= crossing; j++)  
      nsp[1][i][j] = nwsp[1][j] * psp[1][i][j];
    }
  if (lf[1] > 0) {
    for (i = 1; i <= lf[1]; i++) {
      for (j = 1; j <= crossing; j++) { 
	ndiedfat[1][i][j] = nsp[1][i+2][j] * (1 - surfat[1][i][j]);
	nfattar[1][i][j] = nsp[1][i+2][j] * surfat[1][i][j];
	}
      }
    }
  for (i = 1; i <= crossing; i++) { 
    nsold[1][0][i] = nsp[1][2][i] * psold[1][0][i]; 
    nspdied[1][1][i] = (nsp[1][2][i] - nsold[1][0][i] * ps13[i]) 
      * (1 - surbs[1][1][i]);
    if (psold[1][0][i] < 1.00000) {    
      nmatFP[1][i] = (nsp[1][2][i] - nsold[1][0][i]) * surbs[1][1][i] 
	* pmat[1][1][i];
      nspcull[1][1][i] = nmatFP[1][i] * (1 - conrateFP[1][i]) * (1 - pbarrFP[1][i]);
      nsold[1][1][i] = nmatFP[1][i] * conrateFP[1][i];
      nmatFP[2][i] = (nsp[1][2][i] - nsold[1][0][i] - nsold[1][1][i] 
	- nspdied[1][1][i] - nspcull[1][1][i]) * surbs[1][2][i];
      nsold[1][2][i] = nmatFP[2][i] * conrateFP[2][i];   
      nspdied[1][2][i] = (nsp[1][2][i] - nsold[1][0][i] - nsold[1][1][i] 
	- nspdied[1][1][i] - nspcull[1][1][i]) * (1 - surbs[1][2][i]);  
      nspcull[1][2][i] = (nmatFP[2][i] - nsold[1][2][i]) * (1 - pbarrFP[2][i]);   
      nmatFP[3][i] = (nmatFP[2][i] - nsold[1][2][i] - nspcull[1][2][i]) 
	* surbs[1][3][i];
      nsold[1][3][i] = nmatFP[3][i] * conrateFP[3][i];  
      nspdied[1][3][i] = (nmatFP[2][i] - nsold[1][2][i] - nspcull[1][2][i])
	* (1 - surbs[1][3][i]);
      nspcull[1][3][i] = nmatFP[3][i] - nsold[1][3][i];               
      }
    }  

  /* Frequencies of rams of the breed of the flock and rams used for crossing 
     in the individual categories */
  a2 = 0;
  for (i = 1; i <= bs[1]; i++) a2 += pmat[1][i][1];
  a2 *= nherd[1];
  for (i = 1; i <= TR; i++) {
    l1aR[i][1] = l1R[i] * (double)((pctE[1] + a2 * (1 - pcrossE[0])) / 
      (pctE[1] + pctE[2] + a2));
    l1aR[i][2] = l1R[i] - l1aR[i][1];
  }  
  for (i = 0; i < R; i++) 
    for (j = 0; j < CB; j++) l5R[i][j] = 0;
  for (i = 1; i <= RR; i++) {
    l5R[i][1] = l4R[i] * (double)((pctE[1] + a2 * (1 - pcrossE[0])) /
      (pctE[1] + pctE[2] + a2));
    l5R[i][2] = l4R[i] - l5R[i][1];
    }

  /* Male lambs for own replacement */
  pherd[2][1] = pmat[2][1][1] * surbs[2][1][1] * (1 - cullbsMP[1][1]);
  pherd[2][2] = surbs[2][1][1] * (1 - cullbsMP[1][1]) * (1 - pmat[2][1][1])
    * surbs[2][2][1] * (1 - cullbsMP[2][1]);
  Pherd[2] = pherd[2][1] + pherd[2][2];  
  pherdyMP = pherd[2][1]/Pherd[2];
  pyoungMP[1] = pherdyMP * l5R[1][1];
  ratioR = pyoungMP[1] * ratioyoungR + (1 - pyoungMP[1]) * ratiooldR;
  a2 = 0;
  for (i = 1; i <= bs[1]; i++) a2 += pmat[1][i][1];
  a2 *= nherd[1] * (1 - pcrossE[0]);
  neweR[1] = (pctE[1] + a2) / ratioR;
  npurchMP[1] = ppurchMP * neweR[1];  
  nramMP[1] = (neweR[1] - npurchMP[1]) * l5R[1][1];
  nherd[2] = nramMP[1] / Pherd[2];
  nrdied[2][1][1] = nherd[2] * (1 - surbs[2][1][1]);
  nrcull[2][1][1] = nherd[2] * cullbsMP[1][1];
  nrdied[2][2][1] = (nherd[2] - nrdied[2][1][1] - nrcull[2][1][1]
    - nherd[2] * pherd[2][1]) * (1 - surbs[2][2][1]);
  nrcull[2][2][1]= (nherd[2] * (1 - pherd[2][1]) - nrdied[2][1][1] 
    - nrcull[2][1][1]) * cullbsMP[2][1];
  a2 = 0;
  for (i = 1; i <= bs[1]; i++) a2 += pmat[1][i][1];
  a2 *= nherd[1] * pcrossE[0];
  neweR[2] = (pctE[2] + a2) / ratioR;
  nramMP[2] = neweR[2] * l5R[1][2];
  npurchMP[2] = nramMP[2];
    
  /* Surplus weaned male lambs */  
  for (i = 1; i <= crossing; i++) {  
    if (typew == 1) nwsp[2][i] = l1skL[5][i];
    if (typew == 2) nwsp[2][i] = l1skL[6][i];
    }
  nwsp[2][1] -= nherd[2];
  for (i = 1; i <= csp[2]; i++) {
    for (j = 1; j <= crossing; j++) 
      nsp[2][i][j] = nwsp[2][j] * psp[2][i][j];
    }
  if (lf[2] > 0) {
    for (i = 1; i <= lf[2]; i++) {
      for (j = 1; j <= crossing; j++) { 
	ndiedfat[2][i][j] = nsp[2][i+3][j] * (1 - surfat[2][i][j]);
	nfattar[2][i][j] = nsp[2][i+3][j] * surfat[2][i][j];
	}
      }
    }
  for (i = 1; i <= crossing; i++) { 
    nsold[2][1][i] = nsp[2][2][i] * surbs[2][1][i] * (1 - cullbsMP[1][i])
      * psold[2][1][i];
    nspdied[2][1][i] = nsp[2][2][i] * (1-surbs[2][1][i]);
    nspcull[2][1][i] = nsp[2][2][i] * cullbsMP[1][i];
    nsold[2][2][i] = (nsp[2][2][i] - nsold[2][1][i] - nspdied[2][1][i]
      - nspcull[2][1][i]) * surbs[2][2][i] * (1 - cullbsMP[2][i]); 
    nspdied[2][2][i] = (nsp[2][2][i] - nsold[2][1][i] - nspdied[2][1][i]
      - nspcull[2][1][i]) * (1 - surbs[2][2][i]);
    nspcull[2][2][i] = (nsp[2][2][i] - nsold[2][1][i] - nspdied[2][1][i]
      - nspcull[2][1][i]) * cullbsMP[2][i];
    }  
  for (i = 1; i <= lf[0]; i++) {
    for (j = 1; j <= crossing; j++) 
      nsp[0][i][j] = nwsp[2][j] * psp[0][i][j];
    }
  if (lf[0] > 0) {
    for (i = 1; i <= lf[0]; i++) {
      for (j = 1; j <= crossing; j++) { 
	ndiedfat[0][i][j] = nsp[0][i][j] * (1 - surfat[0][i][j]);
	nfattar[0][i][j] = nsp[0][i][j] * surfat[0][i][j];
	}
      }
    } 

  /* Calculating vector l1skL - second part */
  /* Category 3 */
  if (lf[1] > 0) {
    for (i = 1; i <= lf[1]; i++) {
      l1skL[3][1] += ndiedfat[1][i][1];
      if (crossing == 2) l1skL[3][2] += ndiedfat[1][i][2];
      }
    for (j = 1; j <= crossing; j++) {
      if (l1skL[3][j] > 0) {
	wP[3][j] = 0;
	if (typew == 1) a2 = avww[1][j];
	  else a2 = avwar[1][j];
	for (i = 1; i <= lf[1]; i++) {
	  wP[3][j] += (wP[7+i][j] + a2) * ndiedfat[1][i][j]; 
	  }
	wP[3][j] /= (2 * l1skL[3][j]);  
        }
      }    
    }       
  /* Category 4 */  
  for (i = 1; i <= bs[1]; i++) 
    l1skL[4][1] += nrdied[1][i][1] + nspdied[1][i][1];
  l1skL[4][1] += nrdiedmlFP[1];
  if (crossing == 2) {
    for (i = 1; i <= bs[1]; i++) l1skL[4][2] += nspdied[1][i][2];
    }   
  if (typew == 1) a2 = avww[1][1];
    else a2 = avwar[1][1];
  if (l1skL[4][1] > 0.000001) {
    wP[4][1] = ((wrL[1][1][1] + a2) * (nrdied[1][1][1] + nspdied[1][1][1])
      + (wrL[1][2][1] + wnmat[1][1]) * (nrdied[1][2][1] + nspdied[1][2][1])
      + (wrL[1][3][1] + wrL[1][2][1]) * (nrdied[1][3][1] + nspdied[1][3][1])
      + nrdiedmlFP[1] * (pherd[1][1] * (wnmat[1][1] + wlFP[1])
      + pherd[1][2] * (wrL[1][2][1] + wlFP[2]) + pherd[1][3] *
      (wrL[1][3][1] + wlFP[3])) / Pherd[1]) / (2 * l1skL[4][1]);
    }
  if (crossing == 2) {
    if (typew == 1) a2 = avww[1][2];
      else a2 = avwar[1][2];
    if (l1skL[4][2] > 0) {
      wP[4][2] = ((wrL[1][1][2] + a2) * (nrdied[1][1][2] + nspdied[1][1][2])
	+ (wrL[1][2][2] + wnmat[1][2]) * (nrdied[1][2][2] + nspdied[1][2][2])
	+ (wrL[1][3][2] + wrL[1][2][2]) * (nrdied[1][3][2] + nspdied[1][3][2]))
	/ (2 * l1skL[4][2]);
      }
    }
  /* Categories 7 to 13 */  
  for (i = 1; i <= crossing; i++) { 
    l1skL[7][i] = nsp[1][1][i];
    if (lf[1] > 0) for (j = 8; j <= 12; j++) l1skL[j][i] = nfattar[1][j-7][i]; 
    l1skL[13][i] = nsold[1][0][i] * ps13[i];
    }  
  /* Category 14 */      
  l1skL[14][1] = (nherd[1] + nsp[1][2][1] - nsold[1][0][1] * ps13[1]) 
    * surbs[1][1][1];
  if (crossing == 2) l1skL[14][2] = (nsp[1][2][2] - nsold[1][0][2] * ps13[2]) 
    * surbs[1][1][2]; 
  /* Category 26 */
  for (j = 1; j <= crossing; j++) 
    l1skL[26][j] = nsold[1][0][j] * (1 - ps13[j]) * surbs[1][1][j];
  /* Categories 18 and 22 */      
  l1skL[18][1] = nrmatFP[2] + nmatFP[2][1];
  if (crossing == 2) l1skL[18][2] = nmatFP[2][2];  
  l1skL[22][1] = nrmatFP[3] + nmatFP[3][1];
  if (crossing == 2) l1skL[22][2] = nmatFP[3][2];  
  /* Categories 15, 19 and 23 */        
  for (i = 1; i <= crossing; i++) { 
    for (j = 15; j <= 23; j++) {
      if (j == 16) j = 19;
      if (j == 20) j = 23;
      k = (j - 11)/4;
      l1skL[j][i] = nsold[1][k][i];
      }
    }    
  /* Categories 16, 20 and 24 */          
  for (j = 16; j <= 24; j++) {
    if (j == 17) j = 20;
    if (j == 21) j = 24;
    k = (j - 12)/4;
    l1skL[j][1] = nherd[1] * pherd[1][k];
    } 
  /* Categories 17, 21 and 25 */        
  for (j = 17; j <= 25; j++) {
    if (j == 18) j = 21;
    if (j == 22) j = 25;
    k = (j - 13)/4;
    l1skL[j][1] = nrcull[1][k][1] + nspcull[1][k][1];
    if (crossing == 2) l1skL[j][2] = nspcull[1][k][2];
    } 
  /* Category 28 */
  if (lf[2] > 0) {
    for (i = 1; i <= lf[2]; i++) {
      l1skL[28][1] += ndiedfat[2][i][1];
      if (crossing == 2) l1skL[28][2] += ndiedfat[2][i][2];
      }
    for (j = 1; j <= crossing; j++) {
      if (l1skL[28][j] > 0) {
	wP[28][j] = 0;
	if (typew == 1) a2 = avww[2][j];
	  else a2 = avwar[2][j];
	for (i = 1; i <= lf[2]; i++) {
	  wP[28][j] += (wP[32+i][j] + a2) * ndiedfat[2][i][j]; 
	  }
	wP[28][j] /= (2 * l1skL[28][j]);  
        }
      }    
    } 
  /* Category 29 */  
  for (i = 1; i <= bs[2]; i++) { 
    l1skL[29][1] += nrdied[2][i][1] + nspdied[2][i][1];
    }
  if (crossing == 2) {
    for (i = 1; i <= bs[2]; i++) l1skL[29][2] += nspdied[2][i][2];
    }  
  for (j = 1; j <= crossing; j++) {
    if (typew == 1) a2 = avww[2][j];
      else a2 = avwar[2][j];
    if (l1skL[29][j] > 0) {
      wP[29][j] = ((wrL[2][1][j] + a2) * (nrdied[2][1][j] + nspdied[2][1][j])
	+ (wrL[2][2][j] + wnmat[2][j]) * (nrdied[2][2][j] + nspdied[2][2][j]))
        / (2 * l1skL[29][j]);
      }
    }

  /* Categories 32 to 38 and 40 */  
  for (i = 1; i <= crossing; i++) { 
    l1skL[32][i] = nsp[2][1][i];
    if (lf[2] > 0) for (j = 33; j <= 37; j++) l1skL[j][i] = nfattar[2][j-32][i]; 
    l1skL[38][i] = nsold[2][1][i];
    l1skL[40][i] = nsold[2][2][i];
    }  
  /* Category 39 */      
  l1skL[39][1] = nherd[2] + nsp[2][2][1] - nrdied[2][1][1] - nrcull[2][1][1] 
    - nsold[2][1][1];
  if (crossing == 2) l1skL[39][2] = nsp[2][2][2] - nsold[2][1][2] 
    - nspdied[2][1][2] - nspcull[2][1][2]; 
  /* Category 41 */
  l1skL[41][1] = nherd[2] * pherd[2][2]; 
  /* Category 42 */
  for (i = 1; i <= crossing; i++) { 
    for (j = 1; j <= bs[2]; j++) {
      l1skL[42][i] += nspcull[2][j][i];
      if (i == 1) l1skL[42][i] += nrcull[2][j][i];
      }
    } 
  for (j = 1; j <= crossing; j++) {
    if (l1skL[42][j] > 0.000001) {
      if (typew == 1) a3 = avww[2][j];
      if (typew == 2) a3 = avwar[2][j];
      wP[42][j] = ((a3 + wP[39][j]) * (nrcull[2][1][j] + nspcull[2][1][j])
	  + (wnmat[2][j] + wP[41][j]) * (nrcull[2][2][j] + nspcull[2][2][j])) 
	  / (2 * l1skL[42][j]);
    }
  }    

  /* Categories 43 to 47 */    
  for (i = 1; i <= crossing; i++) { 
    if (lf[0] > 0) for (j = 43; j <= 47; j++) l1skL[j][i] = nfattar[0][j-42][i];
    } 
  /* Category 48 */
  if (lf[0] > 0) {
    for (i = 1; i <= lf[0]; i++) {
      l1skL[48][1] += ndiedfat[0][i][1];
      if (crossing == 2) l1skL[48][2] += ndiedfat[0][i][2];
      }
    for (j = 1; j <= crossing; j++) {
      if (l1skL[48][j] > 0) {
	wP[48][j] = 0;
	if (typew == 1) a2 = avww[2][j];
	  else a2 = avwar[2][j];
	for (i = 1; i <= lf[0]; i++) {
	  wP[48][j] += (wP[42+i][j] + a2) * ndiedfat[0][i][j]; 
	  }
	wP[48][j] /= (2 * l1skL[48][j]);  
        }
      }    
    } 
       
  /* Sum of pure-bred and cross-bred animals */      
  for (i = 3; i <= PP; i++) {
    if (i == 5) i = 7;
    if (i == 30) i = 32;
    l1skL[i][0] = l1skL[i][1] + l1skL[i][2];
    }

  /* Reading input file INPUTS13.TXT and writing the data from this file 
     to the results file */
  if (trait == 0) {
    if (l1skL[7][1] + l1skL[7][2] + l1skL[32][1] + l1skL[32][2] > 0.000001) {   
      if (breed == 1) printf("Reading data from INPUTS13A.TXT\n");   
      if (breed == 2) printf("Reading data from INPUTS13B.TXT\n");   
      n2 = 13;
      zz++;
      inp00(fw,n2,zz,breed);
      if (breed == 1) fr = fopen("INPUTS13A.TXT", "r");
      if (breed == 2) fr = fopen("INPUTS13B.TXT", "r");
      readcom(fr);
      pricewL = readint(fw,fr);
      readcom(fr);
      if (pricewL == 1) {
	prlwwL[1] = readfloat(fw,fr);
	if (crossing == 2) prlwwL[2] = readfloat(fw,fr);
	else readdes(fr);
      }
      else for (i = 1; i <=2; i++) readdes(fr);
      readcom(fr);  
      if (pricewL == 2) {
	nclwL = readint(fw,fr);
	for (i = 1; i <= nclwL; i++) fscanf(fr, "%f", &prclwL[i]);
	wrides(fr,fw);
	for (i = 1; i <= nclwL; i++) fprintf(fw, "%12.4f", prclwL[i]);
	for (j = 1; j <= crossing; j++) {
	  for (i = 1; i <= nclwL; i++) fscanf(fr, "%f", &pclwL[j][i]);
	  wrides(fr,fw);
	  for (i = 1; i <= nclwL; i++) fprintf(fw, "%8.2f", pclwL[j][i]);
	  a2 = 0;
	  for (i = 1; i <= nclwL; i++) a2 += pclwL[j][i];
	  if (a2 >= 1.00001 || a2 <= 0.99999) {
	    nonsense09(breed,j+5,1,13,a2);
	    errmess = 1;
	    goto END;
	  }  
	}
	if (crossing == 1) readdes(fr);
      }
	else for (i = 1; i <= 4; i++) readdes(fr);
      readcom(fr); 
      if (pricewL == 3 || pricewL == 4) {
        dreswL[1] = readfloat(fw,fr);
        if (crossing == 2) dreswL[2] = readfloat(fw,fr);
	else readdes(fr);
      }
	else for (i = 1; i <= 2; i++) readdes(fr);
      readcom(fr);      
      if (pricewL == 3) {
	prcwwL[1] = readfloat(fw,fr);
	if (crossing == 2) prcwwL[2] = readfloat(fw,fr);
	else readdes(fr);
      }
      else for (i = 1; i <=2; i++) readdes(fr);
      readcom(fr);          
      if (pricewL == 4) {
	vcwwL = readfloat(fw,fr);
	for (i = 1; i <= nclcwwL; i++) 
	  for (j = 1; j <= nclcqwL; j++) fscanf(fr, "%f", &prclcwwL[i][j]);
	wrides(fr,fw);
	for (i = 1; i <= nclcwwL; i++) 
	  for (j = 1; j <= nclcqwL; j++) fprintf(fw, "%12.4f", prclcwwL[i][j]);
	for (k = 1; k <= crossing; k++) {
          for (i = 1; i <= nclcwwL; i++) {
	    for (j = 1; j <= nclcqwL; j++) fscanf(fr, "%f", &pclcqwL[i][j][k]);
	    wrides(fr,fw);
	    for (j = 1; j <= nclcqwL; j++) fprintf(fw, "%8.2f", pclcqwL[i][j][k]);
	  }
	}    
	if (crossing == 1) for (i = 1; i <= 3; i++) readdes(fr);
      }
      else for (i = 1; i <= 8; i++) readdes(fr);
      readcom(fr);          
      if (pricewL == 4) {
	nclflwL = readint(fw,fr);
	nclfcwL = readint(fw,fr);
	prrefwL = readfloat(fw,fr);
	for (i = 1; i <= nclflwL; i++) 
	  for (j = 1; j <= nclfcwL; j++) 
            fscanf(fr, "%f", &prclfcwL[i][j]);
	wrides(fr,fw);    
	for (i = 1; i <= nclflwL; i++) {
	  fprintf(fw, "\n");
	  for (j = 1; j <= nclfcwL; j++) 
            fprintf(fw, "%12.4f", prclfcwL[i][j]);
	}
	for (j = 1; j <= crossing; j++) {
	  a2 = 0;    
	  for (i1 = 1; i1 <= nclflwL; i1++) {
	    for (i2 = 1; i2 <= nclfcwL; i2++) { 
              fscanf(fr, "%f", &pclfcwL[j][i1][i2]);
	      a2 += pclfcwL[j][i1][i2];
	    }
	  }  
	  if (a2 >= 1.00001 || a2 <= 0.99999) {
	    nonsense31(breed,j,a2);
	    errmess = 1;
	    goto END;
	  }    	
	  wrides(fr,fw);    
	  for (i1 = 1; i1 <= nclflwL; i1++) {
	    fprintf(fw, "\n");
	    for (i2 = 1; i2 <= nclfcwL; i2++) 
              fprintf(fw, "%8.3f", pclfcwL[j][i1][i2]);
	  }
          if (crossing == 1) readdes(fr); 
	}
      }
      else for (i1 = 1; i1 <= 6; i1++) readdes(fr);
      fclose(fr); /* End of reading INPUTS13.TXT  */    
      fprintf(fw, "\n\n\n");
    }
  }
  if (pricewL == 2) {
    for (j = 1; j <= crossing; j++) {
      avclwL[j] = 0;
      for (i = 1; i <= nclwL; i++) avclwL[j] += i * pclwL[j][i];
    }
  }
  if (pricewL == 4) {
    for (j = 1; j <= crossing; j++) {
      avfleshwL[j] = avfcwL[j] = 0;
      for (i = 1; i <= nclflwL; i++) {
        a2 = 0;
	for (k = 1; k <= nclfcwL; k++) a2 += pclfcwL[j][i][k];
	avfleshwL[j] += i * a2;
      }
      for (k = 1; k <= nclfcwL; k++) {
        a2 = 0;
	for (i = 1; i <= nclflwL; i++) a2 += pclfcwL[j][i][k];
	avfcwL[j] += k * a2;
      }	
    }
  }
  /* Reading input file INPUTS14.TXT and writing the data from this file 
     to the results file */
  if (trait == 0) {
    if (lf[1] + lf[2] + lf[0] > 0) {   
      if (breed == 1) printf("Reading data from INPUTS14A.TXT\n");   
      if (breed == 2) printf("Reading data from INPUTS14B.TXT\n");   
      n2 = 14;
      zz++;
      inp00(fw,n2,zz,breed);
      if (breed == 1) fr = fopen("INPUTS14A.TXT", "r");
      if (breed == 2) fr = fopen("INPUTS14B.TXT", "r");
      readcom(fr);
      pricefL = readint(fw,fr);
      readcom(fr);
      if (pricefL == 1) {
	prlwfL[1] = readfloat(fw,fr);
	if (crossing == 2) prlwfL[2] = readfloat(fw,fr);
	else readdes(fr);
      }
      else for (i = 1; i <=2; i++) readdes(fr);
      readcom(fr);  
      if (pricefL == 2) {
	nclfL = readint(fw,fr);
	for (i = 1; i <= nclfL; i++) fscanf(fr, "%f", &prclfL[i]);
	wrides(fr,fw);
	for (i = 1; i <= nclfL; i++) fprintf(fw, "%12.4f", prclfL[i]);
	for (j = 1; j <= crossing; j++) {
	  for (i = 1; i <= nclfL; i++) fscanf(fr, "%f", &pclfL[j][i]);
	  wrides(fr,fw);
	  for (i = 1; i <= nclfL; i++) fprintf(fw, "%8.2f", pclfL[j][i]);
	  a2 = 0;
	  for (i = 1; i <= nclfL; i++) a2 += pclfL[j][i];
	  if (a2 >= 1.00001 || a2 <= 0.99999) {
	    nonsense09(breed,j+7,1,14,a2);
	    errmess = 1;
	    goto END;
	  }  
	}
	if (crossing == 1) readdes(fr);
      }
      else for (i = 1; i <= 4; i++) readdes(fr);
      readcom(fr);
      if (pricefL == 3 || pricefL == 4) {
	for (i = 0; i <= 2; i++) {
          if (lf[i] > 0) {
	    for (j = 1; j <= crossing; j++) {
	      for (k = 1; k <= lf[i]; k++) fscanf(fr, "%f", &dresfL[i][k][j]);
	      wrides(fr,fw);
	      for (k = 1; k <= lf[i]; k++) fprintf(fw, "%8.1f", dresfL[i][k][j]);
	    }
	    if (crossing == 1) readdes(fr);
	  }
	  else for (i1 = 1; i1 <= 2; i1++) readdes(fr);
	}
      }  
      else for (i = 1; i <= 6; i++) readdes(fr);  
      readcom(fr);
      if (pricefL == 3) {
	prcwfL[1] = readfloat(fw,fr);
	if (crossing == 2) prcwfL[2] = readfloat(fw,fr);
	else readdes(fr);
      }
      else for (i = 1; i <=2; i++) readdes(fr);
      if (pricefL == 4) {
	nclflfL = readint(fw,fr);
	nclfcfL = readint(fw,fr);
	prreffL = readfloat(fw,fr);
	for (i = 1; i <= nclflfL; i++) 
	  for (j = 1; j <= nclfcfL; j++) 
            fscanf(fr, "%f", &prclfcfL[i][j]);
	wrides(fr,fw);    
	for (i = 1; i <= nclflfL; i++) {
	  fprintf(fw, "\n");
	  for (j = 1; j <= nclfcfL; j++) 
            fprintf(fw, "%12.4f", prclfcfL[i][j]);
	}
        if (fatpb == 1 && fatcb == 0) ja = jb = 1;
	if (fatpb == 1 && fatcb == 1) {
	  ja = 1;
	  jb = 2;
	}  
        if (fatpb == 0 && fatcb == 1) {
	  ja = jb = 2;
          readdes(fr);
	}
	for (j = ja; j <= jb; j++) {
	  a2 = 0;    
	  for (i1 = 1; i1 <= nclflfL; i1++) {
	    for (i2 = 1; i2 <= nclfcfL; i2++) { 
              fscanf(fr, "%f", &pclfcfL[j][i1][i2]);
	      a2 += pclfcfL[j][i1][i2];
	    }
	  }  
	  if (a2 >= 1.00001 || a2 <= 0.99999) {
	    nonsense10(breed,j,a2);
	    errmess = 1;
	    goto END;
	  }    	
	  wrides(fr,fw);    
	  for (i1 = 1; i1 <= nclflfL; i1++) {
	    fprintf(fw, "\n");
	    for (i2 = 1; i2 <= nclfcfL; i2++) 
              fprintf(fw, "%8.3f", pclfcfL[j][i1][i2]);
	  }
          if (jb == 1) readdes(fr); 
	}
      }
      else for (i1 = 1; i1 <= 6; i1++) readdes(fr);
      fclose(fr); /* End of reading INPUTS14.TXT  */    
      fprintf(fw, "\n\n\n");
    }
  }
  
  /* Set values zero if the categories are not present */  
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= 2; j++)
      if (l1skL[i][j] < 0.000001)
        revsbL[i][j] = prsbL[i][j] = wP[i][j] = 0; 
  }   

  if (pricefL == 2) {
    for (j = 1; j <= crossing; j++) {
      avclfL[j] = 0;
      for (i = 1; i <= nclfL; i++) avclfL[j] += i * pclfL[j][i];
    }
  }
  if (trait == 0 && fatpb + fatcb > 0) {
    for (j = 1; j <= crossing; j++) {
      k = k0[1][j];
      if (lf[1] >= 1 && dresfL[1][k][j] > 0.000001) {
	for (i = 1; i <= lf[1]; i++)
          kdresfL[1][i][j] = dresfL[1][i][j] / dresfL[1][k][j];
	if (lf[2] >= 1) for (i = 1; i <= lf[2]; i++)
          kdresfL[2][i][j] = dresfL[2][i][j] / dresfL[1][k][j];
	if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
          kdresfL[0][i][j] = dresfL[0][i][j] / dresfL[1][k][j];
      }
      k = k0[2][j];
      if (lf[1] == 0 && lf[2] >= 1 && dresfL[2][k][j] > 0.000001) {
	for (i = 1; i <= lf[2]; i++)
          kdresfL[2][i][j] = dresfL[2][i][j] / dresfL[2][k][j];
	if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
          kdresfL[0][i][j] = dresfL[0][i][j] / dresfL[2][k][j];
      }
      k = k0[0][j];
      if (lf[1] == 0 && lf[2] == 0 && lf[0] >= 1 && dresfL[0][k][j] > 0.000001) {
	for (i = 1; i <= lf[0]; i++)
          kdresfL[0][i][j] = dresfL[0][i][j] / dresfL[0][k][j];
      }
    }
  }
  if (trait > 0 && fatpb + fatcb > 0) {
    for (j = 1; j <= crossing; j++) {
      k = k0[1][j];
      if (lf[1] >= 1) {
	for (i = 1; i <= lf[1]; i++)
          dresfL[1][i][j] = kdresfL[1][i][j] * dresfL[1][k][j];
	if (lf[2] >= 1) for (i = 1; i <= lf[2]; i++)
          dresfL[2][i][j] = kdresfL[2][i][j] * dresfL[1][k][j];
	if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
          dresfL[0][i][j] = kdresfL[0][i][j] * dresfL[1][k][j];
      }
      k = k0[2][j];
      if (lf[1] == 0 && lf[2] >= 1) {
	for (i = 1; i <= lf[2]; i++)
          dresfL[2][i][j] = kdresfL[2][i][j] * dresfL[2][k][j];
	if (lf[0] >= 1) for (i = 1; i <= lf[0]; i++)
          dresfL[0][i][j] = kdresfL[0][i][j] * dresfL[2][k][j];
      }
      k = k0[0][j];
      if (lf[1] == 0 && lf[2] == 0 && lf[0] >= 1) {
	for (i = 1; i <= lf[0]; i++)
          dresfL[0][i][j] = kdresfL[0][i][j] * dresfL[0][k][j];
      }
    }
  }
  if (pricefL == 4) {
    for (j = 1; j <= crossing; j++) {
      avfleshfL[j] = avfcfL[j] = 0;
      for (i = 1; i <= nclflfL; i++) {
        a2 = 0;
	for (k = 1; k <= nclfcfL; k++) a2 += pclfcfL[j][i][k];
	avfleshfL[j] += i * a2;
      }
      for (k = 1; k <= nclfcfL; k++) {
        a2 = 0;
	for (i = 1; i <= nclflfL; i++) a2 += pclfcfL[j][i][k];
	avfcfL[j] += k * a2;
      }	
    }
  }
  /* Average classes for fleshiness and fat covering as weighted mean for
     fattened lambs and lambs slaughtered after weaning or artificial rearing */
  if (pricefL == 4 || pricewL == 4) {
    for (j = 1; j <= crossing; j++) {
      favfL[j] = 0;
      if (pricefL == 4) {
	for (i = 8; i < 48; i++) {
          if (i == 13) i = 33;
	  if (i == 38) i = 43;
	  favfL[j] += l1skL[i][j];
	}
      }
    }
  }   
  /* Age and weight of ewes */
  ageE[1] = 0;
  for (i = 1; i <= bs[1]; i++) ageE[1] += agelFP[i] * pherd[1][i];
  ageE[1] /= Pherd[1];  
  for (i = 2; i <= LL; i++) ageE[i] = ageE[1] + (i - 1) * lengthrc;
  wlE[1] = 0;
  for (i = 1; i <= bs[1]; i++) wlE[1] += wlFP[i] * pherd[1][i];
  wlE[1] /= Pherd[1];  
  for (i = 2; i <= LL; i++) wlE[i] = mwE[1];
  adgE = (wlE[2] - wlE[1]) / lengthrc; 

  /* Age and weight of rams */
  ageR[1][1] = 0;
  for (i = 1; i <= bs[2]; i++) ageR[1][1] += ager[2][i] * pherd[2][i];
  ageR[1][1] /= Pherd[2];
  ageR[1][1] *= (1 - ppurchMP);
  ageR[1][1] += agepurMP[1] * ppurchMP;  
  for (i = 2; i <= RR; i++) ageR[i][1] =  ageR[1][1] + (i - 1) * lengthrc; 
  if (crossing == 2) {
    ageR[1][2] = agepurMP[2];
    for (i = 2; i <= RR; i++) ageR[i][2] =  ageR[1][2] + (i - 1) * lengthrc; 
  }
  wbR[1][1] = 0;
  for (i = 1; i <= bs[2]; i++) wbR[1][1] += wrL[2][i][1] * pherd[2][i];
  wbR[1][1] /= Pherd[2];
  wbR[1][1] *= (1 - ppurchMP);
  wbR[1][1] += wpurMP[1] * ppurchMP;  
  for (i = 2; i <= RR; i++) wbR[i][1] = mwR[1];
  adgR[1] = (wbR[2][1] - wbR[1][1]) / (float)lengthrc; 
  if (crossing == 2) {
    wbR[1][2] = wpurMP[2];
    for (i = 2; i <= RR; i++) wbR[i][2] = mwR[2];
    adgR[2] = (wbR[2][2] - wbR[1][2]) / (float)lengthrc; 
  }
  
/* Milk production */
  if (trait == 0) printf("Calculating milk production\n");
  if (typeb == 3) {
    awo = basemilkw / agewL;
    bwo = cwo = 0;
  }
  for (i = 1; i <= clt; i++) {
    for (j = 0; j < i; j++)
      pbtba[i][j] = pdiedbtL[i][i-j]/(i - j);
    a2 = 0;
    for (k = 1; k <= i; k++)
      a2 += pdiedbtL[i][k]/k;
    pbtba[i][i] = 1 - a2;   
  }
  for (j = 1; j <= LL; j++) {
    for (i = 0; i <= clt; i++) {
      PsuckE[i][j] = 0;
      i1 = 1;
      if (i > 1) i1 = i;
      for (k = i1; k <= clt; k++) 
        PsuckE[i][j] += Pltype[k][j] * pbtba[k][i];
      PsuckE[i][j] *= l3E[j];
    }  
  }  
  if (typeb < 3) {
    basemilkw = 0;
    for (i = 1; i <= agewL-1; i++)
      basemilkw += pow(i,bwo) * exp(-cwo*i);    
    basemilkw *= awo;
  }
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      milkwrel[i][j] = basemilkw * ktlsl[i] * ktlp[j];
    }
  }
  tmilkw = 0;
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      tmilkw += milkwrel[i][j] * PsuckE[i][j];
    }  
  }
  if (pmilkwm > 0.000001) {
    for (j = 1; j <= LL; j++) {
      milksw[j] = 0;
      for (i = 1; i <= clt; i++) milksw[j] += milkwrel[i][j] * PsuckE[i][j];
      milksw[j] *= pmilkwm;
      milksw[j] += milkwrel[0][j] * PsuckE[0][j];
      milksw[j] /= l3E[j];
    }
  }
  if (typeb == 1) { 
    lengthmp = datdry - datwL;  
    basemilkm = 0;
    for (i = agewL; i <= lengthmp + agewL; i++)
      basemilkm += pow(i,bwo) * exp(-cwo*i);    
    basemilkm *= awo;
    for (i = 0; i <= clt; i++) {
      for (j = 1; j <= LL; j++) {
	milkmrel[i][j] = basemilkm * ktlsl[i] * ktlp[j];
      }
    }
    tmilkm = 0;
    for (i = 0; i <= clt; i++) {
      for (j = 1; j <= LL; j++) {
	tmilkm += milkmrel[i][j] * PsuckE[i][j];
      }  
    }
    a2 = 0;
    for (i = agewL; i <= dmilkst + agewL; i++)
      a2 += pow(i,bwo) * exp(-cwo*i);    
    a2 *= awo;
    tmilkst = 0;
    for (i = 0; i <= clt; i++) {
      for (j = 1; j <= LL; j++) {
	tmilkst += a2 * ktlsl[i] * ktlp[j] * PsuckE[i][j];
      }  
    }
    avmilkd = (tmilkw + tmilkm) / (datdry - datlamb);
    fatymst = tmilkst * fat / 100;
    protymst = tmilkst * prot / 100;
    for (j = 1; j <= LL; j++) {
      milkmpar[j] = 0;
      for (i = 0; i <= clt; i++) 
	milkmpar[j] += PsuckE[i][j] * milkmrel[i][j];
      if (l3E[j] > 0.000001) milkmpar[j] /= l3E[j];  
	else milkmpar[j] = 0;
    }
  }
  if (typeb == 1 && pmilkch > 0.000001) { 
    if (cy == 1) milkch = ach + bch * fat + cch * prot;
    if (cy == 2) {
      fdm = 100 * fatch / (100 - moich);
      if (zr == 1)
        rs = 100 * rfat * fat / (fdm * (rfat * fat + rcas * casprot * prot));
      cheesey = ((rfat * fat + rcas * casprot * prot) * rs) / (100 - moich);
      milkch = 1 / cheesey;
    }
    cheesewhey = milkch - 1;
  }
  
/* Wool production */
  woolptE = wsheE * nsheE;
  for (j = 1; j <= crossing; j++) woolptR[j] = wsheR[j] * nsheR[j];
  
/* Discounting */
  for (j = 1; j <= LL; j++) {
    dcE[(j - 1) * nstgE + 1] = lengthrc/2.0;
    dcE[(j - 1) * nstgE + 2] = (float)datdry - (float)datlamb + 1.0;
    dcE[(j - 1) * nstgE + 3] = (float)datebs + (float)dnpregcE - (float)datlamb 
      + 1.0;
    if (j == LL) break;
    dcE[(j - 1) * nstgE + 4] = dcE[(j - 1) * nstgE + 5] = (float)lengthrc;  
  } 
  for (k = 1; k <= RR; k++) {
    dcR[(k - 1) * nstgR + 1] = lengthrc/2.0;
    dcR[(k - 1) * nstgR + 2] = (float)(datebs + dselR - datbbs + flushbbR) + 1.0;
    if (k < RR) dcR[(k - 1) * nstgR + 3] = lengthrc/2.0;
    if (k == RR) dcR[(k - 1) * nstgR + 3] = (float)(datebs - datbbs + flushbbR)
      + 1.0;
    dcR[(k - 1) * nstgR + 4] = (float)lengthrc;
  }
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= PP; i++)
      dcL[i][j] = 0;
    if (typew == 1) a2 = (float)agewL;
    if (typew == 2) a2 = (float)agearL;
    for (i = 8; i <= 42+lf[0]; i++) {
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      if (l1skL[i][j] > 0.000001) 
	dcL[i][j] = agetP[i][j] - a2;
    }
    if (l1skL[5][j] > 0.000001) dcL[5][j] = (float)agewL;
    if (l1skL[6][j] > 0.000001) dcL[6][j] = (float)(agearL - agewL);
    if (l1skL[13][j] > 0.000001) dcL[13][j] = agetP[13][j] - a2;
    if (l1skL[14][j] > 0.000001) dcL[14][j] = ager[1][1] - a2;
    if (l1skL[15][j] > 0.000001) dcL[15][j] = dpregsFP + datconFP[1] - datbbs;
    if (l1skL[16][j] > 0.000001) dcL[16][j] = lengthrc - ager[1][1];
    if (l1skL[17][j] > 0.000001) 
      dcL[17][j] =  datebs + dnpregcFP - datlamb -ager[1][1];
    if (l1skL[18][j] > 0.000001) dcL[18][j] = ager[1][2] - ager[1][1];
    if (l1skL[19][j] > 0.000001) dcL[19][j] = dpregsFP + datconFP[2] - datbbs -
      365.0;
    if (l1skL[20][j] > 0.000001) dcL[20][j] = 2.0 * lengthrc - ager[1][2];
    if (l1skL[21][j] > 0.000001) 
      dcL[21][j] =  datebs + dnpregcFP + lengthrc - datlamb - ager[1][2];
    if (l1skL[22][j] > 0.000001) dcL[22][j] = ager[1][3] - ager[1][2];
    if (l1skL[23][j] > 0.000001) dcL[23][j] = dpregsFP + datconFP[2] - datbbs -
      2 * 365.0;;
    if (l1skL[24][j] > 0.000001) dcL[24][j] = 3.0 * lengthrc - ager[1][3];
    if (l1skL[25][j] > 0.000001) 
      dcL[25][j] =  datebs + dnpregcFP + 2 * lengthrc - datlamb - ager[1][3];
    if (l1skL[26][j] > 0.000001) dcL[26][j] = agetP[26][j] - ager[1][1];
    if (l1skL[30][j] > 0.000001) dcL[30][j] = (float)agewL;
    if (l1skL[31][j] > 0.000001) dcL[31][j] = (float)(agearL - agewL);
    if (l1skL[38][j] > 0.000001) dcL[38][j] = agetP[38][j] - a2;
    if (l1skL[39][j] > 0.000001) dcL[39][j] = ager[2][1] - a2;
    if (l1skL[40][j] > 0.000001) dcL[40][j] = agetP[40][j] - ager[2][1];
    if (l1skL[41][j] > 0.000001) dcL[41][j] = ager[2][2] - ager[2][1];
    if (l1skL[2][j] > 0.000001) dcL[2][j] = a2/2.0;
  }
  /* Categories 3, 4, 28, 29, 42 and 48 */ 
  for (j = 1; j <= crossing; j++) {
    if (l1skL[3][j] > 0.000001) {
      for (i = 8; i <= 7 + lf[1]; i++) {
	dcL[3][j] += dcL[i][j] * ndiedfat[1][i-7][j]; 
      }
      dcL[3][j] /= (2 * l1skL[3][j]);
    }
    if (l1skL[28][j] > 0.000001) {
      for (i = 33; i <= 32 + lf[2]; i++) {
	dcL[28][j] += dcL[i][j] * ndiedfat[2][i-32][j]; 
      }
      dcL[28][j] /= (2 * l1skL[28][j]);	
    }
    if (l1skL[48][j] > 0.000001) {
      for (i = 43; i <= 42 + lf[0]; i++) {
	dcL[48][j] += dcL[i][j] * ndiedfat[0][i-42][j]; 
      }
      dcL[48][j] /= (2 * l1skL[48][j]);
    }
    if (l1skL[4][j] > 0.000001) {
      dcL[4][j] = (dcL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + dcL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ dcL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ dcL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
    }
    if (l1skL[29][j] > 0.000001) {
      dcL[29][j] = (dcL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + dcL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
    }
    if (l1skL[42][j] > 0.000001) {
      dcL[42][j] = (dcL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + dcL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
    }
  }
  /* Discounting coefficients for ewes */
  for (i = 1; i <= TE; i++) {
    qaveE[i] = pow(1 + u, -(dcE[i]/2)/365);
    qendE[i] = pow(1 + u, - dcE[i]/365);
    qbreedE[i] = pow(1 + u, -(datbbs - datlamb)/365.0);
    if (typeb == 1) qmilkE[i] = pow(1 + u, -(agewL + lengthmp/2.0)/365.0);
  }
  /* Discounting coefficients for rams */
  qpurchR = pow(1 + u, -(datbbs - datlamb)/365.0);
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      qaveR[i][j] = pow(1 + u, -(dcR[i]/2.0)/365);
      qendR[i][j] = pow(1 + u, - dcR[i]/365);
    }  
  }  
  /* Discounting coefficients for lambs */
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      taveL[i][j] = tendL[i][j] = 0;
  }
  if (typew == 1) a2 = (float)agewL;
  if (typew == 2) a2 = (float)agearL;
  for (j = 1; j <= crossing; j++) {
    taveL[2][j] = dcL[2][j]/2.0;
    tendL[2][j] = dcL[2][j];
    for (i = 3; i <= 48; i++) {
      if (i == 5) i = 8;
      if (i == 8 + lf[1]) i = 13;
      if (i == 15) i = 28;
      if (i == 30) i = 33;
      if (i == 33 + lf[2]) i = 38;
      if (i == 40) i = 42;
      if (l1skL[i][j] > 0.000001) {
	taveL[i][j] = a2 + dcL[i][j]/2.0;
	tendL[i][j] = a2 + dcL[i][j];
      }
    }
    if (l1skL[5][j] > 0.000001) {
      taveL[5][j] = (float)agewL/2.0;
      tendL[5][j] = (float)agewL;
    }
    if (l1skL[6][j] > 0.000001) {
      taveL[6][j] = (float)agewL + dcL[6][j]/2;
      tendL[6][j] = (float)agearL;
    }
    if (l1skL[30][j] > 0.000001) {
      taveL[30][j] = (float)agewL/2.0;
      tendL[30][j] = (float)agewL;
    }
    if (l1skL[31][j] > 0.000001) {
      taveL[31][j] = (float)agewL + dcL[31][j]/2;
      tendL[31][j] = (float)agearL;
    }
    if (l1skL[7][j] > 0.000001) {
      taveL[7][j] = a2; 
      tendL[7][j] = a2;
    }  
    if (l1skL[32][j] > 0.000001) {
      taveL[32][j] = a2; 
      tendL[32][j] = a2;
    }  
    for (i = 15; i <= 26; i++) {
      if (i == 19) i = 26;
      if (l1skL[i][j] > 0.000001) {
	taveL[i][j] = ager[1][1] + dcL[i][j]/2;
	tendL[i][j] = ager[1][1] + dcL[i][j];
      }
    }
    for (i = 19; i <= 22; i++) {
      if (l1skL[i][j] > 0.000001) {
	taveL[i][j] = ager[1][2] + dcL[i][j]/2;
	tendL[i][j] = ager[1][2] + dcL[i][j];
      }
    }
    for (i = 23; i <= 25; i++) {
      if (l1skL[i][j] > 0.000001) {
	taveL[i][j] = ager[1][3] + dcL[i][j]/2;
	tendL[i][j] = ager[1][3] + dcL[i][j];
      }	
    }
    for (i = 40; i <= 41; i++) {
      if (l1skL[i][j] > 0.000001) {
	taveL[i][j] = ager[2][1] + dcL[i][j]/2;
	tendL[i][j] = ager[2][1] + dcL[i][j];
      }
    }
    for (i = 1; i <= PP; i++) {  
      if (l1skL[i][j] > 0.000001) {
	qaveL[i][j] = pow(1 + u, -(taveL[i][j]/365));
	qendL[i][j] = pow(1 + u, -(tendL[i][j]/365));
      }
    }
    for (i = 1; i <= 3; i++) {
      k = 10 + 4 * i;
      if (l1skL[k][1] + l1skL[k][2] > 0.000001) 
        qbreedL[k] = pow(1 + u, -(ager[1][i]/365));
    } 
  }
  
    
/* Nutrition */
  if (trait == 0) printf("Calculating nutrition costs\n");
  nchfst = 4 * nchfs;
  for (i = 2; i <= 4; i++) {
    for (j = 1; j <= nchfs; j++) {
      datchfs[(i-1)*nchfs+j] = datchfs[j] + (i - 1) * 365;
      valfs[(i-1)*nchfs+j] = valfs[j]; 
    }
  }
  /* Nutrition of rams */
  for (j = 1; j <= crossing; j++) dwoolptR[j] = woolptR[j]/lengthrc;
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {
      k = 2;
      a2 = 1.8;
      k1 = datbbs - flushbbR;
      k2 = datebs;
      for (i2 = 1; i2 <= nfs; i2++) 
        newR[i][j][k][i2] = negR[i][j][k][i2] = nemR[i][j][k][i2] = 
	pdiwR[i][j][k][i2] = pdigR[i][j][k][i2] = pdimR[i][j][k][i2] = 
	watR[i][j][k][i2] = 0;
      for (k3 = k1; k3 <= k2; k3++) {
        k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newR[i][j][k][i2]++;
	if (i3 <= RR) {
          negR[i][j][k][i2] += 2.5 + 0.35 * (wbR[1][j] + adgR[j] * k5);
	  nemR[i][j][k][i2] += 0.277 * pow(wbR[1][j] + adgR[j] * k5, 0.75)
	    * a2 * (1 + 0.0091 * (20 - tp[i2])) + 0.0054 * (wbR[1][j]
	    + adgR[j] * k5);
          if (feedcost == 1) {
	    pdigR[i][j][k][i2] += adgR[j] * (160.4 - 1.22 * (wbR[1][j] +
	      adgR[j] * k5) + 0.0105 * (wbR[1][j] + adgR[j] * k5) * 
	      (wbR[1][j] + adgR[j] * k5)) / 0.59; 
	    pdimR[i][j][k][i2] += 2.1875 * pow(wbR[1][j] + adgR[j] * k5,0.75) 
	      * a2;  
          }
	}  
	if (i3 > RR)
	  nemR[i][j][k][i2] += 0.277 * pow(mwR[j],0.75) * a2 * (1 + 0.0091 *
	    (20 - tp[i2])) + 0.0054 * mwR[j];
	  if (feedcost == 1) 
	    pdimR[i][j][k][i2] += 2.1875 * pow(mwR[j],0.75) * a2;  
      }
      for (i2 = 1; i2 <= nfs; i2++) {
        if (feedcost == 1) 
	  pdiwR[i][j][k][i2] = 3088.6 * dwoolptR[j] * newR[i][j][k][i2];
	watR[i][j][k][i2] = newR[i][j][k][i2] * dwatR[k][i2];  
        newR[i][j][k][i2] *= 23.7 * dwoolptR[j];
	if (i3 <= RR) negR[i][j][k][i2] *= adgR[j];
      }
      k = 1;
      a2 = 1;
      k1 = datebs + 1;
      k2 = datebs + dselR;
      if (fmod(i, 4)<0.00001) 
        k2 = datbbs - flushbbR + lengthrc - 1;
      for (i2 = 1; i2 <= nfs; i2++) 
        newR[i][j][k][i2] = negR[i][j][k][i2] = nemR[i][j][k][i2] =
	pdiwR[i][j][k][i2] = pdigR[i][j][k][i2] = pdimR[i][j][k][i2] = 
	watR[i][j][k][i2] = 0;
      for (k3 = k1; k3 <= k2; k3++) {
        k5++;      
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++) {
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  }
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newR[i][j][k][i2]++;
	if (i3 <= RR) {
          negR[i][j][k][i2] += 2.5 + 0.35 * (wbR[1][j] + adgR[j] * k5);
	  nemR[i][j][k][i2] += 0.277 * pow(wbR[1][j] + adgR[j] * k5, 0.75)
	    * a2 * (1 + 0.0091 * (20 - tp[i2])) + 0.0054 * (wbR[1][j]
	    + adgR[j] * k5);
          if (feedcost == 1) {
	    pdigR[i][j][k][i2] += adgR[j] * (160.4 - 1.22 * (wbR[1][j] +
	      adgR[j] * k5) + 0.0105 * (wbR[1][j] + adgR[j] * k5) * 
	      (wbR[1][j] + adgR[j] * k5)) / 0.59; 
	    pdimR[i][j][k][i2] += 2.1875 * pow(wbR[1][j] + adgR[j] * k5,0.75) 
	      * a2;  
          } 
	}  
	if (i3 > RR)
	  nemR[i][j][k][i2] += 0.277 * pow(mwR[j],0.75) * a2 * (1 + 0.0091 *
	    (20 - tp[i2])) + 0.0054 * mwR[j];
	  if (feedcost == 1) 
	    pdimR[i][j][k][i2] += 2.1875 * pow(mwR[j],0.75) * a2;  	    
      }
      for (i2 = 1; i2 <= nfs; i2++) {
        if (feedcost == 1) 
	  pdiwR[i][j][k][i2] = 3088.6 * dwoolptR[j] * newR[i][j][k][i2];
	watR[i][j][k][i2] = newR[i][j][k][i2] * dwatR[k][i2];  
        newR[i][j][k][i2] *= 23.7 * dwoolptR[j];
	if (i3 <= RR) negR[i][j][k][i2] *= adgR[j];
      }
    }
  }

  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      costfR[i][j] = costwatR[i][j] = 0;
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) {   
          neR[i][j][k][i2] = newR[i][j][k][i2] + negR[i][j][k][i2]
	    + nemR[i][j][k][i2];
          if (feedcost == 1)           
	    pdiR[i][j][k][i2] = pdiwR[i][j][k][i2] + pdigR[i][j][k][i2]
	      + pdimR[i][j][k][i2];
	  feR[i][j][k][i2] = neR[i][j][k][i2] / (nedR[k][i2] * drymR[k][i2]);
	  if (feedcost == 1) 
	    fpdiR[i][j][k][i2] = pdiR[i][j][k][i2] / (pdidR[k][i2] * drymR[k][i2]);
	  if (feedcost == 1) ffR[i][j][k][i2] = maxi(feR[i][j][k][i2], 
	    fpdiR[i][j][k][i2]) / (1 - lossfR[k][i2]/100);
	  if (feedcost == 2) ffR[i][j][k][i2] = feR[i][j][k][i2]   
	    / (1 - lossfR[k][i2]/100);
	  costfR[i][j] += ffR[i][j][k][i2] * prfR[k][i2]; 
	  costwatR[i][j] += watR[i][j][k][i2] * prwat; 
	  }  
        }
      }
    }      
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i < RR; i++) {
      costfR[1+4*(i-1)][j] = costfR[3+4*(i-1)][j] = costfR[4*i][j] / 2;
      costwatR[1+4*(i-1)][j] = costwatR[3+4*(i-1)][j] = costwatR[4*i][j] / 2;
      }
    costfR[1+4*(i-1)][j] = costfR[2+4*(i-1)][j] / 2;  
    costfR[3+4*(i-1)][j] = costfR[2+4*(i-1)][j]; 
    costwatR[1+4*(i-1)][j] = costwatR[2+4*(i-1)][j] / 2;  
    costwatR[3+4*(i-1)][j] = costwatR[2+4*(i-1)][j]; 
    }
  /* Setting nutrition cost for non-existing categories of rams to zero */
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) { 
      if (l1aR[i][j] < 0.000001) {
        costwatR[i][j] = costfR[i][j] = 0;
	for (k = 1; k <= fR; k++) {
	  for (i2 = 1; i2 <= nfs; i2++) ffR[i][j][k][i2] = 0;
	}
      }	
    }  
  }
  /* Discounting of nutrition costs for rams */
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= TR; i++) {
      costfR[i][j] *= qaveR[i][j];
      costwatR[i][j] *= qaveR[i][j];  
    }  
  }

  /* Nutrition of ewes */  
  for (i = 2; i <= LL; i++) {
    a2 = l1E[(i-2)*nstgE + 5] + l1E[(i-2)*nstgE + 4];
    if (i < LL) j1 = nstgE;
    if (i == LL) j1 = nstg1E;
    for (j = 1; j <= nstgE; j++) {
      plambE[j] = 1;
      plambE[(i-1)*nstgE+j] = l1E[(i-2)*nstgE + 5] / a2;
      pnlambE[(i-1)*nstgE+j] = l1E[(i-2)*nstgE + 4] / a2;
    }  
  }
  dwoolptE = woolptE / lengthrc;
  if (flushbbE + flushabE > 0) adgfE = wgfE / (flushbbE + flushabE);
    else adgfE = 0;    
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++)
      twL[i][j] = i * ((1 - pcrossE[j-1]) * (bwL[1][i][1] * sexrbf + bwL[2][i][1] 
        * sexrbm) + pcrossE[j-1] * (bwL[1][i][2] * sexrbf + bwL[2][i][2] * sexrbm));
  }  
    /* Net energy and protein requirement for ewes */
  for (i = 1; i <= TE; i++) {
    for (k = 1; k <= fE; k++) {
      for (i2 = 1; i2 <= nfs; i2++) {
	newlE[i][k][i2] = pdiwlE[i][k][i2] = neglE[i][k][i2] = 
	pdiglE[i][k][i2] = nemlE[i][k][i2] = pdimlE[i][k][i2] = 
	newnlE[i][k][i2] = pdiwnlE[i][k][i2] = negnlE[i][k][i2] = 
	pdignlE[i][k][i2] = nemnlE[i][k][i2] = pdimnlE[i][k][i2] = 
	watlE[i][k][i2] = watnlE[i][k][i2] = watE[i][k][i2] = 0;
      }
    }
  } 
    /* Categories 3,4,5, 8,9,10, 13,14,15, ... */
  for (i3 = 1; i3 <= LL; i3++) {
    i = (i3 - 1) * nstgE + 3;
    for (k = 1; k <= 2; k++) {
      k1 = datlamb;
      k2 = datdry - 1;
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i][k][i2]++;
        if (i3 == 1) {
	  neglE[i][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;
	    pdimlE[i][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);
          }
        }
	if (i3 > 1) {   
  	  nemlE[i][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) 
	    pdimlE[i][k][i2] += 2.1875 * pow(mwE[1], 0.75);  
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	if (feedcost == 1) 
	  pdiwlE[i][k][i2] = 3088.6 * dwoolptE * newlE[i][k][i2];
	watlE[i][k][i2] = newlE[i][k][i2] * dwatE[k][i2];
	newlE[i][k][i2] *= 23.7 * dwoolptE;
	neglE[i][k][i2] *= adgE;
	if (i3 == 1) {
	  neglE[i+1][k][i2] = neglE[i+2][k][i2] = neglE[i][k][i2];
	  if (feedcost == 1) 
	    pdiglE[i+1][k][i2] = pdiglE[i+2][k][i2] = pdiglE[i][k][i2];
	}
	if (i3 < LL) {
	  nemlE[i+1][k][i2] = nemlE[i+2][k][i2] = nemlE[i][k][i2];
	  if (feedcost == 1) 
	    pdimlE[i+1][k][i2] = pdimlE[i+2][k][i2] = pdimlE[i][k][i2];
	  newlE[i+1][k][i2] = newlE[i+2][k][i2] = newlE[i][k][i2];
	  watlE[i+1][k][i2] = watlE[i+2][k][i2] = watlE[i][k][i2];
	  if (feedcost == 1) 
	    pdiwlE[i+1][k][i2] = pdiwlE[i+2][k][i2] = pdiwlE[i][k][i2];
	}
      }
    } 
    if (datbbs - flushbbE > datdry && i3 < LL) {
      k = 4;
      k1 = datdry;
      k2 = datbbs - flushbbE - 1;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i][k][i2]++;
        if (i3 == 1) {
	  neglE[i][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;	
            pdimlE[i][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);	    
          }
        }
	if (i3 > 1) {   
  	  nemlE[i][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) pdimlE[i][k][i2] += 2.1875 * pow(mwE[1], 0.75);
	}
      }
    } 
    if (datbbs + flushabE > datdry && i3 < LL) {
      k = 3;
      k1 = datbbs - flushbbE;
      k2 = datbbs + flushabE - 1;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i][k][i2]++;
        if (i3 == 1) {
	  neglE[i][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;	
	    pdimlE[i][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);  
          }
        }	  
	if (i3 > 1) {   
  	  nemlE[i][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) pdimlE[i][k][i2] += 2.1875 * pow(mwE[1], 0.75);
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	if (feedcost == 1) 
	  pdiwlE[i][k][i2] = 3088.6 * dwoolptE * newlE[i][k][i2];
	watlE[i][k][i2] = newlE[i][k][i2] * dwatE[k][i2];  
	newlE[i][k][i2] *= 23.7 * dwoolptE;
        neglE[i][k][i2] *= adgE;
	if (i3 == 1) {
	  neglE[i+1][k][i2] = neglE[i+2][k][i2] = neglE[i][k][i2];
	  if (feedcost == 1) 
	    pdiglE[i+1][k][i2] = pdiglE[i+2][k][i2] = pdiglE[i][k][i2];
	}
	if (i3 < LL) {
	  nemlE[i+1][k][i2] = nemlE[i+2][k][i2] = nemlE[i][k][i2];
	  if (feedcost == 1) 
	    pdimlE[i+1][k][i2] = pdimlE[i+2][k][i2] = pdimlE[i][k][i2];
	  newlE[i+1][k][i2] = newlE[i+2][k][i2] = newlE[i][k][i2];
	  watlE[i+1][k][i2] = watlE[i+2][k][i2] = watlE[i][k][i2];
	  if (feedcost == 1) 
	    pdiwlE[i+1][k][i2] = pdiwlE[i+2][k][i2] = pdiwlE[i][k][i2];
	}
      }
    } 
    if (i3 < LL) {
      k = 4;
      k6 = k5;
      k1 = datbbs + flushabE;
      if (flushbbE == 0 && flushabE == 0) k1 = datdry;
      k2 = datlamb - dshpE + lengthrc - 1;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i+2][k][i2]++;
        if (i3 == 1) {
	  neglE[i+2][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i+2][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i+2][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;	
	    pdimlE[i+2][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);  
          }
        }	  
	if (i3 > 1) {   
  	  nemlE[i+2][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) pdimlE[i+2][k][i2] += 2.1875 * pow(mwE[1], 0.75);	    
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	if (feedcost == 1) 
	  pdiwlE[i+2][k][i2] = 3088.6 * dwoolptE * newlE[i+2][k][i2];
	watlE[i+2][k][i2] = newlE[i+2][k][i2] * dwatE[k][i2];    
	newlE[i+2][k][i2] *= 23.7 * dwoolptE;
	neglE[i+2][k][i2] *= adgE;
	newlE[i+2][k][i2] += 23.7 * dwoolptE * newlE[i][k][i2];
	if (feedcost == 1) 
	  pdiwlE[i+2][k][i2] += 3088.6 * dwoolptE * newlE[i][k][i2];
 	nemlE[i+2][k][i2] += nemlE[i][k][i2];
	if (feedcost == 1) pdimlE[i+2][k][i2] += pdimlE[i][k][i2];
	if (i3 == 1) {
	  neglE[i+2][k][i2] += adgE * neglE[i][k][i2];
	  if (feedcost == 1) pdiglE[i+2][k][i2] += pdiglE[i][k][i2]; 
	} 
      }
      k1 = datbbs + flushabE;
      if (flushbbE == 0 && flushabE == 0) k1 = datdry;
      k2 = datebs + dnpregcE;
      k5 = k6;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i][k][i2]++;
        if (i3 == 1) {
	  neglE[i][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;	
	    pdimlE[i][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);  
          }
        }	  
	if (i3 > 1) {   
  	  nemlE[i][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) pdimlE[i][k][i2] += 2.1875 * pow(mwE[1], 0.75);	    
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	if (feedcost == 1) 
	  pdiwlE[i][k][i2] = 3088.6 * dwoolptE * newlE[i][k][i2];
	watlE[i][k][i2] = newlE[i][k][i2] * dwatE[k][i2];    
	newlE[i][k][i2] *= 23.7 * dwoolptE;
	neglE[i][k][i2] *= adgE;
      }

    if (i3 < LL) {
      k = 5;
      k1 = datlamb - dshpE + lengthrc;
      k2 = datlamb + lengthrc - 1;
      k5 = k1 - datlamb;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newlE[i+2][k][i2]++;
        if (i3 == 1) {
	  neglE[i+2][k][i2] += 2.1 + 0.45 * (wlE[1] + adgE * k5);	
  	  nemlE[i+2][k][i2] += 0.277 * pow(wlE[1] + adgE * k5, 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * (wlE[1]
	    + adgE * k5);
          if (feedcost == 1) {
	    pdiglE[i+2][k][i2] += adgE * (156.1 - 1.94 * (wlE[1] +
	      adgE * k5) + 0.0173 * (wlE[1] + adgE * k5) * 
	      (wlE[1] + adgE * k5)) / 0.59;	
	    pdimlE[i+2][k][i2] += 2.1875 * pow(wlE[1] + adgE * k5, 0.75);  
          }
        }	  
	if (i3 > 1) {   
  	  nemlE[i+2][k][i2] += 0.277 * pow(mwE[1], 0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktE[techE[i2]] * mwE[1];
	  if (feedcost == 1) pdimlE[i+2][k][i2] += 2.1875 * pow(mwE[1], 0.75);	    
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	if (feedcost == 1) 
	  pdiwlE[i+2][k][i2] = 3088.6 * dwoolptE * newlE[i+2][k][i2];
	watlE[i+2][k][i2] = newlE[i+2][k][i2] * dwatE[k][i2];    
	newlE[i+2][k][i2] *= 23.7 * dwoolptE;
	neglE[i+2][k][i2] *= adgE;
      }
    }
  }
    for (i2 = 1; i2 <= nfs; i2++) {
      if (i3 == 1) {
        negnlE[i][3][i2] = neglE[i][3][i2];
	negnlE[i][4][i2] = neglE[i][4][i2] + neglE[i][1][i2];
        if (feedcost == 1) {
	  pdignlE[i][3][i2] = pdiglE[i][3][i2];
	  pdignlE[i][4][i2] = pdiglE[i][4][i2] + pdiglE[i][1][i2];
          }
	negnlE[i+1][3][i2] = negnlE[i+2][3][i2] = neglE[i+1][3][i2];
	if (feedcost == 1) 
	  pdignlE[i+1][3][i2] = pdignlE[i+2][3][i2] = pdiglE[i+1][3][i2];
	neglE[i+1][4][i2] = neglE[i+2][4][i2] + neglE[i+2][5][i2];
	if (feedcost == 1) 
	  pdiglE[i+1][4][i2] = pdiglE[i+2][4][i2] + pdiglE[i+2][5][i2];
	negnlE[i+1][4][i2] = neglE[i+1][4][i2] + neglE[i+1][1][i2];
	if (feedcost == 1) 
	  pdignlE[i+1][4][i2] = pdiglE[i+1][4][i2] + pdiglE[i+1][1][i2]; 
	negnlE[i+2][4][i2] = neglE[i+2][4][i2] + neglE[i+1][1][i2];
	if (feedcost == 1) 
	  pdignlE[i+2][4][i2] = pdiglE[i+2][4][i2] + pdiglE[i+1][1][i2]; 
	negnlE[i+2][5][i2] = neglE[i+2][5][i2];
	if (feedcost == 1) pdignlE[i+2][5][i2] = pdiglE[i+2][5][i2]; 
      }	
      nemnlE[i][3][i2] = nemlE[i][3][i2];
      nemnlE[i][4][i2] = nemlE[i][4][i2] + nemlE[i][1][i2];
      if (feedcost == 1) {
        pdimnlE[i][3][i2] = pdimlE[i][3][i2];
        pdimnlE[i][4][i2] = pdimlE[i][4][i2] + pdimlE[i][1][i2];
	}
      newnlE[i][3][i2] = newlE[i][3][i2];
      newnlE[i][4][i2] = newlE[i][4][i2] + newlE[i][1][i2];
      watnlE[i][3][i2] = watlE[i][3][i2];
      watnlE[i][4][i2] = watlE[i][4][i2] + watlE[i][1][i2];
      if (feedcost == 1) {
        pdiwnlE[i][3][i2] = pdiwlE[i][3][i2];
        pdiwnlE[i][4][i2] = pdiwlE[i][4][i2] + pdiwlE[i][1][i2];
	}
      if (i3 < LL) {
	nemnlE[i+1][3][i2] = nemnlE[i+2][3][i2] = nemlE[i+1][3][i2];
	if (feedcost == 1) 
	  pdimnlE[i+1][3][i2] = pdimnlE[i+2][3][i2] = pdimlE[i+1][3][i2];
	newnlE[i+1][3][i2] = newnlE[i+2][3][i2] = newlE[i+1][3][i2];
	watnlE[i+1][3][i2] = watnlE[i+2][3][i2] = watlE[i+1][3][i2];
	if (feedcost == 1) 
	  pdiwnlE[i+1][3][i2] = pdiwnlE[i+2][3][i2] = pdiwlE[i+1][3][i2];
	nemlE[i+1][4][i2] = nemlE[i+2][4][i2] + nemlE[i+2][5][i2];
	if (feedcost == 1) 
	  pdimlE[i+1][4][i2] = pdimlE[i+2][4][i2] + pdimlE[i+2][5][i2];
	newlE[i+1][4][i2] = newlE[i+2][4][i2] + newlE[i+2][5][i2];
	watlE[i+1][4][i2] = watlE[i+2][4][i2] + watlE[i+2][5][i2];
	if (feedcost == 1) 
	  pdiwlE[i+1][4][i2] = pdiwlE[i+2][4][i2] + pdiwlE[i+2][5][i2];
	nemnlE[i+1][4][i2] = nemlE[i+1][4][i2] + nemlE[i+1][1][i2];
	if (feedcost == 1) 
	  pdimnlE[i+1][4][i2] = pdimlE[i+1][4][i2] + pdimlE[i+1][1][i2]; 
	nemnlE[i+2][4][i2] = nemlE[i+2][4][i2] + nemlE[i+1][1][i2];
	if (feedcost == 1) 
	  pdimnlE[i+2][4][i2] = pdimlE[i+2][4][i2] + pdimlE[i+1][1][i2]; 
	nemnlE[i+2][5][i2] = nemlE[i+2][5][i2];
	if (feedcost == 1) pdimnlE[i+2][5][i2] = pdimlE[i+2][5][i2]; 
	newnlE[i+1][4][i2] = newlE[i+1][4][i2] + newlE[i+1][1][i2];
	watnlE[i+1][4][i2] = watlE[i+1][4][i2] + watlE[i+1][1][i2];
	if (feedcost == 1) 
	  pdiwnlE[i+1][4][i2] = pdiwlE[i+1][4][i2] + pdiwlE[i+1][1][i2]; 
	newnlE[i+2][4][i2] = newlE[i+2][4][i2] + newlE[i+1][1][i2];
	watnlE[i+2][4][i2] = watlE[i+2][4][i2] + watlE[i+1][1][i2];
	if (feedcost == 1) pdiwnlE[i+2][4][i2] = pdiwlE[i+2][4][i2] + pdiwlE[i+1][1][i2]; 
	newnlE[i+2][5][i2] = newlE[i+2][5][i2];
	watnlE[i+2][5][i2] = watlE[i+2][5][i2];
	if (feedcost == 1) pdiwnlE[i+2][5][i2] = pdiwlE[i+2][5][i2]; 
      }
    }
  }    
    
    /* Net energy and protein requirement for pregnancy */
  for (i = 1; i <= TE; i++) {
    for (k = 1; k <= fE; k++) {
      for (i2 = 1; i2 <= nfs; i2++) {
        nepE[i][k][i2] = pdipE[i][k][i2] = 0; 
        for (j = 1; j <= clt; j++)
	  nepbE[j][i][k][i2] = pdipbE[j][i][k][i2] = 0; 
      }
    }
  }  
  for (j = 1; j <= clt; j++) {
    for (i3 = 1; i3 < LL; i3++) {
      i = i3 * nstgE;
      k = 4;
      k1 = datlamb + lengthrc - lpreg;
      k2 = datlamb + lengthrc - dshpE - 1;
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	nepbE[j][i][k][i2] += exp(7.6492 - 0.00643 * k5 - 11.4646 *
	  exp(-0.00643 * k5));
	if (feedcost == 1) 
	  pdipbE[j][i][k][i2] += exp(11.3471 - 0.00601 * k5 - 11.2205 *
	    exp(-0.00601 * k5));
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	nepbE[j][i][k][i2] *= 0.083773 * twL[j][i3+1];
	if (feedcost == 1) pdipbE[j][i][k][i2] *= 0.043889 * twL[j][i3+1];
      }
      k = 5;
      k1 = datlamb + lengthrc - dshpE;
      k2 = datlamb + lengthrc - 1;
      for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	nepbE[j][i][k][i2] += exp(7.6492 - 0.00643 * k5 - 11.4646 *
	  exp(-0.00643 * k5));
	if (feedcost == 1) 
	  pdipbE[j][i][k][i2] += exp(11.3471 - 0.00601 * k5 - 11.2205 *
	    exp(-0.00601 * k5));
	nd[i2]++;  
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	nepbE[j][i][k][i2] *= 0.083773 * twL[j][i3+1];
	if (feedcost == 1) pdipbE[j][i][k][i2] *= 0.043889 * twL[j][i3+1];
	nepbE[j][i][k][i2] -= 20.034 * nd[i2] * wgfE / dshpE;
	if (feedcost == 1) pdipbE[j][i][k][i2] -= 119 * nd[i2] * wgfE / dshpE;
      }
    }     
  }
  for (i3 = 1; i3 < LL; i3++) {
    i = i3 * nstgE;
    for (k = 4; k <= fE; k++) {
      for (i2 = 1; i2 <= nfs; i2++) {
        for (j = 1; j <= clt; j++) {
	  nepE[i][k][i2] += nepbE[j][i][k][i2] * Pltype[j][i3+1];
	  if (feedcost == 1) 
	    pdipE[i][k][i2] += pdipbE[j][i][k][i2] * Pltype[j][i3+1];
	  }
        }
      }
    }

    /* Net energy and protein requirement for ewes in the flushing period */
  if (flushbbE > 0 && flushabE > 0) {
    for (i = 1; i <= TE; i++) {
      for (k = 1; k <= fE; k++) {
	for (i2 = 1; i2 <= nfs; i2++) nefE[i][k][i2] = pdifE[i][k][i2] = 0;
      }
    } 
    for (i3 = 1; i3 < LL; i3++) {
      for (j1 = 3; j1 <= nstgE; j1++) {
        i = (i3 - 1) * nstgE + j1;
	k = 3;
	k1 = datbbs - flushbbE;
	k2 = datbbs + flushabE - 1;
	for (k3 = k1; k3 <= k2; k3++) {
	  k5 = k3 - k1 + 1;
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  nefE[i][k][i2]++;
	}
	for (i2 = 1; i2 <= nfs; i2++) {
	  nefE[i][k][i2] *= adgfE;
	  if (feedcost == 1) pdifE[i][k][i2] = 140 * nefE[i][k][i2];
          nefE[i][k][i2] *= 23.85;
	}
      }
    }
  }

    /* Net energy and protein requirement for lactation */
  for (i = 1; i <= TE; i++) {
    for (k = 1; k <= fE; k++) {
      for (i2 = 1; i2 <= nfs; i2++) {
        nelE[i][k][i2] = pdilE[i][k][i2] = 0;
        for (j = 0; j <= clt; j++)
          nelbE[j][i][k][i2] = pdilbE[j][i][k][i2] = 0;
      }
    }
  } 
    /* Categories 3,4,5, 8,9,10, 13,14,15, ... */
  for (j = 0; j <= clt; j++) {
    for (i3 = 1; i3 <= LL; i3++) {
      a2 = 0;
      for (k7 = 2; k7 <= clt; k7++) a2 += PsuckE[k7][i3];
      for (j1 = 3; j1 <= nstgE; j1++) {
        if (j1 > 3 && i3 == LL) break;
	i = (i3 - 1) * nstgE + j1;
	if (j <= 1) k = 1;
	if (j >= 2) k = 2;
	k1 = datlamb;
	k2 = datdry - 1;
	for (k3 = k1; k3 <= k2; k3++) {
	  k5 = k3 - k1 + 1;
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  nelbE[j][i][k][i2] += awo * pow(k5,bwo) * exp(-cwo * k5);
          }
        for (i2 = 1; i2 <= nfs; i2++) {
          nelbE[j][i][k][i2] *= ktlsl[j] * ktlp[i3];
	  if (feedcost == 1) 
	    pdilbE[j][i][k][i2] = nelbE[j][i][k][i2] * 17.241379 * prot; 
	  nelbE[j][i][k][i2] *= (0.948 + 0.376 * fat + 0.209 * prot); 
	  if (k == 1) {
	    nelE[i][k][i2] += nelbE[j][i][k][i2] * PsuckE[j][i3] 
	      / (PsuckE[0][i3] + PsuckE[1][i3]);
	    if (feedcost == 1) 
	      pdilE[i][k][i2] += pdilbE[j][i][k][i2] * PsuckE[j][i3] 
	        / (PsuckE[0][i3] + PsuckE[1][i3]);
	    }
	  if (k == 2) {
	    if (a2 > 0.00000001) {
	      nelE[i][k][i2] += nelbE[j][i][k][i2] * PsuckE[j][i3] / a2;
	      if (feedcost == 1) 
		pdilE[i][k][i2] += pdilbE[j][i][k][i2] * PsuckE[j][i3] / a2;
	    }	  
	  }
	}
      }    
    }
  }

    /* Total net energy and protein requirement for ewes */
  for (i = 1; i <= TE; i++) {
    costfE[i] = costwatE[i] = 0;
    for (k = 1; k <= fE; k++) {
      for (i2 = 1; i2 <= nfs; i2++) 
        neE[i][k][i2] = pdiE[i][k][i2] = feE[i][k][i2] = ffE[i][k][i2] =
	fpdiE[i][k][i2] = 0;
    }
  } 
  for (i3 = 1; i3 <= LL; i3++) {
    for (j1 = 3; j1 <= nstgE; j1++) {
      if (j1 > 3 && i3 == LL) break;
      i = (i3 - 1) * nstgE + j1;
      for (i2 = 1; i2 <= nfs; i2++) {
        k = 1;
	neE[i][k][i2] = (neglE[i][k][i2] + nemlE[i][k][i2] + newlE[i][k][i2]
	  + nelE[i][k][i2]) * plambE[i] * (PsuckE[0][i3] + PsuckE[1][i3])
	  / l3E[i3];
	watE[i][k][i2] = watlE[i][k][i2] * plambE[i] * (PsuckE[0][i3] + 
	  PsuckE[1][i3]) / l3E[i3];  
	if (feedcost == 1) 
	  pdiE[i][k][i2] = (pdiglE[i][k][i2] + pdimlE[i][k][i2] + pdiwlE[i][k][i2]
	    + pdilE[i][k][i2]) * plambE[i] * (PsuckE[0][i3] + PsuckE[1][i3])
	    / l3E[i3];
        k = 2;
	a2 = 0;
	for (j = 2; j <= clt; j++) a2 += PsuckE[j][i3];
	neE[i][k][i2] = (neglE[i][k][i2] + nemlE[i][k][i2] + newlE[i][k][i2]
	  + nelE[i][k][i2]) * plambE[i] * a2 / l3E[i3];
	watE[i][k][i2] = watlE[i][k][i2] * plambE[i] * a2 / l3E[i3];  
	if (feedcost == 1) 
	  pdiE[i][k][i2] = (pdiglE[i][k][i2] + pdimlE[i][k][i2] + pdiwlE[i][k][i2]
	    + pdilE[i][k][i2]) * plambE[i] * a2 / l3E[i3];
	k = 3;
        neE[i][k][i2] = (neglE[i][k][i2] + nemlE[i][k][i2] + newlE[i][k][i2])
	  * plambE[i] + (negnlE[i][k][i2] + nemnlE[i][k][i2] + newnlE[i][k][i2])
	  * (1 - plambE[i]) + nefE[i][k][i2];
	watE[i][k][i2] = watlE[i][k][i2] * plambE[i] + watnlE[i][k][i2] *
	  (1 - plambE[i]);  	  
        if (feedcost == 1) 
	  pdiE[i][k][i2] = (pdiglE[i][k][i2] + pdimlE[i][k][i2] + pdiwlE[i][k][i2])
	    * plambE[i] + (pdignlE[i][k][i2] + pdimnlE[i][k][i2] 
	    + pdiwnlE[i][k][i2]) * (1 - plambE[i]) + pdifE[i][k][i2];
        k = 4;
        neE[i][k][i2] = (neglE[i][k][i2] + nemlE[i][k][i2] + newlE[i][k][i2])
	  * plambE[i] + (negnlE[i][k][i2] + nemnlE[i][k][i2] + newnlE[i][k][i2])
	  * (1 - plambE[i]);
	watE[i][k][i2] = watlE[i][k][i2] * plambE[i] + watnlE[i][k][i2] *
	  (1 - plambE[i]);  	  
        if (feedcost == 1) 
	  pdiE[i][k][i2] = (pdiglE[i][k][i2] + pdimlE[i][k][i2] + pdiwlE[i][k][i2])
	    * plambE[i] + (pdignlE[i][k][i2] + pdimnlE[i][k][i2] 
	    + pdiwnlE[i][k][i2]) * (1 - plambE[i]);
        k = 5;
        neE[i][k][i2] = (neglE[i][k][i2] + nemlE[i][k][i2] + newlE[i][k][i2])
	  * plambE[i] + (negnlE[i][k][i2] + nemnlE[i][k][i2] + newnlE[i][k][i2])
	  * (1 - plambE[i]) + nepE[i][k][i2];
	watE[i][k][i2] = watlE[i][k][i2] * plambE[i] + watnlE[i][k][i2] *
	  (1 - plambE[i]);  	  
        if (feedcost == 1) 
	  pdiE[i][k][i2] = (pdiglE[i][k][i2] + pdimlE[i][k][i2] + pdiwlE[i][k][i2])
	    * plambE[i] + (pdignlE[i][k][i2] + pdimnlE[i][k][i2] 
	    + pdiwnlE[i][k][i2]) * (1 - plambE[i]) + nepE[i][k][i2];
	for (k = 1; k <= fE; k++) {
	  feE[i][k][i2] = neE[i][k][i2] / (nedE[k][i2] * drymE[k][i2]);
	  if (feedcost == 1) 
	    fpdiE[i][k][i2] = pdiE[i][k][i2] / (pdidE[k][i2] * drymE[k][i2]);
	  if (feedcost == 1) ffE[i][k][i2] = maxi(feE[i][k][i2], 
	    fpdiE[i][k][i2]) / (1 - lossfE[k][i2]/100);
	  if (feedcost == 2) ffE[i][k][i2] = feE[i][k][i2]   
	    / (1 - lossfE[k][i2]/100);
	  costfE[i] += ffE[i][k][i2] * prfE[k][i2]; 
	  costwatE[i] += watE[i][k][i2] * prwat;
	}  
      }
    }
    for (j1 = 1; j1 <= 2; j1++) {
      i = (i3 - 1) * nstgE + j1;
      i2 = i3 * nstgE;
      if (i3 == LL) i2 = TE;
      costfE[i] = costfE[i2]/2;  
      costwatE[i] = costwatE[i2]/2;     
    }
  }
  for (j = 1; j <= clt; j++) {
    for (i3 = 1; i3 < LL; i3++) {
      i = i3 * nstgE;
      for (k = 4; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (nepbE[j][i][k][i2] < -0.00001 || pdipbE[j][i][k][i2] < -0.00001) { 
	    nonsense29(breed,1);
	    errmess = 1;
	    goto END;
	  }
	}
      }      
    }
  /* Discounting of nutrition costs for ewes */
  for (i = 1; i <= TE; i++) {
    costfE[i] *= qaveE[i];
    costwatE[i] *= qaveE[i];
  }
  
  /* Nutrition of lambs */  
  for (i = 1; i <= PP; i++) {
    for (j = 1; j < CB; j++) {  
      costfL[i][j] = costwatL[i][j] = 0;
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) {
          neL[i][j][k][i2] = pdiL[i][j][k][i2] = feL[i][j][k][i2] = 
	  ffL[i][j][k][i2] = fpdiL[i][j][k][i2] = 
	  newL[i][j][k][i2] = negL[i][j][k][i2] = nemL[i][j][k][i2] = 
	  pdigL[i][j][k][i2] = pdimL[i][j][k][i2] = pdiwL[i][j][k][i2] = 
          nepL[i][j][k][i2] = pdipL[i][j][k][i2] = nefL[i][j][k][i2] = 
	  pdifL[i][j][k][i2] = watL[i][j][k][i2] = 0;
	  for (j1 = 1; j1 <= clt; j1++)
	    newbL[j1][i][j][k][i2] = negbL[j1][i][j][k][i2] =
	    nembL[j1][i][j][k][i2] = pdigbL[j1][i][j][k][i2] = 
	    pdimbL[j1][i][j][k][i2] = pdiwbL[j1][i][j][k][i2] = 
	    nebL[j1][i][j][k][i2] = pdibL[j1][i][j][k][i2] = 
    	    nepbL[j1][i][j][k][i2] = pdipbL[j1][i][j][k][i2] = 0;
	  }   
        }
      }
    } 
  for (i = 1; i < CB; i++) {    
    for (j = 1; j <= nfs; j++) 
      negL14m[i][j] = negL14nm[i][j] = nemL14m[i][j] = nemL14nm[i][j] = 
      newL14m[i][j] = newL14nm[i][j] = pdigL14m[i][j] = pdigL14nm[i][j] = 
      pdimL14m[i][j] = pdimL14nm[i][j] = pdiwL14m[i][j] = pdiwL14nm[i][j] = 
      watL14m[i][j] = watL14nm[i][j] = 0;
     }
    
  c1[1] = 1;
  c1[2] = c1[0] = 1.15;
  c2[1] = 2.1;
  c2[2] = 2.5;
  c2[0] = 4.4;
  c3[1] = 0.45;
  c3[2] = 0.35;
  c3[0] = 0.32;
  c4[1] = 156.1;
  c4[2] = c4[0] = 160.4;
  c5[1] = 1.94;
  c5[2] = c5[0] = 1.22;
  c6[1] = 0.0173;
  c6[2] = c6[0] = 0.0105;
  if (flushbbL + flushabL > 0) adgfL = wgfL / (flushbbL + flushabL);
    else adgfL = 0;    
  
    /* Categories 5, 30, 2 */
  for (j1 = 1; j1 <= clt; j1++) {
    for (i3 = 0; i3 <= 1; i3++) {
      i = i3 * 25 + 5;
      k = 1;
      k1 = datlamb;
      k2 = datwL-1;
      for (j = 1; j <= crossing; j++) { 
        if (l1skL[i][j] > 0.000001) {
          if (i == 5) k6 = 1;
	    else k6 = 2;
	  adgb[k6][j1][j] = adgbwL[k6][j1][j];
	  swb[k6][j1][j] = bwL[k6][j1][j];       
	  for (k3 = k1; k3 <= k2; k3++) {
	    k5 = k3 - k1 + 1;
	    if (k3 < datchfs[1]) i2 = valfs[0];
	    for (k4 = 1; k4 < nchfst; k4++)
              if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	    if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	    newbL[j1][i][j][k][i2]++;
	    negbL[j1][i][j][k][i2] += c2[k6] + c3[k6] * (swb[k6][j1][j] +
	      adgb[k6][j1][j] * k5);
	    nembL[j1][i][j][k][i2] += pow(swb[k6][j1][j] + adgb[k6][j1][j] * k5,0.75)
	      * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	      (swb[k6][j1][j] + adgb[k6][j1][j] * k5);
            if (feedcost == 1) {
	      pdimbL[j1][i][j][k][i2] += pow(swb[k6][j1][j] + adgb[k6][j1][j] *
		k5,0.75);  
	      pdigbL[j1][i][j][k][i2] += c4[k6] - c5[k6] * (swb[k6][j1][j] 
		+ adgb[k6][j1][j] * k5) + c6[k6] * (swb[k6][j1][j] + adgb[k6][j1][j] 
		* k5) * (swb[k6][j1][j] + adgb[k6][j1][j] * k5);
	      pdiwbL[j1][i][j][k][i2] += 3 + adgb[k6][j1][j] * 0.1 * 
		(c4[k6] - c5[k6] * (swb[k6][j1][j] + adgb[k6][j1][j] * k5) + 
		c6[k6] * (swb[k6][j1][j] + adgb[k6][j1][j] * k5) 
		* (swb[k6][j1][j] + adgb[k6][j1][j] * k5));
            }
	  }
	  for (i2 = 1; i2 <= nfs; i2++) {
	    if (j1 == 1) watL[i][j][k][i2] = newbL[j1][i][j][k][i2] * dwatL[k][i2];
	    newbL[j1][i][j][k][i2] *= 23.7 * dwoolptwL;
	    negbL[j1][i][j][k][i2] *= adgb[k6][j1][j];
	    nembL[j1][i][j][k][i2] *= 0.277 * c1[k6]; 
            if (feedcost == 1) {
	      pdimbL[j1][i][j][k][i2] *= 2.1875; 
	      pdigbL[j1][i][j][k][i2] *= adgb[k6][j1][j];
            }
	  }
	} 
      }      
    }
  }    
  for (i = 1; i <= nfs; i++) basemilkws[i] = 0;
  k1 = datlamb;
  k2 = datwL-1;
  for (k3 = k1; k3 <= k2; k3++) {
    k5 = k3 - k1 + 1;
    if (k3 < datchfs[1]) i2 = valfs[0];
    for (k4 = 1; k4 < nchfst; k4++)
      if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
    if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];    
    basemilkws[i2] += pow(k5,bwo) * exp(-cwo*k5);    
  }
  for (i = 1; i <= nfs; i++) basemilkws[i] *= awo; 
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      for (k = 1; k <= nfs; k++) {
	milkwsrel[i][j][k] = basemilkws[k] * ktlsl[i] * ktlp[j];
	milkws[i][j][k] = milkwsrel[i][j][k] * PsuckE[i][j];
      }
    }
  }
  for (j = 1; j <= clt; j++) {
    for (k = 1; k <= nfs; k++) {
      milkwL[j][k] = 0;
      for (i = 1; i <= LL; i++) milkwL[j][k] += milkwsrel[j][i][k] * l3E[i];
      milkwL[j][k] *= (1 - pmilkwm) / (Nlamb * j);
      }
    }
  for (k = 1; k <= nfs; k++) {
    tmilkw0[k] = milkw0L[k] = 0;
    if (typeb == 1) {
      for (i = 1; i <= LL; i++) tmilkw0[k] += milkws[0][i][k];
      tmilkw0[k] /= Nlamb;
      if (pmilkwm < 0.000001) {    
	for (i = 2; i <= clt; i++) milkw0L[k] += na24hL[0][i];
	milkw0L[k] = tmilkw0[k] / (milkw0L[k] * Nlamb);
      }
    }
    for (i = 1; i <= clt; i++) {
      if (i < 2) i2 = 0;
	else i2 = 1;
      nelwL[i][k] = (milkwL[i][k] + i2 * milkw0L[k]) * nemilk;
      if (feedcost == 1) 
        pdilwL[i][k] = (milkwL[i][k] + i2 * milkw0L[k]) * pdimilk;
    }
  }
  for (j1 = 1; j1 <= clt; j1++) {
    for (i3 = 0; i3 <= 1; i3++) {
      i = i3 * 25 + 5;
      for (j = 1; j <= crossing; j++) { 
	for (i2 = 1; i2 <= nfs; i2++) {
	  nebL[j1][i][j][1][i2] = newbL[j1][i][j][1][i2] 
	    + negbL[j1][i][j][1][i2] + nembL[j1][i][j][1][i2] 
	    - nelwL[j1][i2]; 
	  if (feedcost == 1) 
	    pdibL[j1][i][j][1][i2] = pdiwbL[j1][i][j][1][i2] 
	      + pdigbL[j1][i][j][1][i2] + pdimbL[j1][i][j][1][i2] 
	      - pdilwL[j1][i2]; 
	}
      } 
    }
  }    
  for (i3 = 0; i3 <= 1; i3++) {
    i = i3 * 25 + 5;
    for (j = 1; j <= crossing; j++) { 
      for (i2 = 1; i2 <= nfs; i2++) {
        a2 = 0;
        for (j1 = 1; j1 <= clt; j1++) {
	  a2 += l1L[i][j][j1];
	  if (nebL[j1][i][j][1][i2] > 0) 
            neL[i][j][1][i2] += l1L[i][j][j1] * nebL[j1][i][j][1][i2];
          if (feedcost == 1) {
	    if (pdibL[j1][i][j][1][i2] > 0) 
	      pdiL[i][j][1][i2] += l1L[i][j][j1] * pdibL[j1][i][j][1][i2];
          }
	}
	neL[i][j][1][i2] /= a2;
	if (feedcost == 1) pdiL[i][j][1][i2] /= (a2 * 0.65);
	if (neL[i][j][1][i2] > 0)
	  feL[i][j][1][i2] = neL[i][j][1][i2] / (nedL[1][i2] * drymL[1][i2]);
        if (feedcost == 1) {
	  if (pdiL[i][j][1][i2] > 0)
	    fpdiL[i][j][1][i2] = pdiL[i][j][1][i2] / (pdidL[1][i2] * drymL[1][i2]);
          ffL[i][j][1][i2] = maxi(feL[i][j][1][i2], 
	    fpdiL[i][j][1][i2]) / (1 - lossfL[1][i2]/100);
	  }    
	if (feedcost == 2) ffL[i][j][1][i2] = feL[i][j][1][i2]   
	  / (1 - lossfL[1][i2]/100);
	costfL[i][j] += ffL[i][j][1][i2] * prfL[1][i2];
	costwatL[i][j] += watL[i][j][1][i2] * prwat;  
      }
    }
  }    
  for (j = 1; j <= crossing; j++) {
    costfL[2][j] = (costfL[5][j] * sexrbf + costfL[30][j] * sexrbm)/2;
    costwatL[2][j] = (costwatL[5][j] * sexrbf + costwatL[30][j] * sexrbm)/2;
    }
    
    /* Categories 6, 31, 2 */
  if (typew == 2) {
    for (j1 = 1; j1 <= clt; j1++) {
      for (i3 = 0; i3 <= 1; i3++) {
	i = i3 * 25 + 6;
	k = 2;
	k1 = datwL;
	k2 = datlamb + agearL -1;
	for (j = 1; j <= crossing; j++) { 
          if (l1skL[i][j] > 0.000001) {
            if (i == 6) k6 = 1;
	      else k6 = 2;
	    adgb[k6][j1][j] = adgwarL[k6][j1][j];
	    swb[k6][j1][j] = wwL[k6][j1][j];       
	    for (k3 = k1; k3 <= k2; k3++) {
	      k5 = k3 - k1 + 1;
	      if (k3 < datchfs[1]) i2 = valfs[0];
	      for (k4 = 1; k4 < nchfst; k4++)
        	if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	      if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	      newbL[j1][i][j][k][i2]++;
	      negbL[j1][i][j][k][i2] += c2[k6] + c3[k6] * (swb[k6][j1][j] +
		adgb[k6][j1][j] * k5);
	      nembL[j1][i][j][k][i2] += pow(swb[k6][j1][j] + adgb[k6][j1][j] * k5,0.75)
		* (1 + 0.0091 * (20 - tp[i2])) + ktL[1] * 
		(swb[k6][j1][j] + adgb[k6][j1][j] * k5);
              if (feedcost == 1) {
		pdimbL[j1][i][j][k][i2] += pow(swb[k6][j1][j] + adgb[k6][j1][j] *
		  k5,0.75);  
		pdigbL[j1][i][j][k][i2] += c4[k6] - c5[k6] * (swb[k6][j1][j] 
		  + adgb[k6][j1][j] * k5) + c6[k6] * (swb[k6][j1][j] + adgb[k6][j1][j] 
		  * k5) * (swb[k6][j1][j] + adgb[k6][j1][j] * k5);
		pdiwbL[j1][i][j][k][i2] += 3 + adgb[k6][j1][j] * 0.1 *
		  (c4[k6] - c5[k6] 
		  * (swb[k6][j1][j] + adgb[k6][j1][j] * k5) + c6[k6] * (swb[k6][j1][j] 
		  + adgb[k6][j1][j] * k5) * (swb[k6][j1][j] + adgb[k6][j1][j] * k5));
              }
	    }
	    for (i2 = 1; i2 <= nfs; i2++) {
	      if (j1 == 1) watL[i][j][k][i2] = newbL[j1][i][j][k][i2] 
		* dwatL[k][i2];	  
	      newbL[j1][i][j][k][i2] *= 23.7 * dwoolptarL;
	      negbL[j1][i][j][k][i2] *= adgb[k6][j1][j];
	      nembL[j1][i][j][k][i2] *= 0.277 * c1[k6]; 
              if (feedcost == 1) {
		pdimbL[j1][i][j][k][i2] *= 2.1875; 
		pdigbL[j1][i][j][k][i2] *= adgb[k6][j1][j]/0.8;
		pdiwbL[j1][i][j][k][i2] /= 0.8;
        	}
	      nebL[j1][i][j][k][i2] = newbL[j1][i][j][k][i2] 
		+ negbL[j1][i][j][k][i2] + nembL[j1][i][j][k][i2];
	      if (feedcost == 1) 
		pdibL[j1][i][j][k][i2] = pdiwbL[j1][i][j][k][i2] 
	          + pdigbL[j1][i][j][k][i2] + pdimbL[j1][i][j][k][i2];
	    }
          }
	} 
      }
    } 
    for (i3 = 0; i3 <= 1; i3++) {
      i = i3 * 25 + 6;
      for (j = 1; j <= crossing; j++) { 
	for (i2 = 1; i2 <= nfs; i2++) {
          a2 = 0;
          for (j1 = 1; j1 <= clt; j1++) {
	    a2 += l1L[i][j][j1];
            neL[i][j][2][i2] += l1L[i][j][j1] * nebL[j1][i][j][2][i2];
            if (feedcost == 1) 
	      pdiL[i][j][2][i2] += l1L[i][j][j1] * pdibL[j1][i][j][2][i2];
	    }
	  neL[i][j][2][i2] /= a2;
	  if (feedcost == 1) pdiL[i][j][2][i2] /= a2;
	  feL[i][j][2][i2] = neL[i][j][2][i2] / (nedL[2][i2] * drymL[2][i2]);
	  if (feedcost == 1) {
	    fpdiL[i][j][2][i2] = pdiL[i][j][2][i2] / (pdidL[2][i2] 
	      * drymL[2][i2]);
	    ffL[i][j][2][i2] = maxi(feL[i][j][2][i2], 
	      fpdiL[i][j][2][i2]) / (1 - lossfL[2][i2]/100);
	    }  
	  if (feedcost == 2) ffL[i][j][2][i2] = feL[i][j][2][i2]   
	    / (1 - lossfL[2][i2]/100);
          costfL[i][j] += ffL[i][j][2][i2] * prfL[2][i2]; 
          costwatL[i][j] += watL[i][j][2][i2] * prwat; 	   
          }  
        }
      }  
    for (j = 1; j <= crossing; j++) {
      costfL[2][j] = ((costfL[5][j] + costfL[6][j]) * sexrbf 
        + (costfL[30][j] + costfL[31][j]) * sexrbm)/2;
      costwatL[2][j] = ((costwatL[5][j] + costwatL[6][j]) * sexrbf 
        + (costwatL[30][j] + costwatL[31][j]) * sexrbm)/2;
    }	
  }

    /* Category 13 */
  i = 13;
  k = 4;
  if (typew == 1) k1 = datwL;
  if (typew == 2) k1 = datlamb + agearL;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      k2 = datlamb + (int)(agetP[13][j] + 0.5) - 1;
      k6 = 1;
      adg[k6][j] = adgr[1][1][j];
      if (typew == 1) sw[k6][j] = avww[1][j];
      if (typew == 2) sw[k6][j] = avwar[1][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] + adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 14, mated */
      /* feeding ration is 4 */
  i = 14;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      if (typew == 1) k1 = datwL;
      if (typew == 2) k1 = datlamb + agearL;
      k2 = datbbs - flushbbL - 1;
      adg[k6][j] = adgr[1][1][j];
      if (typew == 1) sw[k6][j] = avww[1][j];
      if (typew == 2) sw[k6][j] = avwar[1][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL14m[j][i2]++;
	negL14m[j][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL14m[j][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL14m[j][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL14m[j][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL14m[j][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL14m[j][i2] = newL14m[j][i2] * dwatL[4][i2];
	newL14m[j][i2] *= 23.7 * dwoolptrL[k6][j];
	negL14m[j][i2] *= adg[k6][j];
	nemL14m[j][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL14m[j][i2] *= 2.1875; 
	  pdigL14m[j][i2] *= adg[k6][j]/0.59;
	}
      }
	/* feeding ration is 3 */
      k = 3;
      k1 = datbbs - flushbbL;
      k2 = datlamb + (int)(ager[1][1] + 0.5) - 1;
      adg[k6][j] = adgr[1][1][j];
      if (typew == 1) sw[k6][j] = avww[1][j];
      if (typew == 2) sw[k6][j] = avwar[1][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL * pmat[1][1][j];
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL * pmat[1][1][j];
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2] * pmat[1][1][j]; 	 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j] * pmat[1][1][j];
	negL[i][j][k][i2] *= adg[k6][j] * pmat[1][1][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6] * pmat[1][1][j]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875 * pmat[1][1][j]; 
	  pdigL[i][j][k][i2] *= adg[k6][j] * pmat[1][1][j] / 0.59;
	  pdiwL[i][j][k][i2] *= pmat[1][1][j];
	}
      }
    }
  } 

    /* Category 14, not mated */
    /* feeding ration is 4 */
  i = 14;
  if (typew == 1) k1 = datwL;
  if (typew == 2) k1 = datlamb + agearL;
  k2 = datlamb + (int)(ager[1][1] + 0.5) - 1;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      adg[k6][j] = adgr[1][1][j];
      if (typew == 1) sw[k6][j] = avww[1][j];
      if (typew == 2) sw[k6][j] = avwar[1][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL14nm[j][i2]++;
	negL14nm[j][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL14nm[j][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL14nm[j][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL14nm[j][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL14nm[j][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL14nm[j][i2] = newL14nm[j][i2] * dwatL[4][i2];
	newL14nm[j][i2] *= 23.7 * dwoolptrL[k6][j];
	negL14nm[j][i2] *= adg[k6][j];
	nemL14nm[j][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL14nm[j][i2] *= 2.1875; 
	  pdigL14nm[j][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

  /* Category 14 totals */
  for (j = 1; j <= crossing; j++) {   
    if (l1skL[i][j] > 0.000001) {  
      for (i2 = 1; i2 <= nfs; i2++) {
	negL[i][j][4][i2] = negL14m[j][i2] * pmat[1][1][j] + negL14nm[j][i2]
          * (1 - pmat[1][1][j]);
	nemL[i][j][4][i2] = nemL14m[j][i2] * pmat[1][1][j] + nemL14nm[j][i2]
          * (1 - pmat[1][1][j]);
	newL[i][j][4][i2] = newL14m[j][i2] * pmat[1][1][j] + newL14nm[j][i2]
          * (1 - pmat[1][1][j]);
	watL[i][j][4][i2] = watL14m[j][i2] * pmat[1][1][j] + watL14nm[j][i2]
          * (1 - pmat[1][1][j]);
	if (feedcost == 1) {
	  pdigL[i][j][4][i2] = pdigL14m[j][i2] * pmat[1][1][j] + pdigL14nm[j][i2]
            * (1 - pmat[1][1][j]);
	  pdimL[i][j][4][i2] = pdimL14m[j][i2] * pmat[1][1][j] + pdimL14nm[j][i2]
            * (1 - pmat[1][1][j]);
	  pdiwL[i][j][4][i2] = pdiwL14m[j][i2] * pmat[1][1][j] + pdiwL14nm[j][i2]
            * (1 - pmat[1][1][j]);
	}
      }
    }
  }  

    /* Category 15 */
  i = 15;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
       /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][1] + 0.5);
      k2 = datlamb + (int)(ager[1][1] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */  
      k = 4;
      k1 = datlamb + (int)(ager[1][1] + 0.5) + flushabL;
      if ((int)(dpregsFP + 0.5) < lpreg - dshpE) 
	k2 = datlamb + lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
	else k2 = datlamb + lengthrc - dshpE - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	if (k3 >= datconFP[1]) {
          k7 = k5 + datlamb + (int)(ager[1][1] + 0.5) - datconFP[1];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];    
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
          }
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      if ((int)(dpregsFP + 0.5) >= lpreg - dshpE) {
	k = 5;
	k1 = datlamb + lengthrc - dshpE;
	k2 = datlamb + lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
	for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;
	adg[k6][j] = adgr[1][2][j];
	sw[k6][j] = wmat[1][j];
	for (k3 = k1; k3 <= k2; k3++) {
	  k5++;
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  newL[i][j][k][i2]++;
	  negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	    adg[k6][j] * k5);
	  nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * k5);
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	      k5,0.75);  
	    pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	      + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	      * k5) * (sw[k6][j] + adg[k6][j] * k5);
	    pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
          }
          k7 = k5 + datlamb + (int)(ager[1][1] + 0.5) - datconFP[1];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	  nd[i2]++;  
	}
	for (i2 = 1; i2 <= nfs; i2++) {
          watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];      
	  newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	  negL[i][j][k][i2] *= adg[k6][j];
	  nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] *= 2.1875; 
	    pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
          }
          for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	    if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	    nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	    if (feedcost == 1) pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
          }
	}
      } 
    }      
  }

    /* Category 16 */
  i = 16;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][1] + 0.5);
      k2 = datlamb + (int)(ager[1][1] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][1] + 0.5) + flushabL;
      k2 = datlamb + lengthrc - dshpE - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	if (k3 >= datconFP[1]) {
          k7 = k5 + datlamb + (int)(ager[1][1] + 0.5) - datconFP[1];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      k = 5;
      k1 = datlamb + lengthrc - dshpE;
      k2 = datlamb + lengthrc - 1;
      for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;  
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
          }
	k7 = k5 + datlamb + (int)(ager[1][1] + 0.5) - datconFP[1];
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	    exp(-0.00643 * k7));
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
	      exp(-0.00601 * k7));
	}
	nd[i2]++;  
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];    
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	  nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
	}
      }
    }      
  } 

    /* Category 17 */
  i = 17;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
	/* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][1] + 0.5);
      k2 = datlamb + (int)(ager[1][1] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][1] + 0.5) + flushabL;
      k2 = datebs + dnpregcFP - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 18 */
  i = 18;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
	/* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][1] + 0.5);
      k2 = datlamb + (int)(ager[1][1] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][1] + 0.5) + flushabL;
      k2 = datbbs + lengthrc - flushbbL - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wnmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
	/* feeding ration is 3 again */    
      k = 3;
      k1 = datbbs + lengthrc - flushbbL;
      k2 = datbbs + lengthrc - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wnmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 19 */
  i = 19;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][2] + 0.5);
      k2 = datlamb + (int)(ager[1][2] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][2] + 0.5) + flushabL;
      if ((int)(dpregsFP + 0.5) < lpreg - dshpE) 
	k2 = datlamb + 2 * lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
      else k2 = datlamb + 2 * lengthrc - dshpE - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
          }
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k5 - 11.4646 *
	    exp(-0.00643 * k5));
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k5 - 11.2205 *
	      exp(-0.00601 * k5));
	}
	if (k3 >= datconFP[2]) {
          k7 = k5 + datlamb + (int)(ager[1][2] + 0.5) - datconFP[2];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      if ((int)(dpregsFP + 0.5) >= lpreg - dshpE) {
	k = 5;
	k1 = datlamb + 2 * lengthrc - dshpE;
	k2 = datlamb + 2 * lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
	for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;
	adg[k6][j] = adgr[1][3][j];
	sw[k6][j] = wrL[1][2][j];
	for (k3 = k1; k3 <= k2; k3++) {
	  k5++;
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  newL[i][j][k][i2]++;
	  negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	    adg[k6][j] * k5);
	  nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * k5);
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	      k5,0.75);  
	    pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	      + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	      * k5) * (sw[k6][j] + adg[k6][j] * k5);
	    pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
          }
          k7 = k5 + datlamb + (int)(ager[1][2] + 0.5) - datconFP[2];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	  nd[i2]++;  
	}
	for (i2 = 1; i2 <= nfs; i2++) {
          watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	  newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	  negL[i][j][k][i2] *= adg[k6][j];
	  nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] *= 2.1875; 
	    pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
          } 
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	    if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	    nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
	  }
	}
      }
    }       
  }

    /* Category 20 */
  i = 20;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][2] + 0.5);
      k2 = datlamb + (int)(ager[1][2] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][2] + 0.5) + flushabL;
      k2 = datlamb + 2 * lengthrc - dshpE - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	if (k3 >= datconFP[2]) {
          k7 = k5 + datlamb + (int)(ager[1][2] + 0.5) - datconFP[2];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      k = 5;
      k1 = datlamb + 2 * lengthrc - dshpE;
      k2 = datlamb + 2 * lengthrc - 1;
      for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) { 
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	k7 = k5 + datlamb + (int)(ager[1][2] + 0.5) - datconFP[2];
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	    exp(-0.00643 * k7));
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
	      exp(-0.00601 * k7));
	}
	nd[i2]++;  
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	  nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
	}
      }
    }      
  } 

    /* Category 21 */
  i = 21;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][2] + 0.5);
      k2 = datlamb + (int)(ager[1][2] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][2] + 0.5) + flushabL;
      k2 = datebs + lengthrc + dnpregcFP - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 22 */
  i = 22;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][2] + 0.5);
      k2 = datlamb + (int)(ager[1][2] + 0.5) + flushabL - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][2] + 0.5) + flushabL;
      k2 = datbbs + 2 * lengthrc - flushbbL - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
	/* feeding ration is 3 again */
      k = 3;
      k1 = datbbs + 2 * lengthrc - flushbbL;
      k2 = datbbs + 2 * lengthrc - 1;
      adg[k6][j] = adgr[1][3][j];
      sw[k6][j] = wrL[1][2][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 23 */
  i = 23;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][3] + 0.5);
      k2 = datlamb + (int)(ager[1][3] + 0.5) + flushabL - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][3] + 0.5) + flushabL;
      if ((int)(dpregsFP + 0.5) < lpreg - dshpE) 
	k2 = datlamb + 3 * lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
      else k2 = datlamb + 3 * lengthrc - dshpE - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	if (k3 >= datconFP[3]) {
          k7 = k5 + datlamb + (int)(ager[1][3] + 0.5) - datconFP[3];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) pdimL[i][j][k][i2] *= 2.1875; 
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      if ((int)(dpregsFP + 0.5) >= lpreg - dshpE) {
	k = 5;
	k1 = datlamb + 3 * lengthrc - dshpE;
	k2 = datlamb + 3 * lengthrc - lpreg + (int)(dpregsFP + 0.5) - 1;
	k1 = datlamb + (int)(ager[1][3] + 0.5) + lpreg - dshpE;
	k2 = datlamb + (int)(ager[1][3] + 0.5) + (int)(dpregsFP + 0.5) - 1;
	for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;    
	adg[k6][j] = 0;
	sw[k6][j] = wrL[1][3][j];
	for (k3 = k1; k3 <= k2; k3++) {
	  k5++;
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  newL[i][j][k][i2]++;
	  nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * k5);
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	      k5,0.75);  
	    pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
          }
          k7 = k5 + datlamb + (int)(ager[1][3] + 0.5) - datconFP[3];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	  nd[i2]++;  
	}
	for (i2 = 1; i2 <= nfs; i2++) {
          watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	  newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	  nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	  if (feedcost == 1) pdimL[i][j][k][i2] *= 2.1875; 
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	    if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	    nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
	  }
	}
      } 
    }
  }

    /* Category 24 */
  i = 24;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][3] + 0.5);
      k2 = datlamb + (int)(ager[1][3] + 0.5) + flushabL - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][3] + 0.5) + flushabL;
      k2 = datlamb + 3 * lengthrc - dshpE - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	} 
	if (k3 >= datconFP[3]) {
          k7 = k5 + datlamb + (int)(ager[1][3] + 0.5) - datconFP[3];
	  for (j1 = 1; j1 <= clt; j1++) { 
	    nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	      exp(-0.00643 * k7));
	    if (feedcost == 1) 
	      pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
		exp(-0.00601 * k7));
	  }
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) pdimL[i][j][k][i2] *= 2.1875; 
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	}
      }
      k = 5;
      k1 = datlamb + 3 * lengthrc - dshpE;
      k2 = datlamb + 3 * lengthrc - 1;
      for (i2 = 1; i2 <= nfs; i2++) nd[i2] = 0;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
	k7 = k5 + datlamb + (int)(ager[1][3] + 0.5) - datconFP[3];
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] += exp(7.6492 - 0.00643 * k7 - 11.4646 *
	    exp(-0.00643 * k7));
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] += exp(11.3471 - 0.00601 * k7 - 11.2205 *
	      exp(-0.00601 * k7));
	}
	nd[i2]++;  
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) pdimL[i][j][k][i2] *= 2.1875; 
	for (j1 = 1; j1 <= clt; j1++) { 
	  nepbL[j1][i][j][k][i2] *= 0.083773 * twL[j1][1];
	  if (feedcost == 1) pdipbL[j1][i][j][k][i2] *= 0.043889 * twL[j1][1];
	  nepbL[j1][i][j][k][i2] -= 20.034 * nd[i2] * wgfL / dshpE;
	  if (feedcost == 1) 
	    pdipbL[j1][i][j][k][i2] -= 119 * nd[i2] * wgfL / dshpE;
	}
      }
    }
  } 

    /* Category 25 */
  i = 25;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      /* feeding ration is 3 */
      k = 3;
      k1 = datlamb + (int)(ager[1][3] + 0.5);
      k2 = datlamb + (int)(ager[1][3] + 0.5) + flushabL - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	nefL[i][j][k][i2] = newL[i][j][k][i2] * 23.85 * adgfL;
	if (feedcost == 1) 
          pdifL[i][j][k][i2] = newL[i][j][k][i2] * 140 * adgfL; 
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j] / 0.59;
	}
      }
	/* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][3] + 0.5) + flushabL;
      k2 = datebs + 2 * lengthrc + dnpregcFP - 1;
      adg[k6][j] = 0;
      sw[k6][j] = wrL[1][3][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5++;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) pdimL[i][j][k][i2] *= 2.1875; 
      }
    }
  } 

    /* Category 26 */
  i = 26;
  k6 = 1;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      /* feeding ration is 4 */
      k = 4;
      k1 = datlamb + (int)(ager[1][1] + 0.5);
      k2 = datlamb + (int)(agetP[26][j] + 0.5) - 1;
      adg[k6][j] = adgr[1][2][j];
      sw[k6][j] = wnmat[1][j];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 38 */
  i = 38;
  k = 4;
  if (typew == 1) k1 = datwL;
  if (typew == 2) k1 = datlamb + agearL;
  k6 = 2;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      k2 = datlamb + (int)(agetP[38][j] + 0.5) - 1;
      adg[k6][j] = adgr[2][1][j];
      if (typew == 1) sw[k6][j] = avww[2][j];
      if (typew == 2) sw[k6][j] = avwar[2][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];    
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 39 */
  i = 39;
  k = 4;
  if (typew == 1) k1 = datwL;
  if (typew == 2) k1 = datlamb + agearL;
  k6 = 2;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      k2 = datbbs - 1;
      adg[k6][j] = adgr[2][1][j];
      if (typew == 1) sw[k6][j] = avww[2][j];
      if (typew == 2) sw[k6][j] = avwar[2][j];         
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 40 */
  i = 40;
  k = 4;
  k1 = datbbs;
  k6 = 2;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {
      k2 = datlamb + (int)(agetP[40][j]+0.5) - 1;    
      adg[k6][j] = adgr[2][2][j];
      sw[k6][j] = wnmat[2][1];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Category 41 */
  i = 41;
  k = 4;
  k1 = datbbs;
  k6 = 2;
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[i][j] > 0.000001) {  
      k2 = datbbs + lengthrc - 1;    
      adg[k6][j] = adgr[2][2][j];
      sw[k6][j] = wnmat[2][1];
      for (k3 = k1; k3 <= k2; k3++) {
	k5 = k3 - k1 + 1;
	if (k3 < datchfs[1]) i2 = valfs[0];
	for (k4 = 1; k4 < nchfst; k4++)
          if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	newL[i][j][k][i2]++;
	negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	  adg[k6][j] * k5);
	nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	  * (1 + 0.0091 * (20 - tp[i2])) + ktL[techbL[i2]] * 
	  (sw[k6][j] + adg[k6][j] * k5);
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
	    k5,0.75);  
	  pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	    * k5) * (sw[k6][j] + adg[k6][j] * k5);
	  pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	    * (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
	    + adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
	}
      }
      for (i2 = 1; i2 <= nfs; i2++) {
	watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];
	newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	negL[i][j][k][i2] *= adg[k6][j];
	nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
	if (feedcost == 1) {
	  pdimL[i][j][k][i2] *= 2.1875; 
	  pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
	}
      }
    }
  } 

    /* Categories 15, 16, 19, 20, 23 and 24 */
  for (i = 14; i <= 24; i++) {
    if (i == 17) i = 19;
    if (i == 21) i = 23;
    for (j = 1; j <= crossing; j++) { 
      if (l1skL[i][j] > 0.000001) {
	for (k = 4; k <= 5; k++) {
          for (i2 = 1; i2 <= nfs; i2++) {
            for (j1 = 1; j1 <= clt; j1++) {
	      nepL[i][j][k][i2] += nepbL[j1][i][j][k][i2] * Pltype[j1][1];
	      if (feedcost == 1) 
		pdipL[i][j][k][i2] += pdipbL[j1][i][j][k][i2] * Pltype[j1][1];
	      }
	    }
          } 
	}
      }
    }

    /* Categories 13 to 26 and 38 to 41 */
  for (i = 13; i <= 41; i++) {
    if (i == 27) i = 38;
    for (j = 1; j <= crossing; j++) {
      if (l1skL[i][j] > 0.000001) { 
	for (k = 3; k <= 5; k++) {
          for (i2 = 1; i2 <= nfs; i2++) {
	    neL[i][j][k][i2] = negL[i][j][k][i2] + nemL[i][j][k][i2] +
	      newL[i][j][k][i2] + nepL[i][j][k][i2] + nefL[i][j][k][i2];
	    if (feedcost == 1) 
	      pdiL[i][j][k][i2] = pdigL[i][j][k][i2] + pdimL[i][j][k][i2] +
		pdiwL[i][j][k][i2] + pdipL[i][j][k][i2] + pdifL[i][j][k][i2];
	    if (neL[i][j][k][i2] > 0)
	      feL[i][j][k][i2] = neL[i][j][k][i2] / (nedL[k][i2] * drymL[k][i2]);
            if (feedcost == 1) {
	      if (pdiL[i][j][k][i2] > 0)
		fpdiL[i][j][k][i2] = pdiL[i][j][k][i2] / (pdidL[k][i2] 
	          * drymL[k][i2]);
	      ffL[i][j][k][i2] = maxi(feL[i][j][k][i2], fpdiL[i][j][k][i2]) 
		/ (1 - lossfL[k][i2]/100);
            }
	    if (feedcost == 2) ffL[i][j][k][i2] = feL[i][j][k][i2]   
	      / (1 - lossfL[k][i2]/100);
	    costfL[i][j] += ffL[i][j][k][i2] * prfL[k][i2];  
	    costwatL[i][j] += watL[i][j][k][i2] * prwat;  
	    }
          } 
        }	
      }
    }

    /* Categories 4, 29 and 42 */
  for (j = 1; j <= crossing; j++) { 
    if (l1skL[29][j] > 0) {
      costfL[29][j] = (costfL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
	+ costfL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      costwatL[29][j] = (costwatL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
	+ costwatL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      }	
    if (l1skL[42][j] > 0) {
      costfL[42][j] = (costfL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
	+ costfL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      costwatL[42][j] = (costwatL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
	+ costwatL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      }
    if (l1skL[4][j] > 0) {
      costfL[4][j] = (costfL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
	+ costfL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costfL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ (costfL[16][j] * pherd[1][1] + costfL[20][j] * pherd[1][2]
	+ costfL[24][j] * pherd[1][3]) * nrdiedmlFP[j] / Pherd[1]) 
	/ (2 * l1skL[4][j]);
      costwatL[4][j] = (costwatL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
	+ costwatL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costwatL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ (costwatL[16][j] * pherd[1][1] + costwatL[20][j] * pherd[1][2]
	+ costwatL[24][j] * pherd[1][3]) * nrdiedmlFP[j] / Pherd[1]) 
	/ (2 * l1skL[4][j]);
      }	
  }

    /* Categories 8 to 12 */
  if (lf[1] > 0) {
    for (i = 8; i <= 8 + lf[1] - 1; i++) {
      k = i-2;
      if (typew == 1) k1 = datwL;
      if (typew == 2) k1 = datlamb + agearL;
      for (j = 1; j <= crossing; j++) { 
        if (l1skL[i][j] > 0.000001) {
	  k6 = 1;
	  k2 = datlamb + (int)agetP[i][j] - 1;
	  adg[k6][j] = adgP[i][j];
	  if (typew == 1) sw[k6][j] = avww[k6][j];
	  if (typew == 2) sw[k6][j] = avwar[k6][j];         
	  for (k3 = k1; k3 <= k2; k3++) {
	    k5 = k3 - k1 + 1;
	    if (k3 < datchfs[1]) i2 = valfs[0];
	    for (k4 = 1; k4 < nchfst; k4++)
              if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	    if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	    newL[i][j][k][i2]++;
	    negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	      adg[k6][j] * k5);
	    nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	      * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	      (sw[k6][j] + adg[k6][j] * k5);
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
		k5,0.75);  
	      pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
		* k5) * (sw[k6][j] + adg[k6][j] * k5);
	      pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
		* (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
            }
	  }
	  a2 = agetP[i][j] - (int)agetP[i][j];
	  newL[i][j][k][i2] += a2;
	  negL[i][j][k][i2] += a2 * (c2[k6] + c3[k6] * (sw[k6][j] + adg[k6][j] * 
	    (k5 + a2)));
	  nemL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] * (k5 + a2),0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * (k5 + a2)));
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] *
	      (k5 + a2),0.75));  
	    pdigL[i][j][k][i2] += a2 * (c4[k6] - c5[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	      * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2)));
	    pdiwL[i][j][k][i2] += a2 * (11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2))));
          }
	  for (i2 = 1; i2 <= nfs; i2++) {
            watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];	
	    newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	    negL[i][j][k][i2] *= adg[k6][j];
	    nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] *= 2.1875; 
	      pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
            }
	  }
        }	
      } 
    }
  }
   
    /* Categories 33 to 37 */
  if (lf[2] > 0) {
    for (i = 33; i <= 33 + lf[2] - 1; i++) {
      k = i-22;
      if (typew == 1) k1 = datwL;
      if (typew == 2) k1 = datlamb + agearL;
      for (j = 1; j <= crossing; j++) { 
        if (l1skL[i][j] > 0.000001) {
	  k6 = 2;
	  k2 = datlamb + (int)agetP[i][j] - 1;
	  adg[k6][j] = adgP[i][j];
	  if (typew == 1) sw[k6][j] = avww[k6][j];
	  if (typew == 2) sw[k6][j] = avwar[k6][j];         
	  for (k3 = k1; k3 <= k2; k3++) {
	    k5 = k3 - k1 + 1;
	    if (k3 < datchfs[1]) i2 = valfs[0];
	    for (k4 = 1; k4 < nchfst; k4++)
              if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	    if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	    newL[i][j][k][i2]++;
	    negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	      adg[k6][j] * k5);
	    nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	      * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	      (sw[k6][j] + adg[k6][j] * k5);
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
		k5,0.75);  
	      pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
		* k5) * (sw[k6][j] + adg[k6][j] * k5);
	      pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
		* (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
            }
	  }
	  a2 = agetP[i][j] - (int)agetP[i][j];
	  newL[i][j][k][i2] += a2;
	  negL[i][j][k][i2] += a2 * (c2[k6] + c3[k6] * (sw[k6][j] + adg[k6][j] * 
	    (k5 + a2)));
	  nemL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] * (k5 + a2),0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * (k5 + a2)));
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] *
	      (k5 + a2),0.75));  
	    pdigL[i][j][k][i2] += a2 * (c4[k6] - c5[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	      * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2)));
	    pdiwL[i][j][k][i2] += a2 * (11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2))));
          }
	  for (i2 = 1; i2 <= nfs; i2++) {
            watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];	
	    newL[i][j][k][i2] *= 23.7 * dwoolptrL[k6][j];
	    negL[i][j][k][i2] *= adg[k6][j];
	    nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] *= 2.1875; 
	      pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
            }
	  }
        }	
      } 
    }
  }

    /* Categories 43 to 47 */
  if (lf[0] > 0) {
    for (i = 43; i <= 43 + lf[0] - 1; i++) {
      k = i-27;
      if (typew == 1) k1 = datwL;
      if (typew == 2) k1 = datlamb + agearL;
      for (j = 1; j <= crossing; j++) { 
        if (l1skL[i][j] > 0.000001) {      
	  k6 = 0;
	  k2 = datlamb + (int)agetP[i][j] - 1;
	  adg[k6][j] = adgP[i][j];
	  if (typew == 1) sw[k6][j] = avww[2][j];
	  if (typew == 2) sw[k6][j] = avwar[2][j];         
	  for (k3 = k1; k3 <= k2; k3++) {
	    k5 = k3 - k1 + 1;
	    if (k3 < datchfs[1]) i2 = valfs[0];
	    for (k4 = 1; k4 < nchfst; k4++)
              if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	    if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	    newL[i][j][k][i2]++;
	    negL[i][j][k][i2] += c2[k6] + c3[k6] * (sw[k6][j] +
	      adg[k6][j] * k5);
	    nemL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] * k5,0.75)
	      * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	      (sw[k6][j] + adg[k6][j] * k5);
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] += pow(sw[k6][j] + adg[k6][j] *
		k5,0.75);  
	      pdigL[i][j][k][i2] += c4[k6] - c5[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) + c6[k6] * (sw[k6][j] + adg[k6][j] 
		* k5) * (sw[k6][j] + adg[k6][j] * k5);
	      pdiwL[i][j][k][i2] += 11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
		* (sw[k6][j] + adg[k6][j] * k5) + c6[k6] * (sw[k6][j] 
		+ adg[k6][j] * k5) * (sw[k6][j] + adg[k6][j] * k5));
            }
	  }
	  a2 = agetP[i][j] - (int)agetP[i][j];
	  newL[i][j][k][i2] += a2;
	  negL[i][j][k][i2] += a2 * (c2[k6] + c3[k6] * (sw[k6][j] + adg[k6][j] * 
	    (k5 + a2)));
	  nemL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] * (k5 + a2),0.75)
	    * (1 + 0.0091 * (20 - tp[i2])) + ktL[techfatL[i2]] * 
	    (sw[k6][j] + adg[k6][j] * (k5 + a2)));
          if (feedcost == 1) {
	    pdimL[i][j][k][i2] += a2 * (pow(sw[k6][j] + adg[k6][j] *
	      (k5 + a2),0.75));  
	    pdigL[i][j][k][i2] += a2 * (c4[k6] - c5[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] + adg[k6][j] 
	      * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2)));
	    pdiwL[i][j][k][i2] += a2 * (11.54 + adg[k6][j] * 0.3846 * (c4[k6] - c5[k6] 
	      * (sw[k6][j] + adg[k6][j] * (k5 + a2)) + c6[k6] * (sw[k6][j] 
	      + adg[k6][j] * (k5 + a2)) * (sw[k6][j] + adg[k6][j] * (k5 + a2))));
          }
	  for (i2 = 1; i2 <= nfs; i2++) {
            watL[i][j][k][i2] = newL[i][j][k][i2] * dwatL[k][i2];	
	    newL[i][j][k][i2] *= 23.7 * dwoolptrL[2][j];
	    negL[i][j][k][i2] *= adg[k6][j];
	    nemL[i][j][k][i2] *= 0.277 * c1[k6]; 
            if (feedcost == 1) {
	      pdimL[i][j][k][i2] *= 2.1875; 
	      pdigL[i][j][k][i2] *= adg[k6][j]/0.59;
            }
	  }
        }	
      } 
    }
  }

  /* Categories 8 to 12, 33 to 37 and 43 to 47 */
  if (lf[1] + lf[2] + lf[0] > 0) {
    i3 = 8;
    if (lf[1] == 0) i3 = 33;
    if (lf[1] == 0 && lf[2] == 0) i3 = 43;
    if (lf[0] > 0) i1 = 42 + lf[0];
    if (lf[0] == 0 && lf[2] > 0) i1 = 32 + lf[2];
    if (lf[0] == 0 && lf[2] == 0) i1 = 7 + lf[1]; 
    for (i = i3; i <= i1; i++) {
      if (i < 13) j1 = 2;
      if (i == 8 + lf[1]) i = 33;
      if (i == 33) j1 = 22; 
      if (i == 33 + lf[2]) i = 43;
      if (i == 43) j1 = 27;
      k = i - j1;    
      for (j = 1; j <= crossing; j++) { 
        if (l1skL[i][j] > 0.000001) {
	  for (i2 = 1; i2 <= nfs; i2++) {
	    neL[i][j][k][i2] = negL[i][j][k][i2] + nemL[i][j][k][i2] +
	      newL[i][j][k][i2] + nepL[i][j][k][i2] + nefL[i][j][k][i2];
	    if (feedcost == 1) 
	      pdiL[i][j][k][i2] = pdigL[i][j][k][i2] + pdimL[i][j][k][i2] +
		pdiwL[i][j][k][i2] + pdipL[i][j][k][i2] + pdifL[i][j][k][i2];
	    if (neL[i][j][k][i2] > 0)
	      feL[i][j][k][i2] = neL[i][j][k][i2] / (nedL[k][i2] * drymL[k][i2]);
            if (feedcost == 1) {
	      if (pdiL[i][j][k][i2] > 0)
		fpdiL[i][j][k][i2] = pdiL[i][j][k][i2] / (pdidL[k][i2] * drymL[k][i2]);
	      ffL[i][j][k][i2] = maxi(feL[i][j][k][i2], fpdiL[i][j][k][i2]) 
		/ (1 - lossfL[k][i2]/100);
            }
	    if (feedcost == 2) ffL[i][j][k][i2] = feL[i][j][k][i2]   
	      / (1 - lossfL[k][i2]/100);
	    costfL[i][j] += ffL[i][j][k][i2] * prfL[k][i2];  
	    costwatL[i][j] += watL[i][j][k][i2] * prwat;  
	    }
          }	  
	}
      }
    }

  /* Categories 3, 28 and 48 */
  if (lf[1] > 0) {
    for (j = 1; j <= crossing; j++) {
      if (l1skL[3][j] > 0) {
	costfL[3][j] = costwatL[3][j] = 0;
	for (i = 1; i <= lf[1]; i++) { 
	  costfL[3][j] += costfL[i+7][j] * ndiedfat[1][i][j]; 
	  costwatL[3][j] += costwatL[i+7][j] * ndiedfat[1][i][j]; 
	  }
	costfL[3][j] /= (2 * l1skL[3][j]);    
	costwatL[3][j] /= (2 * l1skL[3][j]);  
        }
      }    
    }
  if (lf[2] > 0) {
    for (j = 1; j <= crossing; j++) {
      if (l1skL[28][j] > 0) {
	costfL[28][j] = costwatL[28][j] = 0;
	for (i = 1; i <= lf[2]; i++) {
	  costfL[28][j] += costfL[i+32][j] * ndiedfat[2][i][j]; 
	  costwatL[28][j] += costwatL[i+32][j] * ndiedfat[2][i][j]; 
	  }
	costfL[28][j] /= (2 * l1skL[28][j]);
	costwatL[28][j] /= (2 * l1skL[28][j]);  
        }
      }    
    }
  if (lf[0] > 0) {
    for (j = 1; j <= crossing; j++) {
      if (l1skL[48][j] > 0) {
	costfL[48][j] = costwatL[48][j] = 0;
	for (i = 1; i <= lf[0]; i++) {
	  costfL[48][j] += costfL[i+42][j] * ndiedfat[0][i][j]; 
	  costwatL[48][j] += costwatL[i+42][j] * ndiedfat[0][i][j]; 
	  }
	costfL[48][j] /= (2 * l1skL[48][j]);  
	costwatL[48][j] /= (2 * l1skL[48][j]);  
        }
      }    
    }
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (nepbL[j1][i][j][k][i2] < -0.00001 || nepbL[j1][i][j][k][i2] <
	      -0.00001) {
	      nonsense29(breed,2);
	      errmess = 1;
	      goto END;
	    }
	  }   
        }
      }
    } 
  /* Discounting of nutrition costs for lambs */
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= PP; i++) {
      costfL[i][j] *= qaveL[i][j];
      costwatL[i][j] *= qaveL[i][j];  
    }  
  }
 
/* Non-feed costs */
  if (trait == 0) printf("Calculating non-feed costs\n");
  for (i = 1; i <= TE; i++) revmanE[i] = 0; 
  /* Non-feed costs for ewes */
  avlifeyE = 0;
  for (i = 1; i <= LL; i++) {
    for (j = 1; j <= nstg1E; j++) {
      k = (i - 1) * nstgE + j;
      avlifeyE += l1E[k] * (dcE[k] + (i - 1) * lengthrc);
    }
  }
  avlifeyE = avlifeyE / (365 * l4E[1]);
  j = 0;
  for (i = 1; i <= TE; i++) {
    if (i <= nstgE) a2 = (wlE[1] + mwE[1])/2;
      else a2 = mwE[1];
    costvetE[i] = (nendopE * a2 * prendop + nectopE * prectop + vetE) * qaveE[i]
      * dcE[i] / lengthrc; 
    costlabE[i] = qaveE[i] * costAkh * AkhE * dcE[i] / 365;
    costsheE[i] = qaveE[i] * nsheE * costshe0E * dcE[i] / lengthrc;
    costfixE[i] = qaveE[i] * costfix0E * lengthrc;
    costbedE[i] = 0;
    k1 = datlamb;
    k2 = datlamb + (int)dcE[i] - 1;
    a4 = dcE[i] - (int)dcE[i];
    for (k3 = k1; k3 <= k2; k3++) {
      if (k3 < datchfs[1]) i2 = valfs[0];
      for (k4 = 1; k4 < nchfst; k4++)
        if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
      if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
      if (techE[i2] == 1) costbedE[i]++;
      }
    costbedE[i] += a4;
    revmanE[i] = qaveE[i] * costbedE[i] * prman * manE;
    costbedE[i] *= qaveE[i] * prstraw * strawE;
    if (fmod(i-1,5) < 0.00001) j++;
    if (j < LL) {
      costbreedE[i] = pinsE[1] * (1 - pcrossE[j]) * (costins[1] + nreins *
	costreins[1]) / 100 + costoeinE;
      if (crossing == 2) costbreedE[i] += pinsE[2] * pcrossE[j] * (costins[2] +
	nreins * costreins[2]) / 100;
      costbreedE[i] *= qbreedE[i];  
    }
  }        
  for (j = 1; j <= LL; j++) { 
    costskE[(j-1)*nstgE+2] = qendE[(j-1)*nstgE+2] * costtan * pskE * ptskE;
    costskE[(j-1)*nstgE+3] = qendE[(j-1)*nstgE+3] * costtan * pskE * ptskE;
    costmarkE[(j-1)*nstgE+2] = qendE[(j-1)*nstgE+2] * costmarkcul; 
    costmarkE[(j-1)*nstgE+3] = qendE[(j-1)*nstgE+3] * costmarkcul; 
    costdiedE[(j-1)*nstgE+1] = qendE[(j-1)*nstgE+1] * costdead * wlE[j];
    if (typeb == 1) {
      if (pmilkwm < 0.000001) a2 = 0;
        else a2 = milksw[j];
      for (i2 = 1; i2 <= nstgE; i2++) {
        if (j == LL && i2 == 4) break;
	costmilkE[(j-1)*nstgE+i2] = costmilk0E * (milkmpar[j] + a2) 
	  * plambE[(j-1)*nstgE+i2];
	costcheeseE[(j-1)*nstgE+i2] = costcheese0E * (milkmpar[j] + a2)
	  * plambE[(j-1)*nstgE+i2] * pmilkch; 
	if (i2 < 3) {
	  costmilkE[(j-1)*nstgE+i2] *= kmilkcE;  
	  costcheeseE[(j-1)*nstgE+i2] *= kmilkcE;  
	  }
	costmilkE[(j-1)*nstgE+i2] *= qmilkE[(j-1)*nstgE+i2];  
	costcheeseE[(j-1)*nstgE+i2] *= qmilkE[(j-1)*nstgE+i2];  
        }
      }
    }
  for (i = 1; i <= TE; i++) {
    costnfE[i] = costvetE[i] + costlabE[i] + costfixE[i] + costsheE[i]
      + costbedE[i] + costbreedE[i] + costskE[i] + costmarkE[i] + costdiedE[i]
      + costmilkE[i] + costcheeseE[i];
    costE[i] = costfE[i] + costnfE[i] + costwatE[i];
    }  

  /* Non-feed costs for rams */
  for (k = 1; k <= RR; k++) {
    for (j = 1; j <= crossing; j++) {
      costskR[(k-1)*nstgR+3][j] = qendR[(k-1)*nstgR+3][j] * costtan * pskR 
        * ptskR; 
      costmarkR[(k-1)*nstgR+2][j] = qendR[(k-1)*nstgR+2][j] * costmarkbR;
      costmarkR[(k-1)*nstgR+3][j] = qendR[(k-1)*nstgR+3][j] * costmarkcul;
      costdiedR[(k-1)*nstgR+1][j] = qendR[(k-1)*nstgR+1][j] * costdead *
        wbR[k][j];
    }
  }    
  for (i = 1; i <= nstgR; i++) {
    costpurchR[i][1] = qpurchR * ppurchMP * prbR[1];
    costpurchR[i][2] = qpurchR * prbR[2];      
  }
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      if (i <= nstgR) a2 = (wbR[1][j] + mwR[j])/2;
	else a2 = mwR[j];
      costvetR[i][j] = qaveR[i][j] * (nendopR * a2 * prendop + nectopR 
        * prectop + vetR) * dcR[i] / lengthrc; 
      costlabR[i][j] = qaveR[i][j] * costAkh * AkhR * dcR[i] / 365;
      costsheR[i][j] = qaveR[i][j] * nsheR[j] * costshe0R * dcR[i] / lengthrc;      	
      costfixR[i][j] = qaveR[i][j] * costfix0R * lengthrc;
      costbedR[i][j] = qaveR[i][j] * prstraw * strawR * dcR[i];
      costnfR[i][j] = costvetR[i][j] + costlabR[i][j] + costfixR[i][j]
        + costsheR[i][j] + costbedR[i][j] + costskR[i][j] + costmarkR[i][j] 
	+ costdiedR[i][j] + costpurchR[i][j];
      costR[i][j] = costfR[i][j] + costnfR[i][j] + costwatR[i][j];
    }
  }   
  /* Setting non-feed costs of non-existing ram categories to zero */
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      if (l1aR[i][j] < 0.000001) {
        costskR[i][j] = costmarkR[i][j] = costdiedR[i][j] = costpurchR[i][j] = 
	costvetR[i][j] = costlabR[i][j] = costsheR[i][j] = costfixR[i][j] = 
	costbedR[i][j] = costnfR[i][j] = costR[i][j] = 0;
      }
    }
  }  

    /* Non-feed costs for lambs */
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= PP; i++)
      costvetL[i][j] = costlabL[i][j] = costsheL[i][j] = 
      costfixL[i][j] = costbedL[i][j] = costbreedL[i][j] = costskL[i][j] = 
      costmarkL[i][j] = costdiedL[i][j] = costnfL[i][j] = revwL[i][j] = 
      revcL[i][j] = revskrL[i][j] = revsktL[i][j] = revmanL[i][j] = 0;
    if (typew == 1) a2 = agewL;
    if (typew == 2) a2 = agearL;
    for (i = 8; i <= 42+lf[0]; i++) {
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      if (l1skL[i][j] > 0.000001) {
	if (i < 13) {
	  i2 = 1;
	  i3 = i - 7;
	}
	if (i > 32 && i < 43) {
	  i2 = 2;
	  i3 = i - 32;
	}
	if (i > 42) { 
	  i2 = 0;
	  i3 = i - 42;
	}  
        if (typew == 1) {
	  k1 = datwL;
          a3 = avww[i2][j];   
	}
	if (typew == 2) {
	  k1 = datlamb + agearL;
          a3 = avwar[i2][j];	  
	}  
        a4 = agetP[i][j] - (int)agetP[i][j];
	k2 = datlamb + (int)agetP[i][j] - 1;
	costvetL[i][j] = nendopf[i2][i3] * prendop * (a3 + wP[i][j])/2 
	  + nectopf[i2][i3] * prectop + vetf[i2][i3];
	costsheL[i][j] = nshefL[i2][i3] * costshe0L;  
	revwL[i][j] = nshefL[i2][i3] * wshefL[i2][j] * prwoolL[j];
        costskL[i][j] = costtan * pskfL * ptskfL;
	costmarkL[i][j] = costmarkfL * wP[i][j]; 
        costlabL[i][j] = costAkh * AkhfL * dcL[i][j] / 365;
	costfixL[i][j] = costfixfL * dcL[i][j];
	for (k3 = k1; k3 <= k2; k3++) {
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  if (techfatL[i2] == 1) costbedL[i][j]++;
	}
	if (techfatL[i2] == 1) costbedL[i][j] += a4;
	revmanL[i][j] = costbedL[i][j] * prman * manfL;
	costbedL[i][j] *= prstraw * strawfL; 	
      }
    }
    if (l1skL[5][j] > 0.000001) {
      costvetL[5][j] = nendopwL * avww[1][j] * prendop + nectopwL * prectop 
        + vetwL;
      costsheL[5][j] = nshewL * costshe0L;
      revwL[5][j] = nshewL * wshewL[1][j] * prwoolL[j];
    }
    if (l1skL[6][j] > 0.000001) {
      costvetL[6][j] = nendoparL * avwar[1][j] * prendop + nectoparL * prectop 
	+ vetarL;
      costlabL[6][j] = costAkh * AkharL;
      costfixL[6][j] = costfixarL * dcL[6][j];
      costbedL[6][j] = prstraw * strawarL * dcL[6][j];
      costsheL[6][j] = nshearL * costshe0L;      
      revmanL[6][j] = prman * manarL * dcL[6][j];
      revwL[6][j] = nshewL * wshearL[1][j] * prwoolL[j];
    }
    if (l1skL[7][j] > 0.000001) {
      if (typew == 1) {
        costmarkL[7][j] = costmarkwL * avww[1][j];
        costskL[7][j] = costtan * pskwL * ptskwL;
	revskrL[7][j] = prskrL[j] * pskwL * (1 - ptskwL);
	revsktL[7][j] = prsktL[j] * pskwL * ptskwL;
      }	
      if (typew == 2) {
        costmarkL[7][j] = costmarkwL * avwar[1][j];
	costskL[7][j] = costtan * pskarL * ptskarL;
	revskrL[7][j] = prskrL[j] * pskarL * (1 - ptskarL);
	revsktL[7][j] = prsktL[j] * pskarL * ptskarL;
      }
    }
    if (l1skL[13][j] > 0.000001) {
      costsheL[13][j] = nsherL[1] * costshe0L * dcL[13][j] / (ager[1][1] - a2);
      costfixL[13][j] = costfixrL * (ager[1][1] - a2);
      costmarkL[13][j] = costmarkrL[1]; 
      revwL[13][j] = nsherL[1] * wsherL[1][j] * prwoolL[j] * dcL[13][j] 
        / (ager[1][1] - a2);    
    }  
    if (l1skL[14][j] > 0.000001) {
      costsheL[14][j] = nsherL[1] * costshe0L;
      costfixL[14][j] = costfixrL * dcL[14][j];
      costbreedL[14][j] = pmat[1][1][j] * (pinsFP[j] * (costins[j] + nreins *
        costreins[j]) / 100 + costoeinFP);
      revwL[14][j] = nsherL[1] * wsherL[1][j] * prwoolL[j];	
    } 
    if (l1skL[15][j] > 0.000001) {
      costvetL[15][j] = (nendoprL[2] * prendop * (wmat[1][j] + wrL[1][2][j]) / 2
          + nectoprL[2] * prectop + vetrL[2]) * dcL[15][j] / (ager[1][2] 
	  - ager[1][1]);  
      costsheL[15][j] = nsherL[2] * costshe0L * dcL[15][j] 
        / (ager[1][2] - ager[1][1]);
      costfixL[15][j] = costfixrL * (ager[1][2] - ager[1][1]);	
      costmarkL[15][j] = costmarkrL[1]; 
      revwL[15][j] = nsherL[1] * wsherL[1][j] * prwoolL[j] * dcL[15][j] 
        / (ager[1][2] - ager[1][1]);
    }  
    if (l1skL[17][j] > 0.000001) {
      costsheL[17][j] = nsherL[2] * costshe0L * dcL[17][j] 
        / (ager[1][2] - ager[1][1]);
      costfixL[17][j] = costfixrL * (ager[1][2] - ager[1][1]);		
      costskL[17][j] = costtan * pskrL * ptskrL;
      costmarkL[17][j] = costmarkcul;
      revwL[17][j] = nsherL[2] * wsherL[1][j] * prwoolL[j] * dcL[17][j] 
        / (ager[1][2] - ager[1][1]);
    }  
    if (l1skL[18][j] > 0.000001) {
      costsheL[18][j] = nsherL[2] * costshe0L;
      costfixL[18][j] = costfixrL * dcL[18][j];
      costbreedL[18][j] = pinsFP[j] * (costins[j] + nreins * costreins[j]) / 100
        + costoeinFP;
      revwL[18][j] = nsherL[2] * wsherL[1][j] * prwoolL[j];		
    }  
    if (l1skL[19][j] > 0.000001) {
      costvetL[19][j] = (nendoprL[2] * prendop * (wrL[1][2][j] + wrL[1][3][j]) / 2
	+ nectoprL[2] * prectop + vetrL[2]) * dcL[19][j] / (ager[1][3] 
	- ager[1][2]);
      costmarkL[19][j] = costmarkrL[1];
      revwL[19][j] = nsherL[3] * wsherL[1][j] * prwoolL[j] * dcL[19][j] 
        / (ager[1][3] - ager[1][2]);
    }      
    if (l1skL[21][j] > 0.000001) {
      costvetL[21][j] = (nendoprL[2] * prendop * (wrL[1][2][j] + wrL[1][3][j]) / 2
	+ nectoprL[2] * prectop + vetrL[2]) * dcL[21][j] / (ager[1][3] 
	- ager[1][2]);
      costskL[21][j] = costtan * pskrL * ptskrL; 
      costmarkL[21][j] = costmarkcul;   
      revwL[21][j] = nsherL[3] * wsherL[1][j] * prwoolL[j] * dcL[21][j] 
        / (ager[1][3] - ager[1][2]);
    }  
    if (l1skL[22][j] > 0.000001) {
      costvetL[22][j] = nendoprL[2] * prendop * (wrL[1][2][j] + wrL[1][3][j]) 
        / 2 + nectoprL[2] * prectop + vetrL[2];
      costsheL[22][j] = nsherL[3] * costshe0L;
      costfixL[22][j] = costfixrL * dcL[22][j];
      costbreedL[22][j] = pinsFP[j] * (costins[j] + nreins * costreins[j]) / 100
	+ costoeinFP;
      revwL[22][j] = nsherL[3] * wsherL[1][j] * prwoolL[j];		
    }  
    if (l1skL[23][j] > 0.000001) {
      costvetL[23][j] = (nendoprL[2] * prendop * (wP[23][j] + wrL[1][2][j]) / 2
	+ nectoprL[2] * prectop + vetrL[2]) * dcL[23][j] / (ager[1][3] 
	  - ager[1][2]);
      costmarkL[23][j] = costmarkrL[1];   
      revwL[23][j] = nsherL[3] * wsherL[1][j] * prwoolL[j] * dcL[23][j] 
        / (ager[1][3] - ager[1][2]);
    }  
    if (l1skL[25][j] > 0.000001) { 
      costvetL[25][j] = (nendoprL[2] * prendop * (wrL[1][2][j] + wrL[1][3][j]) / 2
	+ nectoprL[2] * prectop + vetrL[2]) * dcL[25][j] / (ager[1][3] 
	- ager[1][2]);	
      costskL[25][j] = costtan * pskrL * ptskrL;    
      costmarkL[25][j] = costmarkcul;    
      revwL[25][j] = nsherL[3] * wsherL[1][j] * prwoolL[j] * dcL[25][j] 
        / (ager[1][3] - ager[1][2]);
    }     	
    if (l1skL[26][j] > 0.000001) {
      costvetL[26][j] = (nendoprL[2] * prendop * (wnmat[1][j] + wP[26][j]) / 2
	+ nectoprL[2] * prectop + vetrL[2]) * dcL[26][j] / (ager[1][2] 
	- ager[1][1]);
      costsheL[26][j] = nsherL[2] * costshe0L * dcL[26][j] 
        / (ager[1][2] - ager[1][1]);
      costfixL[26][j] = costfixrL * dcL[26][j];	
      costmarkL[26][j] = costmarkrL[1];       
      revwL[26][j] = nsherL[2] * wsherL[1][j] * prwoolL[j] * dcL[26][j] 
        / (ager[1][2] - ager[1][1]);
    }
    if (l1skL[30][j] > 0.000001) {
      costvetL[30][j] = nendopwL * avww[2][j] * prendop + nectopwL * prectop 
        + vetwL;
      costsheL[30][j] = nshewL * costshe0L;
      revwL[30][j] = nshewL * wshewL[2][j] * prwoolL[j];
    }
    if (l1skL[31][j] > 0.000001) {
      costvetL[31][j] = nendoparL * avwar[2][j] * prendop + nectoparL * prectop 
	+ vetarL;          
      costlabL[31][j] = costAkh * AkharL;
      costfixL[31][j] = costfixarL * dcL[31][j];
      costbedL[31][j] = prstraw * strawarL * dcL[31][j];
      costsheL[31][j] = nshearL * costshe0L;      
      revmanL[31][j] = prman * manarL * dcL[31][j];
      revwL[31][j] = nshearL * wshearL[2][j] * prwoolL[j];
    }  
    if (l1skL[32][j] > 0.000001) {    
      if (typew == 1) {
        costmarkL[32][j] = costmarkwL * avww[2][j];
	costskL[32][j] = costtan * pskwL * ptskwL;
	revskrL[32][j] = prskrL[j] * pskwL * (1 - ptskwL);
	revsktL[32][j] = prsktL[j] * pskwL * ptskwL;
      }	
      if (typew == 2) {
        costmarkL[32][j] = costmarkwL * avwar[2][j];
        costskL[32][j] = costtan * pskarL * ptskarL;      	          	
	revskrL[32][j] = prskrL[j] * pskarL * (1 - ptskarL);
	revsktL[32][j] = prsktL[j] * pskarL * ptskarL;
      }	
    }
    if (l1skL[38][j] > 0.000001) {
      costsheL[38][j] = nsherL[1] * costshe0L * dcL[38][j] / (ager[2][1] - a2);
      costfixL[38][j] = costfixrL * (ager[2][1] - a2);  
      costmarkL[38][j] = costmarkrL[2];      
    }  
    if (l1skL[39][j] > 0.000001) {
      costsheL[39][j] = nsherL[1] * costshe0L;
      costfixL[39][j] = costfixrL * dcL[39][j];
      revwL[39][j] = nsherL[1] * wsherL[2][j] * prwoolL[j];	      
    }  
    if (l1skL[40][j] > 0.000001) {
      costsheL[40][j] = nsherL[2] * costshe0L * dcL[40][j] 
        / (ager[2][2] - ager[2][1]);
      costfixL[40][j] = costfixrL * (ager[2][2] - ager[2][1]);
      costmarkL[40][j] = costmarkrL[2];     
      revwL[40][j] = nsherL[2] * wsherL[2][j] * prwoolL[j] * dcL[40][j] 
        / (ager[2][2] - ager[2][1]);
    }  
    if (l1skL[41][j] > 0.000001) {
      costsheL[41][j] = nsherL[2] * costshe0L;
      costfixL[41][j] = costfixrL * dcL[41][j];
      revwL[41][j] = nsherL[2] * wsherL[2][j] * prwoolL[j];	            
    }  
    if (l1skL[42][j] > 0.000001) {
      costskL[42][j] = costtan * pskrL * ptskrL;    
      costmarkL[42][j] = costmarkcul;    
    }
    if (l1skL[48][j] > 0.000001) costdiedL[48][j] = costdead * wP[48][j];
    if (l1skL[2][j] > 0.000001) {
      costvetL[2][j] = ((costvetL[5][j] + costvetL[6][j]) * sexrbf
       + (costvetL[30][j] + costvetL[31][j]) * sexrbm) / 2;    
    }
    for (i2 = 1; i2 <= 2; i2++) {
      if (typew == 1) a3 = avww[i2][j];
      if (typew == 2) a3 = avwar[i2][j];
      i = 14 + (i2 - 1) * 25;
      if (l1skL[i][j] > 0.000001) costvetL[i][j] = nendoprL[1] * prendop 
        * (a3 + wrL[i2][1][j]) / 2 + nectoprL[1] * prectop + vetrL[1];
      i = 13 + (i2 - 1) * 25;
      if (l1skL[i][j] > 0.000001) costvetL[i][j] = (nendoprL[1] * prendop 
        * (a3 + wrL[i2][1][j]) / 2 + nectoprL[1] * prectop + vetrL[1]) 
	* dcL[i][j] / (ager[i2][1] - a2);
      i = 18 + (i2 - 1) * 23;
      if (l1skL[i][j] > 0.000001) costvetL[i][j] = nendoprL[2] * prendop 
        * (wnmat[i2][j] + wrL[i2][2][j]) / 2 + nectoprL[2] * prectop + vetrL[2];
      i = 17 + (i2 - 1) * 23;
      if (l1skL[i][j] > 0.000001) costvetL[i][j] = (nendoprL[2] * prendop 
        * (wnmat[i2][j] + wrL[i2][2][j]) / 2 + nectoprL[2] * prectop + vetrL[2]) 
	* dcL[i][j] / (ager[i2][2] - ager[i2][1]);
    }
    for (i2 = 1; i2 <= 3; i2++) {
      i = 16 + (i2 - 1) * 4;
      if (l1skL[i][j] > 0.000001) costvetL[i][j] = nendopclFP * prendop 
      * (wrL[1][i2][j] + wlFP[i2])/2 + nectopclFP * prectop + vetclFP;
    }
    for (i = 13; i <= 41; i++) {
      if (i == 27) i = 38;
      if (l1skL[i][j] > 0.000001) 
        costlabL[i][j] = costAkh * AkhrL * dcL[i][j] / 365;
    }
    for (i2 = 0; i2 <= 2; i2++) {
      i = 16 + i2 * 4;
      if (l1skL[i][j] > 0.000001) {
        costsheL[i][j] = nsheFP * costshe0L;
	costfixL[i][j] = costfixrL * ((i2 + 1) * lengthrc - ager[1][i2 + 1]);
	revwL[i][j] = nsheFP * wsherL[1][j] * prwoolL[j];
      }
    }
    for (i2 = 0; i2 <= 1; i2++) {
      i = 19 + i2 * 2;
      if (l1skL[i][j] > 0.000001) {
        costsheL[i][j] = nsherL[3] * costshe0L * dcL[i][j] 
	  / (ager[1][3] - ager[1][2]);
	costfixL[i][j] = costfixrL * (ager[1][3] - ager[1][2]);
      }	  
    }
    for (i2 = 0; i2 <= 1; i2++) {
      i = 23 + i2 * 2;
      if (l1skL[i][j] > 0.000001) {
        costsheL[i][j] = nsheFP * costshe0L * dcL[i][j] 
	  / (3.0 * lengthrc - ager[1][3]);
	costfixL[i][j] = costfixrL * (3 * lengthrc - ager[1][3]);
      }	  
    }
    for (i = 13; i <= 41; i++) {
      if (i == 27) i = 38;
      if (l1skL[i][j] > 0.000001) {
        a3 = a4 = 0;
        if (i == 13 || i == 14 || i == 38 || i == 39) {
	  if (typew == 1) k1 = datwL;
	  if (typew == 2) k1 = datlamb + agearL;
	}
	if (i >= 15 && i <= 18) {
	  k1 = datlamb + (int)(ager[1][1]);
	  a3 = ager[1][1] - (int)(ager[1][1]);
	}  
	if (i >= 19 && i <= 22) {
	  k1 = datlamb + (int)(ager[1][2]);
	  a3 = ager[1][2] - (int)(ager[1][2]);
	}  
	if (i >= 23 && i <= 25) {
	  k1 = datlamb + (int)(ager[1][3]);
	  a3 = ager[1][3] - (int)(ager[1][3]);
	}  
	if (i == 26) {
	  k1 = datlamb + (int)(ager[1][1]);
	  a3 = ager[1][1] - (int)(ager[1][1]);
	}  
	if (i == 13) {
	  k2 = datlamb + (int)(agetP[13][j]) - 1;
	  a4 = agetP[13][j] - (agetP[13][j]);
	}  
	if (i == 14) {
	  k2 = datlamb + (int)(ager[1][1]) - 1;
	  a4 = ager[1][1] - (int)(ager[1][1]);
	}  
	if (i == 15) {
	  k2 = datlamb - lpreg + lengthrc + (int)(dpregsFP) - 1;
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 16) k2 = datlamb + lengthrc - 1; 
	if (i == 17) {
	  k2 = datebs + (int)(dpregsFP) - 1;
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 18) k2 = datbbs + lengthrc - 1; 
	if (i == 19) {
	  k2 = datlamb + 2 * lengthrc + (int)(dpregsFP) - lpreg - 1;
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 20) k2 = datlamb + 2 * lengthrc - 1; 
	if (i == 21) {
	  k2 = datebs + (int)(dpregsFP) + lengthrc - 1;
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 22) k2 = datbbs + 2 * lengthrc - 1; 
	if (i == 23) {
	  k2 = datlamb + 3 * lengthrc + (int)(dpregsFP) - lpreg - 1;
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 24) k2 = datlamb + 3 * lengthrc - 1; 
	if (i == 25) {
	  k2 = datebs + 2 * lengthrc + (int)(dpregsFP) - 1;	
	  a4 = dpregsFP - (int)(dpregsFP);
	}  
	if (i == 26) {
	  k2 = datlamb + (int)(agetP[26][j]) - 1;
	  a4 = agetP[26][j] - (int)(agetP[26][j]);
	}  
	if (i == 40 || i == 41) k1 = datbbs;
	if (i == 38) {
	  k2 = datlamb + (int)(agetP[38][j]) - 1;
	  a4 = agetP[38][j] - (int)(agetP[38][j]);
	}  
	if (i == 39) k2 = datbbs - 1;
	if (i == 40) {
	  k2 = datlamb + (int)(agetP[40][j]) - 1;
	  a4 = agetP[40][j] - (int)(agetP[40][j]);
	}  
	if (i == 41) k2 = datbbs + lengthrc - 1;	
	for (k3 = k1; k3 <= k2; k3++) {
	  if (k3 < datchfs[1]) i2 = valfs[0];
	  for (k4 = 1; k4 < nchfst; k4++)
            if (k3 >= datchfs[k4] && k3 < datchfs[k4+1]) i2 = valfs[k4];
	  if (k3 >= datchfs[nchfst]) i2 = valfs[nchfst];
	  if (techbL[i2] == 1) costbedL[i][j]++;
	}
	costbedL[i][j] += a4 - a3;
	revmanL[i][j] = costbedL[i][j] * prman * manbL;
	costbedL[i][j] *= prstraw * strawrL; 
      }	
    }
    for (i = 2; i <= 4; i++)
      if (l1skL[i][j] > 0.000001) costdiedL[i][j] = costdead * wP[i][j];
    for (i = 28; i <= 29; i++)
      if (l1skL[i][j] > 0.000001) costdiedL[i][j] = costdead * wP[i][j];
  }
  /* Categories 3, 4, 28, 29, 42 and 48 */ 
  for (j = 1; j <= crossing; j++) {
    if (l1skL[3][j] > 0.000001) {
      for (i = 8; i <= 7 + lf[1]; i++) {
	costvetL[3][j] += costvetL[i][j] * ndiedfat[1][i-7][j]; 
	costlabL[3][j] += costlabL[i][j] * ndiedfat[1][i-7][j]; 
	costsheL[3][j] += costsheL[i][j] * ndiedfat[1][i-7][j]; 
	costfixL[3][j] += costfixL[i][j] * ndiedfat[1][i-7][j]; 
	costbedL[3][j] += costbedL[i][j] * ndiedfat[1][i-7][j]; 
	revwL[3][j] += revwL[i][j] * ndiedfat[1][i-7][j]; 
	revmanL[3][j] += revmanL[i][j] * ndiedfat[1][i-7][j]; 
      }
      costvetL[3][j] /= (2 * l1skL[3][j]);
      costlabL[3][j] /= (2 * l1skL[3][j]);
      costsheL[3][j] /= (2 * l1skL[3][j]);
      costfixL[3][j] /= l1skL[3][j];
      costbedL[3][j] /= (2 * l1skL[3][j]);
      revwL[3][j] /= (2 * l1skL[3][j]);
      revmanL[3][j] /= (2 * l1skL[3][j]);
    }
    if (l1skL[28][j] > 0.000001) {
      for (i = 33; i <= 32 + lf[2]; i++) {
	costvetL[28][j] += costvetL[i][j] * ndiedfat[2][i-32][j]; 
	costlabL[28][j] += costlabL[i][j] * ndiedfat[2][i-32][j]; 
	costsheL[28][j] += costsheL[i][j] * ndiedfat[2][i-32][j]; 
	costfixL[28][j] += costfixL[i][j] * ndiedfat[2][i-32][j]; 
	costbedL[28][j] += costbedL[i][j] * ndiedfat[2][i-32][j]; 
	revwL[28][j] += revwL[i][j] * ndiedfat[2][i-32][j]; 
	revmanL[28][j] += revmanL[i][j] * ndiedfat[2][i-32][j]; 
      }
      costvetL[28][j] /= (2 * l1skL[28][j]);	
      costlabL[28][j] /= (2 * l1skL[28][j]);
      costsheL[28][j] /= (2 * l1skL[28][j]);
      costfixL[28][j] /= l1skL[28][j];
      costbedL[28][j] /= (2 * l1skL[28][j]);
      revwL[28][j] /= (2 * l1skL[28][j]);
      revmanL[28][j] /= (2 * l1skL[28][j]);	
    }
    if (l1skL[48][j] > 0.000001) {
      for (i = 43; i <= 42 + lf[0]; i++) {
	costvetL[48][j] += costvetL[i][j] * ndiedfat[0][i-42][j]; 
	costlabL[48][j] += costlabL[i][j] * ndiedfat[0][i-42][j]; 
	costsheL[48][j] += costsheL[i][j] * ndiedfat[0][i-42][j]; 
	costfixL[48][j] += costfixL[i][j] * ndiedfat[0][i-42][j]; 	
	costbedL[48][j] += costbedL[i][j] * ndiedfat[0][i-42][j]; 
	revwL[48][j] += revwL[i][j] * ndiedfat[0][i-42][j]; 
        revmanL[48][j] += revmanL[i][j] * ndiedfat[0][i-42][j]; 		
      }
      costvetL[48][j] /= (2 * l1skL[48][j]);
      costlabL[48][j] /= (2 * l1skL[48][j]);
      costsheL[48][j] /= (2 * l1skL[48][j]);
      costfixL[48][j] /= l1skL[48][j];      
      costbedL[48][j] /= (2 * l1skL[48][j]);
      revwL[48][j] /= (2 * l1skL[48][j]);
      revmanL[48][j] /= (2 * l1skL[48][j]);
    }
    if (l1skL[4][j] > 0.000001) {
      costvetL[4][j] = (costvetL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + costvetL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costvetL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ costvetL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
      costlabL[4][j] = (costlabL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + costlabL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costlabL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ costlabL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
      costsheL[4][j] = (costsheL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + costsheL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costsheL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ costsheL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
      costfixL[4][j] = (costfixL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + costfixL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costfixL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ costfixL[20][j] * nrdiedmlFP[j]) / l1skL[4][j];
      costbedL[4][j] = (costbedL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + costbedL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ costbedL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ costbedL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
      revwL[4][j] = (revwL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + revwL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ revwL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ revwL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
      revmanL[4][j] = (revmanL[14][j] * (nrdied[1][1][j] + nspdied[1][1][j])
        + revmanL[18][j] * (nrdied[1][2][j] + nspdied[1][2][j])
	+ revmanL[22][j] * (nrdied[1][3][j] + nspdied[1][3][j])
	+ revmanL[20][j] * nrdiedmlFP[j]) / (2 * l1skL[4][j]);
    }
    if (l1skL[29][j] > 0.000001) {
      costvetL[29][j] = (costvetL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + costvetL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      costlabL[29][j] = (costlabL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + costlabL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      costsheL[29][j] = (costsheL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + costsheL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      costfixL[29][j] = (costfixL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + costfixL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ l1skL[29][j];
      costbedL[29][j] = (costbedL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + costbedL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      revwL[29][j] = (revwL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + revwL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
      revmanL[29][j] = (revmanL[39][j] * (nrdied[2][1][j] + nspdied[2][1][j])
        + revmanL[41][j] * (nrdied[2][2][j] + nspdied[2][2][j])) 
	/ (2 * l1skL[29][j]);
    }
    if (l1skL[42][j] > 0.000001) {
      costvetL[42][j] = (costvetL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + costvetL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      costlabL[42][j] = (costlabL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + costlabL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      costsheL[42][j] = (costsheL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + costsheL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      costfixL[42][j] = (costfixL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + costfixL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ l1skL[42][j];
      costbedL[42][j] = (costbedL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + costbedL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      revwL[42][j] = (revwL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + revwL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
      revmanL[42][j] = (revmanL[39][j] * (nrcull[2][1][j] + nspcull[2][1][j])
        + revmanL[41][j] * (nrcull[2][2][j] + nspcull[2][2][j])) 
	/ (2 * l1skL[42][j]);
    }
  }
  /* Total non-feed costs and total costs */
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i <= PP; i++) {
      if (l1skL[i][j] > 0.000001) { 
        costvetL[i][j] *= qaveL[i][j];
	costlabL[i][j] *= qaveL[i][j];
	costsheL[i][j] *= qaveL[i][j];
	costfixL[i][j] *= qaveL[i][j];
	costbedL[i][j] *= qaveL[i][j];
	costbreedL[i][j] *= qbreedL[i];
	costskL[i][j] *= qendL[i][j];
	costmarkL[i][j] *= qendL[i][j];
	costdiedL[i][j] *= qendL[i][j];
	revwL[i][j] *= qaveL[i][j];
        costnfL[i][j] = costvetL[i][j] + costlabL[i][j] + costsheL[i][j] 
	  + costfixL[i][j] + costbedL[i][j] + costbreedL[i][j] 
	  + costskL[i][j] + costmarkL[i][j] + costdiedL[i][j];  
	costL[i][j] = costfL[i][j] + costnfL[i][j] + costwatL[i][j];  
      }	  
    }	  
  }
  
/* Revenues */
  if (trait == 0) printf("Calculating revenues\n");
SCC: /* Somatic cell count, milk price */
  if (typeb == 1) {
    prmilk = prmilkb;  
    if (milkprice == 2 || milkprice > 3) {
      for (i = 0; i < nSCC-1; i++) Phiscc[i] = normdis((tSCS[i]-mSCS)/sigmaSCS);
      pSCC[0] = Phiscc[0];
      for (i = 1; i < nSCC-1; i++) pSCC[i] = Phiscc[i] - Phiscc[i-1];
      pSCC[nSCC-1] = 1 - Phiscc[nSCC - 2];
    }
    if (milkprice == 2 || milkprice == 4) {  
      prscc = 0;
      for (i = 0; i < nSCC; i++) prscc += pSCC[i]*prSCC[i];
      prmilk += prscc;
    }
    if (milkprice > 2) {    
      if (nfat > -1) {
	for (i = 0; i <= nfat; i++) {
	  if (i == 0) a2 = 0;
            else a2 = thfat[i-1];
	  if (i == nfat) a3 = 100;
            else a3 = thfat[i];
	  prmilkf[i] = linregm(fat,sigmafat,a2,a3,rf[0][i],rf[1][i],rf[2][i]);
	  prmilk += prmilkf[i];
	} 
      }
      if (nprot > -1) {
	for (i = 0; i <= nprot; i++) {
	  if (i == 0) a2=0;
            else a2 = thprot[i-1];
	  if (i == nprot) a3 = 100;
            else a3 = thprot[i];
	  prmilkp[i]=linregm(prot,sigmaprot,a2,a3,rp[0][i],rp[1][i],rp[2][i]);
	  prmilk += prmilkp[i];		  
	} 
      }
    }
    if (milkprice == 5) {  
      prmilkfp = prmilk;
      prmilk = 0;
      for (i = 0; i < nSCC; i++) 
	prmilk += pSCC[i]*(prmilkfp*facSCC[i] + prSCC[i]);
    }
  }
  /* Revenues from adult sheep */
  if (priceS > 1) {
    for (j = 1; j <= crossing; j++) {
      if (priceS == 2) { 
	prlwS[j] = 0;
	for (i = 1; i <= nclS; i++)
	  prlwS[j] += pclS[j][i] * prclS[i];
      } 
      if (priceS == 4) {
	prcwS[j] = 0;
	for (i = 1; i <= nclflS; i++) {
	  for (k = 1; k <= nclfcS; k++)
            prcwS[j] += pclfcS[j][i][k] * prclfcS[i][k];
	}
	prcwS[j] *= prrefS;
      } 
    }  
  } 
  
  /* Revenues from ewes */
  for (i = 1; i <= TE; i++) revwE[i] = revcE[i] = revskrE[i] =
    revsktE[i] = revmilkE[i] = revcheeseE[i] = 0;
  for (i = 1; i <= TE; i++) 
    revwE[i] = qaveE[i] * nsheE * wsheE * prwoolE * dcE[i] / lengthrc;
  for (j = 1; j <= LL; j++) {
    for (k = 2; k <= 3; k++) {
      i = (j - 1) * nstgE + k;
      revskrE[i] = qendE[i] * prskrE * pskE * (1 - ptskE);
      revsktE[i] = qendE[i] * prsktE * pskE * ptskE;
      if (j > 1) revcE[i] = wlE[j];
        else revcE[i] = wlE[j] + adgE * dcE[i]; 
      if (priceS == 1 || priceS == 2) revcE[i] *= prlwS[1];
      if (priceS == 3 || priceS == 4) revcE[i] *= prcwS[1] * dresE / 100;
      revcE[i] *= qendE[i];	 
    }
  }
  if (typeb == 1) {
    for (j = 1; j <= LL; j++) {
      if (pmilkwm < 0.000001) a2 = 0;
        else a2 = milksw[j];
      for (i1 = 1; i1 <= nstgE; i1++) {
        if (j == LL && i1 == 4) break;      
        i = (j - 1) * nstgE + i1;
	revmilkE[i] = prmilk * plambE[i] * (milkmpar[j] + a2) * (1 - pmilkch);
        if (pmilkch > 0.00001 && milkch > 0.00001)
	  revcheeseE[i] = (prcheese + prwhey * cheesewhey) * plambE[i] * 
	    (milkmpar[j] + a2) * pmilkch / milkch;
	if (i1 < 3) {
	  revmilkE[i] *= kmilkcE;  
	  if (pmilkch > 0.00001 && milkch > 0.00001) revcheeseE[i] *= kmilkcE;  
	}  
        revmilkE[i] *= qmilkE[i];
	if (pmilkch > 0.00001 && milkch > 0.00001) revcheeseE[i] *= qmilkE[i]; 	
      }
    }  
  }
  for (i = 1; i <= TE; i++)
    revE[i] = revwE[i] + revcE[i] + revskrE[i] + revsktE[i] + revmanE[i] +
      revmilkE[i] + revcheeseE[i];

  /* Revenues from rams */
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      revcR[i][j] = revskrR[i][j] = revsktR[i][j] = revsoldR[i][j] = 0;
      revwR[i][j] = qaveR[i][j] * nsheR[j] * wsheR[j] * prwoolR[j] * dcR[i] 
        / lengthrc;
      revmanR[i][j] = qaveR[i][j] * prman * manR * dcR[i];
    }      
  }
  for (j = 1; j <= crossing; j++) {
    for (k = 1; k <= RR; k++) {
      i = (k - 1) * nstgR + 3;
      revskrR[i][j] = qendR[i][j] * prskrR[j] * pskR * (1 - ptskR);
      revsktR[i][j] = qendR[i][j] * prsktR[j] * pskR * ptskR; 
      if (k > 1) revcR[i][j] = wbR[k][j];
        else revcR[i][j] = wbR[k][j] + adgR[j] * dcR[i]; 
      if (priceS == 1 || priceS == 2) revcR[i][j] *= prlwS[j];
      if (priceS == 3 || priceS == 4) revcR[i][j] *= prcwS[j] * dresR[j] / 100;
      revcR[i][j] *= qendR[i][j];
      i--;
      revsoldR[i][j] = qendR[i][j] * prsbR[j];	 
    }
  }
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) 
      revR[i][j] = revwR[i][j] + revcR[i][j] + revskrR[i][j] + revsktR[i][j]
        + revmanR[i][j] + revsoldR[i][j];
  }
  /* Setting revenues from non-existing ram categories to zero */
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      if (l1aR[i][j] < 0.000001) {
        revcR[i][j] = revskrR[i][j] = revsktR[i][j] = revsoldR[i][j] = 
	revwR[i][j] = revmanR[i][j] = revR[i][j] = 0;
      }
    }
  }  

  /* Revenues from lambs */
  for (j = 1; j <= crossing; j++) {
    for (i = 17; i <= 42; i++) {
      if (i == 18) i = 21;
      if (i == 22) i = 25;
      if (i == 26) i = 42;
      if (l1skL[i][j] > 0.000001) {
        revcL[i][j] = wP[i][j];
        if (priceS == 1 || priceS == 2) revcL[i][j] *= prlwS[j];
        if (priceS == 3 || priceS == 4) revcL[i][j] *= prcwS[j] * dresrL[j] 
	  / 100;
	if (priceS == 0) revcL[i][j] = 0;  
      }	  
    }
  }
  for (j = 1; j <= crossing; j++) {
    if (pricewL == 2) { 
      prlwwL[j] = 0;
      for (i = 1; i <= nclwL; i++)
	prlwwL[j] += pclwL[j][i] * prclwL[i];
    }  
    if (pricewL == 4) {
      for (i = 1; i <= 2; i++) {
        if (i == 1) i2 = 7;
	if (i == 2) i2 = 32;
	k7 = nclcwwL + 1;
	if (l1skL[i2][j] > 0.000001) {
	  mcwwL[i][j] = wP[i2][j] * dreswL[j] / 100;
	  sigmacwwL[i][j] = vcwwL * mcwwL[i][j] / 100;
	  for (k = 1; k < k7; k++) {
	    if (k == 1) a2 = 7;
	    if (k == 2) a2 = 10;
	    if (k == 3) a2 = 13;
	    PhicwL[k] = normdis((a2 - mcwwL[i][j])/sigmacwwL[i][j]);
	  } 	  
	  pclcwwL[i][1][j] = PhicwL[1];
	  pclcwwL[i][2][j] = PhicwL[2] - PhicwL[1];
	  pclcwwL[i][3][j] = PhicwL[3] - PhicwL[2];
	  pclcwwL[i][4][j] = 1 - PhicwL[3];
	}
      }
    }  
    if (pricewL == 4) 
      favwL[j] = l1skL[7][j] * pclcwwL[1][4][j] + l1skL[32][j] *
	pclcwwL[2][4][j];
    if (pricewL == 4 || pricefL == 4) {
      a2 = favwL[j] + favfL[j];
      if (a2 > 0) {
        favfL[j] /= a2;
        favwL[j] /= a2;
      }	
      avfleshL[j] = favfL[j] * avfleshfL[j] + favwL[j] * avfleshwL[j];  
      avfcL[j] = favfL[j] * avfcfL[j] + favwL[j] * avfcwL[j];
    } 
    if (pricewL == 4) {      
      for (i1 = 1; i1 < SP; i1++) {
        if (i1 == 1) i3 = 7;
	  else i3 = 32;
	if (l1skL[i3][j] > 0.000001) {  
          prcwawL[i1][j] = 0;
          for (i = 1; i <= nclcwwL; i++) {
	    for (i2 = 1; i2 <= nclcqwL; i2++) {
	      pclcwL[i1][i][i2][j] = pclcqwL[i][i2][j] * pclcwwL[i1][i][j] / 
	        (1 - pclcwwL[i1][4][j]);
              prcwawL[i1][j] += pclcwL[i1][i][i2][j] * prclcwwL[i][i2];
	    }  
	  }
	}  
      }
      if (l1skL[7][j] + l1skL[32][j] > 0.000001) {      
	avcqwL[j] = 0;
	for (i = 1; i <= nclcqwL; i++) {
          a2 = 0;
	  for (k = 1; k <= nclcwwL; k++) {
	    a2 += pclcqwL[k][i][j] * (pclcwwL[1][k][j] * l1skL[7][j] +
	      pclcwwL[2][k][j] * l1skL[32][j]);  
	  }    
	  avcqwL[j] += i * a2;
	}
	avcqwL[j] /= ((1 - pclcwwL[1][nclcwwL+1][j]) * l1skL[7][j] + 
	  (1 - pclcwwL[2][nclcwwL+1][j]) * l1skL[32][j]);
      }
    }  
    if (pricewL == 4) {
      prcwbwL[j] = 0;
      for (j1 = 1; j1 <= nclflwL; j1++) {
	for (k = 1; k <= nclfcwL; k++)
          prcwbwL[j] += pclfcwL[j][j1][k] * prclfcwL[j1][k];
      }
      prcwbwL[j] *= prrefwL;
    } 
    for (i = 7; i <= 32; i++) {
      if (i == 8) i = 32;
      if (l1skL[i][j] > 0.000001) {
        revcL[i][j] = wP[i][j];
	if (pricewL == 1 || pricewL == 2) revcL[i][j] *= prlwwL[j];
	if (pricewL == 3) revcL[i][j] *= prcwwL[j] * dreswL[j] / 100;
        if (i == 7) i2 = 1;
	if (i == 32) i2 = 2;
        if (pricewL == 4) {
	  prcwcwL[i2][j] = (1 - pclcwwL[i2][4][j]) * prcwawL[i2][j] 
	    + pclcwwL[i2][4][j] * prcwbwL[j]; 
          revcL[i][j] *= prcwcwL[i2][j] * dreswL[j] / 100;
	}  
	if (pricewL == 0) revcL[i][j] = 0;  
      }
    }
  }  
  if (fatpb + fatcb > 0) { 
      /* Lambs in fattening */
    for (j = 1; j <= crossing; j++) {
      if (pricefL == 2) { 
	prlwfL[j] = 0;
	for (i = 1; i <= nclfL; i++)
	  prlwfL[j] += pclfL[j][i] * prclfL[i];
      } 
      if (pricefL == 4) {
	prcwfL[j] = 0;
	for (j1 = 1; j1 <= nclflfL; j1++) {
	  for (k = 1; k <= nclfcfL; k++)
            prcwfL[j] += pclfcfL[j][j1][k] * prclfcfL[j1][k];
	}
	prcwfL[j] *= prreffL;
      } 
      for (i = 8; i <= 42 + lf[0]; i++) { 
	if (i == 8 + lf[1]) i = 33;
	if (i == 33 + lf[2] && lf[0] > 0) i = 43;
	if (i == 33 + lf[2] && lf[0] == 0) break;
	if (l1skL[i][j] > 0.000001) {
	  revcL[i][j] = wP[i][j];
	  if (pricefL == 1 || pricefL == 2) revcL[i][j] *= prlwfL[j];
	  if (i < 8 + lf[1]) {
            i1 = 1; 
	    i2 = i - 7;
	    }
	  if (i > 32 && i < 33 + lf[2]) {
            i1 = 2; 
	    i2 = i - 32;
	    }
	  if (i > 42) {
            i1 = 0; 
	    i2 = i - 42;
	    }
	  if (pricefL > 2) { 
            revcL[i][j] *= prcwfL[j] * dresfL[i1][i2][j] / 100;
	  if (pricefL == 0) revcL[i][j] = 0;    
	  }	
	}
      }
    }  
  }
  for (i = 8; i <= 42 + lf[0]; i++) {
    if (i == 8 + lf[1]) i = 17;
    if (i == 18) i = 21;
    if (i == 22) i = 25;
    if (i == 26) i = 33;
    if (i == 33 + lf[2]) i = 42;            
    if ((i > 7 && i < 8 + lf[1]) || (i > 32 && i < 33 + lf[2]) || 
      (i > 42 && i < 43 + lf[0])) {
      a2 = pskfL;
      a3 = ptskfL;
    }  
    else {
      a2 = pskrL;
      a3 = ptskrL;
    }
    for (j = 1; j <= crossing; j++) {
      if (l1skL[i][j] > 0.000001) {
	revskrL[i][j] = prskrL[j] * a2 * (1 - a3);
	revsktL[i][j] = prsktL[j] * a2 * a3;
      }
    }
  }
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      if (l1skL[i][j] > 0.000001) { 
        if (opsbL == 2 && (i == 13 || i == 15 || i == 19 || i == 23 || i == 26
	  || i == 38 || i == 40)) revsbL[i][j] = prsbL[i][j] * wP[i][j];
        revcL[i][j] *= qendL[i][j];    
	revskrL[i][j] *= qendL[i][j];
	revsktL[i][j] *= qendL[i][j];  
	revmanL[i][j] *= qaveL[i][j];  
	revL[i][j] = revwL[i][j] + revcL[i][j] + revskrL[i][j] + revsktL[i][j]
          + revmanL[i][j] + revsbL[i][j] * qendL[i][j];
    }	  
  }

/* Total subsidies, revenues, costs and profit per ewe per year */
  Tsub = Tcosts = Trev = TrevE = TcostsE = 0;
  for (j = 1; j <= crossing; j++) 
    Tsub += l1skL[38][j] + l1skL[40][j];
    Tsub *= subR * 365.0 / lengthrc;
    Tsub += subE;
  for (i = 1; i <= TE; i++) {
    TrevE += revE[i] * l1E[i];
    TcostsE += costE[i] * l1E[i]; 
  } 
  a2 = a3 = 0;
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {
    a2 += revL[i][j] * l1skL[i][j];
    a3 += costL[i][j] * l1skL[i][j]; 
    }
  } 
  Trev = TrevE + a2;
  Tcosts = TcostsE + a3;    
  TrevR = TcostsR = 0;
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
    TrevR += revR[i][j] * l1R[i] * neweR[j];
    TcostsR += costR[i][j] * l1R[i] * neweR[j]; 
    }
  } 

  costlamb = (TcostsE - TrevE + TcostsR - TrevR);
  if (typew == 1) costlamb /= NwL[0];
  if (typew == 2) costlamb /= NarL[0];
  if (costlamb < 0) costlamb = 0;
  costpurchFP = npurchFP * kdif;
  if (typew == 1) costpurchFP *= costL[5][1] + costlamb - revL[5][1];
  else costpurchFP *= costL[6][1] + costlamb - revL[6][1];
  Trev += TrevR;
  Tcosts += TcostsR + costpurchFP;
  Trev *= 365.0 / lengthrc;
  Tcosts *= 365.0 / lengthrc;
  Tprof = Trev + Tsub - Tcosts;
  profsub = 100 * Tprof/Tcosts;
  profnsub = 100 * (Trev - Tcosts)/Tcosts;

  /* Calculation of economic weights */
  if (trait == 0 && zr == 1) goto Printabc;
EW: if (trait == 0) {
    printf("Calculating economic weights (This will take some time)\n");
    for (i = 0; i < NT; i++) {
      for (j = 0; j <= 2; j++)
	ev[i][j] = ev0[i][j] = evp[i][j] = evdiff[i][j] = 0;
    }
    Tprofm = Tprof;
  }	 
  /* Trait: birth weight */
  if (trait == 0) trait = 1;
  if (ewopt == 1 && zr == 1) zr += 5;
  if (zr == 1) {
    tvm = bwL[1][1][1];
    bwL[1][1][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 2) {
    Tprofh = Tprof;
    bwL[1][1][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 3) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    bwL[1][1][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 4) {
    Tprofh = Tprof;
    bwL[1][1][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 5) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    bwL[1][1][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
    } 
  if (zr == 6 && ewopt == 0) zr = 11;  
  if (zr == 6) {
    Tprofm = Tprof;  
    tvm = bwL[1][1][2];
    bwL[1][1][2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 7) {
    Tprofh = Tprof;
    bwL[1][1][2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 8) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    bwL[1][1][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 9) {
    Tprofh = Tprof;
    bwL[1][1][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 10) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    bwL[1][1][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Daily gain from birth to weaning and weaning weight*/
  if (zr == 11) trait = 2;
  if (ewopt == 1 && zr == 11) zr += 5;  
  if (zr == 11) {
    Tprofm = Tprof;
    tvm = adgbwL[1][1][1];
    tv2m = wwL[1][1][1];
    adgbwL[1][1][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 12) {
    Tprofh = Tprof;
    tv2h = wwL[1][1][1];
    adgbwL[1][1][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 13) {
    Tprofl = Tprof;
    tv2l = wwL[1][1][1];
    ev0[trait+1][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgbwL[1][1][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 14) {
    Tprofh = Tprof;
    tv2h = wwL[1][1][1];
    adgbwL[1][1][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 15) {
    Tprofl = Tprof;
    tv2l = wwL[1][1][1];
    ev[trait+1][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    adgbwL[1][1][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 16 && ewopt == 0) zr = 21;
  if (zr == 16) {
    Tprofm = Tprof;
    tvm = adgbwL[1][1][2];
    tv2m = wwL[1][1][2];
    adgbwL[1][1][2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 17) {
    Tprofh = Tprof;
    tv2h = wwL[1][1][2];
    adgbwL[1][1][2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 18) {
    Tprofl = Tprof;
    tv2l = wwL[1][1][2];
    ev0[trait+1][2] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait][2] = (Tprofh - Tprofl)/(tv2h - tv2l);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgbwL[1][1][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 19) {
    Tprofh = Tprof;
    tv2h = wwL[1][1][2];
    adgbwL[1][1][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 20) {
    Tprofl = Tprof;
    tv2l = wwL[1][1][2];
    ev[trait+1][2] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait][2] = (Tprofh - Tprofl)/(tv2h - tv2l);
    adgbwL[1][1][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Weight at the end of artificial rearing and daily gain in artificial
     rearing */
  if (zr == 21 && typew == 1) zr = 31;
  if (zr == 21) trait = 4;
  if (ewopt == 1 && zr == 21) zr += 5;  
  if (zr == 21) {
    Tprofm = Tprof;
    tvm = adgwarL[1][1][1];
    tv2m = warL[1][1][1];
    adgwarL[1][1][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 22) {
    Tprofh = Tprof;
    tv2h = warL[1][1][1];
    adgwarL[1][1][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 23) {
    Tprofl = Tprof;
    tv2l = warL[1][1][1];
    ev0[trait+1][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgwarL[1][1][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 24) {
    Tprofh = Tprof;
    tv2h = warL[1][1][1];
    adgwarL[1][1][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 25) {
    Tprofl = Tprof;
    tv2l = warL[1][1][1];
    ev[trait+1][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    adgwarL[1][1][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 26 && ewopt == 0) zr = 31; 
  if (zr == 26) {
    Tprofm = Tprof;
    tvm = adgwarL[1][1][2];
    tv2m = warL[1][1][2];
    adgwarL[1][1][2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 27) {
    Tprofh = Tprof;
    tv2h = warL[1][1][2];
    adgwarL[1][1][2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 28) {
    Tprofl = Tprof;
    tv2l = warL[1][1][2];
    ev0[trait+1][2] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait][2] = (Tprofh - Tprofl)/(tv2h - tv2l);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgwarL[1][1][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 29) {
    Tprofh = Tprof;
    tv2h = warL[1][1][2];
    adgwarL[1][1][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 30) {
    Tprofl = Tprof;
    tv2l = warL[1][1][2];
    ev[trait+1][2] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait][2] = (Tprofh - Tprofl)/(tv2h - tv2l);
    adgwarL[1][1][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Average daily gain of breeding animals during rearing */
  if (zr == 31) trait = 6;
  if (ewopt == 1 && zr == 31) zr += 5;  
  if (zr == 31) {
    Tprofm = Tprof;
    tvm = adgr[1][1][1];
    adgr[1][1][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 32) {
    Tprofh = Tprof;
    adgr[1][1][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 33) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgr[1][1][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 34) {
    Tprofh = Tprof;
    adgr[1][1][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 35) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    adgr[1][1][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 36 && ewopt == 0) zr = 41;
  if (zr == 36 && ewopt > 0 && psp[1][2][2] + psp[2][2][2] < 0.000001) zr = 41;
  if (zr == 36) {
    Tprofm = Tprof;
    if (adgr[1][1][2] > 0.000001) {
      tvm = adgr[1][1][2];
      adgr[1][1][2] = tvh = 1.01*tvm;
    }
    else {
      tvm = adgr[2][1][2];
      adgr[2][1][2] = tvh = 1.01*tvm;
    }  
    zr++;	
    goto Start;
  }
  if (zr == 37) {
    Tprofh = Tprof;
    if (adgr[1][1][2] > 0.000001) adgr[1][1][2] = tvl = 0.99*tvm;    
    else adgr[2][1][2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 38) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    if (adgr[1][1][2] > 0.000001) adgr[1][1][2] = tvh;
    else adgr[2][1][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 39) {
    Tprofh = Tprof;
    if (adgr[1][1][2] > 0.000001) adgr[1][1][2] = tvl;
    else adgr[2][1][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 40) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    if (adgr[1][1][2] > 0.000001) adgr[1][1][2] = tvm;
    else adgr[2][1][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Average daily gain in fattening */
  if (zr == 41) trait = 7;
  if (zr == 41 && lf[0] + lf[1] + lf[2] == 0) zr = 51; 
  if (ewopt == 1 && zr == 41) zr += 5;    
  if (fatpb == 0 && ewopt == 2 && zr == 41) zr += 5;
  if (zr == 41) {
    Tprofm = Tprof;
    tvm = adgP[ipb][1];
    adgP[ipb][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 42) {
     Tprofh = Tprof;
     adgP[ipb][1] = tvl = 0.99*tvm;
     zr++;
     goto Start;
  }
  if (zr == 43) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgP[ipb][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 44) {
    Tprofh = Tprof;
    adgP[ipb][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 45) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    adgP[ipb][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 46 && ewopt == 0) zr = 51;
  if (fatcb == 0 && ewopt == 2 && zr == 46) zr = 51;
  if (zr == 46) {
    Tprofm = Tprof;
    tvm = adgP[icb][2];
    adgP[icb][2] = tvh = 1.01*tvm;	    
    zr++;	
    goto Start;
  }
  if (zr == 47) {
    Tprofh = Tprof;
    adgP[icb][2] = tvl = 0.99*tvm;	    
    zr++;
    goto Start;
  }
  if (zr == 48) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    adgP[icb][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 49) {
    Tprofh = Tprof;
    adgP[icb][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 50) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    adgP[icb][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  /* Trait: Mature weight */
  if (zr == 51) trait = 8;  
  if (ewopt == 1 && zr == 51) zr += 5;
  if (zr == 51) {
    Tprofm = Tprof;
    tvm = mwE[1];
    mwE[1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 52) {
    Tprofh = Tprof;
    mwE[1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 53) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    mwE[1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 54) {
    Tprofh = Tprof;
    mwE[1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 55) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    mwE[1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 56 && ewopt == 0) zr = 61;    
  if (zr == 56) {
    Tprofm = Tprof;
    tvm = mwE2;
    mwE2 = tvh = 1.01*tvm;	    
    zr++;	
    goto Start;
  }
  if (zr == 57) {
    Tprofh = Tprof;
    mwE2 = tvl = 0.99*tvm;	    
    zr++;
    goto Start;
  }
  if (zr == 58) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    mwE2 = tvh;
    zr++;
    goto Start;
  }
  if (zr == 59) {
    Tprofh = Tprof;
    mwE2 = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 60) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    mwE2 = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Dressing percentage of lambs at weaning */
  if (zr == 61) trait = 9;  
  if (pricewL < 3 && zr == 61) zr = 71;
  if (ewopt == 1 && zr == 61) zr += 5;
  if (zr == 61) {
    Tprofm = Tprof;
    tvm = dreswL[1];
    dreswL[1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 62) {
    Tprofh = Tprof;
    dreswL[1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 63) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dreswL[1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 64) {
    Tprofh = Tprof;
    dreswL[1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 65) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    dreswL[1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 66 && ewopt == 0) zr = 71;    
  if (zr == 66) {
    Tprofm = Tprof;
    tvm = dreswL[2];
    dreswL[2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 67) {
    Tprofh = Tprof;
    dreswL[2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 68) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dreswL[2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 69) {
    Tprofh = Tprof;
    dreswL[2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 70) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    dreswL[2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Dressing percentage of fattened lambs */
  if (zr == 71) trait = 10;
  if (zr == 71 && lf[0] + lf[1] + lf[2] == 0) zr = 81; 
  if (pricefL < 3 && zr == 71) zr = 81;  
  if (ewopt == 1 && zr == 71) zr += 5;    
  if (fatpb == 0 && ewopt == 2 && zr == 71) zr += 5;
  if (zr == 71) {
    Tprofm = Tprof;
    tvm = dresfL[ispb][ilpb][1];
    dresfL[ispb][ilpb][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 72) {
    Tprofh = Tprof;
    dresfL[ispb][ilpb][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 73) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dresfL[ispb][ilpb][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 74) {
    Tprofh = Tprof;
    dresfL[ispb][ilpb][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 75) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    dresfL[ispb][ilpb][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 76 && ewopt == 0) zr = 81;
  if (fatcb == 0 && ewopt == 2 && zr == 76) zr = 81;
  if (zr == 76) {
    Tprofm = Tprof;
    tvm = dresfL[iscb][ilcb][2];
    dresfL[iscb][ilcb][2] = tvh = 1.01*tvm;	    
    zr++;	
    goto Start;
  }
  if (zr == 77) {
    Tprofh = Tprof;
    dresfL[iscb][ilcb][2] = tvl = 0.99*tvm;	    
    zr++;
    goto Start;
  }
  if (zr == 78) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dresfL[iscb][ilcb][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 79) {
    Tprofh = Tprof;
    dresfL[iscb][ilcb][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 80) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    dresfL[iscb][ilcb][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
   /* Trait: Dressing percentage of adult sheep */
  if (zr == 81) trait = 11;  
  if (priceS < 3 && zr == 81) zr = 91;
  if (ewopt == 1 && zr == 81) zr += 5;
  if (zr == 81) {
    Tprofm = Tprof;
    tvm = dresE;
    dresE = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 82) {
    Tprofh = Tprof;
    dresE = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 83) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dresE = tvh;
    zr++;
    goto Start;
  }
  if (zr == 84) {
    Tprofh = Tprof;
    dresE = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 85) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    dresE = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 86 && ewopt == 0) zr = 91;    
  if (zr == 86) {
    Tprofm = Tprof;
    tvm = dresR[2];
    dresR[2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 87) {
    Tprofh = Tprof;
    dresR[2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 88) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    dresR[2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 89) {
    Tprofh = Tprof;
    dresR[2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 90) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    dresR[2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Average quality class for lambs sold at weaning or at the end of
     artificial rearing and are paid for live weight */
  if (zr == 91) trait = 12;
  if (pricewL != 2 && zr == 91) zr = 101;  
  if (ewopt == 1 && zr == 91) zr += 5;    
  if (zr == 91) {
    Tprofm = Tprof;
    tvm = avclwL[1];
    /* Saving the original values of vector pclwL[1][i] */
    for (i = 1; i <= nclwL; i++) {
      pcl0[i] = pclwL[1][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclwL; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclwL[1][i] */
    pclwL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[1][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 92) {
    Tprofh = Tprof;   
    tvh = avclwL[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclwL[1][i] */     
    pclwL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[1][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 93) {
    Tprofl = Tprof;   
    tvl = avclwL[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclwL[1][i] */
    pclwL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[1][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 94) {
    Tprofh = Tprof;   
    tvh = avclwL[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclwL[1][i] */
    pclwL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[1][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 95) {
    Tprofl = Tprof;
    tvl = avclwL[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclwL[1][i] */
    for (i = 1; i <= nclwL; i++) pclwL[1][i] = pcl0[i];
    for (i = 1; i <= nclwL; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 96 && ewopt == 0) zr = 101;
  if (zr == 96) {
    Tprofm = Tprof;
    tvm = avclwL[2];
    /* Saving the original values of vector pclwL[2][i] */
    for (i = 1; i <= nclwL; i++) {
      pcl0[i] = pclwL[2][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclwL; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclwL[2][i] */
    pclwL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[2][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 97) {
    Tprofh = Tprof;   
    tvh = avclwL[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclwL[2][i] */     
    pclwL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[2][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 98) {
    Tprofl = Tprof;   
    tvl = avclwL[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclwL[2][i] */
    pclwL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[2][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 99) {
    Tprofh = Tprof;   
    tvh = avclwL[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclwL[2][i] */
    pclwL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclwL; i++)
      pclwL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclwL[2][nclwL] = 1 - normdis((double)pclwLql[nclwL-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 100) {
    Tprofl = Tprof;
    tvl = avclwL[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclwL[2][i] */
    for (i = 1; i <= nclwL; i++) pclwL[2][i] = pcl0[i];
    for (i = 1; i <= nclwL; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  /* Trait: Average quality class for fattened lambs paid for live weight */
  if (zr == 101) trait = 13;
  if (pricefL != 2 && zr == 101) zr = 111;  
  if (ewopt == 1 && zr == 101) zr += 5;    
  if (zr == 101) {
    Tprofm = Tprof;
    tvm = avclfL[1];
    /* Saving the original values of vector pclfL[1][i] */
    for (i = 1; i <= nclfL; i++) {
      pcl0[i] = pclfL[1][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclfL; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclfL[1][i] */
    pclfL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[1][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 102) {
    Tprofh = Tprof;   
    tvh = avclfL[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclfL[1][i] */     
    pclfL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[1][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 103) {
    Tprofl = Tprof;   
    tvl = avclfL[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclfL[1][i] */
    pclfL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[1][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 104) {
    Tprofh = Tprof;   
    tvh = avclfL[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclfL[1][i] */
    pclfL[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[1][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 105) {
    Tprofl = Tprof;
    tvl = avclfL[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclfL[1][i] */
    for (i = 1; i <= nclfL; i++) pclfL[1][i] = pcl0[i];
    for (i = 1; i <= nclfL; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 106 && ewopt == 0) zr = 111;
  if (zr == 106) {
    Tprofm = Tprof;
    tvm = avclfL[2];
    /* Saving the original values of vector pclfL[2][i] */
    for (i = 1; i <= nclfL; i++) {
      pcl0[i] = pclfL[2][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclfL; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclfL[2][i] */
    pclfL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[2][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 107) {
    Tprofh = Tprof;   
    tvh = avclfL[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclfL[2][i] */     
    pclfL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[2][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 108) {
    Tprofl = Tprof;   
    tvl = avclfL[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclfL[2][i] */
    pclfL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[2][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 109) {
    Tprofh = Tprof;   
    tvh = avclfL[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclfL[2][i] */
    pclfL[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclfL; i++)
      pclfL[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclfL[2][nclfL] = 1 - normdis((double)pclwLql[nclfL-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 110) {
    Tprofl = Tprof;
    tvl = avclfL[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclfL[2][i] */
    for (i = 1; i <= nclfL; i++) pclfL[2][i] = pcl0[i];
    for (i = 1; i <= nclfL; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  /* Trait: Average quality class for adult sheep paid for live weight */
  if (zr == 111) trait = 14;
  if (priceS != 2 && zr == 111) zr = 121;  
  if (ewopt == 1 && zr == 111) zr += 5;    
  if (zr == 111) {
    Tprofm = Tprof;
    tvm = avclS[1];
    /* Saving the original values of vector pclS[1][i] */
    for (i = 1; i <= nclS; i++) {
      pcl0[i] = pclS[1][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclS; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclS[1][i] */
    pclS[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[1][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 112) {
    Tprofh = Tprof;   
    tvh = avclS[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclS[1][i] */     
    pclS[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[1][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 113) {
    Tprofl = Tprof;   
    tvl = avclS[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclS[1][i] */
    pclS[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[1][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 114) {
    Tprofh = Tprof;   
    tvh = avclS[1];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclS[1][i] */
    pclS[1][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[1][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[1][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 115) {
    Tprofl = Tprof;
    tvl = avclS[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclS[1][i] */
    for (i = 1; i <= nclS; i++) pclS[1][i] = pcl0[i];
    for (i = 1; i <= nclS; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 116 && ewopt == 0) zr = 121;
  if (zr == 116) {
    Tprofm = Tprof;
    tvm = avclS[2];
    /* Saving the original values of vector pclS[2][i] */
    for (i = 1; i <= nclS; i++) {
      pcl0[i] = pclS[2][i];
      if (i == 1) pt[i] = pcl0[i];
      else pt[i] = pt[i-1] + pcl0[i];
      }
    /* Threshold values for classes */
    for (i = 1; i < nclS; i++) pclwLqm[i] = probit((double)pt[i]);   
    /* Shifting the distribution to the left */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
    /* New values of the vector pclS[2][i] */
    pclS[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[2][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 117) {
    Tprofh = Tprof;   
    tvh = avclS[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
    /* New values of the vector pclS[2][i] */     
    pclS[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[2][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 118) {
    Tprofl = Tprof;   
    tvl = avclS[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    /* Shifting the distribution to the left */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
    /* New values of the vector pclS[2][i] */
    pclS[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[2][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    goto Start; 
  }
  if (zr == 119) {
    Tprofh = Tprof;   
    tvh = avclS[2];     
    /* Shifting the distribution to the right */
    for (i = 1; i < nclS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
    /* New values of the vector pclS[2][i] */
    pclS[2][1] = normdis((double)pclwLql[1]);
    for (i = 2; i < nclS; i++)
      pclS[2][i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
    pclS[2][nclS] = 1 - normdis((double)pclwLql[nclS-1]);  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 120) {
    Tprofl = Tprof;
    tvl = avclS[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original values of vector pclS[2][i] */
    for (i = 1; i <= nclS; i++) pclS[2][i] = pcl0[i];
    for (i = 1; i <= nclS; i++) pcl0[i] = 0;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  /* Trait: Average class for fleshiness in adult sheep */
  if (zr == 121) trait = 15;
  if (priceS != 4 && zr == 121) zr = 131;  
  if (ewopt == 1 && zr == 121) zr += 5;    
  if (zr == 121) {
    Tprofm = Tprof;
    tvm = avfleshS[1];
    /* Saving the original values of matrix pclcfcS[1][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) pcl00[i][j] = pclfcS[1][i][j];
    }
    for (j = 1; j <= nclfcS; j++) {
      pf0[j] = 0;
      for (i = 1; i <= nclflS; i++) pf0[j] += pclfcS[1][i][j];
    }
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 122) {
    Tprofh = Tprof;   
    tvh = avfleshS[1];     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 123) {
    Tprofl = Tprof;   
    tvl = avfleshS[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 124) {
    Tprofh = Tprof;   
    tvh = avfleshS[1];     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 125) {
    Tprofl = Tprof;
    tvl = avfleshS[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcS[1][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) 
      pclfcS[1][i][j] = pcl00[i][j];
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 126 && ewopt == 0) zr = 131;
  if (zr == 126) {
    Tprofm = Tprof;
    tvm = avfleshS[2];
    /* Saving the original values of matrix pclfcS[2][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) pcl00[i][j] = pclfcS[2][i][j];
    }
    for (j = 1; j <= nclfcS; j++) {
      pf0[j] = 0;
      for (i = 1; i <= nclflS; i++) pf0[j] += pclfcS[2][i][j];
    }
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 127) {
    Tprofh = Tprof;   
    tvh = avfleshS[2];     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 128) {
    Tprofl = Tprof;   
    tvl = avfleshS[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 129) {
    Tprofh = Tprof;   
    tvh = avfleshS[2];     
    for (k = 1; k <= nclfcS; k++) {
      for (i = 1; i <= nclflS; i++)    
	if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclflS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclflS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclflS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclflS] = 1 - normdis((double)pclwLql[nclflS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][i][k] = pf[i] * pf0[k];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 130) {
    Tprofl = Tprof;
    tvl = avfleshS[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcS[2][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) { 
        pclfcS[2][i][j] = pcl00[i][j];
	pcl00[i][j] = 0;
      }	
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] = pf0[i] = pf[i] = pt[i] = 0;
      for (j = 1; j < N; j++) pcl00[i][j] = 0;
      }
    goto Start;
  } 
  /* Trait: Average class for fat covering in adult sheep */
  if (zr == 131) trait = 16;
  if (priceS != 4 && zr == 131) zr = 141;  
  if (ewopt == 1 && zr == 131) zr += 5;    
  if (zr == 131) {
    Tprofm = Tprof;
    tvm = avfcS[1];
    /* Saving the original values of matrix pclcfcS[1][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) pcl00[i][j] = pclfcS[1][i][j];
    }
    for (i = 1; i <= nclflS; i++) {
      pf0[i] = 0; 
      for (j = 1; j <= nclfcS; j++) pf0[i] += pclfcS[1][i][j];
    }
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 132) {
    Tprofh = Tprof;   
    tvh = avfcS[1];     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 133) {
    Tprofl = Tprof;   
    tvl = avfcS[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 134) {
    Tprofh = Tprof;   
    tvh = avfcS[1];     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[1][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[1][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 135) {
    Tprofl = Tprof;
    tvl = avfcS[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcS[1][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) 
      pclfcS[1][i][j] = pcl00[i][j];
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 136 && ewopt == 0) zr = 141;
  if (zr == 136) {
    Tprofm = Tprof;
    tvm = avfcS[2];
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) pcl00[i][j] = pclfcS[2][i][j];
    }
    for (i = 1; i <= nclflS; i++) {
      pf0[i] = 0; 
      for (j = 1; j <= nclfcS; j++) pf0[i] += pclfcS[2][i][j];
    }
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 137) {
    Tprofh = Tprof;   
    tvh = avfcS[2];     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 138) {
    Tprofl = Tprof;   
    tvl = avfcS[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 139) {
    Tprofh = Tprof;   
    tvh = avfcS[2];     
    for (k = 1; k <= nclflS; k++) {
      for (i = 1; i <= nclfcS; i++)    
	if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
      /* Threshold values for classes */
      for (i = 1; i < nclfcS; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclfcS; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclfcS; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclfcS] = 1 - normdis((double)pclwLql[nclfcS-1]);  
      /* New values of matrix pclfcS[2][i][j] */
      for (i = 1; i <= nclflS; i++)  
	pclfcS[2][k][i] = pf[i] * pf0[k];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 140) {
    Tprofl = Tprof;
    tvl = avfcS[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcS[2][i][j] */
    for (i = 1; i <= nclflS; i++) {
      for (j = 1; j <= nclfcS; j++) { 
        pclfcS[2][i][j] = pcl00[i][j];
	pcl00[i][j] = 0;
      }	
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) pclwLql[i] = pclwLqm[i] = pf0[i] = pf[i] = pt[i] = 0;    
    goto Start;
  } 
  /* Trait: Average class for fleshiness in fattened lambs */
  if (zr == 141) trait = 17;
  if (pricefL != 4 && (pricewL != 4 || typeb == 1) && zr == 141) zr = 151;  
  if (ewopt == 1 && zr == 141) zr += 5;    
  if (zr == 141) {
    Tprofm = Tprof;
    tvm = avfleshL[1];
    /* Saving the original values of matrix pclfcfL[1][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) pcl00[i][j] = pclfcfL[1][i][j];
      }
      for (j = 1; j <= nclfcfL; j++) {
	pf0[j] = 0;
	for (i = 1; i <= nclflfL; i++) pf0[j] += pclfcfL[1][i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) pcl11[i][j] = pclfcwL[1][i][j];
      }
      for (j = 1; j <= nclfcwL; j++) {
	pf1[j] = 0;
	for (i = 1; i <= nclflwL; i++) pf1[j] += pclfcwL[1][i][j];
      }
    }
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 142) {
    Tprofh = Tprof;   
    tvh = avfleshL[1];     
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 143) {
    Tprofl = Tprof;   
    tvl = avfleshL[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcfL[1][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 144) {
    Tprofh = Tprof;   
    tvh = avfleshL[1]; 
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 145) {
    Tprofl = Tprof;
    tvl = avfleshL[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcfL[1][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) 
	pclfcfL[1][i][j] = pcl00[i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) 
	pclfcwL[1][i][j] = pcl11[i][j];
      }
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] = pf0[i] = pf1[i] = pf[i] = pt[i] = 0;
      for (j = 1; j < N; j++) pcl00[i][j] = pcl11[i][j] = 0;
    }  
    goto Start;
  } 
  if (zr == 146 && ewopt == 0) zr = 151;
  if (zr == 146) {
    Tprofm = Tprof;
    tvm = avfleshL[2];
    /* Saving the original values of matrix pclfcfL[2][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) pcl00[i][j] = pclfcfL[2][i][j];
      }
      for (j = 1; j <= nclfcfL; j++) {
	pf0[j] = 0;
	for (i = 1; i <= nclflfL; i++) pf0[j] += pclfcfL[2][i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) pcl11[i][j] = pclfcwL[2][i][j];
      }
      for (j = 1; j <= nclfcwL; j++) {
	pf1[j] = 0;
	for (i = 1; i <= nclflwL; i++) pf1[j] += pclfcwL[2][i][j];
      }
    }
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 147) {
    Tprofh = Tprof;   
    tvh = avfleshL[2];  
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 148) {
    Tprofl = Tprof;   
    tvl = avfleshL[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][i][k] = pf[i] * pf0[k];
      }
    }           
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcfL[2][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 149) {
    Tprofh = Tprof;   
    tvh = avfleshL[2];     
    if (pricefL == 4) {
      for (k = 1; k <= nclfcfL; k++) {
	for (i = 1; i <= nclflfL; i++)    
	  if (i == 1) pt[i] = pcl00[i][k] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[i][k] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflfL] = 1 - normdis((double)pclwLql[nclflfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][i][k] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclfcwL; k++) {
	for (i = 1; i <= nclflwL; i++)    
	  if (i == 1) pt[i] = pcl11[i][k] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[i][k] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclflwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclflwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclflwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclflwL] = 1 - normdis((double)pclwLql[nclflwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][i][k] = pf[i] * pf1[k];
      }  
    }
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 150) {
    Tprofl = Tprof;
    tvl = avfleshL[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcfL[2][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) 
	pclfcfL[2][i][j] = pcl00[i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) 
	pclfcwL[2][i][j] = pcl11[i][j];
      }
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] =  pf0[i] = pf1[i] = pf[i] = pt[i] = 0;
      for (j = 1; j < N; j++) pcl00[i][j] = pcl11[i][j] = 0;
    }  
    goto Start;
  } 
  /* Trait: Average class for fat covering in fattened lambs */
  if (zr == 151) trait = 18;
   if (pricefL != 4 && (pricewL != 4 || typeb == 1) && zr == 151) zr = 161;  
  if (ewopt == 1 && zr == 151) zr += 5;    
  if (zr == 151) {
    Tprofm = Tprof;
    tvm = avfcL[1];
    /* Saving the original values of matrix pclfcfL[1][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) pcl00[i][j] = pclfcfL[1][i][j];
      }
      for (i = 1; i <= nclflfL; i++) {
	pf0[i] = 0; 
	for (j = 1; j <= nclfcfL; j++) pf0[i] += pclfcfL[1][i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) pcl11[i][j] = pclfcwL[1][i][j];
      }
      for (i = 1; i <= nclflwL; i++) {
	pf1[i] = 0; 
	for (j = 1; j <= nclfcwL; j++) pf1[i] += pclfcwL[1][i][j];
      }
    }
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][k][i] = pf[i] * pf1[k];
      }  
    } 
    zr++;
    goto Start; 
  }
  if (zr == 152) {
    Tprofh = Tprof;   
    tvh = avfcL[1];     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 153) {
    Tprofl = Tprof;   
    tvl = avfcL[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 154) {
    Tprofh = Tprof;   
    tvh = avfcL[1];     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[1][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[1][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[1][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[1][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 155) {
    Tprofl = Tprof;
    tvl = avfcL[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcfL[1][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) 
	pclfcfL[1][i][j] = pcl00[i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) 
	pclfcwL[1][i][j] = pcl11[i][j];
      }
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] = pf0[i] = pf1[i] = pf[i] = pt[i] = 0;
      for (j = 1; j < N; j++) pcl00[i][j] = pcl11[i][j] = 0;
    }     
    goto Start;
  } 
  if (zr == 156 && ewopt == 0) zr = 161;
  if (zr == 156) {
    Tprofm = Tprof;
    tvm = avfcL[2];
    /* Saving the original values of matrix pclfcfL[2][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) pcl00[i][j] = pclfcfL[2][i][j];
      }
      for (i = 1; i <= nclflfL; i++) {
	pf0[i] = 0; 
	for (j = 1; j <= nclfcfL; j++) pf0[i] += pclfcfL[2][i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) pcl11[i][j] = pclfcwL[2][i][j];
      }
      for (i = 1; i <= nclflwL; i++) {
	pf1[i] = 0; 
	for (j = 1; j <= nclfcwL; j++) pf1[i] += pclfcwL[2][i][j];
      }
    }
    if (pricefL == 4) {    
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {    
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 157) {
    Tprofh = Tprof;   
    tvh = avfcL[2];     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {  
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 158) {
    Tprofl = Tprof;   
    tvl = avfcL[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the left */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    goto Start; 
  }
  if (zr == 159) {
    Tprofh = Tprof;   
    tvh = avfcL[2];     
    if (pricefL == 4) {
      for (k = 1; k <= nclflfL; k++) {
	for (i = 1; i <= nclfcfL; i++)    
	  if (i == 1) pt[i] = pcl00[k][i] / pf0[k];
	  else pt[i] = pt[i-1] + pcl00[k][i] / pf0[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcfL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcfL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcfL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcfL] = 1 - normdis((double)pclwLql[nclfcfL-1]);  
	/* New values of matrix pclfcfL[2][i][j] */
	for (i = 1; i <= nclflfL; i++)  
	  pclfcfL[2][k][i] = pf[i] * pf0[k];
      }  
    }
    if (pricewL == 4) {
      for (k = 1; k <= nclflwL; k++) {
	for (i = 1; i <= nclfcwL; i++)    
	  if (i == 1) pt[i] = pcl11[k][i] / pf1[k];
	  else pt[i] = pt[i-1] + pcl11[k][i] / pf1[k];
	/* Threshold values for classes */
	for (i = 1; i < nclfcwL; i++) pclwLqm[i] = probit((double)pt[i]);   
	/* Shifting the distribution to the right */
	for (i = 1; i < nclfcwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
	/* New values of the vector pf[i] */
	pf[1] = normdis((double)pclwLql[1]);
	for (i = 2; i < nclfcwL; i++)
	  pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
	pf[nclfcwL] = 1 - normdis((double)pclwLql[nclfcwL-1]);  
	/* New values of matrix pclfcwL[2][i][j] */
	for (i = 1; i <= nclflwL; i++)  
	  pclfcwL[2][k][i] = pf[i] * pf1[k];
      }  
    }
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 160) {
    Tprofl = Tprof;
    tvl = avfcL[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcfL[2][i][j] */
    if (pricefL == 4) {
      for (i = 1; i <= nclflfL; i++) {
	for (j = 1; j <= nclfcfL; j++) pclfcfL[2][i][j] = pcl00[i][j];
      }
    }
    if (pricewL == 4) {
      for (i = 1; i <= nclflwL; i++) {
	for (j = 1; j <= nclfcwL; j++) pclfcwL[2][i][j] = pcl11[i][j];
      }
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] = pf0[i] = pf1[i] = pf[i] = pt[i] = 0;    
      for (j = 1; j < N; j++) pcl00[i][j] = pcl11[i][j] = 0; 
    }  
    goto Start;
  } 
  /* Trait: Average class for carcass quality of lambs slaughtered at weaning */
  if (zr == 161) trait = 19;
  if (pricewL != 4 && zr == 161) zr = 171;  
  if (ewopt == 1 && zr == 161) zr += 5; 
  if (zr == 161 && ewopt != 1 && l1skL[7][1] + l1skL[32][1] < 0.000001) zr += 5;   
  if (zr == 161) {
    Tprofm = Tprof;
    tvm = avcqwL[1];
    /* Saving the original values of matrix pclcqwL[i][j][1] */
    for (i = 1; i <= nclcwwL; i++) {
      for (j = 1; j <= nclcqwL; j++) pcl00[i][j] = pclcqwL[i][j][1];
    }
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][1] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][1] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 162) {
    Tprofh = Tprof;   
    tvh = avcqwL[1];
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][1] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][1] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 163) {
    Tprofl = Tprof;   
    tvl = avcqwL[1];     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][1] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][1] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 164) {
    Tprofh = Tprof;   
    tvh = avcqwL[1];     
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][1] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][1] = pf[i];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 165) {
    Tprofl = Tprof;
    tvl = avcqwL[1];     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclfcS[1][i][j] */
    for (i = 1; i <= nclcwwL; i++) {
      for (j = 1; j <= nclcqwL; j++) 
      pclcqwL[i][j][1] = pcl00[i][j];
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    goto Start;
  } 
  if (zr == 166 && ewopt == 0) zr = 171;
  if (zr == 166 && ewopt != 0 && l1skL[7][2] + l1skL[32][2] < 0.000001) zr = 171;
  if (zr == 166) {
    Tprofm = Tprof;
    tvm = avcqwL[2];
    /* Saving the original values of matrix pclcqwL[i][j][2] */
    for (i = 1; i <= nclcwwL; i++) {
      for (j = 1; j <= nclcqwL; j++) pcl00[i][j] = pclcqwL[i][j][2];
    }
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][2] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][2] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 167) {
    Tprofh = Tprof;   
    tvh = avcqwL[2];     
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][2] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][2] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 168) {
    Tprofl = Tprof;   
    tvl = avcqwL[2];     
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][2] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][2] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 169) {
    Tprofh = Tprof;   
    tvh = avcqwL[2];     
    for (k = 1; k <= nclcwwL; k++) {
      for (i = 1; i <= nclcqwL; i++)    
	if (i == 1) pt[i] = pcl00[k][i];
	else pt[i] = pt[i-1] + pcl00[k][i];
      /* Threshold values for classes */
      for (i = 1; i < nclcqwL; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < nclcqwL; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < nclcqwL; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[nclcqwL] = 1 - normdis((double)pclwLql[nclcqwL-1]);  
      /* New values of matrix pclcqwL[i][j][2] */
      for (i = 1; i <= nclcqwL; i++)  
	pclcqwL[k][i][2] = pf[i];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 170) {
    Tprofl = Tprof;
    tvl = avcqwL[2];     
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    /* Returning the original matrix pclcqwL[i][j][2] */
    for (i = 1; i <= nclcwwL; i++) {
      for (j = 1; j <= nclcqwL; j++) 
      pclcqwL[i][j][2] = pcl00[i][j];
    }
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) pclwLql[i] = pclwLqm[i] = pf0[i] = pf[i] = pt[i] = 0;
    goto Start;
  } 
  /* Trait: Conception rate of female lambs */
  if (zr == 171) trait = 20;
  if (ewopt == 1 && zr == 171) zr += 5;  
  if (zr == 171) {
    Tprofm = Tprof;
    tvm = conrateFP[1][1];
    conrateFP[1][1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 172) {
    Tprofh = Tprof;
    conrateFP[1][1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 173) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    conrateFP[1][1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 174) {
    Tprofh = Tprof;
    conrateFP[1][1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 175) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    conrateFP[1][1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 176 && ewopt == 0) zr = 181;
  if (zr == 176 && ewopt != 0 && psp[1][2][2] < 0.000001) zr = 181;
  if (zr == 176) {
    Tprofm = Tprof;
    tvm = conrateFP[1][2];
    conrateFP[1][2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 177) {
    Tprofh = Tprof;
    conrateFP[1][2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 178) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    conrateFP[1][2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 179) {
    Tprofh = Tprof;
    conrateFP[1][2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 180) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    conrateFP[1][2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Average conception rate of ewes */
  if (zr == 181) trait = 21;
  if (ewopt == 1 && zr == 181) zr += 5;  
  if (zr == 181) {
    Tprofm = Tprof;
    tvm = avconrateE;
    for (i = 1; i < LL; i++) {
      pcl0[i] = conrateE[i];
      conrateE[i] = 1.01 * pcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 182) {
    Tprofh = Tprof;
    tvh = avconrateE;
    for (i = 1; i < LL; i++) conrateE[i] = 0.99 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 183) {
    Tprofl = Tprof;
    tvl = avconrateE;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i < LL; i++) conrateE[i] = 1.005 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 184) {
    tvh = avconrateE;  
    Tprofh = Tprof;
    for (i = 1; i < LL; i++) conrateE[i] = 0.995 * pcl0[i];
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 185) {
    tvl = avconrateE;  
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i < LL; i++) {
      conrateE[i] = pcl0[i];    
      pcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Average litter size */
  if (zr == 186) trait = 22;
  if (ewopt == 1 && zr == 186) zr += 5; 
  if (zr == 186) {
    Tprofm = Tprof;
    tvm = avlitE;
    /* Saving the original values of matrix Pltype[i][j] */
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= LL; j++) pcl00[i][j] = Pltype[i][j];
    }
    for (k = 1; k <= LL; k++) {
      for (i = 1; i <= clt; i++)    
	if (i == 1) pt[i] = pcl00[i][k];
	else pt[i] = pt[i-1] + pcl00[i][k];
      /* Threshold values for classes */
      for (i = 1; i < clt; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < clt; i++) pclwLql[i] = pclwLqm[i] - 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < clt; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[clt] = 1 - normdis((double)pclwLql[clt-1]);  
      /* New values of matrix Pltype[i][j] */
      for (i = 1; i <= clt; i++)  
	Pltype[i][k] = pf[i];
    } 
    zr++;
    goto Start; 
  }
  if (zr == 187) {
    Tprofh = Tprof;   
    tvh = avlitE;
    for (k = 1; k <= LL; k++) {
      for (i = 1; i <= clt; i++)    
	if (i == 1) pt[i] = pcl00[i][k];
	else pt[i] = pt[i-1] + pcl00[i][k];
      /* Threshold values for classes */
      for (i = 1; i < clt; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < clt; i++) pclwLql[i] = pclwLqm[i] + 0.1;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < clt; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[clt] = 1 - normdis((double)pclwLql[clt-1]);  
      /* New values of matrix Pltype[i][j] */
      for (i = 1; i <= clt; i++)  
	Pltype[i][k] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 188) {
    Tprofl = Tprof;   
    tvl = avlitE;     
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);     
    for (k = 1; k <= LL; k++) {
      for (i = 1; i <= clt; i++)    
	if (i == 1) pt[i] = pcl00[i][k];
	else pt[i] = pt[i-1] + pcl00[i][k];
      /* Threshold values for classes */
      for (i = 1; i < clt; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the left */
      for (i = 1; i < clt; i++) pclwLql[i] = pclwLqm[i] - 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < clt; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[clt] = 1 - normdis((double)pclwLql[clt-1]);  
      /* New values of matrix Pltype[i][j] */
      for (i = 1; i <= clt; i++)  
	Pltype[i][k] = pf[i];
    }  
    zr++;
    goto Start; 
  }
  if (zr == 189) {
    Tprofh = Tprof;   
    tvh = avlitE;     
    for (k = 1; k <= LL; k++) {
      for (i = 1; i <= clt; i++)    
	if (i == 1) pt[i] = pcl00[i][k];
	else pt[i] = pt[i-1] + pcl00[i][k];
      /* Threshold values for classes */
      for (i = 1; i < clt; i++) pclwLqm[i] = probit((double)pt[i]);   
      /* Shifting the distribution to the right */
      for (i = 1; i < clt; i++) pclwLql[i] = pclwLqm[i] + 0.05;
      /* New values of the vector pf[i] */
      pf[1] = normdis((double)pclwLql[1]);
      for (i = 2; i < clt; i++)
	pf[i] = normdis((double)pclwLql[i]) - normdis((double)pclwLql[i-1]);
      pf[clt] = 1 - normdis((double)pclwLql[clt-1]);  
      /* New values of matrix Pltype[i][j] */
      for (i = 1; i <= clt; i++)  
	Pltype[i][k] = pf[i];
    }  
    zr++;
    printf("  Loop #%4d\n", zr);    
    goto Start; 
  }
  if (zr == 190) {
    Tprofl = Tprof;
    tvl = avlitE;     
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl); 
    /* Returning the original matrix Pltype[i][j] */
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= LL; j++) 
      Pltype[i][j] = pcl00[i][j];
    } 
    zr++; 
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0; 
    for (i = 1; i < N; i++) {
      pclwLql[i] = pclwLqm[i] = pf0[i] = pf[i] = pt[i] = 0;
      for (j = 1; j < N; j++) pcl00[i][j] = 0;
    }  
    goto Start;
  } 



  /* Trait: Average survival rate of lambs at lambing */
  if (zr == 191) trait = 23;
  if (ewopt == 1 && zr == 191) zr += 5;  
  if (zr == 191) {
    Tprofm = Tprof;
    tvm = avsur24hL[1];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedbL[i][1];
      pdiedbL[i][1] = 0.99 * pcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 192) {
    Tprofh = Tprof;
    tvh = avsur24hL[1];
    for (i = 1; i <= clt; i++) pdiedbL[i][1] = 1.01 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 193) {
    Tprofl = Tprof;
    tvl = avsur24hL[1];
    ev0[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) pdiedbL[i][1] = 0.995 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 194) {
    tvh = avsur24hL[1];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) pdiedbL[i][1] = 1.005 * pcl0[i];
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 195) {
    tvl = avsur24hL[1];  
    Tprofl = Tprof;
    ev[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedbL[i][1] = pcl0[i];    
      pcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 196 && ewopt == 0) zr = 201;
  if (zr == 196) {
    Tprofm = Tprof;
    tvm = avsur24hL[2];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedbL[i][2];
      pdiedbL[i][2] = 0.99 * pcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 197) {
    Tprofh = Tprof;
    tvh = avsur24hL[2];
    for (i = 1; i <= clt; i++) pdiedbL[i][2] = 1.01 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 198) {
    Tprofl = Tprof;
    tvl = avsur24hL[2];
    ev0[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) pdiedbL[i][2] = 0.995 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 199) {
    tvh = avsur24hL[2];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) pdiedbL[i][2] = 1.005 * pcl0[i];
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 200) {
    tvl = avsur24hL[2];  
    Tprofl = Tprof;
    ev[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedbL[i][2] = pcl0[i];    
      pcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Average survival rate of lambs till weaning */
  if (zr == 201) trait = 24;
  if (zr == 201 && typew == 2) zr = 211;
  if (ewopt == 1 && zr == 201) zr += 5;  
  if (zr == 201) {
    Tprofm = Tprof;
    tvm = avsurwL[1];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedwL[i][1];
      pdiedwL[i][1] = 0.99 * pcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 202) {
    Tprofh = Tprof;
    tvh = avsurwL[1];
    for (i = 1; i <= clt; i++) pdiedwL[i][1] = 1.01 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 203) {
    Tprofl = Tprof;
    tvl = avsurwL[1];
    ev0[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) pdiedwL[i][1] = 0.995 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 204) {
    tvh = avsurwL[1];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) pdiedwL[i][1] = 1.005 * pcl0[i];
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 205) {
    tvl = avsurwL[1];  
    Tprofl = Tprof;
    ev[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][1] = pcl0[i];    
      pcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 206 && ewopt == 0) zr = 211;
  if (zr == 206) {
    Tprofm = Tprof;
    tvm = avsurwL[2];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedwL[i][2];
      pdiedwL[i][2] = 0.99 * pcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 207) {
    Tprofh = Tprof;
    tvh = avsurwL[2];
    for (i = 1; i <= clt; i++) pdiedwL[i][2] = 1.01 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 208) {
    Tprofl = Tprof;
    tvl = avsurwL[2];
    ev0[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) pdiedwL[i][2] = 0.995 * pcl0[i];
    zr++;
    goto Start;
  }
  if (zr == 209) {
    tvh = avsurwL[2];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) pdiedwL[i][2] = 1.005 * pcl0[i];
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 210) {
    tvl = avsurwL[2];  
    Tprofl = Tprof;
    ev[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][2] = pcl0[i];    
      pcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Average survival rate of lambs till the end of artificial rearing */
  if (zr == 211) trait = 25;
  if (zr == 211 && typew == 1) zr = 221;
  if (ewopt == 1 && zr == 211) zr += 5;  
  if (zr == 211) {
    Tprofm = Tprof;
    tvm = avsurarL[1];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedwL[i][1];
      qcl0[i] = pdiedarL[i][1];
      pdiedwL[i][1] = 0.99 * pcl0[i];
      pdiedarL[i][1] = 0.99 * qcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 212) {
    Tprofh = Tprof;
    tvh = avsurarL[1];
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][1] = 1.01 * pcl0[i];
      pdiedarL[i][1] = 1.01 * qcl0[i];
    }  
    zr++;
    goto Start;
  }
  if (zr == 213) {
    Tprofl = Tprof;
    tvl = avsurarL[1];
    ev0[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][1] = 0.995 * pcl0[i];
      pdiedarL[i][1] = 0.995 * qcl0[i];
    }  
    zr++;
    goto Start;
  }
  if (zr == 214) {
    tvh = avsurarL[1];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][1] = 1.005 * pcl0[i];
      pdiedarL[i][1] = 1.005 * qcl0[i];  
    }  
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 215) {
    tvl = avsurarL[1];  
    Tprofl = Tprof;
    ev[trait][1] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][1] = pcl0[i];  
      pdiedarL[i][1] = qcl0[i];    
      pcl0[i] = qcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  if (zr == 216 && ewopt == 0) zr = 221;
  if (zr == 216) {
    Tprofm = Tprof;
    tvm = avsurarL[2];
    for (i = 1; i <= clt; i++) {
      pcl0[i] = pdiedwL[i][2];
      qcl0[i] = pdiedarL[i][2];
      pdiedwL[i][2] = 0.99 * pcl0[i];
      pdiedarL[i][2] = 0.99 * qcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 217) {
    Tprofh = Tprof;
    tvh = avsurarL[2];
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][2] = 1.01 * pcl0[i];
      pdiedarL[i][2] = 1.01 * qcl0[i];      
    }  
    zr++;
    goto Start;
  }
  if (zr == 218) {
    Tprofl = Tprof;
    tvl = avsurarL[2];
    ev0[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][2] = 0.995 * pcl0[i];
      pdiedarL[i][2] = 0.995 * qcl0[i];      
    }  
    zr++;
    goto Start;
  }
  if (zr == 219) {
    tvh = avsurarL[2];  
    Tprofh = Tprof;
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][2] = 1.005 * pcl0[i];
      pdiedarL[i][2] = 1.005 * qcl0[i];
    }
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 220) {
    tvl = avsurarL[2];  
    Tprofl = Tprof;
    ev[trait][2] = 100 * (Tprofh - Tprofl)/(tvh - tvl);
    for (i = 1; i <= clt; i++) {
      pdiedwL[i][2] = pcl0[i];  
      pdiedarL[i][2] = qcl0[i];    
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    for (i = 1; i < N; i++) pcl0[i] = qcl0[i] = 0;
    goto Start;
  } 
  /* Trait: Average length of productive life in lactations and in years */
  if (zr == 221) trait = 26;
  if (ewopt == 1 && zr == 221) zr += 5;  
  if (zr == 221) {
    Tprofm = Tprof;
    tvm = avlifelE;
    tv2m = avlifeyE;
    for (i = 1; i <= LL; i++) {
      pcl0[i] = pdiedE[i];
      qcl0[i] = pcullhE[i];
      pdiedE[i] = 0.99 * pcl0[i];
      pcullhE[i] = 0.99 * qcl0[i];
    }  
    zr++;	
    goto Start;
  }
  if (zr == 222) {
    Tprofh = Tprof;
    tvh = avlifelE;
    tv2h = avlifeyE;    
    for (i = 1; i <= LL; i++) {
      pdiedE[i] = 1.01 * pcl0[i];
      pcullhE[i] = 1.01 * qcl0[i];
    }  
    zr++;
    goto Start;
  }
  if (zr == 223) {
    Tprofl = Tprof;
    tvl = avlifelE;
    tv2l = avlifeyE;    
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait+1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    for (i = 1; i <= LL; i++) {
      pdiedE[i] = 0.995 * pcl0[i];
      pcullhE[i] = 0.995 * qcl0[i];
    }  
    zr++;
    goto Start;
  }
  if (zr == 224) {
    tvh = avlifelE;  
    tv2h = avlifeyE;        
    Tprofh = Tprof;
    for (i = 1; i <= LL; i++) {
      pdiedE[i] = 1.005 * pcl0[i];
      pcullhE[i] = 1.005 * qcl0[i];  
    }  
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 225) {
    tvl = avlifelE;  
    tv2l = avlifeyE;        
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait+1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    for (i = 1; i <= LL; i++) {
      pdiedE[i] = pcl0[i];  
      pcullhE[i] = qcl0[i];    
      pcl0[i] = qcl0[i] = 0;
    }  
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    for (i = 1; i < N; i++) pcl0[i] = qcl0[i] = 0;
    goto Start;
  } 
  /* Trait: Total milk yield in the standardized milking period */
  if (zr == 226) trait = 28;
  if (ewopt == 1 && zr == 226) zr += 5;
  if (ewopt != 1 && typeb > 1 && zr == 226) zr += 5;
  if (zr == 226) {
    Tprofm = Tprof;
    tvm = awo;
    tv2m = avmilkd;
    awo = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 227) {
    tvh = tmilkst;
    tv2h = avmilkd;
    Tprofh = Tprof;
    awo = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 228) {
    Tprofl = Tprof;
    tvl = tmilkst;
    tv2l = avmilkd;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    awo = 1.005*tvm;
    zr++;
    goto Start;
  }
  if (zr == 229) {
    Tprofh = Tprof;
    tvh = tmilkst;    
    tv2h = avmilkd;
    awo = 0.995*tvm;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 230) {
    tvl = tmilkst; 
    tv2l = avmilkd;         
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    awo = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Fat content in milk and milk fat yield */
  if (zr == 231) trait = 30;
  if (ewopt == 1 && zr == 231) zr += 5;
  if (ewopt != 1 && typeb > 1 && zr == 231) zr += 5;
  if (zr == 231) {
    Tprofm = Tprof;
    tvm = fat;
    tv2m = fatymst;
    fat = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 232) {
    tv2h = fatymst;
    Tprofh = Tprof;
    fat = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 233) {
    Tprofl = Tprof;
    tv2l = fatymst;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    fat = tvh = 1.005*tvm;
    zr++;
    goto Start;
  }
  if (zr == 234) {
    Tprofh = Tprof;
    tv2h = fatymst;
    fat = tvl = 0.995*tvm;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 235) {
    tv2l = fatymst;         
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    fat = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Protein content in milk and milk protein yield */
  if (zr == 236) trait = 32;
  if (ewopt == 1 && zr == 236) zr += 5;
  if (ewopt != 1 && typeb > 1 && zr == 236) zr += 5;
  if (zr == 236) {
    Tprofm = Tprof;
    tvm = prot;
    tv2m = protymst;
    prot = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 237) {
    tv2h = protymst;
    Tprofh = Tprof;
    prot = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 238) {
    Tprofl = Tprof;
    tv2l = protymst;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev0[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    prot = tvh = 1.005*tvm;
    zr++;
    goto Start;
  }
  if (zr == 239) {
    Tprofh = Tprof;
    tv2h = protymst;
    prot = tvl = 0.995*tvm;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 240) {
    tv2l = protymst;         
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    ev[trait + 1][1] = (Tprofh - Tprofl)/(tv2h - tv2l);
    prot = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = tv2h = tv2l = tv2m = 0;
    goto Start;
  } 
  /* Trait: Somatic cell score */
  if (zr == 241) trait = 34;
  if (typeb != 1 && zr == 241) zr = 246;  
  if (ewopt == 1 && zr == 241) zr += 5;    
  if (zr == 241) {
    Tprofm = Tprof;
    tvm = mSCS;
    tvh = mSCS = 1.01 * tvm;
    zr++;	
    goto Start;
  }
  if (zr == 242) {
    Tprofh = Tprof;
    tvl = mSCS = 0.99 * tvm;
    zr++;
    goto Start;
  }
  if (zr == 243) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = mSCS = 1.005 * tvm;
    zr++;
    goto Start;
  }
  if (zr == 244) {
    Tprofh = Tprof;
    tvl = mSCS = 0.995 * tvm;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 245) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    mSCS = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  /* Trait: Fleece weight */
  if (zr == 246) trait = 35;
  if (ewopt == 1 && zr == 246) zr += 5;
  if (zr == 246) {
    tvm = wsheR[1];
    wsheR[1] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 247) {
    Tprofh = Tprof;
    wsheR[1] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 248) {
    Tprofl = Tprof;
    ev0[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    wsheR[1] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 249) {
    Tprofh = Tprof;
    wsheR[1] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 250) {
    Tprofl = Tprof;
    ev[trait][1] = (Tprofh - Tprofl)/(tvh - tvl);
    wsheR[1] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 251 && ewopt == 0) zr = 256;  
  if (zr == 251) {
    Tprofm = Tprof;  
    tvm = wsheR[2];
    wsheR[2] = tvh = 1.01*tvm;
    zr++;	
    goto Start;
  }
  if (zr == 252) {
    Tprofh = Tprof;
    wsheR[2] = tvl = 0.99*tvm;
    zr++;
    goto Start;
  }
  if (zr == 253) {
    Tprofl = Tprof;
    ev0[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    tvh = 1.005*tvm;
    tvl = 0.995*tvm;
    wsheR[2] = tvh;
    zr++;
    goto Start;
  }
  if (zr == 254) {
    Tprofh = Tprof;
    wsheR[2] = tvl;
    zr++;
    printf("  Loop #%4d\n", zr);
    goto Start;
  }
  if (zr == 255) {
    Tprofl = Tprof;
    ev[trait][2] = (Tprofh - Tprofl)/(tvh - tvl);
    wsheR[2] = tvm;
    zr++;
    Tprofl = Tprofh = Tprofm = tvh = tvl = tvm = 0;
    goto Start;
  } 
  if (zr == 256) {  
    for (j = 1; j <= crossing; j++) {
      for (i = 1; i < NT; i++) {
        evp[i][j] = ev[i][j]; 
        if (fabs(ev[i][j]) > 0.000001) 
	  evdiff[i][j] = 100 * (ev[i][j] - ev0[i][j]) / ev[i][j];
	if (fabs(ev[i][j]) <= 0.000001) evdiff[i][j] = -999;   
      }
      evp[3][j] = ev[3][j]/1000;
      evp[5][j] = ev[5][j]/1000;
      evp[6][j] = ev[6][j]/1000;            
      evp[7][j] = ev[7][j]/1000;
      for (i = 12; i <= 25; i++) evp[i][j] = ev[i][j]/100;
      evp[29][j] = ev[29][j]/10;
      evp[30][j] = ev[30][j]/100;   
      evp[32][j] = ev[32][j]/100;      
      evp[34][j] = ev[34][j]/100;   
    }
  }

Next:
/* Paramter(s) for next run(s) */
  if (zr == 256) {
    if (prods == 2 && breed == 2 && calc == 1) { 
      nsoldMPA = npurchMP[2] * pdB / pdA;
      fw3 = fopen("TRANSFER01.TXT", "w");
      fprintf(fw3, "%10.5f\n", nsoldMPA);
      fclose(fw3);     
      fw3 = fopen("P00.TXT", "w");
      fprintf(fw3, "%d\n%d\n%d\n", 2,1,2);
      fclose(fw3);        
    }
    if (prods == 2 && breed == 1 && calc == 2) { 
      fr = fopen("TRANSFER01.TXT", "r");
      fscanf(fr, "%f", &nsoldMPA);
      fclose(fr);
      a2 = 1 / (1 - psp[2][2][1]);
      psp[2][2][1] = nsoldMPA * (surbs[2][1][1] - cullbsMP[1][1]) / nwsp[2][1];
      a2 *= (1 - psp[2][2][1]);
      for (i = 1; i <= csp[2]; i++) {
        if (i == 2) i = 3;
	psp[2][i][1] *= a2;
	}
      fw3 = fopen("TRANSFER02.TXT", "w");
      for (i = 1; i <= csp[2]; i++)
        fprintf(fw3, "%14.8f\n", psp[2][i][1]);
      fclose(fw3);     
      fw3 = fopen("P00.TXT", "w");
      fprintf(fw3, "%d\n%d\n%d\n", 2,1,3);
      fclose(fw3);        
    }
    if (prods == 2 && breed == 1 && calc == 3) {
      fw3 = fopen("TRANSFER03.TXT", "w");
      fprintf(fw3, "%10.3f\n", mwE[1]);
      fprintf(fw3, "%10.3f\n", mwR[1]);
      a2 = psold[2][1][1] * agetP[38][1] + (1 - psold[2][1][1]) * agetP[40][1];
      fprintf(fw3, "%10.3f\n", a2);
      a2 = psold[2][1][1] * wP[38][1] + (1 - psold[2][1][1]) * wP[40][1];
      fprintf(fw3, "%10.3f\n", a2);
      a2 = psold[2][1][1] * revsbL[38][1] + (1 - psold[2][1][1]) * revsbL[40][1];
      fprintf(fw3, "%10.3f\n", a2);
      fclose(fw3);    
      fw3 = fopen("P00.TXT", "w");
      fprintf(fw3, "%d\n%d\n%d\n", 2,2,4);
      fclose(fw3);        
    } 
    if ((prods == 1 && calc == 1) || (prods == 2 && calc == 4)) {    
      fw3 = fopen("P01.TXT", "w");
      fprintf(fw3, "%d\n", prods);
      fclose(fw3);        
    }
  }

Printabc: /* Printing variable values to CHECKS for checking the calulation */
  if (trait == 0) {
    if (breed == 1) 
      printf("Writing results from loop 1 to file CHECKSA0%da\n", calc);
    if (breed == 2)
      printf("Writing results from loop 1 to file CHECKSB0%da\n", calc);
    if (breed == 1 && calc == 1) fw2 = fopen("CHECKSA01a", "w");
    if (breed == 1 && calc == 2) fw2 = fopen("CHECKSA02a", "w");
    if (breed == 1 && calc == 3) fw2 = fopen("CHECKSA03a", "w");
    if (breed == 2 && calc == 1) fw2 = fopen("CHECKSB01a", "w");
    if (breed == 2 && calc == 4) fw2 = fopen("CHECKSB04a", "w");
  }  
  if (zr == 256) {
    if (breed == 1) {
      printf("Writing results from loop %d to file CHECKSA0%d\n", zr, calc);
      if (calc == 1) fw2 = fopen("CHECKSA01", "w");
      if (calc == 2) fw2 = fopen("CHECKSA02", "w");
      if (calc == 3) fw2 = fopen("CHECKSA03", "w");
      }
    if (breed == 2) {
      printf("Writing results from loop %d to file CHECKSB0%d\n", zr, calc);
      if (calc == 1) fw2 = fopen("CHECKSB01", "w");
      if (calc == 4) fw2 = fopen("CHECKSB04", "w");
    }  
  }  
  fprintf(fw2, "a = %16.14f\n", a);
  fprintf(fw2, "a1 = %16.14f\n", a1);
  fprintf(fw2, "aa1 = %16.14f\n", aa1);
  fprintf(fw2, "ach = %10.5f\n", ach);
  fprintf(fw2, "\n");
  for (i = 1; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "adg[%d][%d] = %f\n", i,j,adg[i][j]);
  }
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "adgb[%d][%d][%d] = %f\n", k,i,j,adgb[k][i][j]);
    }
  }
  fprintf(fw2, "\n");  
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "adgbwL[%d][%d][%d] = %f\n", k,i,j,adgbwL[k][i][j]);
    } 
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "adgE = %f\n", adgE);
  if (flushabE + flushbbE > 0) fprintf(fw2, "adgfE = %f\n", adgfE);
  if (flushabE + flushbbE > 0) fprintf(fw2, "adgfL = %f\n", adgfL);
  fprintf(fw2, "\n");     
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) 
      if (fabs(adgP[i][j] > 0.000001))
	fprintf(fw2, "adgP[%d][%d] = %f\n", i,j,adgP[i][j]);
  }
  fprintf(fw2, "\n");
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "adgR[%d] = %9.5f\n", j,adgR[j]);
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++) 
        if (fabs(adgr[k][i][j]) > 0.000001)
	  fprintf(fw2, "adgr[%d][%d][%d] = %f\n", k,i,j,adgr[k][i][j]);
    }
  }  
  fprintf(fw2, "\n"); 
  if (typew == 2) {
    for (k = 1; k < SP; k++) {
      for (i = 1; i <= clt; i++) {
	for (j = 1; j <= crossing; j++)
	  fprintf(fw2, "adgwarL[%d][%d][%d] = %f\n", k,i,j,adgwarL[k][i][j]);
      }
    }
    fprintf(fw2, "\n");      
    fprintf(fw2, "agearL = %d\n", agearL);
    fprintf(fw2, "\n");
  }
  for (j = 1; j <= LL; j++)
    fprintf(fw2, "ageE[%d] = %7.1f\n", j,ageE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) 
    fprintf(fw2, "agelFP[%d] = %7.1f\n", i,agelFP[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(agetP[i][j]) > 0.00001)
        fprintf(fw2, "agetP[%d][%d] = %8.1f\n",i,j,agetP[i][j]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "agepurMP[%d] = %7.1f\n", j,agepurMP[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= RR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "ageR[%d][%d] = %7.1f\n", i,j,ageR[i][j]);
  }
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) 
      fprintf(fw2, "ager[%d][%d] = %7.1f\n", k,i,ager[k][i]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "agewL = %d\n", agewL);
  fprintf(fw2, "\n");
  if (typew == 2) fprintf(fw2, "AkharL = %7.2f\n", AkharL);
  fprintf(fw2, "AkhE = %7.2f\n", AkhE);
  if (fatpb + fatcb > 0) fprintf(fw2, "AkhfL = %7.2f\n", AkhfL);
  fprintf(fw2, "AkhR = %7.2f\n", AkhR);
  fprintf(fw2, "AkhrL = %7.2f\n", AkhrL);
  fprintf(fw2, "\n");
  if (pricefL == 2) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avclfL[%d] = %8.3f\n", j,avclfL[j]);
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "avlifelE = %8.3f\n", avlifelE);
  fprintf(fw2, "avlifeyE = %8.3f\n", avlifeyE);
  fprintf(fw2, "\n");
  if (priceS == 2) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avclS[%d] = %8.3f\n", j,avclS[j]);
    fprintf(fw2, "\n");
  }
  if (pricewL == 2) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avclwL[%d] = %8.3f\n", j,avclwL[j]);
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "avconrateE = %8.3f\n", avconrateE);
  fprintf(fw2, "\n");
  if (pricewL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avcqwL[%d] = %8.3f\n", j,avcqwL[j]);
    fprintf(fw2, "\n");
  }
  if (pricefL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfcfL[%d] = %8.3f\n", j,avfcfL[j]);
    fprintf(fw2, "\n");
  }
  if (pricefL == 4 || pricewL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfcL[%d] = %8.3f\n", j,avfcL[j]);
    fprintf(fw2, "\n");
  }
  if (priceS == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfcS[%d] = %8.3f\n", j,avfcS[j]);
    fprintf(fw2, "\n");
  }
  if (pricewL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfcwL[%d] = %8.3f\n", j,avfcwL[j]);
    fprintf(fw2, "\n");
  }
  if (pricefL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfleshfL[%d] = %8.3f\n", j,avfleshfL[j]);
    fprintf(fw2, "\n");
  }
  if (pricefL == 4 || pricewL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfleshL[%d] = %8.3f\n", j,avfleshL[j]);
    fprintf(fw2, "\n");
  }
  if (priceS == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfleshS[%d] = %8.3f\n", j,avfleshS[j]);
    fprintf(fw2, "\n");
  }
  if (pricewL == 4) {
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "avfleshwL[%d] = %8.3f\n", j,avfleshwL[j]);
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "avlitE = %8.3f\n", avlitE);
  fprintf(fw2, "\n");
  for (j = 1; j <= LL; j++) 
    fprintf(fw2, "avlitpE[%d] = %8.3f\n", j,avlitpE[j]);
  fprintf(fw2, "\n");
  if (typeb == 1) {
    fprintf(fw2, "avmilkd = %8.3f\n", avmilkd);
    fprintf(fw2, "\n");
  }
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "avsur24hL[%d] = %9.2f\n", j,avsur24hL[j]);
  fprintf(fw2, "\n");  
  if (typew == 1) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "avsurwL[%d] = %9.2f\n", j,avsurwL[j]);
    fprintf(fw2, "\n");  
  }
  if (typew == 2) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "avsurarL[%d] = %9.2f\n", j,avsurarL[j]);
    fprintf(fw2, "\n");  
  }
  if (typew == 2) {  
    for (i = 0; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "avwar[%d][%d] = %f\n", i,j,avwar[i][j]);
    }
    fprintf(fw2, "\n");  
  }
  for (i = 0; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "avww[%d][%d] = %f\n", i,j,avww[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "awo = %12.8f\n", awo); 
  if (typeb == 1) fprintf(fw2, "basemilkm = %8.3f\n", basemilkm);
  fprintf(fw2, "basemilkw = %8.3f\n", basemilkw);
  fprintf(fw2, "\n");
  for (j = 1; j <= nfs; j++)
    fprintf(fw2, "basemilkws[%d] = %f\n", j,basemilkws[j]);
  fprintf(fw2, "\n");
  fprintf(fw2, "BS = %d\n", BS);
  fprintf(fw2, "bch = %10.5f\n", bch);
  fprintf(fw2, "breed = %d\n", breed);
  fprintf(fw2, "\n");     
  for (i = 1; i < SP; i++)
    fprintf(fw2, "bs[%d] = %d\n", i,bs[i]);    
  fprintf(fw2, "\n"); 
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "bwL[%d][%d][%d] = %f\n", k,i,j,bwL[k][i][j]);
    }
  }
  fprintf(fw2, "\n");  
  fprintf(fw2, "bwo = %12.8f\n", bwo);      
  fprintf(fw2, "C = %d\n", C);
  fprintf(fw2, "\n");  
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c1[%d] = %f\n", i,c1[i]);
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c2[%d] = %f\n", i,c2[i]);
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c3[%d] = %f\n", i,c3[i]);
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c4[%d] = %f\n", i,c4[i]);
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c5[%d] = %f\n", i,c5[i]);
  for (i = 1; i < SP; i++) 
    fprintf(fw2, "c6[%d] = %f\n", i,c6[i]);
  fprintf(fw2, "\n");  
  fprintf(fw2, "calc = %d\n", calc);
  if (typeb == 1 && pmilkch > 0.000001) 
    fprintf(fw2, "casprot = %7.3f\n", casprot);   
  fprintf(fw2, "cch = %10.5f\n", cch);    
  fprintf(fw2, "\n");  
  if (pmilkch > 0.000001 && typeb == 1) {
    fprintf(fw2, "cheesewhey = %7.2f\n", cheesewhey);
    fprintf(fw2, "cheesey = %7.3f\n", cheesey);
    fprintf(fw2, "\n");
  }  
  if (lf[0] > 0.00001) {
    for (i = 1; i <= lf[0]; i++) 
      fprintf(fw2, "clf[0][%d] = %d\n", i,clf[0][i]);
    fprintf(fw2, "\n");  
  }
  if (lf[1] > 0.00001) {
    for (i = 1; i <= lf[1]; i++) 
      fprintf(fw2, "clf[1][%d] = %d\n", i,clf[1][i]);
    fprintf(fw2, "\n");  
  }
  if (lf[2] > 0.00001) {  
    for (i = 1; i <= lf[2]; i++) 
      fprintf(fw2, "clf[2][%d] = %d\n", i,clf[2][i]);
    fprintf(fw2, "\n");  
  }  
  fprintf(fw2, "CLT = %d\n", CLT);
  fprintf(fw2, "clt = %d\n", clt);
  fprintf(fw2, "coninsE = %7.2f\n", coninsE);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "conrateE[%d] = %f\n", i,conrateE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(conrateFP[i][j]) > 0.000001)
        fprintf(fw2, "conrateFP[%d][%d] = %f\n", i,j,conrateFP[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "costAkh = %7.2f\n", costAkh);
  fprintf(fw2, "\n");  
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costbedE[%d] = %7.2f\n", j,costbedE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costbedL[i][j]) > 0.00001)
        fprintf(fw2, "costbedL[%d][%d] = %9.2f\n",i,j,costbedL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costbedR[%d][%d] = %9.2f\n", i,j,costbedR[i][j]);
  }
  fprintf(fw2, "\n");
  a2 = 0;
  for (j = 1; j <= TE; j++) {
    if (fabs(costbreedE[j]) > 0.00001)
      fprintf(fw2, "costbreedE[%d] = %7.4f\n", j,costbreedE[j]);
    a2 += costbreedE[j];  
  }    
  if (a2 > 0.00001) fprintf(fw2, "\n");
  a2 = 0;
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      if (fabs(costbreedL[i][j]) > 0.00001)
        fprintf(fw2, "costbreedL[%d][%d] = %9.2f\n",i,j,costbreedL[i][j]);
      a2 += costbreedL[i][j];	
    }	
  }
  if (a2 > 0.00001) fprintf(fw2, "\n");     
  if (typeb == 1) { 
    if (pmilkch > 0.000001) {
      fprintf(fw2, "costcheese0E = %7.2f\n", costcheese0E);
      fprintf(fw2, "\n");
    }
    for (j = 1; j <= TE; j++)
      if (fabs(costcheeseE[j]) > 0.000001)
	fprintf(fw2, "costcheeseE[%d] = %7.2f\n", j,costcheeseE[j]);
    if (pmilkch > 0.000001) fprintf(fw2, "\n");
  }
  fprintf(fw2, "costdead = %7.3f\n", costdead);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    if (fabs(costdiedE[j]) > 0.000001)
      fprintf(fw2, "costdiedE[%d] = %7.2f\n", j,costdiedE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costdiedL[i][j]) > 0.00001)
        fprintf(fw2, "costdiedL[%d][%d] = %9.2f\n",i,j,costdiedL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(costdiedR[i][j]) > 0.000001)
      fprintf(fw2, "costdiedR[%d][%d] = %9.2f\n", i,j,costdiedR[i][j]);
  }
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    if (fabs(costE[j]) > 0.000001)
      fprintf(fw2, "costE[%d] = %7.2f\n", j,costE[j]);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costfE[%d] = %9.2f\n", j,costfE[j]);
  fprintf(fw2, "\n");
  fprintf(fw2, "costfix0E = %9.2f\n", costfix0E);
  fprintf(fw2, "costfix0R = %9.2f\n", costfix0R);
  if (typew == 2) fprintf(fw2, "costfixarL = %9.2f\n", costfixarL);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costfixE[%d] = %9.2f\n", j,costfixE[j]);
  fprintf(fw2, "\n");
  if (fatpb + fatcb > 0) {
    fprintf(fw2, "costfixfL = %9.2f\n", costfixfL);  
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costfixL[i][j]) > 0.00001)
        fprintf(fw2, "costfixL[%d][%d] = %9.2f\n",i,j,costfixL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costfixR[%d][%d] = %9.2f\n", i,j,costfixR[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "costfixrL = %9.2f\n", costfixrL); 
  fprintf(fw2, "\n"); 
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costfL[i][j]) > 0.00001)
        fprintf(fw2, "costfL[%d][%d] = %9.2f\n",i,j,costfL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costfR[%d][%d] = %9.2f\n", i,j,costfR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "costins[%d] = %5.1f\n", i,costins[i]);
  fprintf(fw2, "\n");   
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costL[i][j]) > 0.00001)
        fprintf(fw2, "costL[%d][%d] = %9.2f\n",i,j,costL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costlabE[%d] = %9.2f\n", j,costlabE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costlabL[i][j]) > 0.00001)
        fprintf(fw2, "costlabL[%d][%d] = %9.2f\n",i,j,costlabL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costlabR[%d][%d] = %9.2f\n", i,j,costlabR[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "costlamb = %9.2f\n", costlamb);
  fprintf(fw2, "costmarkbR = %9.2f\n", costmarkbR);
  fprintf(fw2, "costmarkcul = %9.2f\n", costmarkcul);
  fprintf(fw2, "\n");
  a2 = 0;
  for (j = 1; j <= TE; j++) {
    if (fabs(costmarkE[j]) > 0.000001)
      fprintf(fw2, "costmarkE[%d] = %7.2f\n", j,costmarkE[j]);
    a2 += costmarkE[j];  
  }   
  if (a2 > 0.00001) fprintf(fw2, "\n");
  fprintf(fw2, "costmarkfL = %7.2f\n", costmarkfL);
  fprintf(fw2, "\n");  
  a2 = 0;
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      if (fabs(costmarkL[i][j]) > 0.00001)
        fprintf(fw2, "costmarkL[%d][%d] = %9.2f\n",i,j,costmarkL[i][j]);
    a2 += costmarkL[i][j];	
    }
  }
  if (a2 > 0.00001) fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(costmarkR[i][j]) > 0.000001)
      fprintf(fw2, "costmarkR[%d][%d] = %9.2f\n", i,j,costmarkR[i][j]);
  }
  fprintf(fw2, "\n");
  a2 = 0;
  for (i = 1; i < SP; i++) {
    if (fabs(costmarkrL[i]) > 0.00001)  
      fprintf(fw2, "costmarkrL[%d] = %7.2f\n", i,costmarkrL[i]);
    a2 += costmarkrL[i];
  }
  if (a2 > 0.00001) fprintf(fw2, "\n");
  fprintf(fw2, "costmarkwL = %7.2f\n", costmarkwL);
  if (typeb == 1) fprintf(fw2, "costmilk0E = %7.2f\n", costmilk0E);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    if (fabs(costmilkE[j]) > 0.000001)
      fprintf(fw2, "costmilkE[%d] = %7.2f\n", j,costmilkE[j]);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    if (fabs(costnfE[j]) > 0.000001)
      fprintf(fw2, "costnfE[%d] = %7.2f\n", j,costnfE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costnfL[i][j]) > 0.00001)
        fprintf(fw2, "costnfL[%d][%d] = %9.2f\n",i,j,costnfL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(costnfR[i][j]) > 0.000001)
      fprintf(fw2, "costnfR[%d][%d] = %9.2f\n", i,j,costnfR[i][j]);
  }
  fprintf(fw2, "\n");
  if (pinsE[1] + pinsE[2] > 0.00001) 
    fprintf(fw2, "costoeinE = %9.2f\n", costoeinE);
  if (pinsFP[1] + pinsFP[2] > 0.00001)   
    fprintf(fw2, "costoeinFP = %9.2f\n", costoeinFP);
  fprintf(fw2, "costpurchFP = %9.2f\n", costpurchFP);
  fprintf(fw2, "\n");  
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(costpurchR[i][j]) > 0.000001)
      fprintf(fw2, "costpurchR[%d][%d] = %9.2f\n", i,j,costpurchR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(costR[i][j]) > 0.000001)
      fprintf(fw2, "costR[%d][%d] = %9.2f\n", i,j,costR[i][j]);
  }
  fprintf(fw2, "\n");     
  if (pinsE[1] + pinsE[2] + pinsFP[1] + pinsFP[2] > 0.00001) {  
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "costreins[%d] = %7.2f\n", i,costreins[i]);
    fprintf(fw2, "\n");   
  }
  fprintf(fw2, "costshe0E = %7.2f\n", costshe0E);
  fprintf(fw2, "costshe0L = %7.2f\n", costshe0L);  
  fprintf(fw2, "costshe0R = %7.2f\n", costshe0R);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costsheE[%d] = %7.2f\n", j,costsheE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costsheL[i][j]) > 0.00001)
        fprintf(fw2, "costsheL[%d][%d] = %9.2f\n",i,j,costsheL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costsheR[%d][%d] = %9.2f\n", i,j,costsheR[i][j]);
  }
  fprintf(fw2, "\n");
  a2 = 0;
  for (j = 1; j <= TE; j++) {
    if (fabs(costskE[j]) > 0.000001)
      fprintf(fw2, "costskE[%d] = %7.2f\n", j,costskE[j]);
    a2 += costskE[j];  
  }    
  if (a2 > 0) fprintf(fw2, "\n");
  a2 = 0;
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {   
      if (fabs(costskL[i][j]) > 0.00001)
        fprintf(fw2, "costskL[%d][%d] = %9.2f\n",i,j,costskL[i][j]);
      a2 += costskL[i][j];	
    }	
  }
  if (a2 > 0) fprintf(fw2, "\n");
  a2 = 0; 
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++) {
      if (fabs(costskR[i][j]) > 0.000001)
      fprintf(fw2, "costskR[%d][%d] = %9.2f\n", i,j,costskR[i][j]);
      a2 += costskR[i][j];
    }
  }
  if (a2 > 0) fprintf(fw2, "\n");
  if (fabs(costtan) > 0.00001) {
    fprintf(fw2, "costtan = %7.2f\n", costtan);
    fprintf(fw2, "\n");  
  }
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costvetE[%d] = %7.2f\n", j,costvetE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costvetL[i][j]) > 0.00001)
        fprintf(fw2, "costvetL[%d][%d] = %9.2f\n",i,j,costvetL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costvetR[%d][%d] = %9.2f\n", i,j,costvetR[i][j]);
  }
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "costwatE[%d] = %f\n", j,costwatE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(costwatL[i][j]) > 0.00001)
        fprintf(fw2, "costwatL[%d][%d] = %f\n",i,j,costwatL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "costwatR[%d][%d] = %f\n", i,j,costwatR[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "CR = %d\n", CR);
  fprintf(fw2, "crossing = %d\n", crossing);
  fprintf(fw2, "\n");
  for (i = 0; i < SP; i++)
    fprintf(fw2, "csp[%d] = %d\n", i,csp[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[2]; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(cullbsMP[i][j]) > 0.000001)
        fprintf(fw2, "cullbsMP[%d][%d] = %f\n", i,j,cullbsMP[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "cwo = %12.8f\n", cwo);  
  if (typeb == 1 && pmilkch > 0.000001) fprintf(fw2, "cy = %d\n", cy);    
  fprintf(fw2, "datbbs = %d\n", datbbs);
  fprintf(fw2, "\n");        
  for (i = 1; i <= nchfst; i++) 
    fprintf(fw2, "datchfs[%d] = %d\n", i,datchfs[i]);
  fprintf(fw2, "\n");    
  for (i = 1; i <= bs[1]; i++) 
    fprintf(fw2, "datconFP[%d] = %d\n", i,datconFP[i]);
  fprintf(fw2, "\n");        
  fprintf(fw2, "datdry = %d\n", datdry);
  fprintf(fw2, "datebs = %d\n", datebs);
  fprintf(fw2, "datlamb = %d\n", datlamb);
  fprintf(fw2, "datwL = %d\n", datwL);
  fprintf(fw2, "\n");
  for (j = 1; j <= TE; j++)
    fprintf(fw2, "dcE[%d] = %7.1f\n", j,dcE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(dcL[i][j]) > 0.00001)
        fprintf(fw2, "dcL[%d][%d] = %9.2f\n",i,j,dcL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= TR; j++)
    fprintf(fw2, "dcR[%d] = %7.1f\n", j,dcR[j]);
  fprintf(fw2, "\n");
  if (typeb == 1) fprintf(fw2, "dmilkst = %7d\n", dmilkst);  
  fprintf(fw2, "dnpregcE = %5d\n", dnpregcE);  
  fprintf(fw2, "dnpregcFP = %7.1f\n", dnpregcFP);
  fprintf(fw2, "dpregsFP = %7.1f\n", dpregsFP);  
  fprintf(fw2, "\n");        
  if (priceS == 3 || priceS == 4) {
    fprintf(fw2, "dresE = %8.2f\n", dresE);
    fprintf(fw2, "\n");
  }        
  if (pricefL == 3 || pricefL == 4) {
    for (k = 0; k < SP; k++) {
      for (j = 1; j <= crossing; j++) {
	for (i = 1; i <= lf[k]; i++)
	  fprintf(fw2, "dresfL[%d][%d][%d] = %7.1f\n", k,i,j,dresfL[k][i][j]);
      }
    }
  fprintf(fw2, "\n");  
  }  
  if (priceS == 3 || priceS == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "dresR[%d] = %8.2f\n", i,dresR[i]);
    fprintf(fw2, "\n");    
  }  
  if (priceS == 3 || priceS == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "dresrL[%d] = %8.2f\n", i,dresrL[i]);  
    fprintf(fw2, "\n");
  }
  if (pricewL == 3 || pricewL == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "dreswL[%d] = %8.2f\n", i,dreswL[i]);  
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "drymE[%d][%d] = %f\n", i,j,drymE[i][j]);
  }
  fprintf(fw2, "\n");    
  for (i = 1; i <= fL; i++) {
    for (j = 1; j <= nfs; j++) 
      if (fabs(drymL[i][j]) > 0.00001)
        fprintf(fw2, "drymL[%d][%d] = %f\n", i,j,drymL[i][j]);
  }
  fprintf(fw2, "\n");    
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "drymR[%d][%d] = %f\n", i,j,drymR[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "dselR = %d\n", dselR);
  fprintf(fw2, "dshpE = %d\n", dshpE);
  fprintf(fw2, "\n");
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "dwatE[%d][%d] = %f\n", i,j,dwatE[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= fL; i++) {
    for (j = 1; j <= nfs; j++)
      if (fabs(dwatL[i][j]) > 0.00001)     
        fprintf(fw2, "dwatL[%d][%d] = %f\n", i,j,dwatL[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "dwatR[%d][%d] = %f\n", i,j,dwatR[i][j]);
  }
  fprintf(fw2, "\n");
  if (typew == 2) fprintf(fw2, "dwoolptarL = %f\n", dwoolptarL);          
  fprintf(fw2, "dwoolptE = %f\n", dwoolptE);  
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "dwoolptR[%d] = %f\n", i,dwoolptR[i]);
  fprintf(fw2, "\n");
  for (i = 1; i < SP; i++) { 
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "dwoolptrL[%d][%d] = %f\n", i,j,dwoolptrL[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "dwoolptwL = %f\n", dwoolptwL);  
  fprintf(fw2, "errmess = %d\n", errmess);
  fprintf(fw2, "\n");
  for (i = 1; i < NT; i++) {
    for (j = 1; j <= crossing; j++) {
      if (fabs(ev[i][j]) > .000001) 
        fprintf(fw2, "ev[%d][%d]  = %12.4f\n",i, j, ev[i][j]);
      if (fabs(ev0[i][j]) > .000001) 
        fprintf(fw2, "ev0[%d][%d] = %12.4f\n",i, j, ev0[i][j]);
      if (fabs(evp[i][j]) > .000001) 
        fprintf(fw2, "evp[%d][%d] = %12.4f\n",i, j, evp[i][j]);
      if (fabs(evdiff[i][j]) > .000001 && evdiff[i][j] != -999) 
        fprintf(fw2, "evdiff[%d][%d] = %12.4f\n",i, j, evdiff[i][j]);
    }
  }          
  fprintf(fw2, "\n");  
  fprintf(fw2, "ewopt = %d\n", ewopt); 
  fprintf(fw2, "\n");  
  if (milkprice == 5)
    for (i = 0; i < nSCC; i++) 
      fprintf(fw2, "facSCC[%d] = %8.3f\n", i,facSCC[i]);
  fprintf(fw2, "\n");      
  fprintf(fw2, "fat = %f\n", fat);
  fprintf(fw2, "fatcb = %d\n", fatcb);
  if (typeb == 1 && pmilkch > 0.000001) 
    fprintf(fw2, "fatch = %7.1f\n", fatch);   
  fprintf(fw2, "fatpb = %d\n", fatpb);   
  if (typeb == 1) fprintf(fw2, "fatymst = %f\n", fatymst); 
  fprintf(fw2, "\n");  
  if (pricefL == 4 || pricewL == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "favfL[%d] = %8.2f\n", i,favfL[i]);  
    fprintf(fw2, "\n");
  }
  if (pricefL == 4 || pricewL == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "favwL[%d] = %8.2f\n", i,favwL[i]);  
    fprintf(fw2, "\n");
  }
  if (typeb == 1 && pmilkch > 0.000001) fprintf(fw2, "fdm = %7.2f\n", fdm);    
  fprintf(fw2, "FE = %d\n", FE);
  fprintf(fw2, "fE = %d\n", fE);
  fprintf(fw2, "\n");
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (j > 3 && i3 == LL) break;
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)    
          if (fabs(feE[i][k][i2]) > 0.00001)
            fprintf(fw2, "feE[%d][%d][%d] = %f\n",i,k,i2,feE[i][k][i2]);
      }
    }
    fprintf(fw2, "\n");     
  }      
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(feL[i][j][k][i2]) > 0.000001)
            fprintf(fw2, "feL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,feL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");     
  fprintf(fw2, "femrep = %d\n", femrep);
  fprintf(fw2, "\n");         
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(feR[i][j][k][i2]) > 0.000001)  
            fprintf(fw2, "feR[%d][%d][%d][%d] = %f\n",i,j,k,i2,feR[i][j][k][i2]);
      }
    }
    fprintf(fw2, "\n");     
  }      
  fprintf(fw2, "feedcost = %d\n", feedcost);        
  fprintf(fw2, "\n");
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (j > 3 && i3 == LL) break;
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(ffE[i][k][i2]) > 0.00001)  
            fprintf(fw2, "ffE[%d][%d][%d] = %f\n",i,k,i2,ffE[i][k][i2]);
      }
    }
    fprintf(fw2, "\n");     
  }      
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(ffL[i][j][k][i2]) > 0.00001)
            fprintf(fw2, "ffL[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,ffL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)    
	  if (fabs(ffR[i][j][k][i2]) > 0.00001)
            fprintf(fw2, "ffR[%d][%d][%d][%d] = %f\n",i,j,k,i2,ffR[i][j][k][i2]);
      }
    }
  }      
  fprintf(fw2, "\n");     
  fprintf(fw2, "FL = %d\n", FL);    
  fprintf(fw2, "fL = %d\n", fL);
  fprintf(fw2, "flushabE = %d\n", flushabE);
  fprintf(fw2, "flushabL = %d\n", flushabL);  
  fprintf(fw2, "flushbbE = %d\n", flushbbE);
  fprintf(fw2, "flushbbL = %d\n", flushbbL);
  fprintf(fw2, "flushbbR = %d\n", flushbbR);
  fprintf(fw2, "\n"); 
  if (feedcost == 1) {
    for (i3 = 1; i3 <= LL; i3++) {
      for (j = 3; j <= nstgE; j++) {
	if (j > 3 && i3 == LL) break;
	i = (i3 - 1) * nstgE + j;
	for (k = 1; k <= fE; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)    
	    if (fabs(fpdiE[i][k][i2]) > 0.000001)
              fprintf(fw2, "fpdiE[%d][%d][%d] = %f\n",i,k,i2,fpdiE[i][k][i2]);
        }
      }
      fprintf(fw2, "\n");     
    }      
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (fabs(fpdiL[i][j][k][i2]) > 0.00001)
	      fprintf(fw2, "fpdiL[%d][%d][%d][%d] = %f\n",
	        i,j,k,i2,fpdiL[i][j][k][i2]);
	  }   
        }
      }
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 < 2*RR; i3++) {
      i = 2 * i3;
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fR; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)
	    if ((fpdiR[i][j][k][i2]) > 0.000001)
            fprintf(fw2, "fpdiR[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,fpdiR[i][j][k][i2]);
        }
      }
    }      
  fprintf(fw2, "\n");       
  }
  fprintf(fw2, "FR = %d\n", FR);  
  fprintf(fw2, "fR = %d\n", fR);  
  fprintf(fw2, "hetmw = %5.1f\n", hetmw);
  fprintf(fw2, "HS = %d\n", HS);      
  fprintf(fw2, "hs = %d\n", hs);
  if (fatpb + fatcb > 0) fprintf(fw2, "ilcb = %d\n", ilcb);
  if (fatpb + fatcb > 0) fprintf(fw2, "ilpb = %d\n", ilpb);  
  fprintf(fw2, "intlm = %5.1f\n", intlm);
  fprintf(fw2, "intml = %5.1f\n", intml);
  if (fatpb + fatcb == 0) fprintf(fw2, "\n");       
  if (fatpb + fatcb > 0) {
    fprintf(fw2, "iscb = %d\n", iscb);
    fprintf(fw2, "ispb = %d\n", ispb);
    fprintf(fw2, "ja = %d\n", ja);    
    fprintf(fw2, "jb = %d\n", jb);
    fprintf(fw2, "\n"); 
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= crossing; i++) 
        if (fabs(k0[k][i]) > 0.000001)
	fprintf(fw2, "k0[%d][%d] = %d\n", k,i,k0[k][i]);
    }
    fprintf(fw2, "\n");
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[k]; i++) {
	for (j = 1; j <= crossing; j++) 
	  fprintf(fw2, "kadgfat[%d][%d][%d] = %f\n", k,i,j,kadgfat[k][i][j]);
      }
    }
    fprintf(fw2, "\n");      
  }  
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "kadgbw[%d][%d][%d] = %f\n", k,i,j,kadgbw[k][i][j]);
    }
  } 
  fprintf(fw2, "\n");      
  if (typew == 2) {
    for (k = 1; k < SP; k++) {
      for (i = 1; i <= clt; i++) {
	for (j = 1; j <= crossing; j++)
	  if (fabs(kadgwar[k][i][j]) > 0.000001)
            fprintf(fw2, "kadgwar[%d][%d][%d] = %f\n", k,i,j,kadgwar[k][i][j]);
      }
    }
    fprintf(fw2, "\n");       
  } 
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++)
        if (fabs(kadgr[k][i][j]) > 0.000001)
	  fprintf(fw2, "kadgr[%d][%d][%d] = %f\n", k,i,j,kadgr[k][i][j]);
    }
  fprintf(fw2, "\n");     
  } 
  for (k = 1; k < SP; k++) {  
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "kbw[%d][%d][%d] = %f\n", k,i,j,kbw[k][i][j]);
    }
    fprintf(fw2, "\n");
  }  
  for (i = 1; i <= bs[1]; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(kconrateFP[i][j]) > 0.000001)
        fprintf(fw2, "kconrateFP[%d][%d] = %f\n", i,j,kconrateFP[i][j]);
  }
  fprintf(fw2, "\n");      
  fprintf(fw2, "kdif = %7.2f\n", kdif);
  if (priceS > 2) {
    fprintf(fw2, "kdresEL = %7.2f\n", kdresEL);
    fprintf(fw2, "kdresER = %7.2f\n", kdresER);
  }  
  fprintf(fw2, "\n");
  if (pricefL > 2) {
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[k]; i++) {
	for (j = 1; j <= crossing; j++) 
	  if (fabs(kdresfL[k][i][j]) > 0.000001)
	    fprintf(fw2, "kdresfL[%d][%d][%d] = %f\n", k,i,j,kdresfL[k][i][j]);
      }
    }
  fprintf(fw2, "\n");
  }
  if (priceS > 2) fprintf(fw2, "kdresRL = %7.2f\n", kdresRL);    
  fprintf(fw2, "kE = %d\n", kE); 
  if (typeb == 1) fprintf(fw2, "kmilkcE = %7.3f\n", kmilkcE); 
  fprintf(fw2, "\n");  
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "kmwRE[%d] = %f\n", j,kmwRE[j]);
  fprintf(fw2, "\n");
  fprintf(fw2, "kR = %d\n", kR);    
  fprintf(fw2, "\n");
  for (j = 1; j <= hs; j++) fprintf(fw2, "ktE[%d] = %f\n", j,ktE[j]);
  fprintf(fw2, "\n");
  for (j = 1; j <= hs; j++) fprintf(fw2, "ktL[%d] = %f\n", j,ktL[j]);
  fprintf(fw2, "\n");
  for (j = 1; j <= LL; j++)
    fprintf(fw2, "ktlp[%d] = %7.3f\n", j,ktlp[j]);
  fprintf(fw2, "\n");
  for (j = 0; j <= clt; j++)
    fprintf(fw2, "ktlsl[%d] = %7.3f\n", j,ktlsl[j]);
  fprintf(fw2, "\n");
  if (typew == 2) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "kwarL[%d][%d] = %7.3f\n", i,j,kwarL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "kwE = %8.3f\n", kwE);  
  fprintf(fw2, "\n");  
  if (fatpb + fatcb > 0) {
    for (i = 0; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "kwfL[%d][%d] = %7.3f\n", i,j,kwfL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  for (i = 1; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "kwrL[%d][%d] = %7.3f\n", i,j,kwrL[i][j]);
  }
  fprintf(fw2, "\n");  
  if (typew == 1) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "kwwL[%d][%d] = %7.3f\n", i,j,kwwL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "\n"); 
  fprintf(fw2, "L = %d\n", L);
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) fprintf(fw2, "l1E[%d] = %f\n", i,l1E[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 0; j <= crossing; j++) {
      for (k = 1; k <= clt; k++)
        if (fabs(l1L[i][j][k]) > 0.000001)
          fprintf(fw2, "l1L[%d][%d][%d] = %f\n", i,j,k,l1L[i][j][k]);
    }
  } 
  fprintf(fw2, "\n");  
  for (i = 1; i <= PP; i++) {
    for (j = 0; j <= crossing; j++) 
      if (fabs(l1skL[i][j]) > 0.000001)
      fprintf(fw2, "l1skL[%d][%d] = %f\n", i,j,l1skL[i][j]);
  } 
  fprintf(fw2, "\n");  
  for (i = 1; i <= TR; i++) fprintf(fw2, "l1R[%d] = %f\n", i,l1R[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "l1aR[%d][%d] = %f\n", i,j,l1aR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= LL; i++) fprintf(fw2, "l3E[%d] = %f\n", i,l3E[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL; i++) fprintf(fw2, "l4E[%d] = %f\n", i,l4E[i]);
  fprintf(fw2, "\n");  
  for (i = 1; i <= RR; i++) fprintf(fw2, "l4R[%d] = %f\n", i,l4R[i]);
  fprintf(fw2, "\n");  
  for (i = 1; i <= RR; i++) { 
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "l5R[%d][%d] = %f\n", i,j,l5R[i][j]);
    }
  fprintf(fw2, "\n");      
  if (typeb == 1) fprintf(fw2, "lengthmp = %d\n", lengthmp);
  fprintf(fw2, "lengthrc = %d\n", lengthrc);
  if (fatpb + fatcb > 0) {
    fprintf(fw2, "LF = %d\n", LF);
    fprintf(fw2, "\n");  
    for (i = 0; i < SP; i++)
      fprintf(fw2, "lf[%d] = %d\n", i,lf[i]);
    fprintf(fw2, "\n");  
  }
  fprintf(fw2, "LL = %d\n", LL);
  fprintf(fw2, "\n");  
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "lossfE[%d][%d] = %f\n", i,j,lossfE[i][j]);
  }
  fprintf(fw2, "\n");  
  for (i = 1; i <= fL; i++) {
    for (j = 1; j <= nfs; j++) 
      if (fabs(lossfL[i][j]) > 0.000001)
        fprintf(fw2, "lossfL[%d][%d] = %f\n", i,j,lossfL[i][j]);
  }
  fprintf(fw2, "\n");  
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "lossfR[%d][%d] = %f\n", i,j,lossfR[i][j]);
    }
  fprintf(fw2, "\n");  
  fprintf(fw2, "lpreg = %d\n", lpreg);
  if (typew == 2) fprintf(fw2, "manarL = %7.2f\n", manarL);
  fprintf(fw2, "manbL = %7.2f\n", manbL); 
  fprintf(fw2, "manE = %7.2f\n", manE);
  if (fatpb + fatcb > 0) fprintf(fw2, "manfL = %7.2f\n", manfL);
  fprintf(fw2, "manR = %7.2f\n", manR);
  fprintf(fw2, "\n");
  if (pricewL == 4) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "mcwwL[%d][%d] = %f\n", i,j,mcwwL[i][j]);
    }
    fprintf(fw2, "\n");
  }  
  if (typeb == 1) {
    fprintf(fw2, "milkch = %7.2f\n", milkch);
    fprintf(fw2, "\n");
  }      
  if (typeb == 1) {
    for (j = 1; j <= LL; j++)
      fprintf(fw2, "milkmpar[%d] = %7.3f\n", j,milkmpar[j]);
    fprintf(fw2, "\n");
  }
  if (typeb == 1) {
    for (i = 0; i <= clt; i++) {
      for (j = 1; j <= LL; j++)
	fprintf(fw2, "milkmrel[%d][%d] = %f\n", i,j,milkmrel[i][j]);
    } 
    fprintf(fw2, "\n");
  }
  if (typeb == 1) fprintf(fw2, "milkprice = %d\n", milkprice); 
  fprintf(fw2, "\n"); 
  if (pmilkwm > 0) {
    for (j = 1; j <= LL; j++)
      fprintf(fw2, "milksw[%d] = %7.3f\n", j,milksw[j]);
    fprintf(fw2, "\n");
  }
  for (j = 1; j <= nfs; j++)
    fprintf(fw2, "milkw0L[%d] = %8.4f\n", j,milkw0L[j]);
  fprintf(fw2, "\n");
  for (j = 1; j <= clt; j++) {
    for (k = 1; k <= nfs; k++)
      fprintf(fw2, "milkwL[%d][%d] = %8.4f\n", j,k,milkwL[j][k]);
    }
  fprintf(fw2, "\n");
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++)
      if (fabs(milkwrel[i][j]) > 0.000001)
        fprintf(fw2, "milkwrel[%d][%d] = %f\n", i,j,milkwrel[i][j]);
  } 
  fprintf(fw2, "\n");
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      for (k = 1; k <= nfs; k++)
        if (fabs(milkwsrel[i][j][k]) > 0.000001)
          fprintf(fw2, "milkwsrel[%d][%d][%d] = %f\n", i,j,k,milkwsrel[i][j][k]);
    }
  }
  fprintf(fw2, "\n");   
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++) {
      for (k = 1; k <= nfs; k++)
        if (fabs(milkws[i][j][k]) > 0.000001)
          fprintf(fw2, "milkws[%d][%d][%d] = %f\n", i,j,k,milkws[i][j][k]);
    }
  }
  fprintf(fw2, "\n"); 
  for (j = 1; j <= crossing; j++) {
    for (i = 1; i < SP; i++) 
      if (fabs(minw[i][j]) > 0.000001)
        fprintf(fw2, "minw[%d][%d] = %5.1f\n", i,j,minw[i][j]);
  }
  fprintf(fw2, "\n");   
  if (typeb == 1 && pmilkch > 0.000001) 
    fprintf(fw2, "moich = %7.1f\n", moich);   
  if (milkprice == 2 || milkprice > 3) {
    fprintf(fw2, "mSCS = %7.2f\n", mSCS);
    fprintf(fw2, "\n");
  }     
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "mwE[%d] = %5.1f\n", i,mwE[i]);
  fprintf(fw2, "mwE2 = %5.1f\n", mwE2);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "mwMP[%d] = %5.1f\n", i,mwMP[i]);
  fprintf(fw2, "\n");    
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "mwR[%d] = %5.1f\n", i,mwR[i]);
  fprintf(fw2, "\n");    
  fprintf(fw2, "N = %d\n", N);  
  fprintf(fw2, "\n");    
  for (i = 0; i <= crossing; i++) 
    fprintf(fw2, "Na24hL[%d] = %f\n", i,Na24hL[i]);
  fprintf(fw2, "\n");    
  for (i = 0; i <= crossing; i++) {
    for (j = 1; j <= clt; j++)
      fprintf(fw2, "na24hL[%d][%d] = %f\n", i,j,na24hL[i][j]);
  }
  fprintf(fw2, "\n");        
  if (typew == 2) { 
    for (i = 0; i <= crossing; i++) 
      fprintf(fw2, "NarL[%d] = %f\n", i,NarL[i]);
    fprintf(fw2, "\n");    
    for (i = 0; i <= crossing; i++) {
      for (j = 1; j <= clt; j++)
	fprintf(fw2, "narL[%d][%d] = %f\n", i,j,narL[i][j]);
    }
    fprintf(fw2, "\n");          
  }
  for (i = 0; i <= crossing; i++) 
    fprintf(fw2, "NbtL[%d] = %f\n", i,NbtL[i]);
  fprintf(fw2, "\n");    
  for (i = 0; i <= crossing; i++) {
    for (j = 1; j <= clt; j++)
      fprintf(fw2, "nbtL[%d][%d] = %f\n", i,j,nbtL[i][j]);
    }
  fprintf(fw2, "\n");    
  fprintf(fw2, "NCHFS = %d\n", NCHFS);  
  fprintf(fw2, "nchfs = %d\n", nchfs);  
  fprintf(fw2, "nchfst = %d\n", nchfst); 
  fprintf(fw2, "NCLCQ = %d\n", NCLCQ);
  fprintf(fw2, "NCLCW = %d\n", NCLCW);
  if (pricewL == 4) fprintf(fw2, "nclcqwL = %d\n", nclcqwL);       
  if (pricewL == 4) fprintf(fw2, "nclcwwL = %d\n", nclcwwL);  
  if (pricefL == 4) fprintf(fw2, "nclfcfL = %d\n", nclfcfL);        
  if (priceS == 4) fprintf(fw2, "nclfcS = %d\n", nclfcS); 
  if (pricewL == 4) fprintf(fw2, "nclfcwL = %d\n", nclfcwL);          
  if (pricefL == 2) fprintf(fw2, "nclfL = %d\n", nclfL);
  if (pricefL == 4) fprintf(fw2, "nclflfL = %d\n", nclflfL);         
  if (priceS == 4) fprintf(fw2, "nclflS = %d\n", nclflS); 
  if (pricewL == 4) fprintf(fw2, "nclflwL = %d\n", nclflwL);            
  if (priceS == 2) fprintf(fw2, "nclS = %d\n", nclS);  
  if (pricewL == 2) fprintf(fw2, "nclwL = %d\n", nclwL);  
  for (i = 1; i <= nfs; i++) fprintf(fw2, "nd[%d] = %d\n", i,nd[i]);
  fprintf(fw2, "\n");
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[k]; i++) {
	for (j = 1; j <= crossing; j++) 
	  fprintf(fw2, "ndiedfat[%d][%d][%d] = %f\n", k,i,j,ndiedfat[k][i][j]);
      }
    }
    fprintf(fw2, "\n");
  }  
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (fabs(nebL[j1][i][j][k][i2]) > 0.00001)
	    fprintf(fw2, "nebL[%d][%d][%d][%d][%d] = %f\n",
	      j1,i,j,k,i2,nebL[j1][i][j][k][i2]);
        }   
      }
    }
  }
  fprintf(fw2, "\n");          
  if (typew == 2) fprintf(fw2, "nectoparL = %7.2f\n", nectoparL);
  fprintf(fw2, "nectopclFP = %7.2f\n", nectopclFP);
  fprintf(fw2, "nectopE = %7.2f\n", nectopE);
  fprintf(fw2, "\n");  
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++ ) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "nectopf[%d][%d] = %f\n", k,i,nectopf[k][i]);
    }
    fprintf(fw2, "\n"); 
  }
  fprintf(fw2, "nectopR = %7.2f\n", nectopR);
  fprintf(fw2, "\n");
  for (i = 1; i <= 2; i++) fprintf(fw2, "nectoprL[%d] = %7.2f\n",i,nectoprL[i]);
  fprintf(fw2, "\n");  
  fprintf(fw2, "nectopwL = %7.2f\n", nectopwL);
  fprintf(fw2, "\n");
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "nedE[%d][%d] = %f\n", i,j,nedE[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= fL; i++) {
    for (j = 1; j <= nfs; j++) 
      if (fabs(nedL[i][j]) > 0.000001)
        fprintf(fw2, "nedL[%d][%d] = %f\n", i,j,nedL[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "nedR[%d][%d] = %f\n", i,j,nedR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i3 = 1; i3 <= LL; i3++) {
    for (j1 = 3; j1 <= nstgE; j1++) {
      if (j1 > 3 && i3 == LL) break;
      i = (i3 - 1) * nstgE + j1;
      for (k = 1; k <= fE; k++) {
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(neE[i][k][i2]) > 0.00001)    
	    fprintf(fw2, "neE[%d][%d][%d] = %f\n",i,k,i2,neE[i][k][i2]);
      }  
    }  
  }  
  fprintf(fw2, "\n");           
  if (flushabE + flushbbE > 0) {
  for (i3 = 1; i3 < LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      i = (i3 - 1) * nstgE + j;
      k = 3;
      for (i2 = 1; i2 <= nfs; i2++)    
        if (fabs(nefE[i][k][i2]) > 0.000001)
	  fprintf(fw2, "nefE[%d][%d][%d] = %f\n",i,k,i2,nefE[i][k][i2]);
      }	
    }
    fprintf(fw2, "\n");           
  }  
  if (flushabL + flushbbL > 0) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (nefL[i][j][k][i2] > 0.00001)
	      fprintf(fw2, "nefL[%d][%d][%d][%d] = %f\n",
		i,j,k,i2,nefL[i][j][k][i2]);
        }   
      }
    }
    fprintf(fw2, "\n"); 
  }
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (negbL[j1][i][j][k][i2] > 0.00001)
	    fprintf(fw2, "negbL[%d][%d][%d][%d][%d] = %f\n",
	      j1,i,j,k,i2,negbL[j1][i][j][k][i2]);
	}   
      }
    }
  } 
  fprintf(fw2, "\n");         
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (negL[i][j][k][i2] > 0.00001)
	  fprintf(fw2, "negL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,negL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (negL14m[j][i2] > 0.00001)
        fprintf(fw2, "negL14m[%d][%d] = %f\n",j,i2,negL14m[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (negL14nm[j][i2] > 0.00001)
        fprintf(fw2, "negL14nm[%d][%d] = %f\n",j,i2,negL14nm[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (i = 3; i <= nstgE; i++) {
    for (k = 1; k <= fE; k++) {    
      for (i2 = 1; i2 <= nfs; i2++) 
        if (fabs(neglE[i][k][i2]) > 0.000001)   
        fprintf(fw2, "neglE[%d][%d][%d] = %f\n",i,k,i2,neglE[i][k][i2]);
    }
  }	
  fprintf(fw2, "\n");             
  for (i = 3; i <= nstgE; i++) {
    for (k = 1; k <= fE; k++) {    
      for (i2 = 1; i2 <= nfs; i2++)
        if (fabs(negnlE[i][k][i2]) > 0.000001) 
        fprintf(fw2, "negnlE[%d][%d][%d] = %f\n",i,k,i2,negnlE[i][k][i2]);
    }
  }
  fprintf(fw2, "\n");             	
  for (i3 = 1; i3 <= RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)  
	  if (fabs(negR[i][j][k][i2]) > 0.000001)  
          fprintf(fw2, "negR[%d][%d][%d][%d] = %f\n",i,j,k,i2,negR[i][j][k][i2]);
      }
    }
  } 
  fprintf(fw2, "\n");     
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(neL[i][j][k][i2]) > 0.00001)
	  fprintf(fw2, "neL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,neL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");     
  for (j = 0; j <= clt; j++) {
    for (i3 = 1; i3 <= LL; i3++) {
      for (j1 = 3; j1 <= nstgE; j1++) {
        if (j1 > 3 && i3 == LL) break;
	i = (i3 - 1) * nstgE + j1;
        if (j <= 1) k = 1;
	  else k = 2;  
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(nelbE[j][i][k][i2]) > 0.000001) 
          fprintf(fw2, "nelbE[%d][%d][%d][%d] = %f\n",j,i,k,i2,
	    nelbE[j][i][k][i2]);
      }  
    }      
  }
  fprintf(fw2, "\n");       
  for (i3 = 1; i3 <= LL; i3++) {
    for (j1 = 3; j1 <= nstgE; j1++) {
      if (j1 > 3 && i3 == LL) break;
      i = (i3 - 1) * nstgE + j1;
      for (k = 1; k <=2; k++) {
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(nelE[i][k][i2]) > 0.000001) 
	  fprintf(fw2, "nelE[%d][%d][%d] = %f\n",i,k,i2,
	    nelE[i][k][i2]);
      }  
    }  
  } 
  fprintf(fw2, "\n");              
  for (j = 1; j <= clt; j++) {
    for (k = 1; k <= nfs; k++)
      if (fabs(nelwL[j][k]) > 0.000001)
      fprintf(fw2, "nelwL[%d][%d] = %10.4f\n", j,k,nelwL[j][k]);
  }
  fprintf(fw2, "\n");
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (nembL[j1][i][j][k][i2] > 0.00001)
	    fprintf(fw2, "nembL[%d][%d][%d][%d][%d] = %f\n",
	      j1,i,j,k,i2,nembL[j1][i][j][k][i2]);
        }   
      }
    }
  } 
  fprintf(fw2, "\n");         
  fprintf(fw2, "nemilk = %8.3f\n", nemilk);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (nemL[i][j][k][i2] > 0.00001)
	  fprintf(fw2, "nemL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,nemL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n"); 
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (nemL14m[j][i2] > 0.00001)
        fprintf(fw2, "nemL14m[%d][%d] = %f\n",j,i2,nemL14m[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (nemL14nm[j][i2] > 0.00001)
        fprintf(fw2, "nemL14nm[%d][%d] = %f\n",j,i2,nemL14nm[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(nemlE[i][k][i2]) > 0.000001)  
          fprintf(fw2, "nemlE[%d][%d][%d] = %f\n",i,k,i2,nemlE[i][k][i2]);
      }
    }	
  }  
  fprintf(fw2, "\n");             
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(nemnlE[i][k][i2]) > 0.000001)    
          fprintf(fw2, "nemnlE[%d][%d][%d] = %f\n",i,k,i2,nemnlE[i][k][i2]);
      }
    }	
  } 
  fprintf(fw2, "\n");         
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(nemR[i][j][k][i2]) > 0.000001)    
          fprintf(fw2, "nemR[%d][%d][%d][%d] = %f\n",i,j,k,i2,nemR[i][j][k][i2]);
      }
    }
  }      
  fprintf(fw2, "\n");     
  if (typew == 2) fprintf(fw2, "nendoparL = %7.2f\n", nendoparL);
  fprintf(fw2, "nendopclFP = %7.2f\n", nendopclFP);
  fprintf(fw2, "nendopE = %7.2f\n", nendopE);  
  if (fatpb + fatcb > 0) {
    fprintf(fw2, "\n");  
    for (k = 0; k < SP; k++ ) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "nendopf[%d][%d] = %f\n", k,i,nendopf[k][i]);
    }
    fprintf(fw2, "\n");  
  }
  fprintf(fw2, "nendopR = %7.2f\n", nendopR); 
  fprintf(fw2, "\n");
  for (i = 1; i <= 2; i++) fprintf(fw2, "nendoprL[%d] = %7.2f\n",i,nendoprL[i]);
  fprintf(fw2, "\n");  
  fprintf(fw2, "nendopwL = %7.2f\n", nendopwL);
  fprintf(fw2, "\n");
  for (j = 1; j <= clt; j++) {
    for (i3 = 1; i3 < LL; i3++) {
      i = i3 * nstgE;
      for (k = 4; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(nepbE[j][i][k][i2]) > 0.000001)  
          fprintf(fw2, "nepbE[%d][%d][%d][%d] = %f\n",j,i,k,i2,
	    nepbE[j][i][k][i2]);
      }
    }      
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 < LL; i3++) {
    i = i3 * nstgE;
    for (k = 4; k <= fE; k++) {    
      for (i2 = 1; i2 <= nfs; i2++)  
        if (fabs(nepE[i][k][i2]) > 0.000001)  
        fprintf(fw2, "nepE[%d][%d][%d] = %f\n",i,k,i2,nepE[i][k][i2]);
    }
  } 
  fprintf(fw2, "\n");            
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (nepbL[j1][i][j][k][i2] > 0.00001)
	    fprintf(fw2, "nepbL[%d][%d][%d][%d][%d] = %f\n",
	      j1,i,j,k,i2,nepbL[j1][i][j][k][i2]);
        }   
      }
    }
  } 
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (nepL[i][j][k][i2] > 0.00001)
	  fprintf(fw2, "nepL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,nepL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(neR[i][j][k][i2]) > 0.000001)   
          fprintf(fw2, "neR[%d][%d][%d][%d] = %f\n",i,j,k,i2,neR[i][j][k][i2]);
      }
    }
  }
  fprintf(fw2, "\n");          
  for (j1 = 1; j1 <= clt; j1++) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (newbL[j1][i][j][k][i2] > 0.00001)
	    fprintf(fw2, "newbL[%d][%d][%d][%d][%d] = %f\n",
	      j1,i,j,k,i2,newbL[j1][i][j][k][i2]);
	}   
      }
    }
  } 
  fprintf(fw2, "\n");         
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "neweR[%d] = %f\n", i,neweR[i]);
  fprintf(fw2, "\n");     
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (newL[i][j][k][i2] > 0.00001)
	  fprintf(fw2, "newL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,newL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n"); 
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (newL14m[j][i2] > 0.00001)
        fprintf(fw2, "newL14m[%d][%d] = %f\n",j,i2,newL14m[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (newL14nm[j][i2] > 0.00001)
        fprintf(fw2, "newL14nm[%d][%d] = %f\n",j,i2,newL14nm[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;    
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(newlE[i][k][i2]) > 0.000001)   
          fprintf(fw2, "newlE[%d][%d][%d] = %f\n",i,k,i2,newlE[i][k][i2]);
      }
    }	
  }      
  fprintf(fw2, "\n");       
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;    
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(newnlE[i][k][i2]) > 0.000001)    
          fprintf(fw2, "newnlE[%d][%d][%d] = %f\n",i,k,i2,newnlE[i][k][i2]);
      }
    }	
  } 
  fprintf(fw2, "\n");            
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)   
	  if (fabs(newR[i][j][k][i2]) > 0.000001) 
          fprintf(fw2, "newR[%d][%d][%d][%d] = %f\n",i,j,k,i2,newR[i][j][k][i2]);
      }
    }
  }      
  fprintf(fw2, "\n");     
  if (typeb == 1) {
    fprintf(fw2, "NFAT = %d\n", NFAT);
    fprintf(fw2, "nfat = %d\n", nfat);    
    fprintf(fw2, "\n");  
  }
  if (fatpb + fatcb > 0) {  
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[1]; i++) {
	for (j = 1; j <= crossing; j++) 
	  fprintf(fw2, "nfattar[%d][%d][%d] = %f\n", k,i,j,nfattar[k][i][j]);
      }
    }
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "NFS = %d\n", NFS);
  fprintf(fw2, "nfs = %d\n", nfs);  
  fprintf(fw2, "\n");  
  for (k = 1; k < SP; k++) {
    fprintf(fw2, "nherd[%d] = %f\n", k,nherd[k]);
  }
  fprintf(fw2, "\n");    
  fprintf(fw2, "Nlamb = %f\n", Nlamb);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "nmatFP[%d][%d] = %f\n", i,j,nmatFP[i][j]);
  }
  fprintf(fw2, "\n");
  if (typeb == 1) {
    fprintf(fw2, "NPROT = %d\n", NPROT);  
    fprintf(fw2, "nprot = %d\n", nprot);
  }
  fprintf(fw2, "npurchFP = %f\n", npurchFP);
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "npurchMP[%d] = %f\n", i,npurchMP[i]);
  fprintf(fw2, "\n");       
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "nramMP[%d] = %f\n", i,nramMP[i]);
  fprintf(fw2, "\n");    
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "nrcull[%d][%d][%d] = %f\n", k,i,j,nrcull[k][i][j]);
    }
  }
  fprintf(fw2, "\n");    
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "nrdied[%d][%d][%d] = %f\n", k,i,j,nrdied[k][i][j]);
    }
  }
  fprintf(fw2, "\n");  
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "nrdiedmlFP[%d] = %f\n", i,nrdiedmlFP[i]);
  fprintf(fw2, "\n");
  if (pinsE[1] + pinsE[2] + pinsFP[1] + pinsFP[2] > 0.00001) {   
    fprintf(fw2, "nreins = %d\n", nreins);
    fprintf(fw2, "\n");      
  }
  for (i = 1; i <= bs[1]; i++) {
    fprintf(fw2, "nrmatFP[%d] = %f\n", i,nrmatFP[i]);
  }
  fprintf(fw2, "\n");
  if (typeb == 1) {
    fprintf(fw2, "NSCC = %d\n", NSCC);
    fprintf(fw2, "nSCC = %d\n", nSCC);    
  }
  if (typew == 2) fprintf(fw2, "nshearL = %7.1f\n", nshearL);  
  fprintf(fw2, "nsheE = %7.1f\n", nsheE);  
  if (fatpb + fatcb > 0) {
    fprintf(fw2, "\n");      
    for (k = 0; k < SP; k++ ) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "nshefL[%d][%d] = %7.1f\n", k,i,nshefL[k][i]);
    }
    fprintf(fw2, "\n");  
  }
  fprintf(fw2, "nsheFP = %7.1f\n", nsheFP);
  fprintf(fw2, "\n");  
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "nsheR[%d] = %7.1f\n", i,nsheR[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) 
    fprintf(fw2, "nsherL[%d] = %7.1f\n", i,nsherL[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "nshewL = %7.1f\n", nshewL);    
  fprintf(fw2, "nsl = %d\n", nsl);     
  fprintf(fw2, "\n");
  a2 = 0;
  for (k = 1; k < SP; k++) {
    for (i = k-1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++) {
        if (fabs(nsold[k][i][j]) > 0.000001)
	  fprintf(fw2, "nsold[%d][%d][%d] = %f\n", k,i,j,nsold[k][i][j]);
	a2 += nsold[k][i][j];  
      }	  
    }
  }
  if (a2 > 0.000001) fprintf(fw2, "\n");
  if (prods == 2 && ((breed == 2 && calc == 1) || (breed == 1 && calc == 2))) {
    fprintf(fw2, "nsoldMPA = %10.5f\n", nsoldMPA);  
    fprintf(fw2, "\n");
  }  
  a2 = 0;
  for (k = 0; k < SP; k++) {
    for (i = 1; i <= csp[k]; i++) {
      for (j = 1; j <= crossing; j++) {
        if (fabs(nsp[k][i][j]) > 0.000001)
	  fprintf(fw2, "nsp[%d][%d][%d] = %f\n", k,i,j,nsp[k][i][j]);
	a2 += nsp[k][i][j];
      }  
    }
  }
  if (a2 > 0.000001) fprintf(fw2, "\n");
  a2 = 0;  
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++) {
        if (fabs(nspcull[k][i][j]) > 0.000001)	
	  fprintf(fw2, "nspcull[%d][%d][%d] = %f\n", k,i,j,nspcull[k][i][j]);
        a2 += nspcull[k][i][j];	
      }	
    }
  } 
  if (a2 > 0.000001) fprintf(fw2, "\n");
  a2 = 0;  
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++) {
        if (fabs(nspdied[k][i][j]) > 0.000001)	
          fprintf(fw2, "nspdied[%d][%d][%d] = %f\n", k,i,j,nspdied[k][i][j]);
	a2 += nspdied[k][i][j];
      }
    }
  }
  if (a2 > 0.000001) fprintf(fw2, "\n");  
  fprintf(fw2, "nstg1E = %d\n", nstg1E);
  fprintf(fw2, "nstg1R = %d\n", nstg1R);
  fprintf(fw2, "nstg2E = %d\n", nstg2E);
  fprintf(fw2, "nstg2R = %d\n", nstg2R);
  fprintf(fw2, "nstgE = %d\n", nstgE);
  fprintf(fw2, "nstgR = %d\n", nstgR);
  fprintf(fw2, "NT = %d\n", NT);  
  fprintf(fw2, "\n");
  for (i = 0; i <= crossing; i++) 
    fprintf(fw2, "NwL[%d] = %f\n", i,NwL[i]);
  fprintf(fw2, "\n");    
  for (i = 0; i <= crossing; i++) {
    for (j = 1; j <= clt; j++)
      fprintf(fw2, "nwL[%d][%d] = %f\n", i,j,nwL[i][j]);
  }
  fprintf(fw2, "\n");    
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "nwsp[%d][%d] = %f\n", k,i,nwsp[k][i]);
  }  
  fprintf(fw2, "\n");
  fprintf(fw2, "opsbL = %d\n", opsbL);
  if (typew == 2)  {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "parL[%d][%d] = %f\n", i,j,parL[i][j]);
    }
    fprintf(fw2, "\n");    
  }
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pbarrE[%d] = %f\n", i,pbarrE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) {
    for (j = 0; j <= crossing; j++)
      fprintf(fw2, "pbarrFP[%d][%d] = %f\n", i,j,pbarrFP[i][j]);
  }
  fprintf(fw2, "\n");  
  for (i = 1; i <= clt; i++) {
    for (j = 0; j <= i; j++)
    fprintf(fw2, "pbtba[%d][%d] = %f\n", i,j,pbtba[i][j]);
  }
  fprintf(fw2, "\n");    
  if (lf[0] > 0.000001) {
    fprintf(fw2, "pcastMP = %f\n", pcastMP);
    fprintf(fw2, "\n");
  }  
  a2 = 0;
  for (i = 1; i < N; i++) {
    if (fabs(pcl0[i] > 0.000001)) 
      fprintf(fw2, "pcl0[%d] = %9.4f\n", i,pcl0[i]);
    a2 += pcl0[i];  
  }    
  if (a2 > 0) fprintf(fw2, "\n");      
  a2 = 0;
  for (i = 1; i < N; i++) {  
    for (j = 1; j < N; j++) {
      if (fabs(pcl00[i][j]) > 0.000001)
        fprintf(fw2, "pcl00[%d][%d] = %10.4f\n", i,j,pcl00[i][j]);
      a2 += pcl00[i][j];
    }	
  }
  if (a2 > 0) fprintf(fw2, "\n");      
  a2 = 0;
  for (i = 1; i < N; i++) {  
    for (j = 1; j < N; j++) {
      if (fabs(pcl11[i][j]) > 0.000001)
        fprintf(fw2, "pcl11[%d][%d] = %10.4f\n", i,j,pcl11[i][j]);
      a2 += pcl00[i][j];
    }	
  }
  if (a2 > 0) fprintf(fw2, "\n");      
  if (pricewL == 4) {
    for (i = 1; i <= nclcwwL; i++) {
      for (k = 1; k <= nclcqwL; k++) {
        for (j = 1; j <= crossing; j++)
	  fprintf(fw2, "pclcqwL[%d][%d][%d] = %9.4f\n", i,k,j,pclcqwL[i][k][j]);
      }	
    }
    fprintf(fw2, "\n");      
  }
  if (pricewL == 4) {
    for (i = 1; i <= 2; i++) {
      for (k = 1; k <= nclcwwL; k++) {
        for (i2 = 1; i2 <= nclcqwL; i2++) {      
          for (j = 1; j <= crossing; j++)
	    fprintf(fw2, "pclcwL[%d][%d][%d][%d] = %9.4f\n",
	      i,k,i2,j,pclcwL[i][k][i2][j]);
        }
      }
    }
    fprintf(fw2, "\n");            	
  }
  if (pricewL == 4) {
    k7 = nclcwwL + 1;
    for (i = 1; i <= 2; i++) {
      for (k = 1; k <= k7; k++) {
        for (j = 1; j <= crossing; j++)
	  fprintf(fw2, "pclcwwL[%d][%d][%d] = %9.4f\n", i,k,j,pclcwwL[i][k][j]);
      }	
    }
    fprintf(fw2, "\n");      
  }
  if (pricefL == 4) {
    for (k = 1; k <= crossing; k++) {  
      for (i = 1; i <= nclflfL; i++) {  
	for (j = 1; j <= nclfcfL; j++)
	  if (fabs(pclfcfL[k][i][j]) > 0.000001)
            fprintf(fw2, "pclfcfL[%d][%d][%d] = %9.4f\n", 
	      k,i,j,pclfcfL[k][i][j]);
      }
    }
    fprintf(fw2, "\n");      
  }
  if (priceS == 4) {
    for (k = 1; k <= crossing; k++) {  
      for (i = 1; i <= nclflS; i++) {  
	for (j = 1; j <= nclfcS; j++)
	  if (fabs(pclfcS[k][i][j]) > 0.000001)
            fprintf(fw2, "pclfcS[%d][%d][%d] = %9.4f\n", k,i,j,pclfcS[k][i][j]);
      }
    }
    fprintf(fw2, "\n");      
  }
  if (pricewL == 4) {
    for (k = 1; k <= crossing; k++) {  
      for (i = 1; i <= nclflwL; i++) {  
	for (j = 1; j <= nclfcwL; j++)
	  if (fabs(pclfcwL[k][i][j]) > 0.000001)
            fprintf(fw2, "pclfcwL[%d][%d][%d] = %9.4f\n", 
	      k,i,j,pclfcwL[k][i][j]);
      }
    }
    fprintf(fw2, "\n");      
  }
  if (pricefL == 2) {
    for (j = 1; j <= crossing; j++) {
      for (i = 1; i <= nclfL; i++) 
        fprintf(fw2, "pclfL[%d][%d] = %9.4f\n", j,i,pclfL[j][i]);
    }
    fprintf(fw2, "\n");      
  }
  if (priceS == 2) {
    for (j = 1; j <= crossing; j++) {
      for (i = 1; i <= nclS; i++) 
        fprintf(fw2, "pclS[%d][%d] = %9.4f\n", j,i,pclS[j][i]);
    }
    fprintf(fw2, "\n");      
  }
  if (pricewL == 2) {
    for (j = 1; j <= crossing; j++) {
      for (i = 1; i <= nclwL; i++) 
        fprintf(fw2, "pclwL[%d][%d] = %9.4f\n", j,i,pclwL[j][i]);
    }
    fprintf(fw2, "\n");      
  }
  a2 = 0;
  for (i = 1; i < N; i++) {
    if (fabs(pclwLql[i]) > 0.000001) 
      fprintf(fw2, "pclwLql[%d] = %9.4f\n", i,pclwLql[i]);
    a2 += fabs(pclwLql[i]);   
  }    
  if (a2 > 0.000001) fprintf(fw2, "\n");      
  a2 = 0;
  for (i = 1; i < N; i++) { 
    if (fabs(pclwLqm[i]) > 0.000001)   
      fprintf(fw2, "pclwLqm[%d] = %9.4f\n", i,pclwLqm[i]);
    a2 += fabs(pclwLqm[i]);  
  }    
  if (a2 > 0.000001) fprintf(fw2, "\n");      
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pconE[%d] = %f\n", i,pconE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pconstayE[%d] = %f\n", i,pconstayE[i]);
  fprintf(fw2, "\n");
  if (crossing == 2) {
    for (i = 0; i < LL; i++) 
      fprintf(fw2, "pcrossE[%d] = %f\n", i,pcrossE[i]);
    fprintf(fw2, "\n");
    fprintf(fw2, "pcrosst = %f\n", pcrosst);
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "pctE[%d] = %f\n", i,pctE[i]);
  fprintf(fw2, "\n");    
  for (i = 1; i <= LL; i++) 
    fprintf(fw2, "pcullE[%d] = %f\n", i,pcullE[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "pcullfcE0 = %f\n", pcullfcE0);
  fprintf(fw2, "pcullfcEp = %f\n", pcullfcEp);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL; i++) 
    fprintf(fw2, "pcullhE[%d] = %f\n", i,pcullhE[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "pcullhE0 = %f\n", pcullhE0);
  fprintf(fw2, "pcullhEp = %f\n", pcullhEp);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL; i++) 
    fprintf(fw2, "pcullmE[%d] = %f\n", i,pcullmE[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "pcullmE0 = %f\n", pcullmE0);
  fprintf(fw2, "pcullmEp = %f\n", pcullmEp);
  fprintf(fw2, "\n");
  for (i = 1; i <= RR; i++) 
    fprintf(fw2, "pcullR[%d] = %f\n", i,pcullR[i]);
  fprintf(fw2, "\n");
  if (prods > 1 && calc == 1) fprintf(fw2, "pdA = %8.3f\n", pdA);
  if (prods > 1 && calc == 1) fprintf(fw2, "pdB = %8.3f\n", pdB); 
  if (prods > 1 && calc == 1) fprintf(fw2, "\n");
  if (feedcost == 1) {
    for (j1 = 1; j1 <= clt; j1++) {
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (fabs(pdibL[j1][i][j][k][i2]) > 0.00001)
	      fprintf(fw2, "pdibL[%d][%d][%d][%d][%d] = %f\n",
		j1,i,j,k,i2,pdibL[j1][i][j][k][i2]);
	  }   
        }
      }
    }
    fprintf(fw2, "\n");      
    for (i = 1; i <= fE; i++) {
      for (j = 1; j <= nfs; j++)
        fprintf(fw2, "pdidE[%d][%d] = %f\n", i,j,pdidE[i][j]);
    }
    fprintf(fw2, "\n");
    for (i = 1; i <= fL; i++) {
      for (j = 1; j <= nfs; j++) 
        if (fabs(pdidL[i][j] > 0.000001))
	  fprintf(fw2, "pdidL[%d][%d] = %f\n", i,j,pdidL[i][j]);
    }
    fprintf(fw2, "\n");
    for (i = 1; i <= fR; i++) {
      for (j = 1; j <= nfs; j++) 
	fprintf(fw2, "pdidR[%d][%d] = %f\n", i,j,pdidR[i][j]);
    }
    fprintf(fw2, "\n");
    for (i3 = 1; i3 <= LL; i3++) {
      for (j1 = 3; j1 <= nstgE; j1++) {
	if (j1 > 3 && i3 == LL) break;
	i = (i3 - 1) * nstgE + j1;
	for (k = 1; k <= fE; k++) {
	  for (i2 = 1; i2 <= nfs; i2++)   
	    if (fabs(pdiE[i][k][i2]) > 0.000001) 
	    fprintf(fw2, "pdiE[%d][%d][%d] = %f\n",i,k,i2,pdiE[i][k][i2]);
	}  
      }  
    }
    fprintf(fw2, "\n");           
  }
  if (typew == 2) { 
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "pdiedarL[%d][%d] = %f\n", i,j,pdiedarL[i][j]);
      }
    fprintf(fw2, "\n"); 
  }
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "pdiedbL[%d][%d] = %f\n", i,j,pdiedbL[i][j]);
  }
  fprintf(fw2, "\n"); 
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= i; j++)
    fprintf(fw2, "pdiedbtL[%d][%d] = %f\n", i,j,pdiedbtL[i][j]);
  }
  fprintf(fw2, "\n");    
  for (i = 1; i <= LL; i++) 
    fprintf(fw2, "pdiedE[%d] = %f\n", i,pdiedE[i]);
  fprintf(fw2, "\n"); 
  fprintf(fw2, "pdiedE0 = %f\n", pdiedE0);
  fprintf(fw2, "pdiedEp = %f\n", pdiedEp);
  fprintf(fw2, "\n"); 
  for (i = 1; i <= RR; i++) 
    fprintf(fw2, "pdiedR[%d] = %f\n", i,pdiedR[i]);
  fprintf(fw2, "\n"); 
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= crossing; j++)  
      fprintf(fw2, "pdiedwL[%d][%d] = %f\n", i,j,pdiedwL[i][j]);
    }
  fprintf(fw2, "\n"); 
  if (feedcost == 1) {
    if (flushabE + flushbbE > 0) {
      for (i3 = 1; i3 < LL; i3++) {
	for (j = 3; j <= nstgE; j++) {
	  i = (i3 - 1) * nstgE + j;
	  k = 3;
	  for (i2 = 1; i2 <= nfs; i2++)   
	    if (fabs(pdifE[i][k][i2]) > 0.000001) 
            fprintf(fw2, "pdifE[%d][%d][%d] = %f\n",i,k,i2,pdifE[i][k][i2]);
	}	
      }
      fprintf(fw2, "\n");           
    }
    if (flushabL + flushbbL > 0) { 
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (pdifL[i][j][k][i2] > 0.00001)
	      fprintf(fw2, "pdifL[%d][%d][%d][%d] = %f\n",
		i,j,k,i2,pdifL[i][j][k][i2]);
	  }   
        }
      }
      fprintf(fw2, "\n");     
    }
    for (j1 = 1; j1 <= clt; j1++) {
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (pdigbL[j1][i][j][k][i2] > 0.00001)
	      fprintf(fw2, "pdigbL[%d][%d][%d][%d][%d] = %f\n",
		j1,i,j,k,i2,pdigbL[j1][i][j][k][i2]);
	  }   
        }
      }
    }
    fprintf(fw2, "\n");     	 
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (pdigL[i][j][k][i2] > 0.00001)
	    fprintf(fw2, "pdigL[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,pdigL[i][j][k][i2]);
	  }   
        }
      }
    fprintf(fw2, "\n");     
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdigL14m[j][i2] > 0.00001)
          fprintf(fw2, "pdigL14m[%d][%d] = %f\n",j,i2,pdigL14m[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdigL14nm[j][i2] > 0.00001)
          fprintf(fw2, "pdigL14nm[%d][%d] = %f\n",j,i2,pdigL14nm[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (i = 3; i <= nstgE; i++) {
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(pdiglE[i][k][i2]) > 0.000001) 
          fprintf(fw2, "pdiglE[%d][%d][%d] = %f\n",i,k,i2,pdiglE[i][k][i2]);
      }
    }	
    fprintf(fw2, "\n");
    for (i = 3; i <= nstgE; i++) {
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)
	  if (fabs(pdignlE[i][k][i2]) > 0.000001)
          fprintf(fw2, "pdignlE[%d][%d][%d] = %f\n",i,k,i2,pdignlE[i][k][i2]);
      }
    }
    fprintf(fw2, "\n");             	
    for (i3 = 1; i3 <= RR; i3++) {
      i = 2 * i3;
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fR; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)   
	    if (fabs(pdigR[i][j][k][i2]) > 0.000001) 
            fprintf(fw2, "pdigR[%d][%d][%d][%d] = %f\n",i,j,k,i2,pdigR[i][j][k][i2]);
        }
      }
    }
    fprintf(fw2, "\n");             
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (fabs(pdiL[i][j][k][i2]) > 0.00001)
	    fprintf(fw2, "pdiL[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,pdiL[i][j][k][i2]);
	  }   
        }
      }
    fprintf(fw2, "\n");     
    for (j = 0; j <= clt; j++) {
      for (i3 = 1; i3 <= LL; i3++) {
	for (j1 = 3; j1 <= nstgE; j1++) {
          if (j1 > 3 && i3 == LL) break;
	  i = (i3 - 1) * nstgE + j1;
          if (j <= 1) k = 1;
	    else k = 2;  
	  for (i2 = 1; i2 <= nfs; i2++)  
	    if (fabs(pdilbE[j][i][k][i2]) > 0.000001)  
              fprintf(fw2, "pdilbE[%d][%d][%d][%d] = %f\n",j,i,k,i2,
		pdilbE[j][i][k][i2]);
        }  
      }      
    }
    fprintf(fw2, "\n");       
    for (i3 = 1; i3 <= LL; i3++) {
      for (j1 = 3; j1 <= nstgE; j1++) {
	if (j1 > 3 && i3 == LL) break;
	i = (i3 - 1) * nstgE + j1;
	for (k = 1; k <=2; k++) {
	  for (i2 = 1; i2 <= nfs; i2++) 
            if (fabs(pdilE[i][k][i2]) > 0.000001)   
	    fprintf(fw2, "pdilE[%d][%d][%d] = %f\n",i,k,i2,
	      pdilE[i][k][i2]);
	}  
      }  
    }      
    fprintf(fw2, "\n");       
    for (j = 1; j <= clt; j++) {
      for (k = 1; k <= nfs; k++)
        if (fabs(pdilwL[j][k]) > 0.000001)
	fprintf(fw2, "pdilwL[%d][%d] = %10.4f\n", j,k,pdilwL[j][k]);
    }
    fprintf(fw2, "\n");
    for (j1 = 1; j1 <= clt; j1++) {
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (pdimbL[j1][i][j][k][i2] > 0.00001)
		fprintf(fw2, "pdimbL[%d][%d][%d][%d][%d] = %f\n",
		  j1,i,j,k,i2,pdimbL[j1][i][j][k][i2]);
	  }   
        }
      }
    } 
    fprintf(fw2, "\n");     
    fprintf(fw2, "pdimilk = %8.4f\n", pdimilk);  
    fprintf(fw2, "\n");
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (pdimL[i][j][k][i2] > 0.00001)
	      fprintf(fw2, "pdimL[%d][%d][%d][%d] = %f\n",
		i,j,k,i2,pdimL[i][j][k][i2]);
	}   
      }
    }
    fprintf(fw2, "\n");     
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdimL14m[j][i2] > 0.00001)
          fprintf(fw2, "pdimL14m[%d][%d] = %f\n",j,i2,pdimL14m[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdimL14nm[j][i2] > 0.00001)
          fprintf(fw2, "pdimL14nm[%d][%d] = %f\n",j,i2,pdimL14nm[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 <= LL; i3++) {
      for (j = 3; j <= nstgE; j++) {
	if (i3 == LL && j > nstg1E) break;
	i = (i3 - 1) * nstgE + j;
	for (k = 1; k <= fE; k++) {    
	  for (i2 = 1; i2 <= nfs; i2++)   
	    if (fabs(pdimlE[i][k][i2]) > 0.000001) 
            fprintf(fw2, "pdimlE[%d][%d][%d] = %f\n",i,k,i2,pdimlE[i][k][i2]);
	}
      }	
    } 
    fprintf(fw2, "\n");            
    for (i3 = 1; i3 <= LL; i3++) {
      for (j = 3; j <= nstgE; j++) {
	if (i3 == LL && j > nstg1E) break;
	i = (i3 - 1) * nstgE + j;
	for (k = 1; k <= fE; k++) {    
	  for (i2 = 1; i2 <= nfs; i2++)  
	    if (fabs(pdimnlE[i][k][i2]) > 0.000001)  
              fprintf(fw2, "pdimnlE[%d][%d][%d] = %f\n",i,k,i2,pdimnlE[i][k][i2]);
	}
      }	
    }
    fprintf(fw2, "\n");             
    for (i3 = 1; i3 < 2*RR; i3++) {
      i = 2 * i3;
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fR; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)    
	    if (fabs(pdimR[i][j][k][i2]) > 0.000001)
            fprintf(fw2, "pdimR[%d][%d][%d][%d] = %f\n",i,j,k,i2,pdimR[i][j][k][i2]);
        }
      }
    } 
    fprintf(fw2, "\n");            
    for (j = 1; j <= clt; j++) {
      for (i3 = 1; i3 < LL; i3++) {
	i = i3 * nstgE;
	for (k = 4; k <= fE; k++) {    
	  for (i2 = 1; i2 <= nfs; i2++)  
	    if (fabs(pdipbE[j][i][k][i2]) > 0.000001)  
            fprintf(fw2, "pdipbE[%d][%d][%d][%d] = %f\n",j,i,k,i2,
	      pdipbE[j][i][k][i2]);
	}
      }      
    }
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 < LL; i3++) {
      i = i3 * nstgE;
      for (k = 4; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++)    
	  if (fabs(pdipE[i][k][i2]) > 0.000001)
            fprintf(fw2, "pdipE[%d][%d][%d] = %f\n",i,k,i2,pdipE[i][k][i2]);
      }
    }
    fprintf(fw2, "\n");             
    for (j1 = 1; j1 <= clt; j1++) {
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (pdipbL[j1][i][j][k][i2] > 0.00001)
	      fprintf(fw2, "pdipbL[%d][%d][%d][%d][%d] = %f\n",
		j1,i,j,k,i2,pdipbL[j1][i][j][k][i2]);
	  }   
        }
      }
    } 
    fprintf(fw2, "\n");     	
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (pdipL[i][j][k][i2] > 0.00001)
	    fprintf(fw2, "pdipL[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,pdipL[i][j][k][i2]);
	}   
      }
    }
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 < 2*RR; i3++) {
      i = 2 * i3;
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fR; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)   
	    if (fabs(pdiR[i][j][k][i2]) > 0.000001) 
            fprintf(fw2, "pdiR[%d][%d][%d][%d] = %f\n",i,j,k,i2,pdiR[i][j][k][i2]);
        }
      }
    } 
    fprintf(fw2, "\n");        
    for (j1 = 1; j1 <= clt; j1++) {
      for (i = 1; i <= PP; i++) {
	for (j = 1; j <= crossing; j++) {  
	  for (k = 1; k <= fL; k++) {    
            for (i2 = 1; i2 <= nfs; i2++) 
	      if (pdiwbL[j1][i][j][k][i2] > 0.00001)
	      fprintf(fw2, "pdiwbL[%d][%d][%d][%d][%d] = %f\n",
		j1,i,j,k,i2,pdiwbL[j1][i][j][k][i2]);
	  }   
        }
      }
    } 
    fprintf(fw2, "\n");     
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fL; k++) {    
          for (i2 = 1; i2 <= nfs; i2++) 
	    if (pdiwL[i][j][k][i2] > 0.00001)
	    fprintf(fw2, "pdiwL[%d][%d][%d][%d] = %f\n",
	      i,j,k,i2,pdiwL[i][j][k][i2]);
	}   
      }
    }
    fprintf(fw2, "\n");  
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdiwL14m[j][i2] > 0.00001)
          fprintf(fw2, "pdiwL14m[%d][%d] = %f\n",j,i2,pdiwL14m[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (j = 1; j <= crossing; j++) {  
      for (i2 = 1; i2 <= nfs; i2++) 
	if (pdiwL14nm[j][i2] > 0.00001)
          fprintf(fw2, "pdiwL14nm[%d][%d] = %f\n",j,i2,pdiwL14nm[j][i2]);
    }
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 <= LL; i3++) {
      for (j = 3; j <= nstgE; j++) {
	if (i3 == LL && j > nstg1E) break;    
	i = (i3 - 1) * nstgE + j;
	for (k = 1; k <= fE; k++) {    
	  for (i2 = 1; i2 <= nfs; i2++)
	    if (fabs(pdiwlE[i][k][i2]) > 0.000001)    
            fprintf(fw2, "pdiwlE[%d][%d][%d] = %f\n",i,k,i2,pdiwlE[i][k][i2]);
	}
      }
    }      
    fprintf(fw2, "\n");       
    for (i3 = 1; i3 <= LL; i3++) {
      for (j = 3; j <= nstgE; j++) {
	if (i3 == LL && j > nstg1E) break;    
	i = (i3 - 1) * nstgE + j;
	for (k = 1; k <= fE; k++) {    
	  for (i2 = 1; i2 <= nfs; i2++) 
	    if (fabs(pdiwnlE[i][k][i2]) > 0.000001)   
            fprintf(fw2, "pdiwnlE[%d][%d][%d] = %f\n",i,k,i2,pdiwnlE[i][k][i2]);
	}
      }
    }      
    fprintf(fw2, "\n");     
    for (i3 = 1; i3 < 2*RR; i3++) {
      i = 2 * i3;
      for (j = 1; j <= crossing; j++) {  
	for (k = 1; k <= fR; k++) {    
          for (i2 = 1; i2 <= nfs; i2++)  
	    if (fabs(pdiwR[i][j][k][i2]) > 0.000001)  
            fprintf(fw2, "pdiwR[%d][%d][%d][%d] = %f\n",i,j,k,i2,pdiwR[i][j][k][i2]);
        }
      }
    }      
    fprintf(fw2, "\n");     
  }
  a2 = 0;
  for (i = 1; i < N; i++) { 
    if (fabs(pf[i]) > 0.000001)
      fprintf(fw2, "pf[%d] = %9.3f\n", i,pf[i]);
    a2 += fabs(pf[i]); 
  }    
  if (a2 > 0.000001) fprintf(fw2, "\n");
  if (pricefL == 4 || priceS == 4) {
    a2 = 0;
    for (i = 1; i < N; i++) {
      if (fabs(pf0[i]) > 0.000001)
        fprintf(fw2, "pf0[%d] = %9.3f\n", i,pf0[i]);
    a2 += fabs(pf0[i]); 	
    }	
    if (a2 > 0.000001) fprintf(fw2, "\n");
  }
  if (pricewL == 4) {
    a2 = 0;
    for (i = 1; i < N; i++) {
      if (fabs(pf1[i]) > 0.000001)
        fprintf(fw2, "pf1[%d] = %9.3f\n", i,pf1[i]);
    a2 += fabs(pf1[i]); 	
    }	
    if (a2 > 0.000001) fprintf(fw2, "\n");
  }
  for (k = 1; k < SP; k++)
    fprintf(fw2, "Pherd[%d] = %f\n", k,Pherd[k]);
  fprintf(fw2, "\n");    
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[1]; i++) 
      fprintf(fw2, "pherd[%d][%d] = %f\n", k,i,pherd[k][i]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "pherdyMP = %f\n", pherdyMP);
  fprintf(fw2, "\n"); 
  if (pricewL == 4) {
    if (typeb == 1) k7 = nclcwwL;
      else k7 = nclcwwL + 1;
    for (i = 1; i < k7; i++) 
      fprintf(fw2, "PhicwL[%d] = %8.3f\n", i,PhicwL[i]);
    fprintf(fw2, "\n");      
  }  
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC - 1; i++) 
      fprintf(fw2, "Phiscc[%d] = %8.3f\n", i,Phiscc[i]);
    fprintf(fw2, "\n");      
  }
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "pinsE[%d] = %5.1f\n", i,pinsE[i]);
  fprintf(fw2, "\n");   
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "pinsFP[%d] = %5.1f\n", i,pinsFP[i]);
  fprintf(fw2, "\n");   
  if (typeb < 3) fprintf(fw2, "placE = %d\n", placE);     
  fprintf(fw2, "\n");  
  for (i = 1; i <= TE; i++) fprintf(fw2, "plambE[%d] = %f\n", i,plambE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++)
      fprintf(fw2, "Pltype[%d][%d] = %f\n", i,j,Pltype[i][j]);
  }
  fprintf(fw2, "\n");   
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      if (k == 2 && i == bs[k]) break;
      for (j = 1; j <= crossing; j++)
	if (fabs(pmat[k][i][j]) > 0.000001)
	  fprintf(fw2, "pmat[%d][%d][%d] = %f\n", k,i,j,pmat[k][i][j]);
    }
  }  
  fprintf(fw2, "\n");
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pmatE[%d] = %f\n", i,pmatE[i]);
  fprintf(fw2, "\n"); 
  if (typeb == 1) {
    fprintf(fw2, "pmilkch = %7.3f\n", pmilkch);
  }
  fprintf(fw2, "pmilkwm = %f\n", pmilkwm);
  fprintf(fw2, "\n"); 
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pnconE[%d] = %f\n", i,pnconE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL; i++) 
    fprintf(fw2, "pnconculE[%d] = %f\n", i,pnconculE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= LL-1; i++) 
    fprintf(fw2, "pnconstayE[%d] = %f\n", i,pnconstayE[i]);
  fprintf(fw2, "\n");    
  for (i = 1; i <= TE; i++) fprintf(fw2, "pnlambE[%d] = %f\n", i,pnlambE[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "PP = %d\n", PP);
  fprintf(fw2, "ppurchFP = %f\n", ppurchFP);  
  fprintf(fw2, "ppurchMP = %f\n", ppurchMP);
  fprintf(fw2, "\n");  
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prbR[%d] = %9.2f\n", i,prbR[i]);
  fprintf(fw2, "\n"); 
  if (typeb == 1) {
    if (pmilkch > 0.000001) fprintf(fw2, "prcheese = %7.2f\n", prcheese);  
    fprintf(fw2, "\n"); 
  }
  if (pricewL == 4) {
    for (i = 1; i <= nclcwwL; i++) {
      for (j = 1; j <= nclcqwL; j++) 
	fprintf(fw2, "prclcwwL[%d][%d] = %9.2f\n", i,j,prclcwwL[i][j]);
    }	
    fprintf(fw2, "\n");      
  }
  if (pricefL == 4) {
    for (i = 1; i <= nclflfL; i++) {  
      for (j = 1; j <= nclfcfL; j++)
	if (fabs(prclfcfL[i][j]) > 0.000001)
          fprintf(fw2, "prclfcfL[%d][%d] = %9.3f\n", i,j,prclfcfL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  if (priceS == 4) {
    for (i = 1; i <= nclflS; i++) {  
      for (j = 1; j <= nclfcS; j++)
	if (fabs(prclfcS[i][j]) > 0.000001)
          fprintf(fw2, "prclfcS[%d][%d] = %9.3f\n", i,j,prclfcS[i][j]);
    }
    fprintf(fw2, "\n");
  }
  if (pricewL == 4) {
    for (i = 1; i <= nclflwL; i++) {  
      for (j = 1; j <= nclfcwL; j++)
	if (fabs(prclfcwL[i][j]) > 0.000001)
          fprintf(fw2, "prclfcwL[%d][%d] = %9.3f\n", i,j,prclfcwL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  if (pricefL == 2) {
    for (i = 1; i <= nclfL; i++) 
      fprintf(fw2, "prclfL[%d] = %9.2f\n", i,prclfL[i]);
    fprintf(fw2, "\n");      
  }
  if (priceS == 2) {
    for (i = 1; i <= nclS; i++) 
      fprintf(fw2, "prclS[%d] = %9.2f\n", i,prclS[i]);
    fprintf(fw2, "\n");      
  }
  if (pricewL == 2) {
    for (i = 1; i <= nclwL; i++) 
      fprintf(fw2, "prclwL[%d] = %9.2f\n", i,prclwL[i]);
    fprintf(fw2, "\n");      
  }
  for (i = 1; i <= bs[1]; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "prconFP[%d][%d] = %f\n", i,j,prconFP[i][j]);
  }
  fprintf(fw2, "\n");
  if (pricewL == 4) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "prcwawL[%d][%d] = %7.2f\n", i,j,prcwawL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  if (pricewL == 4) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "prcwbwL[%d] = %7.2f\n", j,prcwbwL[j]);
    fprintf(fw2, "\n");
  }
  if (pricewL == 4 || pricefL ==4) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "prcwcwL[%d][%d] = %7.2f\n", i,j,prcwcwL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  if (pricefL == 3 || pricefL == 4) { 
    for (j = 1; j <= crossing; j++) 
      fprintf(fw2, "prcwfL[%d] = %f\n", j,prcwfL[j]);
    fprintf(fw2, "\n");
  }  
  if (priceS == 3 || priceS == 4) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "prcwS[%d] = %8.2f\n", i,prcwS[i]);
    fprintf(fw2, "\n");  
  }
  if (pricewL == 3) {
    for (j = 1; j <= crossing; j++)    
      fprintf(fw2, "prcwwL[%d] = %8.2f\n", j,prcwwL[j]);
    fprintf(fw2, "\n");    
  }  
  fprintf(fw2, "prectop = %8.2f\n", prectop);
  fprintf(fw2, "prendop = %8.2f\n", prendop);  
  fprintf(fw2, "\n");
  for (i = 1; i <= fE; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "prfE[%d][%d] = %f\n", i,j,prfE[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= fL; i++) {
    for (j = 1; j <= nfs; j++) 
      if (fabs(prfL[i][j]) > 0.000001)
        fprintf(fw2, "prfL[%d][%d] = %f\n", i,j,prfL[i][j]);
    }
  fprintf(fw2, "\n");
  for (i = 1; i <= fR; i++) {
    for (j = 1; j <= nfs; j++) 
      fprintf(fw2, "prfR[%d][%d] = %f\n", i,j,prfR[i][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "pricefL = %d\n", pricefL);
  fprintf(fw2, "priceS = %d\n", priceS);
  fprintf(fw2, "pricewL = %d\n", pricewL);
  fprintf(fw2, "\n");
  if (pricefL == 1 || pricefL == 2) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "prlwfL[%d] = %8.2f\n", i,prlwfL[i]);
    fprintf(fw2, "\n");  
  }
  if (priceS == 1 || priceS == 2) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "prlwS[%d] = %8.2f\n", i,prlwS[i]);
    fprintf(fw2, "\n");  
  }
  if (pricewL == 1 || pricewL == 2) {
    for (i = 1; i <= crossing; i++) 
      fprintf(fw2, "prlwwL[%d] = %8.2f\n", i,prlwwL[i]);
    fprintf(fw2, "\n");  
  }
  fprintf(fw2, "prman = %8.2f\n", prman);
  if (typeb == 1) {
    fprintf(fw2, "prmilk = %8.2f\n", prmilk);
    fprintf(fw2, "prmilkb = %8.2f\n", prmilkb);
    fprintf(fw2, "\n");
  }
  if (milkprice > 2) {
    for (i = 0; i < nfat; i++) 
      fprintf(fw2, "prmilkf[%d] = %8.3f\n", i,prmilkf[i]);
    if (nfat > 0) fprintf(fw2, "\n");
  }        
  if (milkprice == 5) {
    fprintf(fw2, "prmilkfp = %8.2f\n", prmilkfp);
    fprintf(fw2, "\n");
  }        
  if (milkprice > 2) {
    for (i = 0; i < nprot; i++) 
      fprintf(fw2, "prmilkp[%d] = %8.3f\n", i,prmilkp[i]);
    if (nprot > 0) fprintf(fw2, "\n");      
  }
  fprintf(fw2, "prods = %d\n", prods);
  fprintf(fw2, "profnsub = %8.2f\n", profnsub);
  fprintf(fw2, "profsub = %8.2f\n", profsub);
  fprintf(fw2, "prot = %f\n", prot);
  if (typeb == 1) fprintf(fw2, "protymst = %f\n", protymst);  
  if (pricefL == 4) fprintf(fw2, "prreffL = %8.2f\n", prreffL);
  if (priceS == 4) fprintf(fw2, "prrefS = %8.2f\n", prrefS);
  if (pricewL == 4) fprintf(fw2, "prrefwL = %8.2f\n", prrefwL);
  fprintf(fw2, "\n"); 
  if (opsbL == 2) {
    for (i = 1; i <= PP; i++) {
      for (j = 1; j <= crossing; j++)   
	if (fabs(revsbL[i][j]) > 0.00001)
          fprintf(fw2, "prsbL[%d][%d] = %9.2f\n",i,j,prsbL[i][j]);
    }
    fprintf(fw2, "\n");     
  }
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prsbR[%d] = %9.2f\n", i,prsbR[i]);
  fprintf(fw2, "\n"); 
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC; i++) fprintf(fw2, "prSCC[%d] = %8.3f\n", i,prSCC[i]);
    fprintf(fw2, "\n");
  }  
  if (milkprice == 2 || milkprice == 4) fprintf(fw2, "prscc = %8.2f\n", prscc);
  fprintf(fw2, "prskrE = %8.2f\n", prskrE);
  fprintf(fw2, "\n"); 
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prskrL[%d] = %7.2f\n", i,prskrL[i]);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prskrR[%d] = %7.2f\n", i,prskrR[i]);
  fprintf(fw2, "\n");        
  fprintf(fw2, "prsktE = %8.2f\n", prsktE); 
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prsktL[%d] = %7.2f\n", i,prsktL[i]);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prsktR[%d] = %7.2f\n", i,prsktR[i]);
  fprintf(fw2, "\n");        
  fprintf(fw2, "prstraw = %8.2f\n", prstraw); 
  fprintf(fw2, "prwat = %8.3f\n", prwat);
  if (pmilkch > 0.000001 && typeb == 1) fprintf(fw2, "prwhey = %7.2f\n", prwhey);    
  fprintf(fw2, "prwoolE = %7.2f\n", prwoolE);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prwoolL[%d] = %7.2f\n", i,prwoolL[i]);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "prwoolR[%d] = %7.2f\n", i,prwoolR[i]);
  fprintf(fw2, "\n");        
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "ps13[%d] = %7.2f\n", i,ps13[i]);
  fprintf(fw2, "\n");        
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC; i++) fprintf(fw2, "pSCC[%d] = %8.3f\n", i,pSCC[i]);
    fprintf(fw2, "\n");
  }  
  if (typew == 2) fprintf(fw2, "pskarL = %7.2f\n", pskarL);
  fprintf(fw2, "pskE = %7.2f\n", pskE);
  if (fatpb + fatcb > 0) fprintf(fw2, "pskfL = %7.2f\n", pskfL);
  fprintf(fw2, "pskR = %7.2f\n", pskR);
  fprintf(fw2, "pskrL = %7.2f\n", pskrL);
  fprintf(fw2, "pskwL = %7.2f\n", pskwL);
  fprintf(fw2, "\n");  
  for (k = 1; k < SP; k++) {
    for (i = 0; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++)
	if (fabs(psold[k][i][j] > 0.000001))
	  fprintf(fw2, "psold[%d][%d][%d] = %f\n", k,i,j,psold[k][i][j]);
    }
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= RR; i++) 
    fprintf(fw2, "psoldR[%d] = %f\n", i,psoldR[i]);
  fprintf(fw2, "\n");
  for (k = 0; k < SP; k++) {
    for (i = 1; i <= csp[k]; i++) {
      for (j = 1; j <= crossing; j++) 
	fprintf(fw2, "psp[%d][%d][%d] = %f\n", k,i,j,psp[k][i][j]);
    }
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= RR-1; i++) 
    fprintf(fw2, "pstayR[%d] = %f\n", i,pstayR[i]);
  fprintf(fw2, "\n");
  for (i = 0; i <= clt; i++) {
    for (j = 1; j <= LL; j++)
      fprintf(fw2, "PsuckE[%d][%d] = %f\n", i,j,PsuckE[i][j]);
  }
  fprintf(fw2, "\n");   
  a2 = 0;
  for (i = 1; i < N; i++) {
    if (fabs(pt[i]) > 0.000001)
      fprintf(fw2, "pt[%d] = %9.3f\n", i,pt[i]);
    a2 += fabs(pt[i]);  
  }    
  if (a2 > 0.000001) fprintf(fw2, "\n");
  if (typew == 2) fprintf(fw2, "ptskarL = %7.2f\n", ptskarL);  
  fprintf(fw2, "ptskE = %7.2f\n", ptskE);
  if (fatpb + fatcb > 0) fprintf(fw2, "ptskfL = %7.2f\n", ptskfL);
  fprintf(fw2, "ptskR = %7.2f\n", ptskR);
  fprintf(fw2, "ptskrL = %7.2f\n", ptskrL);
  fprintf(fw2, "ptskwL = %7.2f\n", ptskwL);    
  fprintf(fw2, "\n");    
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "pwL[%d][%d] = %f\n", i,j,pwL[i][j]);
  }
  fprintf(fw2, "\n");    
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "pwrepFP[%d] = %f\n", i,pwrepFP[i]);
  fprintf(fw2, "\n");    
  fprintf(fw2, "pwrepMP = %f\n", pwrepMP);  
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "pyoungMP[%d] = %f\n", i,pyoungMP[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) fprintf(fw2, "qaveE[%d] = %f\n", i,qaveE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) 
      if (l1skL[i][j] > 0.000001)  
        fprintf(fw2, "qaveL[%d][%d] = %9.3f\n",i,j,qaveL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "qaveR[%d][%d] = %9.3f\n", i,j,qaveR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) fprintf(fw2, "qbreedE[%d] = %9.3f\n", i,qbreedE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= 3; i++) {
    k =  10 + 4 * i;
    if (l1skL[k][1] + l1skL[k][2] > 0.000001) 
      fprintf(fw2, "qbreedL[%d] = %9.3f\n", k,qbreedL[k]);
  }  
  fprintf(fw2, "\n");
  a2 = 0;    
  for (i = 1; i < N; i++) {
    if (fabs(qcl0[i]) > 0.000001) 
      fprintf(fw2, "qcl0[%d] = %9.4f\n", i,qcl0[i]);
    a2 += fabs(qcl0[i]);        
  }    
  if (a2 > 0.000001) fprintf(fw2, "\n");     
  for (i = 1; i <= TE; i++) fprintf(fw2, "qendE[%d] = %9.3f\n", i,qendE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      if (l1skL[i][j] > 0.000001)     
        fprintf(fw2, "qendL[%d][%d] = %9.3f\n",i,j,qendL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "qendR[%d][%d] = %9.3f\n", i,j,qendR[i][j]);
  }
  fprintf(fw2, "\n");
  if (typeb == 1) {
    for (i = 1; i <= TE; i++) fprintf(fw2, "qmilkE[%d] = %9.3f\n", i,qmilkE[i]);
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "qpurchR = %9.3f\n", qpurchR);
  fprintf(fw2, "\n");
  fprintf(fw2, "ratiooldR = %f\n", ratiooldR);  
  fprintf(fw2, "ratioR = %f\n", ratioR);  
  fprintf(fw2, "ratioyoungR = %f\n", ratioyoungR);
  fprintf(fw2, "\n");
  if (typeb == 1 && pmilkch > 0.000001) 
    fprintf(fw2, "rcas = %7.3f\n", rcas);   
  for (i = 1; i <= TE; i++) 
    if (fabs(revcE[i]) > 0.0000001) 
      fprintf(fw2, "revcE[%d] = %7.2f\n", i,revcE[i]);
  fprintf(fw2, "\n");
  if (typeb == 1) {
    for (i = 1; i <= TE; i++) 
      if (fabs(revcheeseE[i]) > 0.0000001) 
	fprintf(fw2, "revcheeseE[%d] = %7.2f\n", i,revcheeseE[i]);
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revcL[i][j]) > 0.00001)
        fprintf(fw2, "revcL[%d][%d] = %9.1f\n",i,j,revcL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revcR[i][j]) > 0.000001) 
        fprintf(fw2, "revcR[%d][%d] = %9.2f\n", i,j,revcR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) 
    if (fabs(revE[i]) > 0.0000001) 
      fprintf(fw2, "revE[%d] = %7.2f\n", i,revE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revL[i][j]) > 0.00001)
        fprintf(fw2, "revL[%d][%d] = %9.1f\n",i,j,revL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TE; i++) 
    if (fabs(revmanE[i]) > 0.0000001) 
      fprintf(fw2, "revmanE[%d] = %8.2f\n", i,revmanE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revmanL[i][j]) > 0.000001) 
        fprintf(fw2, "revmanL[%d][%d] = %9.2f\n", i,j,revmanL[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revmanR[i][j]) > 0.000001) 
        fprintf(fw2, "revmanR[%d][%d] = %9.2f\n", i,j,revmanR[i][j]);
  }
  fprintf(fw2, "\n");
  if (typeb == 1) {
    for (i = 1; i <= TE; i++) 
      if (fabs(revmilkE[i]) > 0.0000001) 
	fprintf(fw2, "revmilkE[%d] = %8.2f\n", i,revmilkE[i]);
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revR[i][j]) > 0.000001) 
        fprintf(fw2, "revR[%d][%d] = %9.2f\n", i,j,revR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revsbL[i][j]) > 0.00001)
        fprintf(fw2, "revsbL[%d][%d] = %9.2f\n",i,j,revsbL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TE; i++) 
    if (fabs(revskrE[i]) > 0.0000001) 
      fprintf(fw2, "revskrE[%d] = %7.2f\n", i,revskrE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revskrL[i][j]) > 0.00001)
        fprintf(fw2, "revskrL[%d][%d] = %9.2f\n",i,j,revskrL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revskrR[i][j]) > 0.000001) 
        fprintf(fw2, "revskrR[%d][%d] = %9.2f\n", i,j,revskrR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) 
    if (fabs(revsktE[i]) > 0.0000001) 
      fprintf(fw2, "revsktE[%d] = %7.2f\n", i,revsktE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revsktL[i][j]) > 0.00001)
        fprintf(fw2, "revsktL[%d][%d] = %9.2f\n",i,j,revsktL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revsktR[i][j]) > 0.000001) 
        fprintf(fw2, "revsktR[%d][%d] = %9.2f\n", i,j,revsktR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(revsoldR[i][j]) > 0.000001) 
        fprintf(fw2, "revsoldR[%d][%d] = %9.2f\n", i,j,revsoldR[i][j]);
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= TE; i++) 
    if (fabs(revwE[i]) > 0.0000001) 
      fprintf(fw2, "revwE[%d] = %7.2f\n", i,revwE[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (fabs(revwL[i][j]) > 0.00001)
        fprintf(fw2, "revwL[%d][%d] = %9.2f\n",i,j,revwL[i][j]);
  }
  fprintf(fw2, "\n");     
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "revwR[%d][%d] = %9.2f\n", i,j,revwR[i][j]);
  }
  fprintf(fw2, "\n");
  if (milkprice > 2) {
    for (j = 0; j <= nfat; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "rf[%d][%d] = %8.3f\n", i,j,rf[i][j]);
    }  
    fprintf(fw2, "\n");   
  }  
  if (typeb == 1 && pmilkch > 0.000001) 
    fprintf(fw2, "rfat = %7.3f\n", rfat);   
  if (milkprice > 2) {  
    for (j = 0; j <= nprot; j++) {
      for (i = 0; i <= 2; i++) fprintf(fw2, "rp[%d][%d] = %8.3f\n", i,j,rp[i][j]);
    }  
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "RR = %d\n", RR);
  if (typeb == 1 && pmilkch > 0.000001) fprintf(fw2, "rs = %7.3f\n", rs);    
  fprintf(fw2, "sexrbf = %f\n", sexrbf);
  fprintf(fw2, "sexrbm = %f\n", sexrbm);
  for (i = 1; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "sigmacwwL[%d][%d] = %f\n", i,j,sigmacwwL[i][j]);
  }
  fprintf(fw2, "\n");
  if (milkprice > 2) fprintf(fw2, "sigmafat = %f\n", sigmafat);
  if (milkprice > 2) fprintf(fw2, "sigmaprot = %f\n", sigmaprot);
  if (milkprice == 2 || milkprice > 3) fprintf(fw2, "sigmaSCS = %f\n", sigmaSCS);
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(sigmawr[k][j]) > 0.000001)
        fprintf(fw2, "sigmawr[%d][%d] = %f\n", k,j,sigmawr[k][j]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "sl1E = %f\n", sl1E);
  fprintf(fw2, "sl1R = %f\n", sl1R);
  fprintf(fw2, "SP = %d\n", SP);
  if (typew == 2) fprintf(fw2, "strawarL = %8.2f\n", strawarL);  
  fprintf(fw2, "strawE = %8.2f\n", strawE);  
  if (fatpb + fatcb > 0) fprintf(fw2, "strawfL = %8.2f\n", strawfL);  
  fprintf(fw2, "strawR = %8.2f\n", strawR);  
  fprintf(fw2, "strawrL = %8.2f\n", strawrL);  
  fprintf(fw2, "subE = %8.0f\n", subE);
  fprintf(fw2, "subR = %8.0f\n", subR);    
  fprintf(fw2, "\n");
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[k]; i++) {
	for (j = 1; j <= crossing; j++) 
	  if (fabs(surfat[k][i][j]) > 0.000001)
	    fprintf(fw2, "surfat[%d][%d][%d] = %f\n", k,i,j,surfat[k][i][j]);
      }
    }
    fprintf(fw2, "\n");  
  }  
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++) 
	if (fabs(surbs[k][i][j]) > 0.000001)
	  fprintf(fw2, "surbs[%d][%d][%d] = %f\n", k,i,j,surbs[k][i][j]);
    }
  }
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) fprintf(fw2, "surmlFP[%d] = %f\n", i, surmlFP[i]);
  fprintf(fw2, "\n");
  for (i = 0; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "sw[%d][%d] = %f\n", i,j,sw[i][j]);
  }
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "swb[%d][%d][%d] = %f\n", k,i,j,swb[k][i][j]);
    }
  }
  fprintf(fw2, "\n");  
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      if (l1skL[i][j] > 0.000001)   
        fprintf(fw2, "taveL[%d][%d] = %9.1f\n",i,j,taveL[i][j]);
  }
  fprintf(fw2, "\n");     
  fprintf(fw2, "Tcosts = %10.2f\n", Tcosts);    
  fprintf(fw2, "TcostsE = %10.2f\n", TcostsE); 
  fprintf(fw2, "TcostsR = %10.2f\n", TcostsR);      
  fprintf(fw2, "TE = %d\n", TE);    
  fprintf(fw2, "\n");
  for (i1 = 1; i1 <= TE; i1++) {
    for (i2 = 1; i2 <= TE; i2++)
      if (fabs(te[i1][i2])>0.0000001) {
	fprintf(fw2, "te[%d][%d] = %f\n", i1,i2,te[i1][i2]);
    }
  }
  fprintf(fw2, "\n");   
  for (i = 1; i <= nfs; i++) fprintf(fw2, "techbL[%d] = %d\n", i,techbL[i]);
  fprintf(fw2, "\n");
  for (j = 1; j <= nfs; j++) fprintf(fw2, "techE[%d] = %d\n", j,techE[j]);
  fprintf(fw2, "\n");
  if (fatpb + fatcb > 0) {
    for (i = 1; i <= nfs; i++) fprintf(fw2, "techfatL[%d] = %d\n", i,techfatL[i]);
    fprintf(fw2, "\n");
  }
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)   
      if (l1skL[i][j] > 0.000001)   
        fprintf(fw2, "tendL[%d][%d] = %9.1f\n",i,j,tendL[i][j]);
  }
  fprintf(fw2, "\n");     
  if (milkprice > 2) {  
    if (nfat > 0) {  
      for (i = 0; i < nfat; i++) fprintf(fw2, "thfat[%d] = %7.2f\n", i,thfat[i]);
      fprintf(fw2, "\n");
    }
    if (nprot > 0) {  
      for (i = 0; i < nprot; i++) fprintf(fw2, "thprot[%d] = %7.2f\n", i,thprot[i]);
      fprintf(fw2, "\n"); 
    }  
  }
  if (typeb == 1) {
    fprintf(fw2, "tmilkm = %f\n", tmilkm);
    fprintf(fw2, "tmilkst = %f\n", tmilkst);
  }
  fprintf(fw2, "tmilkw = %f\n", tmilkw);
  fprintf(fw2, "\n");
  for (j = 1; j <= nfs; j++)
    fprintf(fw2, "tmilkw0[%d] = %8.4f\n", j,tmilkw0[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= nfs; i++) 
    fprintf(fw2, "tp[%d] = %7.1f\n", i,tp[i]);
  fprintf(fw2, "\n");
  fprintf(fw2, "Tprof = %10.2f\n", Tprof);
  fprintf(fw2, "Tprofh = %10.2f\n", Tprofh);
  fprintf(fw2, "Tprofl = %10.2f\n", Tprofl);
  fprintf(fw2, "Tprofm = %10.2f\n", Tprofm);
  fprintf(fw2, "\n");    
  for (i1 = 1; i1 <= TR; i1++) {
    for (i2 = 1; i2 <= TR; i2++)
      if (fabs(tr[i1][i2])>0.0000001) 
	fprintf(fw2, "tr[%d][%d] = %f\n", i1,i2,tr[i1][i2]);
  }
  fprintf(fw2, "\n");   
  fprintf(fw2, "\n");
  fprintf(fw2, "TR = %d\n", TR); 
  fprintf(fw2, "Trev = %10.2f\n", Trev);  
  fprintf(fw2, "TrevE = %10.2f\n", TrevE);  
  fprintf(fw2, "TrevR = %10.2f\n", TrevR);  
  fprintf(fw2, "\n");
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC - 1; i++) fprintf(fw2, "tSCC[%d] = %8.3f\n", i,tSCC[i]);
    fprintf(fw2, "\n");  
  }  
  if (milkprice == 2 || milkprice > 3) {
    for (i = 0; i < nSCC - 1; i++) fprintf(fw2, "tSCS[%d] = %8.3f\n", i,tSCS[i]);
    fprintf(fw2, "\n");  
  }  
  fprintf(fw2, "Tsub = %10.2f\n", Tsub);
  fprintf(fw2, "tv2h = %10.3f\n", tv2h);
  fprintf(fw2, "tv2l = %10.3f\n", tv2l);
  fprintf(fw2, "tv2m = %10.3f\n", tv2m);
  fprintf(fw2, "tvh = %10.3f\n", tvh);
  fprintf(fw2, "tvl = %10.3f\n", tvl);
  fprintf(fw2, "tvm = %10.3f\n", tvm);
  fprintf(fw2, "\n");     
  for (i = 1; i <= clt; i++) {
    for (j = 1; j <= LL; j++)
      fprintf(fw2, "twL[%d][%d] = %f\n", i,j,twL[i][j]);
  }
  fprintf(fw2, "\n");   
  fprintf(fw2, "typeb = %d\n", typeb);     
  fprintf(fw2, "typew = %d\n", typew);
  fprintf(fw2, "u = %7.3f\n", u); 
  fprintf(fw2, "\n");  
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "ulf[%d][%d] = %d\n", k,i,ulf[k][i]);
    }
    fprintf(fw2, "\n");    
  }
  for (i = 0; i <= nchfst; i++) 
    fprintf(fw2, "valfs[%d] = %d\n", i,valfs[i]);
  fprintf(fw2, "\n");  
  for (k = 1; k < SP; k++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(vcwr[k][j]) > 0.000001)
        fprintf(fw2, "vcwr[%d][%d] = %f\n", k,j,vcwr[k][j]);
  }
  fprintf(fw2, "\n");    
  if (pricewL == 4) fprintf(fw2, "vcwwL = %8.2f\n", vcwwL);         
  if (typew == 2) fprintf(fw2, "vetarL = %8.2f\n", vetarL); 
  fprintf(fw2, "vetclFP = %8.2f\n", vetclFP);   
  fprintf(fw2, "vetE = %8.2f\n", vetE);
  fprintf(fw2, "\n");    
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++ ) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "vetf[%d][%d] = %f\n", k,i,vetf[k][i]);
    }
    fprintf(fw2, "\n");    
  }
  fprintf(fw2, "vetR = %8.2f\n", vetR); 
  fprintf(fw2, "\n");
  for (i = 1; i <= 2; i++) fprintf(fw2, "vetrL[%d] = %7.2f\n",i,vetrL[i]);
  fprintf(fw2, "\n");  
  fprintf(fw2, "vetwL = %8.2f\n", vetwL);   
  fprintf(fw2, "\n");   
  if (fatpb + fatcb > 0) {
    for (k = 0; k < SP; k++ ) {
      for (i = 1; i <= lf[k]; i++) 
	fprintf(fw2, "vlf[%d][%d] = %f\n", k,i,vlf[k][i]);
    }
    fprintf(fw2, "\n");  
  }
  if (typew == 2) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "warL[1][%d][%d] = %f\n", i,j,warL[1][i][j]);
    }
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "warL[2][%d][%d] = %f\n", i,j,warL[2][i][j]);
    }
    fprintf(fw2, "\n");
  }
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;    
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(watE[i][k][i2]) > 0.000001)   
          fprintf(fw2, "watE[%d][%d][%d] = %7.1f\n",i,k,i2,watE[i][k][i2]);
      }
    }	
  }      
  fprintf(fw2, "\n");     
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fL; k++) {    
        for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(watL[i][j][k][i2]) > 0.00001)
	  fprintf(fw2, "watL[%d][%d][%d][%d] = %f\n",
	    i,j,k,i2,watL[i][j][k][i2]);
      }   
    }
  }
  fprintf(fw2, "\n");  
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (watL14m[j][i2] > 0.00001)
        fprintf(fw2, "watL14m[%d][%d] = %f\n",j,i2,watL14m[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (j = 1; j <= crossing; j++) {  
    for (i2 = 1; i2 <= nfs; i2++) 
      if (watL14nm[j][i2] > 0.00001)
        fprintf(fw2, "watL14nm[%d][%d] = %f\n",j,i2,watL14nm[j][i2]);
  }
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;    
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(watlE[i][k][i2]) > 0.000001)   
          fprintf(fw2, "watlE[%d][%d][%d] = %7.1f\n",i,k,i2,watlE[i][k][i2]);
      }
    }	
  }      
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 <= LL; i3++) {
    for (j = 3; j <= nstgE; j++) {
      if (i3 == LL && j > nstg1E) break;    
      i = (i3 - 1) * nstgE + j;
      for (k = 1; k <= fE; k++) {    
	for (i2 = 1; i2 <= nfs; i2++) 
	  if (fabs(watnlE[i][k][i2]) > 0.000001)   
          fprintf(fw2, "watnlE[%d][%d][%d] = %7.1f\n",i,k,i2,watnlE[i][k][i2]);
      }
    }	
  }      
  fprintf(fw2, "\n");     
  for (i3 = 1; i3 < 2*RR; i3++) {
    i = 2 * i3;
    for (j = 1; j <= crossing; j++) {  
      for (k = 1; k <= fR; k++) {    
        for (i2 = 1; i2 <= nfs; i2++)   
	  if (fabs(watR[i][j][k][i2]) > 0.000001) 
          fprintf(fw2, "watR[%d][%d][%d][%d] = %f\n",i,j,k,i2,watR[i][j][k][i2]);
      }
    }
  }      
  fprintf(fw2, "\n");     
  for (i = 1; i <= RR; i++) {
    for (j = 1; j <= crossing; j++)  
      fprintf(fw2, "wbR[%d][%d] = %10.3f\n", i,j,wbR[i][j]);
  }  
  fprintf(fw2, "\n");
  if (flushabE + flushbbE > 0) fprintf(fw2, "wgfE = %f\n", wgfE);  
  if (flushabL + flushbbL > 0) fprintf(fw2, "wgfL = %f\n", wgfL);    
  if (flushabE + flushbbE + flushabL + flushbbL > 0) fprintf(fw2, "\n");  
  for (j = 1; j <= LL; j++)
    fprintf(fw2, "wlE[%d] = %7.1f\n", j,wlE[j]);
  fprintf(fw2, "\n");
  for (i = 1; i <= bs[1]; i++) 
    fprintf(fw2, "wlFP[%d] = %6.2f\n", i,wlFP[i]);
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= crossing; i++) 
      if (fabs(wmat[k][i]) > 0.000001)
        fprintf(fw2, "wmat[%d][%d] = %6.2f\n", k,i,wmat[k][i]);
  }
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= crossing; i++)
      if (fabs(wnmat[k][i]) > 0.000001) 
        fprintf(fw2, "wnmat[%d][%d] = %6.2f\n", k,i,wnmat[k][i]);
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "woolptE = %f\n", woolptE);  
  fprintf(fw2, "\n");
  for (i = 1; i <= crossing; i++) 
    fprintf(fw2, "woolptR[%d] = %f\n", i,woolptR[i]);
  fprintf(fw2, "\n");
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= crossing; j++)
      if (fabs(wP[i][j]) > 0.000001) 
        fprintf(fw2, "wP[%d][%d] = %6.2f\n", i,j,wP[i][j]);
  }
  fprintf(fw2, "\n");
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "wpurMP[%d] = %6.2f\n", j,wpurMP[j]);
  fprintf(fw2, "\n");
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= bs[k]; i++) {
      for (j = 1; j <= crossing; j++)
	if (fabs(wrL[k][i][j]) > 0.000001)
	  fprintf(fw2, "wrL[%d][%d][%d] = %6.2f\n", k,i,j,wrL[k][i][j]);
    }
  }  
  fprintf(fw2, "\n");
  if (typew == 2) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "wshearL[%d][%d] = %7.3f\n", i,j,wshearL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  fprintf(fw2, "wsheE = %7.2f\n", wsheE);
  fprintf(fw2, "\n");  
  if (fatpb + fatcb > 0) {
    for (i = 0; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "wshefL[%d][%d] = %7.3f\n", i,j,wshefL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  for (j = 1; j <= crossing; j++)
    fprintf(fw2, "wsheR[%d] = %7.2f\n", j,wsheR[j]);
  fprintf(fw2, "\n");
  for (i = 1; i < SP; i++) {
    for (j = 1; j <= crossing; j++)
      fprintf(fw2, "wsherL[%d][%d] = %7.3f\n", i,j,wsherL[i][j]);
  }
  fprintf(fw2, "\n");  
  if (typew == 1) {
    for (i = 1; i < SP; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "wshewL[%d][%d] = %7.3f\n", i,j,wshewL[i][j]);
    }
    fprintf(fw2, "\n");
  }
  for (k = 1; k < SP; k++) {
    for (i = 1; i <= clt; i++) {
      for (j = 1; j <= crossing; j++)
	fprintf(fw2, "wwL[%d][%d][%d] = %f\n", k,i,j,wwL[k][i][j]);
    }
  }
  fprintf(fw2, "\n");
  fprintf(fw2, "zr = %d\n", zr);    
  fclose(fw2);
  if (trait == 0 && zr == 1) goto EW;  
  
res: 
  if (prods == 1 && calc == 1) 
    printf("Writing the results to the results file resA01\n");
  if (prods == 2 && calc == 1) 
    printf("Writing the results to the results file resB01\n");
  if (prods == 2 && calc == 2) 
    printf("Writing the results to the results file resA02\n");
  if (prods == 2 && calc == 3) 
    printf("Writing the results to the results file resA03\n");
  if (prods == 2 && calc == 4) 
    printf("Writing the results to the results file resB04\n");
  z1 = z2 = 1;  
  /* 3 Results, 3.1 Structure of the ewe flock */
  outputrw(fr2, fw);
  fprintf(fw, "\n3.%d ", z1); outputrw(fr2, fw);
  outputrw(fr2, fw); 
  fprintf(fw, "%d", kE); 
  /* 3.1.1 Printing vector l1E[i] to output file */
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);
  z2++;
  for (i = 1; i < TE; i++) fprintf(fw, "  Category %3d: %9.5f\n", i, l1E[i]);
  fprintf(fw, "  Category %3d: %9.5f", TE, l1E[TE]);
  outputrw(fr2, fw); 
  /* 3.1.2 Printing vector l4E[i] to output file*/  
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);
  z2 = 1;
  aa1 = l4E[1];  
  fprintf(fw, "\nReproductive cycle %2d: %8.4f\n", 1, l4E[1]);  
  for (i = 2; i <= LL; i++) { 
    fprintf(fw, "Reproductive cycle %2d: %8.4f\n", i, l4E[i]);
    aa1 += l4E[i];
    }
  fprintf(fw, "-------------------------------\n");  
  fprintf(fw, "Sum:                   %8.4f", aa1);
  outputrw(fr2, fw); 
  z1++;
  /* 3.2 Survival and reproduction characteristics of the flock */
  fprintf(fw, "\n\n3.%d ", z1); outputrw(fr2, fw);
  fprintf(fw, "%7.2f",pdiedEp);
  outputrw(fr2, fw);
  fprintf(fw, "%7.2f",pcullhEp);
  outputrw(fr2, fw);
  fprintf(fw, "%7.2f",pcullmEp);
  outputrw(fr2, fw);
  fprintf(fw, "%7.2f",pcullfcEp);
  outputrw(fr2, fw);
  fprintf(fw, "%7.2f",100*l1E[TE]/l4E[1]);
  outputrw(fr2, fw);
  fprintf(fw, "%8.2f", avlifelE);
  outputrw(fr2, fw); 
  fprintf(fw, "%8.2f", avlifeyE);
  outputrw(fr2, fw); 
  fprintf(fw, "%8.2f", 100*avconrateE); 
  outputrw(fr2, fw); 
  fprintf(fw, "\n");
  for (i = 1; i < LL; i++)  
    fprintf(fw, "  Reproductive cycle %2d: %8.2f\n", i, avlitpE[i]);
  fprintf(fw, "  Reproductive cycle %2d: %8.2f", LL, avlitpE[LL]);  
  outputrw(fr2, fw); 
  fprintf(fw, "%8.2f", avlitE); 
  outputrw(fr2, fw); 
  fprintf(fw, "%7.3f", nbtL[0][1]/Nlamb);
  outputrw(fr2, fw);
  fprintf(fw, "%7.3f", nbtL[0][2]/Nlamb);
  if (clt > 2) {
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", nbtL[0][3]/Nlamb);
  }
    else outputr(fr2);  
  if (clt > 3) {
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", nbtL[0][4]/Nlamb);
  }
    else outputr(fr2);  
  if (typew == 1) {
    outputrw(fr2, fw); 
    fprintf(fw, "%7.3f", NwL[0]/Nlamb);  
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", nwL[0][1]/Nlamb);
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", nwL[0][2]/Nlamb);
    if (clt > 2) {
      outputrw(fr2, fw);
      fprintf(fw, "%7.3f", nwL[0][3]/Nlamb);
    }
      else outputr(fr2);  
    if (clt > 3) {
      outputrw(fr2, fw);
      fprintf(fw, "%7.3f", nwL[0][4]/Nlamb);
    }
      else outputr(fr2);  
  }
  else for (i = 1; i <= 5; i++) outputr(fr2);  
  if (typew == 2) {
    outputrw(fr2, fw); 
    fprintf(fw, "%7.3f", NarL[0]/Nlamb);  
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", narL[0][1]/Nlamb);
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", narL[0][2]/Nlamb);
    if (clt > 2) {
      outputrw(fr2, fw);
      fprintf(fw, "%7.3f", narL[0][3]/Nlamb);
    }
      else outputr(fr2);  
    if (clt > 3) {
      outputrw(fr2, fw);
      fprintf(fw, "%7.3f", narL[0][4]/Nlamb);
    }
      else outputr(fr2);  
  }
  else for (i = 1; i <= 5; i++) outputr(fr2);  
  outputrw(fr2, fw); 
  fprintf(fw, "%7.3f", pdiedbL[1][1]);  
  outputrw(fr2, fw);
  fprintf(fw, "%7.3f", pdiedbL[2][1]);
  if (clt > 2) {
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", pdiedbL[3][1]);
  }
    else outputr(fr2);  
  if (clt > 3) {
    outputrw(fr2, fw);
    fprintf(fw, "%7.3f", pdiedbL[4][1]);
  }
    else outputr(fr2);    
  z1++;
  /* 3.3 Structure of the ram population */
  fprintf(fw, "\n\n3.%d ", z1); outputrw(fr2, fw);
  outputrw(fr2, fw); 
  fprintf(fw, "%d", kR); 
  /* 3.3.1 Printing vector l1R[i] to output file */
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);
  z2++;
  for (i = 1; i < TR; i++) fprintf(fw, "  Category %3d: %9.5f\n", i, l1R[i]);
  fprintf(fw, "  Category %3d: %9.5f", TR, l1R[TR]);
  outputrw(fr2, fw); 
  /* 3.3.2 Printing vector l4R[i] to output file*/  
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);
  z2 = 1;
  if (crossing == 1) 
    fprintf(fw, "\n      %2d       %6.4f        %6.4f                -\n",
      1, l4R[1], l5R[1][1]);
  if (crossing == 2) 
    fprintf(fw, "\n      %2d       %6.4f        %6.4f              %6.4f\n",
      1, l4R[1], l5R[1][1], l5R[1][2]);
  for (i = 2; i <= RR; i++) { 
    if (crossing == 1) 
      fprintf(fw, "      %2d       %6.4f        %6.4f                -",
       i, l4R[i], l5R[i][1]);
    if (crossing == 2) 
      fprintf(fw, "      %2d       %6.4f        %6.4f              %6.4f",
	i, l4R[i], l5R[i][1], l5R[i][2]);
    if (i < RR) fprintf(fw, "\n");
  }
  outputrw(fr2, fw);
  z1++;
  /* 3.4. Characteristics of progeny */
  fprintf(fw, "\n\n3.%d ", z1); outputrw(fr2, fw);
  /* 3.4.1. Structure of the progeny */
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);  
  z2++;
  outputrw(fr2, fw); 
  for (i = 1; i <= PP; i++) {
    if (l1skL[i][0] > 0.000001) {
      fprintf(fw, "\n   %2d            %6.4f",i,l1skL[i][1]);
      if (crossing == 1) fprintf(fw, "           -             -");
      if (crossing == 2) 
        fprintf(fw, "        %6.4f        %6.4f",l1skL[i][2],l1skL[i][0]);
    }
  }
  outputrw(fr2, fw);   
  a2 = 0;
  for (j = 1; j <= LL; j++) a2 += l3E[j] * pcrossE[j-1];
  fprintf(fw, "%8.2f", a2 * 100);
  outputrw(fr2, fw);
  fprintf(fw, "%8.3f", nherd[1]);
  outputrw(fr2, fw);
  fprintf(fw, "%8.3f", nherd[2]);
  outputrw(fr2, fw);
  if (crossing == 2 && psp[1][2][2] > 0.000001) 
    fprintf(fw, "%8.4f %8.4f", 100*pmat[1][1][1], 100*pmat[1][1][2]); 
    else fprintf(fw, "%8.4f    -", 100*pmat[1][1][1]); 
  outputrw(fr2, fw);  
  fprintf(fw, "%8.4f", 100*pmat[2][1][1]);
  /* 3.4.2 Growth characteristics of lambs till weaning*/
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);  
  z2++;
  outputrw(fr2, fw);  
  if (crossing == 2) 
    fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[1][1][1], 1000*adgbwL[1][1][2]);
    else fprintf(fw, "%14.0f             -", 1000*adgbwL[1][1][1]);
  outputrw(fr2, fw);
  if (crossing == 2) 
    fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[1][2][1], 1000*adgbwL[1][2][2]);
    else fprintf(fw, "%14.0f             -", 1000*adgbwL[1][2][1]);
  if (clt > 2) {
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[1][3][1], 1000*adgbwL[1][3][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgbwL[1][3][1]);
  }
    else outputr(fr2);  
  if (clt > 3) {
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[1][4][1], 1000*adgbwL[1][4][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgbwL[1][4][1]);
  }
    else outputr(fr2);  
  outputrw(fr2, fw);
  if (crossing == 2) fprintf(fw, "%8.3f %8.3f",avww[1][1], avww[1][2]); 
     else fprintf(fw, "%8.3f     -", avww[1][1]); 
  outputrw(fr2, fw);  
  if (crossing == 2) 
    fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[2][1][1], 1000*adgbwL[2][1][2]);
    else fprintf(fw, "%14.0f             -", 1000*adgbwL[2][1][1]);
  outputrw(fr2, fw);
  if (crossing == 2) 
    fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[2][2][1], 1000*adgbwL[2][2][2]);
    else fprintf(fw, "%14.0f             -", 1000*adgbwL[2][2][1]);
  if (clt > 2) {
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[2][3][1], 1000*adgbwL[2][3][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgbwL[2][3][1]);
  }
    else outputr(fr2);  
  if (clt > 3) {
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgbwL[2][4][1], 1000*adgbwL[2][4][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgbwL[2][4][1]);
  }
    else outputr(fr2);  
  outputrw(fr2, fw);
  if (crossing == 2) fprintf(fw, "%8.3f %8.3f",avww[2][1], avww[2][2]); 
     else fprintf(fw, "%8.3f     -", avww[2][1]); 
  /* 3.4.3 Growth characteristics of lambs in artificial rearing*/  
  if (typew == 2) {  
    fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);  
    z2++;
    outputrw(fr2, fw);  
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[1][1][1], 1000*adgwarL[1][1][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgwarL[1][1][1]);
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[1][2][1], 1000*adgwarL[1][2][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgwarL[1][2][1]);
    if (clt > 2) {
      outputrw(fr2, fw);
      if (crossing == 2) 
	fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[1][3][1], 1000*adgwarL[1][3][2]);
	else fprintf(fw, "%14.0f             -", 1000*adgwarL[1][3][1]);
    }
      else outputr(fr2);  
    if (clt > 3) {
      outputrw(fr2, fw);
      if (crossing == 2) 
	fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[1][4][1], 1000*adgwarL[1][4][2]);
	else fprintf(fw, "%14.0f             -", 1000*adgwarL[1][4][1]);
    }
      else outputr(fr2);  
    outputrw(fr2, fw);
    if (crossing == 2) fprintf(fw, "%8.3f %8.3f",avwar[1][1], avwar[1][2]); 
       else fprintf(fw, "%8.3f     -", avwar[1][1]); 
    outputrw(fr2, fw);  
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[2][1][1], 1000*adgwarL[2][1][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgwarL[2][1][1]);
    outputrw(fr2, fw);
    if (crossing == 2) 
      fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[2][2][1], 1000*adgwarL[2][2][2]);
      else fprintf(fw, "%14.0f             -", 1000*adgwarL[2][2][1]);
    if (clt > 2) {
      outputrw(fr2, fw);
      if (crossing == 2) 
	fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[2][3][1], 1000*adgwarL[2][3][2]);
	else fprintf(fw, "%14.0f             -", 1000*adgwarL[2][3][1]);
    }
      else outputr(fr2);  
    if (clt > 3) {
      outputrw(fr2, fw);
      if (crossing == 2) 
	fprintf(fw, "%14.0f %17.0f", 1000*adgwarL[2][4][1], 1000*adgwarL[2][4][2]);
	else fprintf(fw, "%14.0f             -", 1000*adgwarL[2][4][1]);
    }
      else outputr(fr2);  
    outputrw(fr2, fw);
    if (crossing == 2) fprintf(fw, "%8.3f %8.3f",avwar[2][1], avwar[2][2]); 
       else fprintf(fw, "%8.3f     -", avwar[2][1]); 
  }
  else for (i = 1; i <= 11; i++) outputr(fr2);
  /* 3.4.4 Growth characteristics of breeding lambs in rearing*/
  fprintf(fw, "\n\n3.%d.%d ", z1,z2); outputrw(fr2, fw);  
  z2++;
  outputrw(fr2, fw);  
  printcb9_3(crossing, wrL[1][1][1], wrL[1][1][2], fw);
  outputrw(fr2, fw);  
  printcb9_3(crossing, wmat[1][1], wmat[1][2], fw);
  outputrw(fr2, fw); 
  if (psp[1][2][2] > 0.000001) a2 = ager[1][1]/30.4;
    else a2 = 0;
  printcb8_2(crossing, ager[1][1]/30.4, a2, fw);
  outputrw(fr2, fw);      
  printcb9_3(crossing, wrL[1][2][1], wrL[1][2][2], fw);
  outputrw(fr2, fw); 
  if (psp[1][2][2] > 0.000001) a2 = ager[1][2]/30.4;
    else a2 = 0;
  printcb8_2(crossing, ager[1][2]/30.4, a2, fw);
  if (l1skL[22][1] + l1skL[22][2] > 0.000001) {
    outputrw(fr2, fw);     
    printcb9_3(crossing, wrL[1][3][1], wrL[1][3][2], fw);
    outputrw(fr2, fw);
    if (psp[1][2][2] > 0.000001) a2 = ager[1][3]/30.4;
    else a2 = 0;
    printcb8_2(crossing, ager[1][3]/30.4, a2, fw);
  }
  else for (i = 1; i <= 2; i++) outputr(fr2); 
  outputrw(fr2, fw); 
  printcb9_3(crossing, wrL[2][1][1], wrL[2][1][2], fw);
  outputrw(fr2, fw);  
  printcb9_3(crossing, wmat[2][1], wmat[2][2], fw);
  outputrw(fr2, fw); 
  if (psp[2][2][2] > 0.000001) a2 = ager[2][1]/30.4;
    else a2 = 0;
  printcb8_2(crossing, ager[2][1]/30.4, a2, fw);
  outputrw(fr2, fw);      
  printcb9_3(crossing, wrL[2][2][1], wrL[2][2][2], fw);
  outputrw(fr2, fw); 
  if (psp[2][2][2] > 0.000001) a2 = ager[2][2]/30.4;
    else a2 = 0;
  printcb8_2(crossing, ager[2][2]/30.4, a2, fw);
  z1++;
  z2 = 1;
  /* 3.5 Weight and age of ewes at lambing */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);    
  outputrw(fr2, fw);    
  fprintf(fw, "%8.3f", wlE[1]); 
  outputrw(fr2, fw);  
  fprintf(fw, "%8.2f", ageE[1]/30.4); 
  outputrw(fr2, fw); 
  fprintf(fw, "%8.3f", wlE[2]); 
  outputrw(fr2, fw);
  fprintf(fw, "%8.2f", ageE[2]/30.4); 
  outputrw(fr2, fw);      
  fprintf(fw, "%8.3f", wlE[3]); 
  outputrw(fr2, fw); 
  fprintf(fw, "%8.2f", ageE[3]/30.4); 
  z1++;  
  /* 3.6 Weight and age of rams when entering the flock */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);
  outputrw(fr2, fw); 
  printcb9_3(crossing, wbR[1][1], wbR[1][2], fw);
  outputrw(fr2, fw); 
  printcb8_2(crossing, ageR[1][1]/30.4, ageR[1][2]/30.4, fw);
  z1++;
  /* 3.7 Milk production */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);
  outputrw(fr2, fw);
  fprintf(fw, "%3d", datdry-datlamb);
  if (typeb == 1) {  
    outputrw(fr2, fw);
    fprintf(fw, "%3d", lengthmp);
  }
  else outputr(fr2);
  outputrw(fr2, fw);
  fprintf(fw, "%8.3f", tmilkw);  
  a2 = 0;
  if (typeb ==1) {
    for (i = 1; i <= LL; i++) a2 += milksw[i] * l3E[i];
    outputrw(fr2, fw); 
    fprintf(fw, "%8.3f", a2);
  }
  else outputr(fr2);
  outputrw(fr2, fw);
  fprintf(fw, "%8.3f", tmilkw - a2);     
  if (typeb ==1) {
    outputrw(fr2, fw);  
    for (i = 1; i <= LL; i++)  
      fprintf(fw, "\n  Reproductive cycle %2d: %8.3f", i, milkmpar[i]);
    outputrw(fr2, fw);
    fprintf(fw, "%8.3f", tmilkm);
    outputrw(fr2, fw);
    fprintf(fw, "%6d", dmilkst);
    outputrw(fr2, fw);  
    fprintf(fw, "%8.3f", tmilkst);     
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  z1++;
  /* 3.8 Nutrition costs */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);  
  /* 3.8.1 Ewes */ 
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);  
  outputrw(fr2, fw);  
  for (i = 1; i <= 3*nstgE; i++) {
    i2 =  ceil((float)i/5-0.01);
    for (j = 1; j <= fE; j++) {
      if (j == 1) {
        a2 = plambE[i] * (PsuckE[0][i2] + PsuckE[1][i2]) / l3E[i2];
      }	
      if (j == 2) {
	a2 = 0;
	for (i3 = 2; i3 <= clt; i3++) a2 += PsuckE[i3][i2];
	a2 *= plambE[i] / l3E[i2];  	      
      }  
      if (j > 2) a2 = 1;
      for (k = 1; k <= nfs; k++)
        if (ffE[i][j][k] > 0.000001)
          fprintf(fw, "\n%5d     %7d     %7d            %10.1f", 
	    i,j,k,ffE[i][j][k] / a2);
    }
  }
  outputrw(fr2, fw);  
  outputrw(fr2, fw);  
  for (i = 1; i <= 3*nstgE; i++) 
    fprintf(fw, "\n%5d %14.2f %14.2f",i,costfE[i],costwatE[i]);
  outputrw(fr2, fw);  
  z2++;
  /* 3.8.2 Rams */ 
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);  
  outputrw(fr2, fw);  
  for (i = 1; i <= TR; i++) {
    for (j = 1; j <= fR; j++) {
      for (k = 1; k <= nfs; k++) {
        if (ffR[i][1][j][k] + ffR[i][2][j][k] > 0.000001) {
          fprintf(fw, "\n%5d     %5d     %4d     ",i,j,k);
	  if (ffR[i][1][j][k] > 0.000001) 
	    fprintf(fw, "%10.1f      ", ffR[i][1][j][k]);
	    else fprintf(fw, "       -        ");
	  if (ffR[i][2][j][k] > 0.000001) 
	    fprintf(fw, "%10.1f", ffR[i][2][j][k]);
	    else fprintf(fw, "       -  ");
        }
      }	    
    }
  }
  outputrw(fr2, fw);  
  outputrw(fr2, fw);  
  for (i = 1; i <= TR; i++) {
    if (l1R[i] > 0.000001) {
      if (crossing == 2)
       fprintf(fw, "\n%3d %12.2f %12.2f %14.2f %12.2f",
	 i,costfR[i][1],costfR[i][2],costwatR[i][1],costwatR[i][2]);
      else fprintf(fw, "\n%3d %12.2f        -     %14.2f        -",
	i,costfR[i][1],costwatR[i][1]);
    }
  }  
  outputrw(fr2, fw);    
  z2++;
  /* 3.8.3 Lambs */     
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);    
  outputrw(fr2, fw);  
  for (i = 1; i <= PP; i++) {
    for (j = 1; j <= fL; j++) {
      for (k = 1; k <= nfs; k++) {
        if (ffL[i][1][j][k] + ffL[i][2][j][k] > 0.000001) {
          fprintf(fw, "\n%5d     %5d     %4d     ",i,j,k);
	  if (ffL[i][1][j][k] > 0.000001) 
	    fprintf(fw, "%10.1f      ", ffL[i][1][j][k]);
	    else fprintf(fw, "       -        ");
	  if (ffL[i][2][j][k] > 0.000001) 
	    fprintf(fw, "%10.1f", ffL[i][2][j][k]);
	    else fprintf(fw, "       -  ");
        }
      }	    
    }
  }
  outputrw(fr2, fw);  
  outputrw(fr2, fw);  
  for (i = 1; i <= PP; i++) { 
    if (costfL[i][1] + costfL[i][2] + costwatL[i][1] + costwatL[i][2] >
      0.000001) {
    if (crossing == 2) fprintf(fw, "\n%3d %12.2f %12.2f %14.2f %12.2f",
      i,costfL[i][1],costfL[i][2],costwatL[i][1],costwatL[i][2]);
    else fprintf(fw, "\n%3d %12.2f        -     %14.2f        -",
      i,costfL[i][1],costwatL[i][1]); 
    }  
  }    
  outputrw(fr2, fw);    
  z2=1;
  z1++;
  /* 3.9 Non-feed and total costs */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);    
  /* 3.9.1 Ewes */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);      
  for (i = 1; i <= 3*nstgE; i++)
    fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
      i, costvetE[i], costlabE[i], costsheE[i], costfixE[i], costbedE[i],
      costbreedE[i], costskE[i]);
  outputrw(fr2, fw);
  if (typeb == 1) {
    outputrw(fr2, fw);
    for (i = 1; i <= 3*nstgE; i++)
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	i, costmarkE[i], costdiedE[i], costmilkE[i], costcheeseE[i], costnfE[i],
	costE[i]);
    outputrw(fr2, fw);
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);    
  if (typeb > 1) {
    outputrw(fr2, fw);
    for (i = 1; i <= 3*nstgE; i++)
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f",
	i, costmarkE[i], costdiedE[i], costnfE[i], costE[i]);
    outputrw(fr2, fw);
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);
  outputrw(fr2, fw);
  fprintf(fw, "%9.2f", TcostsE);
  z2++;
  /* 3.9.2 Rams of the breed of the flock */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 1; i <= TR; i++)     
    if (l1aR[i][1] > 0.000001) {
      fprintf(fw, "\n%3d   %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	i, costvetR[i][1], costlabR[i][1], costsheR[i][1], costfixR[i][1], 
	costbedR[i][1], costskR[i][1]);
    }
  outputrw(fr2, fw);
  outputrw(fr2, fw);  
  for (i = 1; i <= TR; i++)     
    if (l1aR[i][1] > 0.000001) {
      fprintf(fw, "\n%3d   %8.2f %9.2f %9.2f %9.2f %9.2f",
	i, costmarkR[i][1], costdiedR[i][1], costpurchR[i][1], costnfR[i][1], 
	costR[i][1]);
    }
  outputrw(fr2, fw);
  outputrw(fr2, fw);
  a2 = 0;
  for (i = 1; i <= TR; i++)
    a2 += costR[i][1] * l1R[i]; 
  fprintf(fw, "%9.2f", a2);  
  z2++;  
  if (crossing == 2) {
    /* 3.9.3 Rams of the breed used for crossing in the flock */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 1; i <= TR; i++)     
      if (l1aR[i][2] > 0.000001) {
	fprintf(fw, "\n%3d   %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costvetR[i][2], costlabR[i][2], costsheR[i][2], costfixR[i][2], 
	  costbedR[i][2], costskR[i][2]);
      }
    outputrw(fr2, fw);
    outputrw(fr2, fw);  
    for (i = 1; i <= TR; i++)     
      if (l1aR[i][2] > 0.000001) {
	fprintf(fw, "\n%3d   %8.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costmarkR[i][2], costdiedR[i][2], costpurchR[i][2], costnfR[i][2], 
	  costR[i][2]);
      }
    outputrw(fr2, fw);
    outputrw(fr2, fw);
    a2 = 0;
    for (i = 1; i <= TR; i++)
      a2 += costR[i][2] * l1R[i]; 
    fprintf(fw, "%9.2f", a2);  
    z2++;  
  }
  else for (i = 1; i <= 5; i++) outputr(fr2);
  /* 3.9.4. Cost per pure-bred lamb till weaning or till the end of artificial 
     rearing */	  
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 2; i <= 32; i++) {    
    if (i == 3) i = 5;
    if (i == 8) i = 30;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	i, costvetL[i][1], costlabL[i][1], costsheL[i][1], costfixL[i][1], 
	costbedL[i][1], costskL[i][1]);
  }   
  outputrw(fr2, fw);
  outputrw(fr2, fw);  
  for (i = 2; i <= 32; i++) {    
    if (i == 3) i = 5;
    if (i == 8) i = 30;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f",
	i, costmarkL[i][1], costdiedL[i][1], costnfL[i][1], costL[i][1]);
  }
  outputrw(fr2, fw);
  z2++;  
  if (crossing == 2) {
    /* 3.9.5. Cost per cross-bred lamb till weaning or till the end of artificial 
       rearing */	  
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 2; i <= 32; i++) {    
      if (i == 3) i = 5;
      if (i == 8) i = 30;
      if (l1skL[i][1] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costvetL[i][2], costlabL[i][2], costsheL[i][2], costfixL[i][2], 
	  costbedL[i][2], costskL[i][2]);
    }   
    outputrw(fr2, fw);
    outputrw(fr2, fw);  
    for (i = 2; i <= 32; i++) {    
      if (i == 3) i = 5;
      if (i == 8) i = 30;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f",
	  i, costmarkL[i][2], costdiedL[i][2], costnfL[i][2], costL[i][2]);
    }
    outputrw(fr2, fw);
    z2++;  
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  /* 3.9.6. Cost per pure-bred female breeding lamb */	  
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 4; i <= 25; i++) {    
    if (i == 5) i = 13;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	i, costvetL[i][1], costlabL[i][1], costsheL[i][1], costfixL[i][1], 
	costbedL[i][1], costskL[i][1]);
  }   
  outputrw(fr2, fw);
  outputrw(fr2, fw);  
  for (i = 4; i <= 25; i++) {    
    if (i == 5) i = 13;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f",
	i, costmarkL[i][1], costdiedL[i][1], costbreedL[i][1], costnfL[i][1], 
	costL[i][1]);
  }
  outputrw(fr2, fw);
  z2++;  
  a2 = l1skL[4][2];
  for (i = 13; i <= 25; i++) a2 += l1skL[i][2];
  if (crossing == 2 && a2 > 0.000001) {
    /* 3.9.7 Cost per cross-bred female breeding lambs */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 4; i <= 25; i++) {    
      if (i == 5) i = 13;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costvetL[i][2], costlabL[i][2], costsheL[i][2], costfixL[i][2], 
	  costbedL[i][2], costskL[i][2]);
    }   
    outputrw(fr2, fw);
    outputrw(fr2, fw);  
    for (i = 4; i <= 25; i++) {    
      if (i == 5) i = 13;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costmarkL[i][2], costdiedL[i][2], costbreedL[i][2], costnfL[i][2], 
	  costL[i][2]);
    }
    outputrw(fr2, fw);
    z2++;  
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  /* 3.9.8. Cost per pure-bred male breeding lamb */	  
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 29; i <= 42; i++) {    
    if (i == 30) i = 38;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	i, costvetL[i][1], costlabL[i][1], costsheL[i][1], costfixL[i][1], 
	costbedL[i][1], costskL[i][1]);
  }   
  outputrw(fr2, fw);
  outputrw(fr2, fw);  
  for (i = 29; i <= 42; i++) {    
    if (i == 30) i = 38;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f",
	i, costmarkL[i][1], costdiedL[i][1], costbreedL[i][1], costnfL[i][1], 
	costL[i][1]);
  }
  outputrw(fr2, fw);
  z2++; 
  a2 = l1skL[29][2];
  for (i = 38; i <= 42; i++) a2 += l1skL[i][2]; 
  if (crossing == 2 && a2 > 0.000001) {
    /* 3.9.9 Cost per cross-bred male breeding lamb */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 29; i <= 42; i++) {    
      if (i == 30) i = 38;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costvetL[i][2], costlabL[i][2], costsheL[i][2], costfixL[i][2], 
	  costbedL[i][2], costskL[i][2]);
    }   
    outputrw(fr2, fw);
    outputrw(fr2, fw);  
    for (i = 29; i <= 42; i++) {    
      if (i == 30) i = 38;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d  %8.2f %9.2f %9.2f %9.2f %9.2f",
	  i, costmarkL[i][2], costdiedL[i][2], costbreedL[i][2], costnfL[i][2], 
	  costL[i][2]);
    }
    outputrw(fr2, fw);
    z2++;  
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  if (fatpb + fatcb > 0) {
    /* 3.9.10 Cost per fattened lamb */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 8; i <= 42 + lf[0]; i++) { 
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d   %8.2f %9.2f %9.2f %9.2f %9.2f",
	  i, j, costvetL[i][j], costlabL[i][j], costsheL[i][j], costfixL[i][j], 
	  costbedL[i][j]);
      }
    }
    outputrw(fr2, fw); 
    outputrw(fr2, fw); 
    for (i = 8; i <= 42 + lf[0]; i++) { 
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d   %8.2f %9.2f %9.2f %9.2f",
	  i, j, costskL[i][j], costmarkL[i][j], costnfL[i][j], costL[i][j]);
      }
    }
    outputrw(fr2, fw);
    z2++; 
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  if (fatpb + fatcb > 0) {
    /* 3.9.11 Cost per lamb died in fattening */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 3; i <= 48; i++) { 
      if (i == 4) i = 28;
      if (i == 29) i = 48;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d   %8.2f %9.2f %9.2f %9.2f %9.2f",
	  i, j, costvetL[i][j], costlabL[i][j], costsheL[i][j], costfixL[i][j], 
	  costbedL[i][j]);
      }
    }
    outputrw(fr2, fw); 
    outputrw(fr2, fw); 
    for (i = 3; i <= 48; i++) { 
      if (i == 4) i = 28;
      if (i == 29) i = 48;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d   %8.2f %9.2f %9.2f",
	  i, j, costdiedL[i][j], costnfL[i][j], costL[i][j]);
      }
    }
    outputrw(fr2, fw); 
  }
  else for (i = 1; i <= 4; i++) outputr(fr2);
  z1++;
  z2 = 1;
  /* 3.10 Meat prices and revenues */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw); 
  /* 3.10.1 Meat prices */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  if (priceS < 3) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prlwS[1], prlwS[2], fw);
  }  
  else outputr(fr2);
  if (priceS > 2) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prcwS[1], prcwS[2], fw);
  }  
  else outputr(fr2);
  if (pricewL < 3 && pricewL > 0) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prlwwL[1], prlwwL[2], fw);
  }  
  else outputr(fr2);
  if (pricewL == 3) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prcwwL[1], prcwwL[2], fw);
  }  
  else outputr(fr2);
  if (pricewL == 4) {
    if (l1skL[7][1] + l1skL[7][2] > 0.000001) {
      outputrw(fr2, fw); 
      printcb8_2(crossing, prcwcwL[1][1], prcwcwL[1][2], fw);
    }
    else outputr(fr2);
    if (l1skL[32][1] + l1skL[32][2] > 0.000001) {
      outputrw(fr2, fw); 
      printcb8_2(crossing, prcwcwL[2][1], prcwcwL[2][2], fw);
    }
    else outputr(fr2);
  }  
  else for (i = 1; i <= 2; i++) outputr(fr2); 
  if (pricefL < 3 && pricefL > 0) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prlwfL[1], prlwfL[2], fw);
  }  
  else outputr(fr2);
  if (pricefL > 2) {
    outputrw(fr2, fw); 
    printcb8_2(crossing, prcwfL[1], prcwfL[2], fw);
  }  
  else outputr(fr2);
  z2++;
  /* 3.10.2 Revenues per ewe and reproductive cycle */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);     
  for (i = 1; i <= 3*nstgE; i++)
    fprintf(fw, "\n%5d     %9.2f %9.2f %9.2f %9.2f %9.2f %9.2f",
      i, revwE[i], revcE[i], revskrE[i], revsktE[i], revmanE[i], revE[i]);
  outputrw(fr2, fw);
  if (typeb == 1) {
    outputrw(fr2, fw);
    for (i = 1; i <= 3*nstgE; i++)
      fprintf(fw, "\n%5d     %9.2f %9.2f",
	i, revmilkE[i], revcheeseE[i]);
    outputrw(fr2, fw);
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);   
  outputrw(fr2, fw);
  fprintf(fw, "%9.2f", TrevE);
  z2++;
  /* 3.10.3 Revenues per ram of the breed of the flock and reproductive cycle */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);     
  for (i = 1; i <= TR; i++)
    if (l1aR[i][1] > 0.000001) {
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	i, revwR[i][1], revcR[i][1], revskrR[i][1], revsktR[i][1], revmanR[i][1], 
	revsoldR[i][1], revR[i][1]);
    }
  outputrw(fr2, fw);
  outputrw(fr2, fw);
  a2 = 0;
  for (i = 1; i <= TR; i++)
    a2 += revR[i][1] * l1R[i]; 
  fprintf(fw, "%9.2f", a2);  
  z2++;
  if (crossing == 2) {
    /* 3.10.4 Revenues per ram of the breed used for crossing in the flock and 
       per reproductive cycle */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);     
    for (i = 1; i <= TR; i++)
      if (l1aR[i][2] > 0.000001) {
	fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	  i, revwR[i][2], revcR[i][2], revskrR[i][2], revsktR[i][2], revmanR[i][2], 
	  revsoldR[i][2], revR[i][2]);
      }
    outputrw(fr2, fw);
    outputrw(fr2, fw);
    a2 = 0;
    for (i = 1; i <= TR; i++)
      a2 += revR[i][2] * l1R[i]; 
    fprintf(fw, "%9.2f", a2);  
    z2++;
  }
  else for (i = 1; i <= 3; i++) outputr(fr2);    
  /* 3.10.5 Revenues per pure-bred lamb till weaning and till the end of
     artificial rearing */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);          
  for (i = 2; i <= 32; i++) {    
    if (i == 3) i = 5;
    if (i == 8) i = 30;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	i, revwL[i][1], revcL[i][1], revskrL[i][1], revsktL[i][1], revmanL[i][1], 
	revL[i][1]);
  }  
  outputrw(fr2, fw);
  z2++;   
  if (crossing == 2) {
    /* 3.10.6 Revenues per cross-bred lamb till weaning and till the end of
       artificial rearing */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);          
    for (i = 2; i <= 32; i++) {    
      if (i == 3) i = 5;
      if (i == 8) i = 30;
      if (l1skL[i][1] > 0.000001)
	fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	  i, revwL[i][2], revcL[i][2], revskrL[i][2], revsktL[i][2], 
	  revmanL[i][2], revL[i][2]);
    }  
    outputrw(fr2, fw);
    z2++;   
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);      
  /* 3.10.7 Revenues per pure-bred female breeding lamb */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 4; i <= 25; i++) {    
    if (i == 5) i = 13;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	i, revwL[i][1], revcL[i][1], revskrL[i][1], revsktL[i][1], 
	revmanL[i][1], revsbL[i][1], revL[i][1]);
  }
  outputrw(fr2, fw);
  z2++;   
  a2 = l1skL[4][2];
  for (i = 13; i <= 25; i++) a2 += l1skL[i][2];
  if (crossing == 2 && a2 > 0.000001) {
    /* 3.10.8 Revenues per cross-bred female breeding lamb */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 4; i <= 25; i++) {    
      if (i == 5) i = 13;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	  i, revwL[i][2], revcL[i][2], revskrL[i][2], revsktL[i][2], 
	  revmanL[i][2], revsbL[i][2], revL[i][2]);
    }
    outputrw(fr2, fw);
    z2++;   
  }  
  else for (i = 1; i <= 2; i++) outputr(fr2);      
  /* 3.10.9 Revenues per pure-bred male breeding lamb */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  for (i = 29; i <= 42; i++) {    
    if (i == 30) i = 38;
    if (l1skL[i][1] > 0.000001)
      fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	i, revwL[i][1], revcL[i][1], revskrL[i][1], revsktL[i][1], 
	revmanL[i][1], revsbL[i][1], revL[i][1]);
  }
  outputrw(fr2, fw);
  z2++;   
  a2 = l1skL[29][2];
  for (i = 38; i <= 42; i++) a2 += l1skL[i][2]; 
  if (crossing == 2 && a2 > 0.000001) {
    /* 3.10.10 Revenues per cross-bred male breeding lamb */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 29; i <= 42; i++) {    
      if (i == 30) i = 38;
      if (l1skL[i][2] > 0.000001)
	fprintf(fw, "\n%3d   %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	  i, revwL[i][2], revcL[i][2], revskrL[i][2], revsktL[i][2], 
	  revmanL[i][2], revsbL[i][2], revL[i][2]);
    }  
    outputrw(fr2, fw);
    z2++;   
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);      
  if (fatpb + fatcb > 0) {
    /* 3.10.11 Revenues per fattened lamb */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 8; i <= 42 + lf[0]; i++) { 
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d    %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f",
	  i, j, revwL[i][j], revcL[i][j], revskrL[i][j], revsktL[i][j], 
	  revmanL[i][j], revL[i][j]);
      }
    }
    outputrw(fr2, fw); 
    z2++; 
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);
  if (fatpb + fatcb > 0) {
    /* 3.10.12 Revenues per lamb died in fattening */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 3; i <= 48; i++) { 
      if (i == 4) i = 28;
      if (i == 29) i = 48;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001)
	fprintf(fw, "\n%3d %4d    %8.2f %8.2f %8.2f",
	  i, j, revwL[i][j], revmanL[i][j], revL[i][j]);
      }
    }
    outputrw(fr2, fw); 
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);
  z1++;
  z2 = 1;
  /* 3.11. Summing-up of revenues and costs for some types of animals from birth 
    till selling, till slaughter or till entering the flock */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw); 
  if (typew == 1) {
    outputrw(fr2, fw); 
    fprintf(fw, "%9.2f",costlamb);
  }  
  else outputr(fr2);
  if (typew == 2) {
    outputrw(fr2, fw); 
    fprintf(fw, "%9.2f",costlamb);
  }
  else outputr(fr2);
  /* 3.11.1 Total revenues and costs per replacement female or male */
  fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
  if (typew == 1) i3 = 0;
    else i3 = 1;
  outputrw(fr2, fw); 
  fprintf(fw, "%10.2f %10.2f",revL[5][1] + i3*revL[6][1] + revL[14][1] + 
    revL[16][1], costL[5][1] + i3*costL[6][1] + costL[14][1] + costL[16][1]);
  outputrw(fr2, fw); 
  fprintf(fw, "%10.2f %10.2f", revL[30][1] + i3*revL[31][1] + revL[39][1],
    costL[30][1] + i3*costL[31][1] + costL[39][1]);
  outputrw(fr2, fw);  
  fprintf(fw, "%10.2f %10.2f",revL[5][1] + i3*revL[6][1] + revL[14][1] + 
    revL[18][1] + revL[20][1], costL[5][1] + i3*costL[6][1] + costL[14][1] +
    costL[18][1] + costL[20][1]);
  outputrw(fr2, fw); 
  fprintf(fw, "%10.2f %10.2f", revL[30][1] + i3*revL[31][1] + revL[39][1] +
    revL[41][1], costL[30][1] + i3*costL[31][1] + costL[39][1] + costL[41][1]);
  if (l1skL[22][1] + l1skL[22][2] > 0.000001) {
    outputrw(fr2, fw); 
    fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[14][1] + 
      revL[18][1] + revL[22][1] + revL[24][1], costL[5][1] + i3*costL[6][1] +
      costL[14][1] + costL[18][1] + costL[22][1] + costL[24][1]);
  }    
  else outputr(fr2);
  z2++;
  if (l1skL[13][1] + l1skL[15][1] + l1skL[19][1] + l1skL[23][1] + 
    l1skL[26][1] + l1skL[38][1] + l1skL[40][1] > 0.0001) {
    /* 3.11.2 Total revenues and costs per sold female or male pure-bred lamb */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    if (l1skL[13][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[13][1],
	costL[5][1] + i3*costL[6][1] + costL[13][1]);
    }
    else outputr(fr2);
    if (l1skL[26][1] > 0.000001) {    
      outputrw(fr2, fw); 
      fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[14][1] +
	revL[26][1], costL[5][1] + i3*costL[6][1] + costL[14][1] + costL[26][1]);
    }
    else outputr(fr2);
    if (l1skL[15][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[14][1] +
        revL[15][1], costL[5][1] + i3*costL[6][1] + costL[14][1] + 
	costL[15][1]);
    }
    else outputr(fr2);
    if (l1skL[19][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[14][1] + 
        revL[18][1] + revL[19][1], costL[5][1] + i3*costL[6][1] + costL[14][1] +
	costL[18][1] + costL[19][1]);
    }
    else outputr(fr2);
    if (l1skL[23][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][1] + i3*revL[6][1] + revL[14][1] + 
        revL[18][1] + revL[22][1] + revL[23][1], costL[5][1] + i3*costL[6][1] + 
	costL[14][1] + costL[18][1] +costL[22][1] + costL[23][1]);
    }
    else outputr(fr2);
    if (l1skL[38][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[30][1] + i3*revL[31][1] + revL[38][1],
        costL[30][1] + i3*costL[31][1] + costL[38][1]);
    }
    else outputr(fr2);
    if (l1skL[40][1] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[30][1] + i3*revL[31][1] + revL[39][1] +
        revL[40][1], costL[30][1] + i3*costL[31][1] + costL[39][1] + 
	costL[40][1]);
    }
    else outputr(fr2); 
    z2++;
  }   
  else for (i = 1; i <= 8; i++) outputr(fr2); 
  if (l1skL[13][2] + l1skL[15][2] + l1skL[19][2] + l1skL[23][2] + 
    l1skL[26][2] + l1skL[38][2] + l1skL[40][2] > 0.000001) { 
    /* 3.11.3 Total revenues and costs per sold female or male cross-bred lamb */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    if (l1skL[13][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][2] + i3*revL[6][2] + revL[13][2],
	costL[5][2] + i3*costL[6][2] + costL[13][2]);
    }
    else outputr(fr2);
    if (l1skL[26][2] > 0.000001) {    
      outputrw(fr2, fw); 
      fprintf(fw, "%10.2f %10.2f", revL[5][2] + i3*revL[6][2] + revL[14][2] +
	revL[26][2], costL[5][2] + i3*costL[6][2] + costL[14][2] + costL[26][2]);
    }
    else outputr(fr2);
    if (l1skL[15][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][2] + i3*revL[6][2] + revL[14][2] +
        revL[15][2], costL[5][2] + i3*costL[6][2] + costL[14][2] + 
	costL[15][2]);
    }
    else outputr(fr2);
    if (l1skL[19][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][2] + i3*revL[6][2] + revL[14][2] + 
        revL[18][2] + revL[19][2], costL[5][2] + i3*costL[6][2] + costL[14][2] +
	costL[18][2] + costL[19][2]);
    }
    else outputr(fr2);
    if (l1skL[23][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[5][2] + i3*revL[6][2] + revL[14][2] + 
        revL[18][2] + revL[22][2] + revL[23][2], costL[5][2] + i3*costL[6][2] + 
	costL[14][2] + costL[18][2] +costL[22][2] + costL[23][2]);
    }
    else outputr(fr2);
    if (l1skL[38][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[30][2] + i3*revL[31][2] + revL[38][2],
        costL[30][2] + i3*costL[31][2] + costL[38][2]);
    }
    else outputr(fr2);
    if (l1skL[40][2] > 0.000001) {    
      outputrw(fr2, fw);  
      fprintf(fw, "%10.2f %10.2f", revL[30][2] + i3*revL[31][2] + revL[39][2] +
        revL[40][2], costL[30][2] + i3*costL[31][2] + costL[39][2] + 
	costL[40][2]);
    }
    else outputr(fr2);
    z2++;
  }   
  else for (i = 1; i <= 8; i++) outputr(fr2);
  if (fatpb + fatcb > 0) {
    /* 3.11.4 Final age and weight and total revenues and costs per 
       fattened lamb */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    for (i = 8; i <= 42 + lf[0]; i++) { 
      if (i == 8 + lf[1]) i = 33;
      if (i == 33 + lf[2]) i = 43;
      for (j = 1; j <= crossing; j++) {
        if (l1skL[i][j] > 0.000001) {
	  fprintf(fw, "\n%3d %4d  %12.2f %11.2f", i, j, agetP[i][j]/30.4, 
	    wP[i][j]);
	  if (i < 13) fprintf(fw, "%12.2f %11.2f", revL[5][j] + i3*revL[6][j] + 
	    revL[i][j], costL[5][j] + i3*costL[6][j] + costL[i][j]);
	  else fprintf(fw, "%12.2f %11.2f", revL[30][j] + i3*revL[31][j] + 
	    revL[i][j], costL[30][j] + i3*costL[31][j] + costL[i][j]);  
	}
      }
    }
    outputrw(fr2, fw); 
    z2++; 
  }
  else for (i = 1; i <= 2; i++) outputr(fr2);
  if (typeb == 1) {
    /* 3.11.5 Total revenues from milk and cheese */	    
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw); 
    a2 = a3 = 0;
    for (i = 1; i <= TE; i++) {
      a2 += revmilkE[i] * l1E[i];
      a3 += revcheeseE[i] * l1E[i];
    }
    outputrw(fr2, fw);     
    fprintf(fw, "%10.2f", a2);
    outputrw(fr2, fw);     
    fprintf(fw, "%10.2f", a3);
  }
  else for (i = 1; i <= 3; i++) outputr(fr2);
  z1++;
  z2 = 1;
  /* 3.12 Miscellaneous */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);   
  if (priceS == 2 || priceS == 4 || pricewL == 2 || pricewL == 4 ||
    pricefL == 2 || pricefL == 4) {
    /* 3.12.1 Mean classes for quality of life animals or for carcass quality
       for slaughter animals */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);    
    if (priceS == 2) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avclS[1],avclS[2],fw);
    }
    else outputr(fr2);
    if (priceS == 4) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avfleshS[1],avfleshS[2],fw);
    }
    else outputr(fr2);
    if (priceS == 4) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avfcS[1],avfcS[2],fw);
    }
    else outputr(fr2);    
    if (pricefL == 2) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avclfL[1],avclfL[2],fw);
    }
    else outputr(fr2);    
    if (pricefL == 4 || pricewL == 4) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avfleshL[1],avfleshL[2],fw);
    }
    else outputr(fr2);    
    if (pricefL == 4 || pricewL == 4) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avfcL[1],avfcL[2],fw);
    }
    else outputr(fr2);    
    if (pricewL == 2) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avclwL[1],avclwL[2],fw);
    }
    else outputr(fr2);    
    if (pricewL == 4) {
      outputrw(fr2, fw);   
      printcb8_2(crossing,avcqwL[1],avcqwL[2],fw);    
    }
    else outputr(fr2);    
    z2++;
  }  
  else for (i = 1; i <= 9; i++) outputr(fr2);
  if (npurchFP + ppurchMP + crossing - 1 > 0.000001) {
    /* 3.12.2 Costs for purchasing replacement */
    fprintf(fw, "\n\n3.%d.%d", z1,z2); outputrw(fr2, fw);    
    if (npurchFP > 0.000001) {
      outputrw(fr2, fw);   
      fprintf(fw, "%9.4f ", npurchFP);
      outputrw(fr2, fw);   
      fprintf(fw, "%9.2f", costpurchFP);
    }
    else for (i = 1; i <= 2; i++) outputr(fr2);
    if (ppurchMP > 0.000001) {    
      outputrw(fr2, fw);   
      fprintf(fw, "%9.4f", neweR[1] * ppurchMP);
      outputrw(fr2, fw);   
      fprintf(fw, "%9.2f", neweR[1] * ppurchMP * costpurchR[1][1]);
    }
    else for (i = 1; i <= 2; i++) outputr(fr2);
    if (crossing == 2) {    
      outputrw(fr2, fw);   
      fprintf(fw, "%9.4f", neweR[2]);
      outputrw(fr2, fw);                 
      fprintf(fw, "%9.2f", neweR[2] * costpurchR[1][2]);
    }
    else for (i = 1; i <= 2; i++) outputr(fr2);
  }
  else for (i = 1; i <= 7; i++) outputr(fr2);
  z1++;
  z2 = 1;
  /* 3.13 Profit */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);   
  outputrw(fr2, fw);
  fprintf(fw, "%12.2f", Trev);
  outputrw(fr2, fw);
  fprintf(fw, "%12.2f", Tsub);      
  outputrw(fr2, fw);
  fprintf(fw, "%12.2f", Tcosts);
  outputrw(fr2, fw);
  fprintf(fw, "%12.2f", Tprof);    
  outputrw(fr2, fw);
  fprintf(fw, "%10.2f", profsub);    
  outputrw(fr2, fw);
  fprintf(fw, "%10.2f", profnsub);    
  z1++;
  /* 3.14 Marginal economic values */
  fprintf(fw, "\n\n3.%d", z1); outputrw(fr2, fw);   
  for (i = 1; i < NT; i++) {
    if (i == 2 && typew == 2) {
      i = 4;
      for (j = 1; j <= 2; j++) outputr(fr2);
    }
    if (i == 4 && typew == 1) {
      i = 6;
      for (j = 1; j <= 2; j++) outputr(fr2);
    }
    if (i == 7 && fatpb + fatcb == 0) {
      i = 8;
      outputr(fr2);
    }
    if (i == 9 && pricewL < 3) {
      i = 10;
      outputr(fr2);
    }
    if (i == 10 && pricefL < 3) {
      i = 11;
      outputr(fr2);
    }
    if (i == 11 && priceS < 3) {
      i = 12;
      outputr(fr2);
    }
    if (i == 12 && pricewL != 2) {
      i = 13;
      outputr(fr2);
    }
    if (i == 13 && pricefL != 2) {
      i = 14;
      outputr(fr2);
    }
    if (i == 14 && priceS != 2) {
      i = 15;
      outputr(fr2);
    }
    if (i == 15 && priceS != 4) {
      i = 17;
      for (j = 1; j <= 2; j++) outputr(fr2);
    }
    if (i == 17 && pricefL != 4 && pricewL != 4) {
      i = 19;
      for (j = 1; j <= 2; j++) outputr(fr2);
    }
    if (i == 19 && pricewL != 4) {
      i = 20;
      outputr(fr2);
    }
    if (i == 24 && typew != 1) {
      i = 25;
      outputr(fr2);
    }
    if (i == 25 && typew != 2) {
      i = 26;
      outputr(fr2);
    }
    if (i == 28 && typeb != 1) {
      for (j = 1; j <= 7; j++) outputr(fr2);
      i = 35;
    }
    outputrw(fr2, fw);
    if (ewopt == 0) fprintf(fw, "%10.3f", evp[i][1]);
    if (ewopt == 2 && evp[i][2] > 0.000001) 
      fprintf(fw, "%10.3f %10.3f", evp[i][1], evp[i][2]); 
    if (ewopt == 2 && evp[i][2] < 0.000001) 
      fprintf(fw, "%10.3f      -", evp[i][1]); 
  }
  outputrw(fr2, fw);

  fclose(fr2);
  fclose(fw);

Inputgf:
  if (breed == 1 && ((prods == 1 && calc == 1) || (prods == 2 && calc == 3))) {
    printf("Writing data to INPUTGFS01A.TXT\n");   
    fw = fopen("INPUTGFS01A.TXT", "w");
    fprintf(fw, "%8.3f\n",u);
    fprintf(fw, "%d\n",RR);
    for (i = 1; i <= RR; i++) fprintf(fw, "%11.7f\n",l4R[i]);
    fprintf(fw, "%d\n",LL);
    for (i = 1; i <= LL; i++) fprintf(fw, "%11.7f\n",l4E[i]);
    for (i = 1; i < NT; i++) {    
      if (fabs(evp[i][1]) < 0.00001) fprintf(fw, "0.000000\n");
      else fprintf(fw, "%11.5f\n",evp[i][1]);
    }   
    fprintf(fw, "%8.2f\n",ageR[1][1]);
    fprintf(fw, "%8.2f\n",ageE[1]);  
    fclose(fw);
  }
  if (prods == 2 && breed == 2 && calc == 4) {
    printf("Writing data to INPUTGFS01B.TXT\n");   
    fw = fopen("INPUTGFS01B.TXT", "w");
    fprintf(fw, "%d\n",RR);
    for (i = 1; i <= RR; i++) fprintf(fw, "%11.7f\n",l4R[i]);
    fprintf(fw, "%d\n",LL);
    for (i = 1; i <= LL; i++) fprintf(fw, "%11.7f\n",l4E[i]);
    for (i = 1; i < NT; i++) {    
      if (fabs(evp[i][1]) < 0.00001) fprintf(fw, "0.000000\n");
      else fprintf(fw, "%11.5f\n",evp[i][1]);
    }   
    for (i = 1; i < NT; i++) {    
      if (fabs(evp[i][2]) < 0.00001) fprintf(fw, "0.000000\n");
      else fprintf(fw, "%11.5f\n",evp[i][2]);
    }   
    fprintf(fw, "%8.2f\n",ageR[1][1]);
    fprintf(fw, "%8.2f\n",ageR[1][2]);
    fprintf(fw, "%8.2f\n",ageE[1]);
    for (i = 0; i < LL; i++) fprintf(fw, "%11.7f\n",pcrossE[i]);  
    fclose(fw);
  }
    
  printf("\nThank you for using the program EWSH2.\n");
  if (breed == 1) 
    printf("The results are given in the file resA0%d.\n", calc);
  if (breed == 2) 
    printf("The results are given in the file resB0%d.\n", calc);
  if (breed == 1) 
    printf("The values of all variables are given in the file CHECKSA0%d.\n", calc);
  if (breed == 2) 
    printf("The values of all variables are given in the file CHECKSB0%d.\n", calc);
END:  kon = clock();
  fw3 = fopen("ERROR.TXT", "w");
  fprintf(fw3, "%d\n",errmess);
  fclose(fw3);
  printf("The program needed %6.2f seconds.\n", ((double) (kon - zac)) / ((double) CLOCKS_PER_SEC));
 
      
} /* End of the main program */


/* Function for reading data from file TEXT_OUT.TXT and writing them to the output file*/
void outputrw(FILE *fr, FILE *fw)
{
  int a, a1, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a < 2);
}
/* Function for reading data from file TEXTD_OUT.TXT without writing them to the output file*/
void outputr(FILE *fr)
{
  int a, a1, z;
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;	
       } while (a<2);
}
/* Function for reading system variables and writing them to output file */
void sysvar(FILE *fr, FILE *fw)
{
  int a, b, i, z;
  for (i = 1; i <= 7; i++)
  { fscanf(fr, "%d", &b);
    a = 0;
    do {z = getc(fr);
        if (z == '"') a++;
	if (z != '"') putc(z, fw); 
       } while (a<2);
    fprintf(fw, ":  %d", b);   
  }
  fprintf(fw, "\n");   
}

/* Function for reading system variables to the main program */
int readsyva(FILE *fr)
{
  int a, b, z;
  fscanf(fr, "%d", &b);
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 2);  
  return b;
}

/* Skipping comments in the input files */
void readcom(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='/') a++;
  } while (a < 2);  
}

/* Function for reading data in format float */
float readdat(FILE *fr)
{
  float pa;
  fscanf(fr, "%f", &pa);
  readdes(fr);
  return pa;
}

/* Function for reading data in format int */
int readdat1(FILE *fr)
{
  int pa;
  fscanf(fr, "%d", &pa);
  readdes(fr);
  return pa;
}

/* Function for reading data in format float and writing them to results */
float readfloat(FILE *fw, FILE *fr)
{
  int a, a1, z;
  float d2;
  fscanf(fr, "%f", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):%12.4f ", d2);   
  return d2;
}

/* Function for reading data in format int and writing them to results */
float readint(FILE *fw, FILE *fr)
{
  int a, a1, z, d2;
  fscanf(fr, "%d", &d2);
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"') putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
    fprintf(fw,"):  %d ", d2);   
  return d2;
}

/* Skipping the description and the unit of the input parameter */
void readdes(FILE *fr)
{
  int a, z;
  a = 0;
  do {z = getc(fr);
      if (z=='"') a++;
  } while (a < 4);  
}

/* Function for reading the head of a input file
   and writing it to the output file*/
void inp00(FILE *fw, int n2, int zz, int breed)
{
  if (zz<10) fprintf(fw, "2.%1d Data from file ", zz);
    else fprintf(fw, "2.%2d Data from file ", zz);
  if (n2<10 && breed == 1) fprintf(fw, "INPUTS0%dA.TXT\n", n2);
  if (n2<10 && breed == 2) fprintf(fw, "INPUTS0%dB.TXT\n", n2);
  if (n2>9 && breed == 1) fprintf(fw, "INPUTS%dA.TXT\n", n2);
  if (n2>9 && breed == 2) fprintf(fw, "INPUTS%dB.TXT\n", n2);
  if (zz<10) fprintf(fw, "--------------------------------\n");
    else fprintf(fw, "---------------------------------\n");
}  

/* Function for reading system variables and writing them to output file */
void wrides(FILE *fr, FILE *fw)
{
int a, a1, z;
  fprintf(fw, "\n");
  a = 0;
  do {z = getc(fr);
      if (z == '"') a++;
      if (z != '"' && a > 0) putc(z, fw); 
     } while (a<2);
  a = 0;
  a1 = 0;    
  do {z = getc(fr);
      if (z == '"') a++;
      if (a == 1 && a1 == 0)
	{ fprintf(fw, "   (");
	  a1++;
	} 
      if (z != '"') putc(z, fw); 
     } while (a<2);
  fprintf(fw,"):");
}

/* Function for calculating days from January 1st from month and day */
int dsjf(int m, int d)
{ 
  int ds;
  ds = d;
  if (m >= 2) ds=ds+31;
  if (m >= 3) ds=ds+28;
  if (m >= 4) ds=ds+31;
  if (m >= 5) ds=ds+30;
  if (m >= 6) ds=ds+31;
  if (m >= 7) ds=ds+30;
  if (m >= 8) ds=ds+31;
  if (m >= 9) ds=ds+31;
  if (m >= 10) ds=ds+30;
  if (m >= 11) ds=ds+31;
  if (m >= 12) ds=ds+30;
  return ds;
}  

/* Function for reading data in format year-month-day */
int readymd(FILE *fr, FILE *fw)
{
  int ye, mo, da, dsj;
  fscanf(fr, "%d %d %d", &ye, &mo, &da);
  dsj = dsjf(mo,da)+ye*365;
  if (mo < 1 || mo > 12) dsj = -1;
  if (da < 1 || da > 31) dsj = -1;
  if (mo == 2 && da > 29) dsj = -1; 
  if ((mo == 4 || mo == 6 || mo == 9 || mo == 11) && da > 30) dsj = -1; 
  if (ye < 0 || ye > 10) dsj = -1;
  wrides(fr,fw);
  fprintf(fw, "%d %d %d\n", ye, mo, da);
  fprintf(fw, "   Days from January 1st of year zero: %d", dsj);
  return dsj;
}     

/* Probit function */
double probit (double y) {
  double x1, x2, y1, y2;
  int i;
  x1=-5;
  x2=5;  
  for (i=1; i<=200; i++){
  y1=normdis(x1);
  y2=normdis(x2);
  if (y2<y) x2=x2+(x2-x1)/2;
  if (y1>y) x1=x1-(x2-x1)/2;
  if (y2-y>y-y1) x2=x2-(x2-x1)/10;
    else x1=x1+(x2-x1)/10;
    }
  return (x1+x2)/2;
  }

/* Normal distribution */    
double normdis(double x) {
  double u;
  if (x<=0) u = .5 - erf(-x/sqrt(2.))/2;  
  if (x>0) u = .5 + erf(x/sqrt(2.))/2;  
  return u;
  }

/* Maximum of two numbers */
float maxi(float a, float b) {
  float c;
  c = a;
  if (a < b) c = b;
  return c;
}

/* Function for the calculation of the somatic cell score from the somatic
   cell count */
float scs(float x) 
{
  float y;
  y = log((double)(x/100000))/0.69314718+3;
  return y;
}   

/* Linear regression on fat or protein content */
float linregm (float xave, float sigma, float xmin, float xmax, float b0, float b1, float xbar) {
  double Phimin, Phimax, sum, dif, inc;
  int i;
  if (xmax > xave + 4*sigma) xmax = xave + 4*sigma;
  if (xmin < xave - 4*sigma) xmin = xave - 4*sigma;  
  Phimin= normdis((double) ((xmin-xave)/sigma));
  Phimax= normdis((double) ((xmax-xave)/sigma));
  sum = 0;
  if (fabs(b1) > 0.000001) {
    inc = (xmax-xmin)/500;
    for (i=1; i<=500; i++) {
      dif = normdis((double) ((xmin+i*inc-xave)/sigma)) -
              normdis((double) ((xmin+(i-1)*inc-xave)/sigma));
      sum += b1*dif*(xmin-xbar+(2*i-1)*inc/2);	    
      }
    }
  if (fabs(b0) > 0.000001) sum += b0*(Phimax-Phimin);  
  return (float) sum;
  }

/* Function for printing results with or without crossbreeding */
void printcb8_2(int cb, float par1, float par2, FILE *fw)
{
  if (cb == 2 && par2 > 0.000001) fprintf(fw, "%8.2f %8.2f", par1, par2);
  if ((cb == 2 && par2 < 0.000001) || cb == 1) 
    fprintf(fw, "%8.2f      -", par1);
}  
/* Function for printing results with or without crossbreeding */
void printcb9_3(int cb, float par1, float par2, FILE *fw)
{
  if (cb == 2 && par2 > 0.000001) fprintf(fw, "%9.3f %9.3f", par1, par2);
  if ((cb == 2 && par2 < 0.000001) || cb == 1) 
    fprintf(fw, "%9.2f       -", par1);
}  

/* Wrong number of reproductive cycles */
void nonsense01(int b)
{
  printf("\nError message:\n");
  printf("The number of reproductive cycles must be in the range from 4\n");
  if (b == 1)
    printf("to 15. Correct this error in INPUTS01A.TXT and restart the program.\n");
  if (b == 2)
    printf("to 15. Correct this error in INPUTS01B.TXT and restart the program.\n");
  }

/* Wrong number of classes for litter size */
void nonsense02(int b)
{
  printf("\nError message:\n");
  printf("The number of classes for litter size must be in the range from 1\n");
  if (b == 1)
    printf("to 5. Correct this error in INPUTS03A.TXT and restart the program.\n");
  if (b == 2)
    printf("to 5. Correct this error in INPUTS03B.TXT and restart the program.\n");
  }

/* Wrong value(s) for age at which female breeding lambs are sold */ 
void nonsense03(int b, int i, int j, float s, float t)
{
  printf("\nError message:\n");
  printf("The age of "); 
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred ");
  printf("breeding female lambs sold\n");
  if (i == 1) printf("  before the 1st breeding season ");
  if (i == 2) printf("  between the 1st and 2nd breeding season ");
  printf("is not correct.\n");
  printf("  The age must be between %3.0f and %3.0f days.\n",s,t);
  if (b == 1)
    printf("  Correct the appropriate value in INPUTS04A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the appropriate value in INPUTS04B.TXT and restart the program.\n");
  }

/* Wrong value(s) for weight of purchased rams */ 
void nonsense04(int b, int j, float s)
{
  printf("\nError message:\n");
  printf("The weight of purchased rams of "); 
  if (j == 1) printf("the breed of the herd\n");
  if (j == 2) printf("of the breed used for crossing in the herd\n");
  printf("  is not correct.\n");
  printf("  The weight must be less than mature weight (%3.0f kg).\n",s);
  if (b == 1)
    printf("  Correct the appropriate value in INPUTS04A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the appropriate value in INPUTS04B.TXT and restart the program.\n");
  }

/* Wrong number of breeding cycles for rams */
void nonsense05(int b)
{
  printf("\nError message:\n");
  printf("The number of breeding cycles for rams must be in the range from 1\n");
  if (b == 1)
    printf("to 5. Correct this error in INPUTS02A.TXT and restart the program.\n");
  if (b == 2)
    printf("to 5. Correct this error in INPUTS02B.TXT and restart the program.\n");
  }

/* Wrong proportions of individual categories of rams in the last breeding 
   cycle */
void nonsense06(int b)
{
  printf("\nError message:\n");
  printf("The sum pdiedR[RR]+psoldR[RR]+pcullR[RR] must be one.\n");
  if (b == 1)
    printf("Correct this error in INPUTS02A.TXT and restart the program.\n");
  if (b == 2)
    printf("Correct this error in INPUTS02B.TXT and restart the program.\n");
  }

/* Wrong proportions of individual categories of rams in one of the breeding 
   cycles */
void nonsense07(int b)
{
  printf("\nError message:\n");
  printf("The proportion of rams staying to the next breeding cycle \n");
  printf("must be > 0. Reduce the fractions of the other categories. \n");  
  if (b == 1)
    printf("Correct this error in INPUTS02A.TXT and restart the program.\n");
  if (b == 2)
    printf("Correct this error in INPUTS02B.TXT and restart the program.\n");
  }

/* Wrong parameter in PARAS.TXT */
void nonsense08(int b, int i)
{
  printf("\nError message:\n");
  if (i == 1) printf("Type of weaning can be only 1 or 2.\n");
  if (i == 3) {
    printf("The number of variants for fattening of surplus female progeny\n");
    printf("must be an integer in the interval from 0 to 5.\n");  
  }
  if (i == 4) {
    printf("The number of variants for fattening of surplus male progeny\n");
    printf("must be an integer in the interval from 0 to 5.\n");  
  }
  if (i == 5) {
    printf("The number of variants for fattening of castrates\n");
    printf("must be an integer in the interval from 0 to 5.\n");  
  }
  if (i == 6) printf("Type of breed can be only 1, 2 or 3.\n");
  if (i == 7) printf("Method for calculating the feed costs can be only 1 or 2.\n");
  if (i == 8) printf("Parameter female replacement may take only values 1 or 2.\n");
  if (b == 1) printf("Correct the error in the parameter file PARASA.TXT ");  
  if (b == 2) printf("Correct the error in the parameter file PARASB.TXT ");
  printf("and restart the program.\n");
  }

/* Quality classes do not sum up to 1 */
void nonsense09(int b, int i, int j, int k, float a2)
{
  printf("\nError message:\n");
  if (j == 1) printf("Frequencies in quality classes for\n"); 
  if (j == 2) printf("Frequencies in classes for fleshiness/ fat covering for\n"); 
  if (i == 1) printf("  pure-bred adult sheep ");
  if (i == 2) printf("  cross-bred adult sheep "); 
  if (i == 6) printf("  pure-bred weaned slaughter lambs "); 
  if (i == 7) printf("  cross-bred weaned slaugher lambs ");
  if (i == 8) printf("  pure-bred fattened lambs "); 
  if (i == 9) printf("  cross-bred fattened lambs ");
  printf("do not sum up to 1. The sum is %6.4f.\n",a2);
  if (b == 1)
    printf("  Correct the error in INPUTS%dA.TXT and restart the program.\n", k);
  if (b == 2)
    printf("  Correct the error in INPUTS%dB.TXT and restart the program.\n", k);
  }

/* Frequencies in classes for fleshiness/fat covering do not sum up to 1 */
void nonsense10(int b, int j, float a2)
{
  printf("\nError message:\n");
  printf("Frequencies in classes for fleshiness/ fat covering for fattened\n"); 
  if (j == 1) printf("  pure-bred "); 
  if (j == 2) printf("  cross-bred "); 
  printf("lambs do not sum up to 1. The sum is %6.4f.\n",a2);
  if (b == 1)
    printf("  Correct the error in INPUTS14A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the error in INPUTS14B.TXT and restart the program.\n");
  }

/* Wrong values for fractions of surplus progeny */
void nonsense11(int b, int j, int k)
{
  printf("\nError message:\n");
  printf("The fractions of ");
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred ");
  if (k == 1) printf("surplus female progeny must sum to 1.\n");
  if (k == 2) printf("surplus male progeny must sum to 1.\n");
  if (k == 0) printf("surplus castrates must sum to 1.\n");
  if (b == 1)
    printf("Correct this error in INPUTS05A.TXT and restart the program.\n");
  if (b == 2)
    printf("Correct this error in INPUTS05B.TXT and restart the program.\n");
  }

/* Inconsistence in your data on the presence/absence of castrates */
void nonsense17(int b)
{
  printf("\nError message:\n");
  if (b == 1) {
    printf("In the parameter file PARASA.TXT you stated that there will\n");
    printf("  be no fattening of castrates. In input file INPUTS05A.TXT\n");
  }
  if (b == 2) {
    printf("In the parameter file PARASB.TXT you stated that there will\n");
    printf("  be no fattening of castrates. In input file INPUTS05B.TXT\n");
  }
  printf("  you gave a non-zero fraction of castrates. Change the\n");
  printf("  input parameters to make them consistent and restart\n");
  printf("  the program.\n");
  }

/* Wrong codes indicating the presence of cross-bred progeny */
void nonsense18(int b, int i)
{
  printf("\nError message:\n");
  if (b == 1)
    printf("In the file INPUTS05A.TXT are wrong codes indicating\n");
  if (b == 2)
    printf("In the file INPUTS05B.TXT are wrong codes indicating\n");
  printf("  the presence of cross-bred ");
  if (i == 1) printf("female progeny ");
  if (i == 2) printf("male progeny ");
  if (i == 3) printf("castrates ");  
  printf("in fattening\n");
  printf("  whereas in PARAS.TXT no crossbreeding was indicated.\n");
  printf("  Correct the error and restart the program.\n");
  }

/* Wrong data for fraction of lambings in individual classes for litter size */
void nonsense19(int b, int i)
{
  printf("\nError message:\n");
  if (b == 1)
    printf("In file INPUTS03A.TXT there are wrong data for the fraction of\n");
  if (b == 2)
    printf("In file INPUTS03B.TXT there are wrong data for the fraction of\n");
  printf("  lambings in individual classes for litter size. The fractions\n");
  printf("  in reproductive cycle %d do not sum to 1.\n",i);
  printf("  Correct the error and restart the program.\n");
  }

/* Wrong codes for feeding season */
void nonsense20(int b)
{
  printf("\nError message:\n");
  printf("The code for the feeding season after the last change in the year\n");
  printf("  must be the same as the code on January 1st.\n");
  if (b == 1)
    printf("  Correct this error in INPUTS08A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct this error in INPUTS08B.TXT and restart the program.\n");
  }
  
/* Wrong value for fraction of progeny determined for fattening */
void nonsense21(int b, int i, int j, int k)
{
  printf("\nError message:\n");
  printf("The fraction of ");
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred ");
  if (k == 1) printf("female progeny\n");
  if (k == 2) printf("male progeny\n");
  if (k == 0) printf("castrates\n");
  printf("  for target %d in fattening is not correct.\n", i);
  if (b == 1)
    printf("  Correct the error in INPUTS05A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the error in INPUTS05B.TXT and restart the program.\n");
  }

/* Too short time for pregnancy */
void nonsense22(int b)
{
  printf("\nError message:\n");
  printf("The time for pregnancy calculated from your input parameters\n");
  printf("  is too short.\n");
  if (b == 1)
    printf("  Correct this error in INPUTS01A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct this error in INPUTS01B.TXT and restart the program.\n");
  }

/* Wrong value(s) for age at which male breeding lambs are sold */ 
void nonsense23(int b, int i, int j)
{
  printf("\nError message:\n");
  printf("The age at which "); 
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred ");
  printf("breeding male lambs are sold\n");
  if (i == 1) printf("  before the first breeding season ");
  if (i == 2) printf("  between the first and second breeding season ");
  printf("is not correct.\n");
  if (b == 1)
    printf("  Correct the appropriate value in INPUTS04A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the appropriate value in INPUTS04B.TXT and restart the program.\n");
  }

/* Too high weight of female or male lambs in 1st or 2nd breeding season */
void nonsense24(int b, int i, int j, int k)
{
  printf("\nError message:\n");
  printf("The weight calculated for "); 
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred ");
  if (i == 1) printf("female ");
  if (i == 2) printf("male "); 
  printf("lambs in the ");
  if (k == 1) printf("first\n");
  if (k == 2) printf("second\n");
  printf("  breeding season is higher than mature weight. Correct the \n");
  if (b == 1)
    printf("  appropriate weights or daily gains in INPUTS03A.TXT and/or INPUTS04A.TXT\n");
  if (b == 2)
    printf("  appropriate weights or daily gains in INPUTS03B.TXT and/or INPUTS04B.TXT\n");
  printf("  and restart the program.\n");
  }

/* Number of classes for litter size is too high */
void nonsense25(int b)
{
  printf("\nError message:\n");
  printf("The number of classes for litter size is too high. The fraction\n");
  printf("  of lambings in the highest class for litter size is zero for all\n");
  printf("  reproductive cycles. Decrease the number of litter size classes by one or\n");  
  printf("  complete the data for the highest class of litter size in\n");
  if (b == 1) printf("  INPUTS03A.TXT and restart the program.\n");
  if (b == 2) printf("  INPUTS03B.TXT and restart the program.\n");
  }

/* Average daily gain not given */
void nonsense26(int b, int i, int j, int k)
{
  printf("\nError message:\n");
  printf("Average daily gain for fattening of "); 
  if (j == 1) printf("pure-bred ");
  if (j == 2) printf("cross-bred "); 
  if (k == 1) printf("female progeny\n");
  if (k == 2) printf("male progeny\n");
  if (k == 3) printf("castrates\n");
  printf("  to target %d must be greater than zero.\n",i);
  if (b == 1)
    printf("  Correct the error in INPUTS05A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the error in INPUTS05B.TXT and restart the program.\n");
  }

/* Not enough female replacement */
void nonsense27(int b)
{
  printf("\nError message:\n");
  printf("There are not enough pure-bred female weaned lambs for own replacement.\n");
  printf("  Decrease the fraction of ewes crossed with other breeds, i.e.\n");
  if (b == 1) 
    printf("  decrease the appropriate values in input file INPUTS01A.TXT\n");  
  if (b == 2) 
    printf("  decrease the appropriate values in input file INPUTS01B.TXT\n");  
  printf("  and restart the program.\n");
  }

/* Negative values for net energy or protein requirement for pregnancy */
void nonsense29(int b,int i)
{
  printf("\nError message:\n");
  printf("There is at least one negative value for net energy or protein\n");
  printf("  requirement for pregnancy for ");
  if (i == 1) printf("ewes.\n");
  if (i == 2) printf("female breeding lambs.\n");
  printf("  Decrease the weight gain during flushing for ");
  if (i == 1) printf("ewes\n");
  if (i == 2) printf("female breeding lambs\n");
  if (b == 1) printf("  in INPUTS04A.TXT and restart the program.\n");  
  if (b == 2) printf("  in INPUTS04B.TXT and restart the program.\n");  
  }

/* Wrong date */
void nonsense30(int b, int i)
{
  printf("\nError message:\n");
  printf("The date ");
  if (i == 1) printf("of lambing ");
  if (i == 2) printf("of weaning lambs ");
  if (i == 3) printf("of the start of the breeding season ");  
  if (i == 4) printf("of the end of the breeding season "); 
  if (i == 5) printf("of drying ");  
  if (i == 6) printf("of change in the feeding season ");
  printf("is wrong. Correct the date in\n");
  if (i <= 5) {
    if (b == 1) printf("  INPUTS01A.TXT");
    if (b == 2) printf("  INPUTS01B.TXT");
  }
  if (i == 6) {
    if (b == 1) printf("  INPUTS08A.TXT");
    if (b == 2) printf("  INPUTS08B.TXT");  
  }
  printf(" and restart the program.\n");  
  }

/* Frequencies in classes for fleshiness/fat covering do not sum up to 1 */
void nonsense31(int b, int j, float a2)
{
  printf("\nError message:\n");
  printf("Frequencies in classes for fleshiness/ fat covering for "); 
  if (j == 1) printf("pure-bred\n"); 
  if (j == 2) printf("cross-bred\n"); 
  printf("  heavy lambs (carcass weight > 13 kg) slaughtered after weaning or\n");
  printf("  artificial rearing do not sum up to 1. The sum is %6.4f.\n",a2);
  if (b == 1)
    printf("  Correct the error in INPUTS13A.TXT and restart the program.\n");
  if (b == 2)
    printf("  Correct the error in INPUTS13B.TXT and restart the program.\n");
  }
